Free Energy Minimization
========================

Quick Start
-----------

Interactive notebook
~~~~~~~~~~~~~~~~~~~~

Launch an interactive Jupyter notebook using Binder to run and edit the examples in the documentation:

.. image:: https://mybinder.org/badge.svg
   :target: https://mybinder.org/v2/gh/nihcompmed/fem/master?filepath=doc%2Fnotebooks

Installation
~~~~~~~~~~~~

- To install ``fem`` on your computer using ``pip``, execute

  .. code-block:: sh

     pip install fem

  Dependencies:

  - Fortran compiler such as gfortran
  - LAPACK development files
  - OpenMP development files (for parallel computing support)


- Load ``fem`` in your Python script:

  .. code-block:: python

     import fem


Links
-----

Online documentation:
    http://nihcompmed.github.io/fem

Source code repository:
    https://github.com/nihcompmed/fem

Python package index:
    https://pypi.python.org/pypi/fem

The target value for the lowest eigenvalue is in TARGET.RESULT.

If the target value is achieved within an appropriate tolerance,
then program "check" writes TEST.RESULT = -1 meaning that the
test is passed in runtests. Otherwise, TEST.RESULT = 1.0 and the
test is failed.

subroutine fit(x, y, p_sum, l, ohx_pinv1, ohx_pinv2, ohx_pinv3, ohx_rank, pq_sum, q, p, k, m_y, max_iters, iters, iter, par, disc)
  implicit none

  ! x(sum(p), l)
  ! y(l)
  ! ohx_pinv1(l, ohx_rank)
  ! ohx_pinv2(ohx_rank)
  ! ohx_pinv3(ohx_rank, pq_sum)
  ! p(k+1), q(k+1)

  integer p_sum
  integer l
  integer x(p_sum, l)
  integer y(l)
  ! f2py intent(hide), depend(x) :: p_sum=shape(x,0)
  ! f2py intent(hide), depend(x) :: l=shape(x,1)
  integer ohx_rank
  integer pq_sum
  real*8 ohx_pinv1(l, ohx_rank)
  real*8 ohx_pinv2(ohx_rank)
  real*8 ohx_pinv3(ohx_rank, pq_sum)
  ! f2py intent(hide), depend(ohx_pinv1) :: ohx_rank=shape(ohx_pinv1,1)
  ! f2py intent(hide), depend(ohx_pinv3) :: ohx_rank=shape(ohx_pinv3,1)
  integer k
  integer p(k)
  integer q(k)
  ! f2py intent(hide), depend(p) :: k=len(p)
  integer m_y
  integer max_iters
  integer, optional :: iters
  integer, intent(out) :: iter
  real*8, intent(out) :: par(max_iters, m_y, pq_sum)
  ! f2py depend(max_iters) :: par
  ! f2py depend(m_y) :: par
  ! f2py depend(pq_sum) :: par
  real*8, intent(out) :: disc(max_iters)
  ! f2py depend(disc) :: max_iters
  logical disc_stop

  real*8 wrk(m_y, l), dpar(m_y, ohx_rank)
  integer pq(k), i_par(k+1), i_x(k+1)
  integer it, id, iv, j, n_wrong_states
  logical mask(m_y, l)

  if (present(iters)) then
     disc_stop = .false.
  else
     disc_stop = .true.
     iters = max_iters
  end if

  n_wrong_states = l*(m_y-1)

  pq = p*q

  i_x(1) = 0
  i_par(1) = 0
  i_x(2:) = p
  i_par(2:) = pq
  do id=1,k
     i_x(id+1) = i_x(id+1) + i_x(id)
     i_par(id+1) = i_par(id+1) + i_par(id)
  end do

  mask = .true.
  do it=1,l
     mask(y(it),it) = .false.
  end do

  iter = 1
  par = 0
  disc(1) = 1.0/m_y/m_y + 1

  do iter=2, iters

     ! compute energies
     wrk = 0
     do it=1,l ! time
        do id=1,k ! degree
           do iv=1,p(id) ! variable
              wrk(:,it) = wrk(:,it) + par(iter-1,:,i_par(id)+(iv-1)*q(id)+x(i_x(id)+iv,it))
           end do
        end do
     end do

     ! compute probabilities
     wrk = exp(wrk)
     do it=1,l
        wrk(:,it) = wrk(:,it) / sum(wrk(:,it))
     end do

     ! discrepancy
     disc(iter) = sum(wrk*wrk, mask) / n_wrong_states

     if (disc_stop.and.(disc(iter) > disc(iter-1))) then
        exit
     end if

     do it=1,l
        wrk(y(it),it) = wrk(y(it),it) - 1
     end do

     dpar = matmul(wrk, ohx_pinv1)
     do j=1,ohx_rank
        dpar(:,j) = dpar(:,j)*ohx_pinv2(j)
     end do
     par(iter,:,:) = par(iter-1,:,:) - matmul(dpar, ohx_pinv3)

  end do

end subroutine fit

module fortran_module
  ! fortran_module description
  !$ use omp_lib
  implicit none

  public :: num_threads
  public :: simulate_time_series
  public :: simulate_mutations
  public :: discrete_fit
  public :: discrete_fit_i

contains

  function num_threads() result (n)
    ! Return the number of threads that the package can see.
    ! If the return value is 1 but there are multiple cpus,
    ! then OpenMP is not installed or not properly configured
    implicit none
    integer n
    n = 1
    !$ n = omp_get_max_threads()
  end function num_threads

  subroutine multiindices(n, m, degs, n_deg, n_idx, n_idx_by_deg, idx_ptr, idx, stratifier)
    implicit none

    integer, intent(in) :: n, n_deg, n_idx, m(n), degs(n_deg), n_idx_by_deg(n_deg)
    integer, intent(out) :: idx_ptr(:), idx(:), stratifier(:)
    integer, allocatable :: var(:)
    integer i, i1, i2, j, k

    idx_ptr(1) = 0
    i = 2
    do j = 1, n_deg
       do k = 1, n_idx_by_deg(j)
          idx_ptr(i) = idx_ptr(i-1) + degs(j)
          i = i + 1
       end do
    end do
    ! print*, 'idx_ptr', idx_ptr

    i = 1
    do j = 1, n_deg
       allocate(var(degs(j)))
       ! var = (/ (i2, i=12, degs(j)) /)
       do i2 = 1, degs(j)
          var(i2) = i2
       end do
       idx(idx_ptr(i)+1:idx_ptr(i+1)) = var
       i = i + 1
       ! do k = 1, n_idx_by_deg(degs(j))-1
       do k = 1, n_idx_by_deg(j)-1
          i1 = degs(j)
          var(i1) = var(i1) + 1
          do while (var(i1) + degs(j) > i1 + n)
             i1 = i1 - 1
             var(i1) = var(i1) + 1
          end do
          ! var(i1+1:) = (/ (var(i2-1)+1, i2=i1+1, degs(j)) /)
          do i2 = i1+1, degs(j)
             var(i2) = var(i2-1)+1
          end do
          idx(idx_ptr(i)+1:idx_ptr(i+1)) = var
          i = i + 1
       end do
       deallocate(var)
    end do
    ! print*, 'idx', idx

    stratifier = 1
    do i = 2, n_idx
       do j = idx_ptr(i-1)+1, idx_ptr(i)
          stratifier(i) = stratifier(i) * m(idx(j))
       end do
       stratifier(i) = stratifier(i) + stratifier(i-1)
    end do
    ! print*, 'stratifier', stratifier

  end subroutine multiindices

  subroutine simulate_time_series(w, m_sum, n_s, n, m, l, degs, n_deg, x)
    ! simulate_time_series description

    real*8, intent(in) :: w(m_sum, n_s)
    integer, intent(in) :: m_sum, n_s, n, n_deg, l, m(n), degs(n_deg)
    integer, intent(out) :: x(n,l)
    !f2py integer, intent(hide), depend(w) :: m_sum=shape(w,0)
    !f2py integer, intent(hide), depend(w) :: n_s=shape(w,1)
    !f2py integer, intent(hide), depend(m) :: n=len(m)
    !f2py integer, intent(hide), depend(degs) :: n_deg=len(degs)

    integer, allocatable :: bc(:), idx_ptr(:), idx(:), stratifier(:), s(:,:)
    integer t, i, i1, i2, j, max_deg, n_idx, n_idx_by_deg(n_deg), m_cumsum(n+1)
    real*8 randr(n, l), wrk(m_sum)

    ! print*, 'passed to fortran'

    call random_seed()
    call random_number(randr)

    max_deg = degs(n_deg)
    allocate(bc(max_deg))
    bc(1) = n
    do i = 2, max_deg
       bc(i) = bc(i-1)*(n-i+1)/i
    end do
    n_idx_by_deg = (/ (bc(degs(i)), i=1, n_deg) /)
    n_idx = sum(n_idx_by_deg)
    m_cumsum(1) = 0
    do i = 1, n
       m_cumsum(i+1) = m_cumsum(i) + m(i)
    end do
    ! print*, 'm_cumsum', m_cumsum

    allocate(idx_ptr(n_idx+1))
    allocate(idx(sum(n_idx_by_deg*degs)))
    allocate(stratifier(n_idx))

    call multiindices(n, m, degs, n_deg, n_idx, n_idx_by_deg, idx_ptr, idx, stratifier)

    ! random initial condition
    do i = 1, n
       x(i, 1) = mod(int((10*m(i)+1)*randr(i, 1)), m(i))
    end do
    allocate(s(n_idx, l))
    do i = 1, n_idx
       s(i, 1) = x(idx(idx_ptr(i)+1), 1)
       do j = idx_ptr(i)+2, idx_ptr(i+1)
          s(i, 1) = s(i, 1) * m(idx(j)) + x(idx(j), 1)
       end do
       s(i, 1) = s(i, 1) + stratifier(i)
    end do
    ! print*, 'initial x', x(:, 1)

    do t = 2, l

       ! print*, 't', t

       ! energies
       wrk = 0
       do i = 1, n_idx
          wrk = wrk + w(:, s(i, t-1))
       end do
       ! print*, 'h', wrk

       ! sample from Boltzmann
       wrk = exp(wrk)
       do i = 1, n
          i1 = m_cumsum(i)+1; i2 = m_cumsum(i+1)
          do j = i1+1, i2
             wrk(j) = wrk(j) + wrk(j-1)
          end do
          j = 0
          do while(wrk(i1+j) <= wrk(i2) * randr(i,t))
             j = j + 1
          end do
          x(i, t) = j
       end do
       ! print*, 'x', x(:, t)

       ! one hot encoding
       do i = 1, n_idx
          s(i, t) = x(idx(idx_ptr(i)+1), t)
          do j = idx_ptr(i)+2, idx_ptr(i+1)
             s(i, t) = s(i, t) * m(idx(j)) + x(idx(j), t)
          end do
          s(i, t) = s(i, t) + stratifier(i)
       end do
       ! print*, 's', s(:, t)

    end do

    deallocate(bc, idx_ptr, idx, stratifier, s)

  end subroutine simulate_time_series

  subroutine simulate_mutations(w, m_sum, n_s, n, m, l, degs, n_deg, x, y)
    ! simulate_mutations description

    real*8, intent(in) :: w(m_sum, n_s)
    integer, intent(in) :: m_sum, n_s, n, n_deg, l, m(n), degs(n_deg)
    integer, intent(out) :: x(n,l), y(n,l)
    !f2py integer, intent(hide), depend(w) :: m_sum=shape(w,0)
    !f2py integer, intent(hide), depend(w) :: n_s=shape(w,1)
    !f2py integer, intent(hide), depend(m) :: n=len(m)
    !f2py integer, intent(hide), depend(degs) :: n_deg=len(degs)

    integer i, i1, i2, j, k, max_deg, n_idx, n_idx_by_deg(n_deg), m_cumsum(n+1)
    real*8 randx(n, l), randy(n, l), wrk(m_sum)
    integer, allocatable :: bc(:), idx_ptr(:), idx(:), stratifier(:), s(:,:)

    call random_seed()
    call random_number(randx)
    call random_number(randy)

    max_deg = degs(n_deg)
    allocate(bc(max_deg))
    bc(1) = n
    do i = 2, max_deg
       bc(i) = bc(i-1)*(n-i+1)/i
    end do
    n_idx_by_deg = (/ (bc(degs(i)), i=1, n_deg) /)
    n_idx = sum(n_idx_by_deg)
    m_cumsum(1) = 0
    do i = 1, n
       m_cumsum(i+1) = m_cumsum(i) + m(i)
    end do

    allocate(idx_ptr(n_idx+1))
    allocate(idx(sum(n_idx_by_deg*degs)))
    allocate(stratifier(n_idx))

    call multiindices(n, m, degs, n_deg, n_idx, n_idx_by_deg, idx_ptr, idx, stratifier)

    ! random initial condition
    do i = 1, n
       do j = 1, l
          x(i, j) = mod(int((10*m(i)+1)*randx(i, j)), m(i))
       end do
    end do

    allocate(s(n_idx, l))
    do i = 1, n_idx
       do j = 1, l
          s(i, j) = x(idx(idx_ptr(i)+1), j)
          do k = idx_ptr(i)+2, idx_ptr(i+1)
             s(i, j) = s(i, j) * m(idx(k)) + x(idx(k), j)
          end do
          s(i, j) = s(i, j) + stratifier(i)
       end do
    end do
    ! print*, 'initial x', x(:, 1)

    do k = 1, l

       ! print*, 'k', k

       ! energies
       wrk = 0
       do i = 1, n_idx
          wrk = wrk + w(:, s(i, k))
       end do
       ! print*, 'h', wrk

       ! sample from Boltzmann
       wrk = exp(wrk)
       do i = 1, n
          i1 = m_cumsum(i)+1; i2 = m_cumsum(i+1)
          do j = i1+1, i2
             wrk(j) = wrk(j) + wrk(j-1)
          end do
          j = 0
          do while(wrk(i1+j) <= wrk(i2) * randy(i, k))
             j = j + 1
          end do
          y(i, k) = j
       end do
       ! print*, 'y', y(:, k)

    end do

    deallocate(bc, idx_ptr, idx, stratifier, s)

  end subroutine simulate_mutations

  subroutine discrete_fit(x, y, n_x, n_y, m_x, m_y, m_y_sum, l, degs, n_deg, &
       x_oh_pinv1, x_oh_pinv2, x_oh_pinv3, x_oh_rank, n_s, &
       iters, overfit, impute, w, disc, iter)
    implicit none

    integer, intent(in) :: n_x, n_y, l, n_deg, x_oh_rank, n_s, m_y_sum
    integer, intent(in) :: x(n_x,l), y(n_y,l), m_x(n_x), m_y(n_y), degs(n_deg)
    real*8, intent(in) :: x_oh_pinv1(l, x_oh_rank)
    real*8, intent(in) :: x_oh_pinv2(x_oh_rank)
    real*8, intent(in) :: x_oh_pinv3(x_oh_rank, n_s)
    integer, intent(in) :: iters
    logical, intent(in) :: overfit, impute
    real*8, intent(out) :: w(m_y_sum, n_s), disc(n_y, iters)
    integer, intent(out) :: iter(n_y)
    !f2py integer, intent(hide), depend(x) :: n_x=shape(x,0)
    !f2py integer, intent(hide), depend(y) :: n_y=shape(y,0)
    !f2py integer, intent(hide), depend(x) :: l=shape(x,1)
    !f2py integer, intent(hide), depend(degs) :: n_deg=len(degs)
    !f2py integer, intent(hide), depend(x_oh_pinv2) :: x_oh_rank=len(x_oh_pinv2)
    !f2py integer, intent(hide), depend(x_oh_pinv3) :: n_s=shape(x_oh_pinv3,1)

    integer i, i1, i2, j, k, max_deg, n_idx, n_idx_by_deg(n_deg), m_y_cumsum(n_y+1)
    integer, allocatable :: bc(:), idx_ptr(:), idx(:), var(:), stratifier(:), s(:,:)

    ! print*, 'x_oh_pinv1', shape(x_oh_pinv1)
    ! print*, 'x_oh_pinv2', shape(x_oh_pinv2)
    ! print*, 'x_oh_pinv3', shape(x_oh_pinv3)
    ! print*, 'n_x', n_x
    ! print*, 'l', l

    ! print*, 'x'
    ! do i = 1, n_x
    !    print*, x(i, :5)
    ! end do

    ! max_deg = degs(n_deg)
    ! allocate(bc(max_deg))
    ! bc(1) = n_x
    ! do i = 2, max_deg
    !    bc(i) = bc(i-1)*(n_x-i+1)/i
    ! end do
    ! n_idx_by_deg = (/ (bc(degs(i)), i=1, n_deg) /)
    ! n_idx = sum(n_idx_by_deg)
    ! allocate(idx_ptr(n_idx+1))
    ! allocate(idx(sum(n_idx_by_deg*degs)))
    ! allocate(stratifier(n_idx))

    ! call multiindices(n_x, m_x, degs, n_deg, n_idx, n_idx_by_deg, idx_ptr, idx, stratifier)

    max_deg = degs(n_deg)
    ! print*, 'n_deg', n_deg
    ! print*, 'max_deg', max_deg

    ! binomial coeff
    allocate(bc(max_deg))
    bc(1) = n_x
    ! bc(2:) = (/ (bc(i-1)*(n_x-i+1)/i, i=2, max_deg) /)
    do i = 2, max_deg
       bc(i) = bc(i-1)*(n_x-i+1)/i
    end do
    ! print*, 'bc', bc

    n_idx_by_deg = (/ (bc(degs(i)), i=1, n_deg) /)
    n_idx = sum(n_idx_by_deg)
    ! print*, 'n_idx_by_deg', n_idx_by_deg
    ! print*, 'n_idx', n_idx

    allocate(idx_ptr(n_idx+1))
    idx_ptr(1) = 0
    i = 2
    do j = 1, n_deg
       ! do k = 1, n_idx_by_deg(degs(j))
       do k = 1, n_idx_by_deg(j)
          idx_ptr(i) = idx_ptr(i-1) + degs(j)
          i = i + 1
       end do
    end do
    ! print*, 'idx_ptr', idx_ptr

    allocate(idx(sum(n_idx_by_deg*degs)))
    i = 1
    do j = 1, n_deg
       allocate(var(degs(j)))
       ! var = (/ (i, i=1, degs(j)) /)
       do i2 = 1, degs(j)
          var(i2) = i2
       end do
       idx(idx_ptr(i)+1:idx_ptr(i+1)) = var
       i = i + 1
       ! do k = 1, n_idx_by_deg(degs(j))-1
       do k = 1, n_idx_by_deg(j)-1
          i1 = degs(j)
          var(i1) = var(i1) + 1
          do while (var(i1) + degs(j) > i1 + n_x)
             i1 = i1 - 1
             var(i1) = var(i1) + 1
          end do
          var(i1+1:) = (/ (var(i2-1)+1, i2=i1+1, degs(j)) /)
          idx(idx_ptr(i)+1:idx_ptr(i+1)) = var
          i = i + 1
       end do
       deallocate(var)
    end do
    ! print*, 'idx', idx

    allocate(stratifier(n_idx))
    stratifier = 1
    do i = 2, n_idx
       do j = idx_ptr(i-1)+1, idx_ptr(i)
          stratifier(i) = stratifier(i) * m_x(idx(j))
       end do
       stratifier(i) = stratifier(i) + stratifier(i-1)
    end do
    ! print*, 'stratifier', stratifier

    ! powers of x stratified, i.e. cols of w
    allocate(s(n_idx, l))
    do i = 1, n_idx
       s(i, :) = x(idx(idx_ptr(i)+1), :)
       do j = idx_ptr(i)+2, idx_ptr(i+1)
          s(i, :) = s(i, :)*m_x(idx(j)) + x(idx(j), :)
       end do
       s(i, :) = s(i, :) + stratifier(i)
    end do
    ! print*, 's'
    ! do i = 1, n_idx
    !    print*, s(i, :5)
    ! end do

    m_y_cumsum(1) = 0
    do i = 1, n_y
       m_y_cumsum(i+1) = m_y_cumsum(i) + m_y(i)
    end do

    ! print*, 'm_y_cumsum', m_y_cumsum
    ! print*, 'n_s', n_s
    ! print*, 'w', shape(w)

    !$omp parallel do default(shared) private(i1,i2)
    do i = 1, n_y
       i1 = m_y_cumsum(i)+1
       i2 = m_y_cumsum(i+1)
       call discrete_fit_i(i1, i2, s, n_idx, y(i,:)+1, m_y(i), l, &
            x_oh_pinv1, x_oh_pinv2, x_oh_pinv3, x_oh_rank, n_s, &
            iters, overfit, impute, w(i1:i2,:), disc(i,:), iter(i))
    end do
    !$omp end parallel do

    deallocate(bc, idx_ptr, idx, stratifier, s)

  end subroutine discrete_fit

  subroutine discrete_fit_i(i1, i2, s, n_idx, y, m_y, l, &
       x_oh_pinv1, x_oh_pinv2, x_oh_pinv3, x_oh_rank, n_s, &
       iters, overfit, impute, w, disc, iter)
    implicit none

    integer, intent(in) :: i1, i2, n_idx, m_y, l, x_oh_rank, n_s, iters
    integer, intent(in) :: s(n_idx, l), y(l)
    real*8, intent(in) :: x_oh_pinv1(l, x_oh_rank)
    real*8, intent(in) :: x_oh_pinv2(x_oh_rank)
    real*8, intent(in) :: x_oh_pinv3(x_oh_rank, n_s)
    logical, intent(in) :: overfit, impute

    real*8 tmp(x_oh_rank, n_s)

    real*8, intent(out) :: w(m_y, n_s), disc(iters)
    integer, intent(out) :: iter

    logical disc_mask(m_y, l)
    integer n_wrong_states
    real*8 wrk(m_y, l), dw(m_y, x_oh_rank)
    integer i, t

    w = 0
    disc(1) = 1.0 / m_y / m_y + 1.0
    n_wrong_states = (m_y - 1) * l

    disc_mask = .true.
    do t = 1, l
       disc_mask(y(t), t) = .false.
    end do

    do iter = 2, iters

       print*, i1, i2, iter, impute

       ! compute energies
       wrk = 0
       do t = 1, l
          do i = 1, n_idx
             wrk(:, t) = wrk(:, t) + w(:, s(i, t))
          end do
       end do

       ! probabilities
       wrk = exp(wrk)
       do t = 1, l
          wrk(:, t) = wrk(:, t) / sum(wrk(:, t))
       end do

       ! discrepancy
       disc(iter) = sum(wrk*wrk, disc_mask) / n_wrong_states
       if (.not.overfit.and.(disc(iter) > disc(iter-1))) then
          exit
       end if

       do t = 1, l
          wrk(y(t), t) = wrk(y(t), t) - 1
       end do

       dw = matmul(wrk, x_oh_pinv1)
       do i = 1, x_oh_rank
          dw(:, i) = dw(:,i) * x_oh_pinv2(i)
       end do
       w = w - matmul(dw, x_oh_pinv3)
       if (impute) then
          w(:,i1:i2) = 0
       end if

    end do

    iter = iter - 1

  end subroutine discrete_fit_i

  subroutine continuous_fit(x, y, n, l, iters, atol, rtol, impute, w, disc, iter)
    implicit none

    real*8, intent(in) ::  x(n,l), y(n,l), atol, rtol
    integer, intent(in) :: n, l, iters
    real*8, intent(out) :: w(n,n), disc(n,iters)
    integer, intent(out) :: iter(n)
    logical, intent(in) :: impute
    real*8 symx(n,l), mean_x(n), x_mean0(n,l), cov_x(n,n)
    real*8 dt, sqrt_dt, sqrt_2, rat
    !f2py integer, intent(hide), depend(x) :: n=shape(x,0)
    !f2py integer, intent(hide), depend(l) :: n=shape(x,1)
    integer i, j, info, ipiv(n)

    dt = 1.0
    sqrt_dt = sqrt(dt)
    sqrt_2 = sqrt(2.0)
    rat = sqrt_dt / sqrt_2

    symx = 1
    symx = sign(symx, y-x)
    ! print*, 'symx(:,1)', symx(:,1)

    do i = 1, n
       mean_x(i) = sum(x(i,:))
    end do
    mean_x = mean_x / l
    ! print*, 'mean_x', mean_x

    do i = 1, l
       x_mean0(:,i) = x(:,i) - mean_x
    end do
    ! print*, 'x_mean0(:,1)', x_mean0(:,1)

    do i = 1, n
       do j = 1, n
          cov_x(i,j) = dot_product(x(i,:), x(j,:))
       end do
    end do
    cov_x = cov_x / l
    ! print*, 'cov_x', cov_x

    call dgetrf(n, n, cov_x, n, ipiv, info)
    ! print*, 'dgetrf info', info

    !$omp parallel do default(shared) private(i)
    do i = 1, n
       ! print*, 'fit_i', i
       call continuous_fit_i(i, x, n, l, x_mean0, symx(i,:), cov_x, ipiv, &
            iters, atol, rtol, impute, w(i,:), disc(i,:), iter(i))
    end do
    !$omp end parallel do

    w = w / rat

  end subroutine continuous_fit

  subroutine continuous_fit_i(i, x, n, l, x_mean0, symx, cov_x, ipiv, iters, atol, rtol, impute, w, disc, iter)
    implicit none

    real*8, intent(in) :: x(n,l), x_mean0(n,l), symx(l), cov_x(n,n), atol, rtol
    integer, intent(in) :: i, n, l, iters, ipiv(n)
    logical, intent(in) :: impute
    real*8, intent(out) :: w(n), disc(iters)
    integer, intent(out) :: iter
    real*8 h(l), erf_last(l), erf_next(l)
    integer info

    w = 0
    w(i) = 1
    erf_last = erf(x(i,:)) + 1

    do iter = 1, iters

       h = matmul(w,x)

       erf_next = erf(h)

       disc(iter) = norm2(erf_next-erf_last)
       if ((disc(iter) < atol).or.(disc(iter) < norm2(erf_next)*rtol)) exit
       erf_last = erf_next

       h = h * symx / erf_next

       w = matmul(x_mean0, h) / l
       call dgetrs('N', n, 1, cov_x, n, ipiv, w, n, info)

       if (impute) w(i) = 0

    end do

    iter = iter - 1

  end subroutine continuous_fit_i

end module fortran_module

subroutine simulate_data(par, nm, pq_sum, degs, p, q, k, x_idx, pdegs_sum, n, m, p_sum, l, x)
  implicit none

  ! par: m*n by sum(pq)
  !
  ! [ par(:, ipar(1)+1:ipar(2)) -- mn by pq(1) | par(:, ipar(2)+1:ipar(3)) -- mn by pq(2) | ... ]

  ! s: sum(p) by l
  !
  ! ------------------------------------
  ! s1: s(is(1)+1:is(2), :) -- p(1) by l
  ! ------------------------------------
  ! s2: s(is(2)+1:is(3), :) -- p(2) by l
  ! ------------------------------------
  ! ...
  ! ------------------------------------

  ! real*8 par(:,:)
  ! integer x_idx(:), degs(:), q(:), p(:)

  integer nm, pq_sum
  real*8 par(nm, pq_sum)
  ! f2py intent(hide), depend(par) :: nm=shape(par,0)
  ! f2py intent(hide), depend(par) :: pq_sum=shape(par,1)
  integer k
  integer degs(k)
  integer p(k)
  integer q(k)
  ! f2py intent(hide), depend(degs) :: k=len(degs)
  integer pdegs_sum
  integer x_idx(pdegs_sum)
  ! f2py intent(hide), depend(x_idx) :: pdegs_sum=len(x_idx)
  integer n
  integer m
  integer p_sum
  integer l
  integer, intent(out) :: x(p_sum,l)

  integer deg, pq(k), i_par(k+1), i_x(k+1), i_x_idx(k+1)
  integer it, id, iv, iv1, iv2, is, jt, jv, s
  real*8 wrk(nm), randr(n, l)

  call random_seed()
  call random_number(randr)

  pq = p*q

  i_x(1) = 0
  i_par(1) = 0
  i_x_idx(1) = 0
  i_x(2:) = p
  i_par(2:) = pq
  i_x_idx(2:) = p*degs
  do id=1,k
     i_x(id+1) = i_x(id+1) + i_x(id)
     i_par(id+1) = i_par(id+1) + i_par(id)
     i_x_idx(id+1) = i_x_idx(id+1) + i_x_idx(id)
  end do

  ! random initial condition
  do iv=1,n
     x(iv,1) = 1 + mod(int((10*m+1)*randr(iv,1)), m)
  end do
  ! fill in higher order (deg > 1) states
  it = 1
  do id=1,k
     deg = degs(id)
     if (deg==1) continue
     do iv=1,p(id)
        jv = (iv-1)*deg
        s = 0
        do is=1,deg
           s = s + (x(x_idx(i_x_idx(id) + jv + is), it)-1)*m**(is-1)
        end do
        x(i_x(id) + iv, it) = s + 1
     end do
  end do

  do it=2,l ! time
     ! compute local field
     wrk = 0
     jt = it-1
     do id=1,k ! degree
        do iv=1,p(id) ! variable
           ! print*, 'col', ipar(i2)+(i3-1)*q(i2)+s(is(i2)+i3,i1-1), 'between (inclusive)', ipar(i2)+1, ipar(i2+1)
           wrk = wrk + par(:,i_par(id)+(iv-1)*q(id)+x(i_x(id)+iv, jt))
        end do
     end do
     ! sample from Boltzmann distribution
     wrk = exp(wrk)
     do iv=1,n
        iv1 = (iv-1)*m+1; iv2 = iv*m
        wrk(iv1:iv2) = wrk(iv1:iv2) / sum(wrk(iv1:iv2))
        do is=1,m-1
           wrk(iv1+is) = wrk(iv1+is) + wrk(iv1+is-1)
        end do
        is=1
        do while(wrk(iv1+is-1) < randr(iv,it))
           is = is + 1
        end do
        x(iv,it) = is
     end do

     ! fill in higher order (deg > 1) states
     do id=1,k
        deg = degs(id)
        if (deg==1) continue
        do iv=1,p(id)
           jv = (iv-1)*deg
           s = 0
           do is=1,deg
              s = s + (x(x_idx(i_x_idx(id) + jv + is), it)-1)*m**(is-1)
           end do
           x(i_x(id) + iv, it) = s + 1
        end do
     end do

  end do

end subroutine simulate_data

! subroutine power_s(i1, m, k, degs, p, pdegs_sum, sidx, isidx, is, s)
!   implicit none

!   integer m, k, pdegs_sum
!   ! integer degs(k), p(k), sidx(pdegs_sum), isidx(k+1), is(k+1), s(p_sum,l)
!   integer degs(:), p(:), sidx(:), isidx(:), is(:), s(:,:)
!   integer i1, i2, i3, i4, deg, state

!   do i2=1,k
!      deg = degs(i2)
!      if (deg==1) continue
!      do i3=1,p(i2)
!         state = 0
!         do i4=1,deg
!            state = state + (s(sidx(isidx(i2) + (i3-1)*deg + i4), i1)-1)*m**(i4-1)
!         end do
!         s(is(i2) + i3, i1) = state + 1
!      end do
!   end do
! end subroutine power_s

!/******************************************************************************
! * 
! *       ELMER, A Computational Fluid Dynamics Program.
! *
! *       Copyright 1st April 1995 - , Center for Scientific Computing,
! *                                    Finland.
! *
! *       All rights reserved. No part of this program may be used,
! *       reproduced or transmitted in any form or by any means
! *       without the written permission of CSC.
! *
! *****************************************************************************/
!
!/******************************************************************************
! *
! * Module containing a solver for the calculation of the original x_coordinate 
! *
! ******************************************************************************
! *
! *                     Author:       Juha Ruokolainen
! *
! *                    Address: Center for Scientific Computing
! *                            Tietotie 6, P.O. Box 405
! *                              02101 Espoo, Finland
! *                              Tel. +358 0 457 2723
! *                            Telefax: +358 0 457 2302
! *                          EMail: Juha.Ruokolainen@csc.fi
! *
! *                       Date: 08 Jun 1997
! *
! *                Modified by: Olivier Gagliardini
! *
! *       Date of modification: avril 2004  
! *
! *****************************************************************************/

!------------------------------------------------------------------------------
   RECURSIVE SUBROUTINE AbsDepSolver( Model,Solver,dt,TransientSimulation )
!------------------------------------------------------------------------------

      USE DefUtils

    IMPLICIT NONE
!------------------------------------------------------------------------------
!******************************************************************************
!
!  Solve a pure transport equation  (da/dt + da/dxi.ui = 0)
!
!  ARGUMENTS:
!
!  TYPE(Model_t) :: Model,  
!     INPUT: All model information (mesh,materials,BCs,etc...)
!
!  TYPE(Solver_t) :: Solver
!     INPUT: Linear equation solver options
!
!  REAL(KIND=dp) :: dt,
!     INPUT: Timestep size for time dependent simulations (NOTE: Not used
!            currently)
!
!******************************************************************************

     TYPE(Model_t)  :: Model
     TYPE(Solver_t), TARGET :: Solver

     LOGICAL ::  TransientSimulation
     REAL(KIND=dp) :: dt
!------------------------------------------------------------------------------
!    Local variables
!------------------------------------------------------------------------------
     TYPE(Solver_t), POINTER :: PSolver

     TYPE(Matrix_t),POINTER :: StiffMatrix

     INTEGER :: n1,n2,i,j,k,l,n,t,iter,NDeg,STDOFs,LocalNodes,istat

     TYPE(ValueList_t),POINTER :: Material, BC
     TYPE(Nodes_t) :: ElementNodes
     TYPE(Element_t),POINTER :: CurrentElement, Element, &
              ParentElement, LeftParent, RightParent, Edge

     REAL(KIND=dp) :: RelativeChange,UNorm,PrevUNorm,Gravity(3), &
         Tdiff,Normal(3),NewtonTol,NonlinearTol,s

     INTEGER :: NewtonIter,NonlinearIter

     TYPE(Variable_t), POINTER :: AbsDepSol,  AbsDepVariable, FlowVariable

     REAL(KIND=dp), POINTER :: AbsDepValues(:), FlowValues(:), Solution(:), Ref(:)
           

     INTEGER, POINTER :: AbsDepPerm(:),NodeIndexes(:), FlowPerm(:)
                        
     CHARACTER(LEN=MAX_NAME_LEN)  ::  FlowSolverName

     LOGICAL :: GotForceBC,GotIt,NewtonLinearization = .FALSE.

     INTEGER :: body_id,bf_id,eq_id, Indexes(128)
!
     INTEGER :: old_body = -1

     LOGICAL :: AllocationsDone = .FALSE., FreeSurface

     TYPE(Variable_t), POINTER :: TimeVar

     REAL(KIND=dp),ALLOCATABLE:: MASS(:,:),STIFF(:,:),&
       LOAD(:,:),Force(:),  Alpha(:,:),Beta(:), &
          Velocity(:,:)
             

     SAVE MASS,STIFF,LOAD, &
       Force,ElementNodes,Alpha,Beta,  AllocationsDone, &
           Velocity, old_body
!------------------------------------------------------------------------------

     REAL(KIND=dp) :: Bu,Bv,Bw,RM(3,3), SaveTime = -1
     REAL(KIND=dp), POINTER :: PrevAbsDep(:),CurrAbsDep(:)

     SAVE   PrevAbsDep, CurrAbsDep
     REAL(KIND=dp) :: at, at0, CPUTime, RealTime

!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!  Read constants from constants section of SIF file
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!    Get variables needed for solution
!------------------------------------------------------------------------------
     IF ( .NOT. ASSOCIATED( Solver % Matrix ) ) RETURN
           
     Solution => Solver % Variable % Values
     STDOFs   =  Solver % Variable % DOFs

     AbsDepSol   => VariableGet( Solver % Mesh % Variables, 'AbsDep' )
     AbsDepPerm   => AbsDepSol % Perm
     AbsDepValues => AbsDepSol % Values

!------------------------------------------------------------------------
!    Get Velocity from (Navier)-Stokes-Solver or AIFlow Solver
!------------------------------------------------------------------------
     FlowSolverName = GetString( Solver % Values, 'Flow Solver Name', GotIt )    
     IF (.NOT.Gotit) FlowSolverName = 'Flow Solution'
         
     FlowVariable => VariableGet( Solver % Mesh % Variables, FlowSolverName )
     IF ( ASSOCIATED( FlowVariable ) ) THEN
       FlowPerm    => FlowVariable % Perm
       FlowValues  => FlowVariable % Values
     ELSE
       CALL Info('DatingSolver', 'No variable for velocity associated.', Level=4)
     END IF

     StiffMatrix => Solver % Matrix
     UNorm = Solver % Variable % Norm
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
!     Allocate some permanent storage, this is done first time only
!------------------------------------------------------------------------------
     IF ( .NOT. AllocationsDone .OR. Solver % Mesh % Changed) THEN
       N = Model % MaxElementNodes

       IF ( AllocationsDone ) THEN
         DEALLOCATE (Force,     &
                     MASS,      &
                     LOAD, Alpha, Beta )
       END IF

       ALLOCATE( Force( 2*STDOFs*N ), & 
                 Velocity(4, N ), &
                 MASS( 2*STDOFs*N,2*STDOFs*N ),  &
                 STIFF( 2*STDOFs*N,2*STDOFs*N ),  &
                 LOAD( 4,N ), Alpha( 3,N ), Beta( N ),STAT=istat )


       IF ( istat /= 0 ) THEN
          CALL Fatal( 'AbsDepSolve', 'Memory allocation error.' )
       END IF

       ALLOCATE( CurrAbsDep( SIZE(Solver % Variable % Values)) )
       CurrAbsDep = 0
       IF ( TransientSimulation ) THEN
          ALLOCATE( PrevAbsDep( SIZE(Solver % Variable % Values)) )
          PrevAbsDep = 0
       END IF

       DO i=1,Solver % NumberOFActiveElements
          CurrentElement => GetActiveElement(i)   
          NodeIndexes => CurrentElement % NodeIndexes
          n = GetElementDOFs( Indexes )
          Indexes(1:n) = Solver % Variable % Perm( Indexes(1:n) )
            IF ( TransientSimulation ) THEN
               PrevAbsDep(Indexes(1:n)) = &
                        AbsDepValues(AbsDepPerm(NodeIndexes))
            END IF
            CurrAbsDep(Indexes(1:n)) = &
                        AbsDepValues(AbsDepPerm(NodeIndexes))
       END DO

       AllocationsDone = .TRUE.
     END IF

     IF( TransientSimulation ) THEN
        TimeVar => VariableGet( Solver % Mesh % Variables, 'Time' )
        IF ( SaveTime /= TimeVar % Values(1) ) THEN
           SaveTime = TimeVar % Values(1)
           PrevAbsDep = CurrAbsDep
        END IF
     END IF

!------------------------------------------------------------------------------
!    Do some additional initialization, and go for it
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
     NonlinearTol = ListGetConstReal( Solver % Values, &
        'Nonlinear System Convergence Tolerance' )

     NewtonTol = ListGetConstReal( Solver % Values, &
        'Nonlinear System Newton After Tolerance' )

     NewtonIter = ListGetInteger( Solver % Values, &
        'Nonlinear System Newton After Iterations' )

     NonlinearIter = ListGetInteger( Solver % Values, &
         'Nonlinear System Max Iterations',GotIt )

     IF ( .NOT.GotIt ) NonlinearIter = 1
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------

     old_body = -1
!------------------------------------------------------------------------------
     DO iter=1,NonlinearIter
!------------------------------------------------------------------------------
       at  = CPUTime()
       at0 = RealTime()

       CALL Info( 'AbsDepSolve', ' ', Level=4 )
       CALL Info( 'AbsDepSolve', ' ', Level=4 )
       CALL Info( 'AbsDepSolve', '-------------------------------------',Level=4 )
       WRITE( Message, * ) 'AbsDep solver  iteration', iter
       CALL Info( 'AbsDepSolve', Message,Level=4 )
       CALL Info( 'AbsDepSolve', '-------------------------------------',Level=4 )
       CALL Info( 'AbsDepSolve', ' ', Level=4 )
       CALL Info( 'AbsDepSolve', 'Starting assembly...',Level=4 )

!------------------------------------------------------------------------------


       PrevUNorm = UNorm

       Solver % Variable % Values = CurrAbsDep
       IF ( TransientSimulation ) THEN
          Solver % Variable % PrevValues(:,1) = PrevAbsDep
       END IF

       CALL DefaultInitialize()
!------------------------------------------------------------------------------
       DO t=1,Solver % NumberOFActiveElements
!------------------------------------------------------------------------------

         IF ( RealTime() - at0 > 1.0 ) THEN
           WRITE(Message,'(a,i3,a)' ) '   Assembly: ', INT(100.0 - 100.0 * &
            (Solver % NumberOfActiveElements-t) / &
               (1.0*Solver % NumberOfActiveElements)), ' % done'
                       
           CALL Info( 'AbsDepSolve', Message, Level=5 )
           at0 = RealTime()
         END IF

         CurrentElement => GetActiveElement(t)
         CALL GetElementNodes( ElementNodes )
         n = GetElementDOFs( Indexes )
         n = GetElementNOFNodes()
         NodeIndexes => CurrentElement % NodeIndexes

!------------------------------------------------------------------------------
!        Read in material constants from Material section
!------------------------------------------------------------------------------
 
!------------------------------------------------------------------------------
!        Get element local stiffness & mass matrices
!------------------------------------------------------------------------------

         k = FlowVariable % DOFs
         Velocity = 0.0d0
         DO i=1,k-1
            Velocity(i,1:n) = FlowValues(k*(FlowPerm(NodeIndexes)-1)+i)
         END DO

         CALL LocalMatrix( MASS, STIFF, FORCE, LOAD, &
              Velocity, CurrentElement, n, ElementNodes)

!------------------------------------------------------------------------------
!        Update global matrices from local matrices 
!------------------------------------------------------------------------------
         IF ( TransientSimulation )  CALL Default1stOrderTime(MASS,STIFF,FORCE)
         CALL DefaultUpdateEquations( STIFF, FORCE )
!------------------------------------------------------------------------------
      END DO
      CALL Info( 'AbsDepSolve', 'Assembly done', Level=4 )
!------------------------------------------------------------------------------
   
!------------------------------------------------------------------------------
!     Assembly of the edge terms
!------------------------------------------------------------------------------
      DO t=1,Solver % Mesh % NumberOfEdges
         Edge => Solver % Mesh % Edges(t)
         IF ( .NOT. ActiveBoundaryElement(Edge) ) CYCLE
       
         LeftParent  => Edge % BoundaryInfo % Left
         RightParent => Edge % BoundaryInfo % Right
         IF ( ASSOCIATED(RightParent) .AND. ASSOCIATED(LeftParent) ) THEN
            n  = GetElementNOFNodes( Edge )
            n1 = GetElementNOFNodes( LeftParent )
            n2 = GetElementNOFNodes( RightParent )

            k = FlowVariable % DOFs
            Velocity = 0.0d0
            DO i=1,k-1
               Velocity(i,1:n) = FlowValues(k*(FlowPerm(Edge % NodeIndexes)-1)+i)
            END DO

            FORCE = 0.0d0
            MASS  = 0.0d0
            CALL LocalJumps( STIFF,Edge,n,LeftParent,n1,RightParent,n2,Velocity )
            IF ( TransientSimulation )  CALL Default1stOrderTime(MASS, STIFF, FORCE)
            CALL DefaultUpdateEquations( STIFF, FORCE, Edge )
         END IF
      END DO

!------------------------------------------------------------------------------
!     Loop over the boundary elements
!------------------------------------------------------------------------------
      DO t = 1, Solver % Mesh % NumberOfBoundaryElements
!------------------------------------------------------------------------------

         Element => GetBoundaryElement(t)
         IF( .NOT. ActiveBoundaryElement() )  CYCLE
         IF( GetElementFamily(Element) == 1 ) CYCLE

         ParentElement => Element % BoundaryInfo % Left
         IF ( .NOT. ASSOCIATED( ParentElement ) ) &
            ParentElement => Element % BoundaryInfo % Right
          
         n  = GetElementNOFNodes( Element )
         n1 = GetElementNOFnodes( ParentElement )
       
         k = FlowVariable % DOFs
         Velocity = 0.0d0
         DO i=1,k-1
            Velocity(i,1:n) = FlowValues(k*(FlowPerm(Element % NodeIndexes)-1)+i)
         END DO

         BC => GetBC()
         LOAD = 0.0d0
         GotIt = .FALSE.
         IF ( ASSOCIATED(BC) ) THEN
            LOAD(1,1:n) = GetReal( BC, 'AbsDep' , GotIt )
         END IF

         MASS = 0.0d0
         CALL LocalMatrixBoundary(  STIFF, FORCE, LOAD(1,1:n), &
                              Element, n, ParentElement, n1, Velocity, GotIt )

         IF ( TransientSimulation )  CALL Default1stOrderTime(MASS, STIFF, FORCE)
         CALL DefaultUpdateEquations( STIFF, FORCE )
      END DO

      CALL DefaultFinishAssembly()
!------------------------------------------------------------------------------
      CALL Info( 'AbsDepSolve', 'Set boundaries done', Level=4 )

!------------------------------------------------------------------------------
!     Solve the system and check for convergence
!------------------------------------------------------------------------------
      Unorm = DefaultSolve()
      CurrAbsDep = Solver % Variable % Values
      WRITE(Message,*) 'solve done', minval( solver % variable % values), maxval( Solver % variable % values)
      CALL Info( 'FabricSolve', Message, Level=4 )

      n1 = Solver % Mesh % NumberOfNodes
      ALLOCATE( Ref(n1) )
      Ref = 0.
      AbsDepValues = 0.
      DO t=1,Solver % NumberOfActiveElements
         Element => GetActiveElement(t) 
         n = GetElementDOFs( Indexes )
         n = GetElementNOFNodes()
         DO i=1,n
            k = Element % NodeIndexes(i)
            AbsDepValues( AbsDepPerm(k) ) =    & 
               AbsDepValues( AbsDepPerm(k) ) + &
                  Solver % Variable % Values( Solver % Variable % Perm(Indexes(i)) )
            Ref(k) = Ref(k) + 1
         END DO
      END DO

      DO i=1,n1
         j = AbsDepPerm(i)
         IF (j < 1) CYCLE
         IF ( Ref(i) > 0 ) THEN
            AbsDepValues( AbsDepPerm(i) ) = &
                AbsDepValues( AbsDepPerm(i) ) / Ref(i)
         END IF
      END DO

      
      DEALLOCATE( Ref )

      Unorm = SQRT( SUM( AbsDepValues**2 ) / SIZE(AbsDepValues) )

      IF ( PrevUNorm + UNorm /= 0.0d0 ) THEN
         RelativeChange = 2.0d0 * ABS( PrevUNorm - UNorm) / ( PrevUnorm + UNorm)
      ELSE
         RelativeChange = 0.0d0
      END IF

      WRITE( Message, * ) 'Result Norm   : ',UNorm
      CALL Info( 'AbsDepSolve', Message, Level=4 )
      WRITE( Message, * ) 'Relative Change : ',RelativeChange
      CALL Info( 'AbsDepSolve', Message, Level=4 )
!------------------------------------------------------------------------------
      IF ( RelativeChange < NewtonTol .OR. &
            iter > NewtonIter ) NewtonLinearization = .TRUE.

      IF ( RelativeChange < NonLinearTol ) EXIT
!------------------------------------------------------------------------------
    END DO ! of nonlinear iter
!------------------------------------------------------------------------------

CONTAINS


!------------------------------------------------------------------------------
   SUBROUTINE LocalMatrix(  MASS, STIFF, FORCE, LOAD, &
                            NodalVelo,  Element, n, Nodes )
          
!------------------------------------------------------------------------------

     REAL(KIND=dp) :: STIFF(:,:),MASS(:,:)
     REAL(KIND=dp) :: LOAD(:,:), NodalVelo(:,:)
     REAL(KIND=dp), DIMENSION(:) :: FORCE

     TYPE(Nodes_t) :: Nodes
     TYPE(Element_t) :: Element

     INTEGER :: n
!------------------------------------------------------------------------------
!
     REAL(KIND=dp) :: Basis(2*n),ddBasisddx(1,1,1)
     REAL(KIND=dp) :: dBasisdx(2*n,3),SqrtElementMetric

     REAL(KIND=dp) :: A,M, hK,tau,pe1,pe2,unorm,C0, SU(n), SW(n)
     REAL(KIND=dp) :: LoadAtIp,  Grad(3,3)

     INTEGER :: i,j,k,p,q,t,dim,NBasis,ind(3), DOFs = 1

     REAL(KIND=dp) :: s,u,v,w, Radius, B(6,3), G(3,6)
     REAL(KIND=dp) :: Velo(3)
  
     INTEGER :: N_Integ
     REAL(KIND=dp), DIMENSION(:), POINTER :: U_Integ,V_Integ,W_Integ,S_Integ

     LOGICAL :: stat, CSymmetry
     TYPE(GaussIntegrationPoints_t), TARGET :: IntegStuff

!------------------------------------------------------------------------------
     dim = CoordinateSystemDimension()

     FORCE = 0.0D0
     MASS  = 0.0D0
     STIFF = 0.0D0
!    
!    Integration stuff:
!    ------------------
     NBasis = n
     IntegStuff = GaussPoints( Element  )

          
     U_Integ => IntegStuff % u
     V_Integ => IntegStuff % v
     W_Integ => IntegStuff % w
     S_Integ => IntegStuff % s
     N_Integ =  IntegStuff % n

     hk = ElementDiameter( Element, Nodes )
!
!   Now we start integrating:
!   -------------------------
    DO t=1,N_Integ

      u = U_Integ(t)
      v = V_Integ(t)
      w = W_Integ(t)

!------------------------------------------------------------------------------
!     Basis function values & derivatives at the integration point
!------------------------------------------------------------------------------
      stat = ElementInfo( Element,Nodes,u,v,w,SqrtElementMetric, &
               Basis, dBasisdx, ddBasisddx, .FALSE. )

      s = SqrtElementMetric * S_Integ(t)
!------------------------------------------------------------------------------
!
      Velo = 0.0d0
      DO i=1,dim
         Velo(i) = SUM( Basis(1:n) * NodalVelo(i,1:n) )
      END DO
      Unorm = SQRT( SUM( Velo**2 ) )

!
!     Reaction coefficient:
!     ---------------------
        C0 = 0.0                        

!     Loop over basis functions (of both unknowns and weights):
!     ---------------------------------------------------------
      DO p=1,NBasis
         DO q=1,NBasis
            A = 0.0d0
            M = Basis(p) * Basis(q)
!
!           Reaction terms:
!           ---------------
            A = A - C0 * Basis(q) * Basis(p)

            !
            ! Advection terms:
            ! ----------------
            DO j=1,dim
               A = A - Velo(j) * Basis(q) * dBasisdx(p,j)
            END DO

!           Add nodal matrix to element matrix:
!           -----------------------------------
            MASS( p,q )  = MASS( p,q )  + s * M
            STIFF( p,q ) = STIFF( p,q ) + s * A
         END DO

!
!        The righthand side...:
!        ----------------------
         LoadAtIp = 0.0

         FORCE(p) = FORCE(p) + s*LoadAtIp

      END DO
   END DO 
!------------------------------------------------------------------------------
 END SUBROUTINE LocalMatrix
!------------------------------------------------------------------------------



!------------------------------------------------------------------------------
    SUBROUTINE FindParentUVW( Edge, nEdge, Parent, nParent, U, V, W, Basis )
!------------------------------------------------------------------------------
      IMPLICIT NONE
      TYPE(Element_t), POINTER :: Edge, Parent
      INTEGER :: nEdge, nParent
      REAL( KIND=dp ) :: U, V, W, Basis(:)
!------------------------------------------------------------------------------
      INTEGER :: i, j,l
      REAL(KIND=dp) :: NodalParentU(nEdge),NodalParentV(nEdge),NodalParentW(nEdge)
!------------------------------------------------------------------------------
      DO i = 1,nEdge
        DO j = 1,nParent
          IF ( Edge % NodeIndexes(i) == Parent % NodeIndexes(j) ) THEN
            NodalParentU(i) = Parent % Type % NodeU(j)
            NodalParentV(i) = Parent % Type % NodeV(j)
            NodalParentW(i) = Parent % Type % NodeW(j)
            EXIT
          END IF
        END DO
      END DO
      U = SUM( Basis(1:nEdge) * NodalParentU(1:nEdge) )
      V = SUM( Basis(1:nEdge) * NodalParentV(1:nEdge) )
      W = SUM( Basis(1:nEdge) * NodalParentW(1:nEdge) )
!------------------------------------------------------------------------------      
    END SUBROUTINE FindParentUVW
!------------------------------------------------------------------------------      


!------------------------------------------------------------------------------
    SUBROUTINE LocalJumps( STIFF,Edge,n,LeftParent,n1,RightParent,n2,Velo )
!------------------------------------------------------------------------------
      REAL(KIND=dp) :: STIFF(:,:), Velo(:,:)
      INTEGER :: n,n1,n2
      TYPE(Element_t), POINTER :: Edge, LeftParent, RightParent
!------------------------------------------------------------------------------
      REAL(KIND=dp) :: EdgeBasis(n), EdgedBasisdx(n,3), EdgeddBasisddx(n,3,3)
      REAL(KIND=dp) :: LeftBasis(n1), LeftdBasisdx(n1,3), LeftddBasisddx(n1,3,3)
      REAL(KIND=dp) :: RightBasis(n2), RightdBasisdx(n2,3), RightddBasisddx(n2,3,3)
      REAL(KIND=dp) :: Jump(n1+n2), Average(n1+n2)
      REAL(KIND=dp) :: detJ, U, V, W, S, Udotn, xx, yy
      LOGICAL :: Stat
      INTEGER :: i, j, p, q, dim, t, nEdge, nParent
      TYPE(GaussIntegrationPoints_t) :: IntegStuff
      REAL(KIND=dp) :: hE, Normal(3), cu(3), LeftOut(3)

      TYPE(Nodes_t) :: EdgeNodes, LeftParentNodes, RightParentNodes
!------------------------------------------------------------------------------
      dim = CoordinateSystemDimension()
      STIFF = 0.0d0

      CALL GetElementNodes( EdgeNodes, Edge )
      CALL GetElementNodes( LeftParentNodes,  LeftParent )
      CALL GetElementNodes( RightParentNodes, RightParent )
!------------------------------------------------------------------------------
!     Numerical integration over the edge
!------------------------------------------------------------------------------
      IntegStuff = GaussPoints( Edge )

      LeftOut(1) = SUM( LeftParentNodes % x(1:n1) ) / n1
      LeftOut(2) = SUM( LeftParentNodes % y(1:n1) ) / n1
      LeftOut(3) = SUM( LeftParentNodes % z(1:n1) ) / n1
      LeftOut(1) = SUM( EdgeNodes % x(1:n) ) / n - LeftOut(1)
      LeftOut(2) = SUM( EdgeNodes % y(1:n) ) / n - LeftOut(2)
      LeftOut(3) = SUM( EdgeNodes % z(1:n) ) / n - LeftOut(3)

      DO t=1,IntegStuff % n
        U = IntegStuff % u(t)
        V = IntegStuff % v(t)
        W = IntegStuff % w(t)
        S = IntegStuff % s(t)

        ! Basis function values & derivatives at the integration point:
        !--------------------------------------------------------------
        stat = ElementInfo( Edge, EdgeNodes, U, V, W, detJ, &
             EdgeBasis, EdgedBasisdx, EdgeddBasisddx, .FALSE. )

        S = S * detJ

        Normal = NormalVector( Edge, EdgeNodes, U, V, .FALSE. )
        IF ( SUM( LeftOut*Normal ) < 0 ) Normal = -Normal

        ! Find basis functions for the parent elements:
        ! ---------------------------------------------
        CALL FindParentUVW( Edge,n,LeftParent,n1,U,V,W,EdgeBasis )
        stat = ElementInfo( LeftParent, LeftParentNodes, U, V, W, detJ, &
                LeftBasis, LeftdBasisdx, LeftddBasisddx, .FALSE. )

        CALL FindParentUVW( Edge,n,RightParent,n2,U,V,W,EdgeBasis )
        stat = ElementInfo( RightParent, RightParentNodes, U, V, W, detJ, &
              RightBasis, RightdBasisdx, RightddBasisddx, .FALSE. )

        ! Integrate jump terms:
        ! ---------------------
        Jump(1:n1) = LeftBasis(1:n1)
        Jump(n1+1:n1+n2) = -RightBasis(1:n2)

        Average(1:n1) = LeftBasis(1:n1) / 2
        Average(n1+1:n1+n2) = RightBasis(1:n2) / 2

        cu = 0.0d0
        DO i=1,dim
          cu(i) = SUM( Velo(i,1:n) * EdgeBasis(1:n) )
        END DO
        Udotn = SUM( Normal * cu )

        DO p=1,n1+n2
          DO q=1,n1+n2
            STIFF(p,q) = STIFF(p,q) + s * Udotn * Average(q) * Jump(p)
            STIFF(p,q) = STIFF(p,q) + s * ABS(Udotn)/2 * Jump(q) * Jump(p)
          END DO
        END DO
     END DO
!------------------------------------------------------------------------------
   END SUBROUTINE LocalJumps
!------------------------------------------------------------------------------



!------------------------------------------------------------------------------
   SUBROUTINE LocalMatrixBoundary( STIFF, FORCE, LOAD, &
        Element, n, ParentElement, np, Velo, InFlowBC )
!------------------------------------------------------------------------------
     REAL(KIND=dp) :: STIFF(:,:),  FORCE(:), LOAD(:), Velo(:,:)
     INTEGER :: n, np
     LOGICAL :: InFlowBC
     TYPE(Element_t), POINTER :: Element, ParentElement
!------------------------------------------------------------------------------
     REAL(KIND=dp) :: Basis(n), dBasisdx(n,3), ddBasisddx(n,3,3)
     REAL(KIND=dp) :: ParentBasis(np), ParentdBasisdx(np,3), ParentddBasisddx(np,3,3)
     INTEGER :: i,j,p,q,t,dim

     REAL(KIND=dp) :: Normal(3), g, L, Udotn, UdotnA, cu(3), detJ,U,V,W,S
     LOGICAL :: Stat
     TYPE(GaussIntegrationPoints_t) :: IntegStuff

     TYPE(Nodes_t) :: Nodes, ParentNodes
     SAVE Nodes, ParentNodes
!------------------------------------------------------------------------------
     dim = CoordinateSystemDimension()
     FORCE = 0.0d0
     STIFF = 0.0d0

     CALL GetElementNodes( Nodes, Element )
     CALL GetElementNodes( ParentNodes, ParentElement )

     ! Numerical integration:
     !-----------------------
     IntegStuff = GaussPoints( Element )
!
! Compute the average velocity.dot.Normal        
!        
     UdotnA = 0.0   
     DO t=1,IntegStuff % n
       U = IntegStuff % u(t)
       V = IntegStuff % v(t)
       W = IntegStuff % w(t)
       S = IntegStuff % s(t)

       Normal = NormalVector( Element, Nodes, U, V, .TRUE. ) 

       ! Basis function values & derivatives at the integration point:
       ! -------------------------------------------------------------
       stat = ElementInfo( Element, Nodes, U, V, W, detJ, &
               Basis, dBasisdx, ddBasisddx, .FALSE. )
       S = S * detJ
       cu = 0.0d0
       DO i=1,dim
          cu(i) = SUM( Velo(i,1:n) * Basis(1:n) )
       END DO
       UdotnA = UdotnA + s*SUM( Normal * cu )

     END DO


     DO t=1,IntegStuff % n
       U = IntegStuff % u(t)
       V = IntegStuff % v(t)
       W = IntegStuff % w(t)
       S = IntegStuff % s(t)

       Normal = NormalVector( Element, Nodes, U, V, .TRUE. ) 

       ! Basis function values & derivatives at the integration point:
       ! -------------------------------------------------------------
       stat = ElementInfo( Element, Nodes, U, V, W, detJ, &
               Basis, dBasisdx, ddBasisddx, .FALSE. )
       S = S * detJ

       CALL FindParentUVW( Element, n, ParentElement, np, U, V, W, Basis )
       stat = ElementInfo( ParentElement, ParentNodes, U, V, W, &
           detJ,  ParentBasis, ParentdBasisdx, ParentddBasisddx, .FALSE. )

       L = SUM( LOAD(1:n) * Basis(1:n) )
       cu = 0.0d0
       DO i=1,dim
          cu(i) = SUM( Velo(i,1:n) * Basis(1:n) )
       END DO
       Udotn = SUM( Normal * cu )


       DO p = 1,np
!       IF ( InFlowBC ) THEN
        IF (InFlowBC .And. (UdotnA < 0.0) ) THEN
            FORCE(p) = FORCE(p) - s * Udotn*L*ParentBasis(p)
         ELSE
           DO q=1,np
             STIFF(p,q) = STIFF(p,q) + s*Udotn*ParentBasis(q)*ParentBasis(p)
           END DO
         END IF
       END DO
     END DO
!------------------------------------------------------------------------------
   END SUBROUTINE LocalMatrixBoundary
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
 END SUBROUTINE AbsDepSolver
!------------------------------------------------------------------------------

SUBROUTINE VelocitySolver( Model,Solver,dt,TransientSimulation )
!DEC$ATTRIBUTES DLLEXPORT :: VelocitySolver
!------------------------------------------------------------------------------
!******************************************************************************
!
! A Navier-Stokes solver with pressure projection, the velocity part
!
!  15/12/2003, Juha
!
!  ARGUMENTS:
!
!  TYPE(Model_t) :: Model,  
!     INPUT: All model information (mesh, materials, BCs, etc...)
!
!  TYPE(Solver_t) :: Solver
!     INPUT: Linear & nonlinear equation solver options
!
!  REAL(KIND=dp) :: dt,
!     INPUT: Timestep size for time dependent simulations
!
!  LOGICAL :: TransientSimulation
!     INPUT: Steady state or transient simulation
!
!******************************************************************************
  USE DefUtils

  IMPLICIT NONE
!------------------------------------------------------------------------------
  TYPE(Solver_t) :: Solver
  TYPE(Model_t) :: Model

  REAL(KIND=dp) :: dt
  LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
! Local variables
!------------------------------------------------------------------------------
  LOGICAL :: AllocationsDone = .FALSE., Newton = .FALSE., Found, Convect
  TYPE(Element_t),POINTER :: Element

  INTEGER :: i,j,k,n, nb, nd, t, istat, dim, active
  REAL(KIND=dp) :: Norm = 0, PrevNorm, RelC

  TYPE(ValueList_t), POINTER :: BodyForce, Material
  TYPE(Mesh_t), POINTER :: Mesh
  REAL(KIND=dp), ALLOCATABLE :: STIFF(:,:), LOAD(:,:), &
            FORCE(:), rho(:), mu(:), Velocity(:,:), Pressure(:)

  SAVE STIFF, LOAD, FORCE, rho, mu, Velocity, Pressure, AllocationsDone
!------------------------------------------------------------------------------

  dim = CoordinateSystemDimension()
  Mesh => GetMesh()

  !Allocate some permanent storage, this is done first time only:
  !--------------------------------------------------------------
  IF ( .NOT. AllocationsDone ) THEN
     n = (dim+1)*Mesh % MaxElementDOFs  ! just big enough for elemental arrays
     ALLOCATE( FORCE(n), LOAD(n,4), STIFF(n,n), &
         rho(n), mu(n), Velocity(dim,n), Pressure(n), STAT=istat )
     IF ( istat /= 0 ) THEN
        CALL Fatal( 'StokesSolve', 'Memory allocation error.' )
     END IF
     AllocationsDone = .TRUE.
  END IF

  Convect = GetLogical( GetSolverParams(), 'Convect', Found )
  IF ( .NOT. Found ) Convect = .TRUE.

  Velocity = 0.0d0

  !Initialize the system and do the assembly:
  !------------------------------------------
  active = GetNOFActive()
  CALL DefaultInitialize()
  DO t=1,active
     Element => GetActiveElement(t)
     n  = GetElementNOFNodes()
     nd = GetElementNOFDOFs()
     nb = GetElementNOFBDOFs()

     ! Get volume forces, if any:
     !---------------------------
     BodyForce => GetBodyForce()
     LOAD = 0.0d0
     IF ( ASSOCIATED(BodyForce) ) THEN
        Load(1:n,1) = GetReal( BodyForce, 'Source x', Found )
        Load(1:n,2) = GetReal( BodyForce, 'Source y', Found )
        Load(1:n,3) = GetReal( BodyForce, 'Source z', Found )
     END IF

     ! Get material paremeters:
     !-------------------------
     Material => GetMaterial()
     rho(1:n) = GetReal( Material, 'Density' )
     mu(1:n)  = GetReal( Material, 'Viscosity' )

     ! Get previous elementwise solution vectors:
     !-------------------------------------------
     IF ( Convect ) CALL GetVectorLocalSolution( Velocity )
     CALL GetScalarLocalSolution( Pressure, 'PressureTot' )

     ! Get element local matrix and rhs vector:
     !-----------------------------------------
     CALL LocalMatrix(  STIFF, FORCE, LOAD, rho, &
         mu,  Velocity, Pressure, Element, n, nd, nd+nb, dim )
     IF ( nb>0 ) CALL LCondensate( nd, nb, dim, STIFF, FORCE )

     ! Update global matrix and rhs vector from local matrix & vector:
     !----------------------------------------------------------------
     CALL DefaultUpdateEquations( STIFF, FORCE )
  END DO
  CALL DefaultFinishAssembly()
  CALL DefaultDirichletBCs()

  ! Finally solve the system:
  !--------------------------
  PrevNorm = Norm
  Norm = DefaultSolve()
  RELC = 2.0d0 * ABS(PrevNorm - Norm) / (PrevNorm + Norm)
  IF ( RELC < 1.0d-2 ) Newton = .TRUE.

CONTAINS

!------------------------------------------------------------------------------
  SUBROUTINE LocalMatrix(  STIFF, FORCE, LOAD, Nodalrho, &
     Nodalmu, NodalVelo, NodalPressure, Element, n, nd, ntot, dim )
!------------------------------------------------------------------------------
    REAL(KIND=dp), TARGET :: STIFF(:,:), FORCE(:), LOAD(:,:)
    REAL(KIND=dp) :: Nodalmu(:), Nodalrho(:), NodalVelo(:,:), NodalPressure(:)
    INTEGER :: dim, n, nd, ntot
    TYPE(Element_t), POINTER :: Element
!------------------------------------------------------------------------------
    REAL(KIND=dp) :: Basis(ntot),dBasisdx(ntot,3), &
               DetJ,LoadAtIP(dim),Velo(dim), Grad(dim,dim), Pressure
    REAL(KIND=dp), POINTER :: A(:,:), F(:)
    LOGICAL :: Stat
    INTEGER :: t, i, j, k, l, p, q
    TYPE(GaussIntegrationPoints_t) :: IP

    REAL(KIND=dp) :: mu = 1.0d0, rho = 1.0d0, s, c

    TYPE(Nodes_t) :: Nodes
    SAVE Nodes
!------------------------------------------------------------------------------
    CALL GetElementNodes( Nodes )
    STIFF = 0.0d0
    FORCE = 0.0d0

    !Numerical integration:
    !----------------------
    IP = GaussPoints( Element,ntot )
    DO t=1,IP % n
      ! Basis function values & derivatives at the integration point:
      !--------------------------------------------------------------
      stat = ElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
       IP % W(t),  detJ, Basis, dBasisdx )

      s = IP % s(t) * detJ

      ! Material parameters at the integration point:
      !----------------------------------------------
      mu  = SUM( Basis(1:n) * Nodalmu(1:n) )
      rho = SUM( Basis(1:n) * Nodalrho(1:n) )

      ! Previous velocity & pressure at the integration point:
      !-------------------------------------------------------
      Pressure = SUM( NodalPressure(1:nd) * Basis(1:nd) )
      Velo = MATMUL( NodalVelo(1:dim,1:nd), Basis(1:nd) )
      Grad = MATMUL( NodalVelo(1:dim,1:nd), dBasisdx(1:nd,1:dim) )

      ! The source term at the integration point:
      !------------------------------------------
      LoadAtIP = MATMUL( Basis(1:n), LOAD(1:n,1:dim) )
      IF ( Newton ) THEN
        LoadAtIp = LoadAtIp + rho * MATMUL(Grad,Velo)
      END IF

      ! Finally, the elemental matrix & vector:
      !----------------------------------------
      DO p=1,ntot
        DO q=1,ntot
          i = (dim) * (p-1)
          j = (dim) * (q-1)
          A => STIFF(i+1:i+dim,j+1:j+dim)
          DO i=1,dim
            DO j = 1,dim
              A(i,i) = A(i,i) + s * mu * dBasisdx(q,j) * dBasisdx(p,j)
              A(i,j) = A(i,j) + s * mu * dBasisdx(q,i) * dBasisdx(p,j)
              A(i,i) = A(i,i) + s * rho * Velo(j) * dBasisdx(q,j) * Basis(p)
              IF ( Newton ) THEN
                 A(i,j) = A(i,j) + s * rho * Grad(i,j) * Basis(q) * Basis(p)
              END IF
            END DO
          END DO
        END DO

        i = (dim) * (p-1)
        F => FORCE(i+1:i+dim)
        F(1:dim) = F(1:dim) +  &
            s * ( LoadAtIP * Basis(p) + Pressure * dBasisdx(p,1:dim) )
      END DO
    END DO
!------------------------------------------------------------------------------
  END SUBROUTINE LocalMatrix
!------------------------------------------------------------------------------


!------------------------------------------------------------------------------
    SUBROUTINE LCondensate( N, nb, dim, K, F )
!------------------------------------------------------------------------------
      USE LinearAlgebra
      INTEGER :: N, nb, dim
      REAL(KIND=dp) :: K(:,:),F(:), Kbb(Nb*dim,Nb*dim), &
       Kbl(nb*dim,n*(dim)),Klb(n*(dim),nb*dim),Fb(nb*dim)

      INTEGER :: m, i, j, l, p, Cdofs((dim)*n), Bdofs(dim*nb)

      m = 0
      DO p = 1,n
        DO i = 1,dim
          m = m + 1
          Cdofs(m) = (dim)*(p-1) + i
        END DO
      END DO
      
      m = 0
      DO p = 1,nb
        DO i = 1,dim
          m = m + 1
          Bdofs(m) = (dim)*(p-1) + i + n*(dim)
        END DO
      END DO

      Kbb = K(Bdofs,Bdofs)
      Kbl = K(Bdofs,Cdofs)
      Klb = K(Cdofs,Bdofs)
      Fb  = F(Bdofs)

      CALL InvertMatrix( Kbb,Nb*dim )

      F(1:(dim)*n) = F(1:(dim)*n) - MATMUL( Klb, MATMUL( Kbb, Fb ) )
      K(1:(dim)*n,1:(dim)*n) = &
           K(1:(dim)*n,1:(dim)*n) - MATMUL( Klb, MATMUL( Kbb,Kbl ) )
!------------------------------------------------------------------------------
    END SUBROUTINE LCondensate
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
END SUBROUTINE VelocitySolver
!------------------------------------------------------------------------------

!/******************************************************************************
! *
! *       ELMER, A Computational Fluid Dynamics Program.
! *
! *       Copyright 1st April 1995 - , Center for Scientific Computing,
! *                                    Finland.
! *
! *       All rights reserved. No part of this program may be used,
! *       reproduced or transmitted in any form or by any means
! *       without the written permission of CSC.
! *
! *****************************************************************************/
!
!/******************************************************************************
! *
! ******************************************************************************
! *
! *                    Author:       Juha Ruokolainen
! *
! *                    Address: Center for Scientific Computing
! *                                Tietotie 6, P.O. BOX 405
! *                                  02101 Espoo, Finland
! *                                  Tel. +358 0 457 2723
! *                                Telefax: +358 0 457 2302
! *                              EMail: Juha.Ruokolainen@csc.fi
! *
! *                       Date: 08 Jun 1997
! *
! *                Modified by: Mikko, Juha
! *
! *       Date of modification: 08 Apr 2004
! *
! *****************************************************************************/
 
!------------------------------------------------------------------------------
  RECURSIVE SUBROUTINE AdvReactSolver( Model,Solver,dt,Transient )
!DEC$ATTRIBUTES DLLEXPORT :: AdvReactSolver
!------------------------------------------------------------------------------
!******************************************************************************
!
! Solves the advection-reaction equation with discontinous Galerkin method!
!
!  ARGUMENTS:
!
!  TYPE(Model_t) :: Model,  
!     INPUT: All model information (mesh, materials, BCs, etc...)
!
!  TYPE(Solver_t) :: Solver
!     INPUT: Linear equation solver options
!
!  DOUBLE PRECISION :: dt,
!     INPUT: Timestep size for time dependent simulations
!
!  LOGICAL :: Transient
!     INPUT: Steady state or transient simulation
!
!******************************************************************************
     USE DefUtils

     IMPLICIT NONE
!------------------------------------------------------------------------------
     TYPE(Model_t) :: Model
     TYPE(Solver_t), TARGET :: Solver
     REAL(KIND=dp) :: dt
     LOGICAL :: Transient
!------------------------------------------------------------------------------
!    Local variables
!------------------------------------------------------------------------------
     TYPE(ValueList_t), POINTER :: BC, BodyForce, Material

     TYPE(Element_t), POINTER :: Element, Face, &
       ParentElement, LeftParent, RightParent

     LOGICAL :: AllocationsDone = .FALSE., Found, Stat
     INTEGER :: Active
     INTEGER :: n1,n2, k, n, t, istat, i, j, NumberOfFAces, Indexes(128)
     REAL(KIND=dp) :: Norm, at, st, CPUTime
     REAL(KIND=dp), ALLOCATABLE :: MASS(:,:), STIFF(:,:), LOAD(:), &
              FORCE(:), Velo(:,:), Gamma(:), Ref(:)

     TYPE(Mesh_t), POINTER :: Mesh
     TYPE(Variable_t), POINTER ::  Var
     SAVE MASS, STIFF, LOAD, FORCE, Velo, Gamma, AllocationsDone
!*******************************************************************************

     TYPE( Element_t ), POINTER :: Faces(:)
     TYPE(Nodes_t) :: ElementNodes

     INTEGER :: DOFs
!*******************************************************************************
     Mesh => GetMesh()

     IF ( CoordinateSystemDimension() == 2 ) THEN
        Faces => Mesh % Edges
        NumberOfFaces = Mesh % NumberOfEdges
     ELSE
        Faces => Mesh % Faces
        NumberOfFaces = Mesh % NumberOfFaces
     END IF

     ! Initialize & allocate some permanent storage, this is done first time only:
     !----------------------------------------------------------------------------
     IF ( .NOT. AllocationsDone ) THEN
        N = 2 * MAX(Mesh % MaxElementDOFs, Mesh % MaxElementNodes )
        ALLOCATE( FORCE(N), MASS(n,n), STIFF(N,N), LOAD(N),  &
                  Velo(3,N), Gamma(n), STAT = istat )
        
       IF ( istat /= 0 ) CALL FATAL('AdvReactDG','Memory allocation error.' )
       AllocationsDone = .TRUE.
     END IF

     ! Assembly of the bulk elements:
     !-------------------------------
     Active = GetNOFActive()
     at = CPUTime()
     CALL DefaultInitialize()
     DO t = 1, Active
        Element => GetActiveElement( t ) 
        n = GetElementNOfNodes( Element )
        
        BodyForce => GetBodyForce( Element )
        LOAD(1:n) = GetReal( BodyForce, 'Source', Found )
        
        Material => GetMaterial()
        Velo(1,1:n) = GetReal( Material, 'u 1', Found )
        Velo(2,1:n) = GetReal( Material, 'u 2', Found )
        Velo(3,1:n) = GetReal( Material, 'u 3', Found )
        Gamma(1:n)  = GetReal( Material, 'Gamma', Found )

        CALL LocalMatrix( MASS, STIFF, FORCE, LOAD, Velo, Gamma, Element, n ) 
        IF ( Transient ) CALL Default1stOrderTime( MASS, STIFF, FORCE )
        CALL DefaultUpdateEquations( STIFF, FORCE )
     END DO

     ! Assembly of the face terms:
     !----------------------------
     FORCE = 0.0d0
     DO t=1,NumberOfFaces
        Face => Faces(t)
        IF ( .NOT. ActiveBoundaryElement(Face) ) CYCLE
      
        LeftParent  => Face % BoundaryInfo % Left
        RightParent => Face % BoundaryInfo % Right
        IF ( ASSOCIATED(RightParent) .AND. ASSOCIATED(LeftParent) ) THEN
          n  = GetElementNOFNodes( Face )
          n1 = GetElementNOFNodes( LeftParent )
          n2 = GetElementNOFNodes( RightParent )

          Material => GetMaterial( LeftParent )
          Velo(1,1:n) = GetReal( Material, 'u 1', Found, Face )
          Velo(2,1:n) = GetReal( Material, 'u 2', Found, Face )
          Velo(3,1:n) = GetReal( Material, 'u 3', Found, Face )

          CALL LocalJumps( STIFF,Face,n,LeftParent,n1,RightParent,n2,Velo )
          CALL DefaultUpdateEquations( STIFF, FORCE, Face )
        END IF
     END DO

     ! Loop over the boundary elements:
     !---------------------------------
     DO t=1,Mesh % NumberOfBoundaryElements
       Element => GetBoundaryElement(t)
       IF( .NOT. ActiveBoundaryElement() )  CYCLE
       IF( GetElementFamily(Element) == 1 ) CYCLE

       ParentElement => Element % BoundaryInfo % Left
       IF ( .NOT. ASSOCIATED( ParentElement ) ) &
         ParentElement => Element % BoundaryInfo % Right
        
       n  = GetElementNOFNodes( Element )
       n1 = GetElementNOFnodes( ParentElement )
      
       Material => GetMaterial( ParentElement )
       Velo(1,1:n) = GetReal( Material, 'u 1', Found )
       Velo(2,1:n) = GetReal( Material, 'u 2', Found )
       Velo(3,1:n) = GetReal( Material, 'u 3', Found )

       BC => GetBC()
       LOAD = 0.0d0
       Found = .FALSE.
       IF ( ASSOCIATED(BC) ) THEN
         LOAD(1:n) = GetReal( BC, Solver % Variable % Name, Found )
       END IF

       MASS = 0.0d0
       CALL LocalMatrixBoundary(  STIFF, FORCE, LOAD, &
         Element, n, ParentElement, n1, Velo, Found )

       IF ( Transient ) CALL Default1stOrderTime( MASS, STIFF, FORCE )
       CALL DefaultUpdateEquations( STIFF, FORCE )
     END DO

     CALL DefaultFinishAssembly()

     ! Solve the system:
     !------------------
     Norm = DefaultSolve()

     ! Average the elemental results to nodal values:
     !-----------------------------------------------
     Var => VariableGet( Mesh % Variables, 'Nodal Result' )
     IF ( ASSOCIATED( Var ) ) THEN
       n1 = Mesh % NumberOfNodes
       ALLOCATE( Ref(n1) )
       Ref = 0

       IF ( ASSOCIATED( Var % Perm, Solver % Variable % Perm ) ) THEN
         ALLOCATE( Var % Perm(SIZE(Solver % Variable % Perm))  )
         Var % Perm = 0
         DO i = 1,n1
            Var % Perm(i) = i
         END DO
       END IF

       Var % Values = 0.0d0
       DO t=1,Active
          Element => GetActiveElement(t) 
          n = GetElementDOFs( Indexes )
          n = GetElementNOFNodes()
          DO i=1,n
             k = Element % NodeIndexes(i)
             Var % Values(k) = Var % Values(k) + &
               Solver % Variable % Values( Solver % Variable % Perm(Indexes(i)) )
             Ref(k) = Ref(k) + 1
          END DO
       END DO

       WHERE( Ref > 0 )
         Var % Values(1:n1) = Var % Values(1:n1) / Ref
       END WHERE
       DEALLOCATE( Ref )
     END IF

   CONTAINS

!------------------------------------------------------------------------------      
     SUBROUTINE LocalMatrix(MASS, STIFF, FORCE, LOAD, Velo, Gamma, Element, n)
!------------------------------------------------------------------------------
       REAL(KIND=dp) :: MASS(:,:), STIFF(:,:), FORCE(:), &
                  LOAD(:), Velo(:,:), Gamma(:)
       INTEGER :: n
       TYPE(Element_t), POINTER :: Element
!------------------------------------------------------------------------------
       REAL(KIND=dp) :: Basis(n),dBasisdx(n,3)
       REAL(KIND=dp) :: detJ,U,V,W,S,A,L,cu(3),divu,g
       LOGICAL :: Stat
       INTEGER :: i,p,q,t,dim
       TYPE(GaussIntegrationPoints_t) :: IntegStuff
       TYPE(Nodes_t) :: Nodes
       SAVE Nodes
!------------------------------------------------------------------------------
       dim = CoordinateSystemDimension()
       FORCE = 0.0d0
       STIFF = 0.0d0
       MASS  = 0.0d0
       CALL GetElementNodes( Nodes, Element )
!------------------------------------------------------------------------------
!      Numerical integration
!------------------------------------------------------------------------------
       IntegStuff = GaussPoints( Element )
 
       DO t=1,IntegStuff % n
         U = IntegStuff % u(t)
         V = IntegStuff % v(t)
         W = IntegStuff % w(t)
         S = IntegStuff % s(t)
!------------------------------------------------------------------------------
!        Basis function values & derivatives at the integration point
!------------------------------------------------------------------------------
         stat = ElementInfo( Element, Nodes, U, V, W, detJ, &
                 Basis, dBasisdx )

         S = S * detJ
         L = SUM( LOAD(1:n) *  Basis(1:n) )
         g = SUM( Basis(1:n) * Gamma(1:n) )

         cu   = 0.0d0
         divu = 0.0d0
         DO i=1,dim
           cu(i) = SUM( Basis(1:n) * Velo(i,1:n) )
           divu = divu + SUM( Velo(i,1:n) * dBasisdx(1:n,i) )
         END DO
!------------------------------------------------------------------------------
!        The advection-reaction equation
!------------------------------------------------------------------------------
         DO p=1,n
            DO q=1,n
              MASS(p,q)  = MASS(p,q)  + s * Basis(q) * Basis(p)
              STIFF(p,q) = STIFF(p,q) + s * (g-divu) * Basis(q) * Basis(p)
              DO i=1,dim
                STIFF(p,q) = STIFF(p,q) - s * cu(i) * Basis(q) * dBasisdx(p,i)
              END DO
            END DO
         END DO
         FORCE(1:n) = FORCE(1:n) + s*L*Basis(1:n)
!------------------------------------------------------------------------------
      END DO
!------------------------------------------------------------------------------
     END SUBROUTINE LocalMatrix
!------------------------------------------------------------------------------


!------------------------------------------------------------------------------
    SUBROUTINE FindParentUVW(Face, nFace, Parent, nParent, U, V, W, Basis)
!------------------------------------------------------------------------------
      IMPLICIT NONE
      TYPE(Element_t) :: Face, Parent
      INTEGER :: nFace, nParent
      REAL( KIND=dp ) :: U, V, W, Basis(:)
!------------------------------------------------------------------------------
      INTEGER :: i,j
      REAL(KIND=dp) :: ParentU(nFace), ParentV(nFace), ParentW(nFace)
!------------------------------------------------------------------------------
      DO i = 1,nFace
        DO j = 1,nParent
          IF ( Face % NodeIndexes(i) == Parent % NodeIndexes(j) ) THEN
            ParentU(i) = Parent % Type % NodeU(j)
            ParentV(i) = Parent % Type % NodeV(j)
            ParentW(i) = Parent % Type % NodeW(j)
            EXIT
          END IF
        END DO
      END DO
      U = SUM( Basis(1:nFace) * ParentU(1:nFace) )
      V = SUM( Basis(1:nFace) * ParentV(1:nFace) )
      W = SUM( Basis(1:nFace) * ParentW(1:nFace) )
!------------------------------------------------------------------------------      
    END SUBROUTINE FindParentUVW
!------------------------------------------------------------------------------      


!------------------------------------------------------------------------------
    SUBROUTINE LocalJumps( STIFF,Face,n,LeftParent,n1,RightParent,n2,Velo )
!------------------------------------------------------------------------------
      IMPLICIT NONE
      REAL(KIND=dp) :: STIFF(:,:), Velo(:,:)
      INTEGER :: n,n1,n2
      TYPE(Element_t), POINTER :: Face, LeftParent, RightParent
!------------------------------------------------------------------------------
      REAL(KIND=dp) :: FaceBasis(n), FacedBasisdx(n,3)
      REAL(KIND=dp) :: LeftBasis(n1), LeftdBasisdx(n1,3)
      REAL(KIND=dp) :: RightBasis(n2), RightdBasisdx(n2,3)
      REAL(KIND=dp) :: Jump(n1+n2), Average(n1+n2)
      REAL(KIND=dp) :: detJ, U, V, W, S, Udotn, xx, yy
      LOGICAL :: Stat
      INTEGER :: i, j, p, q, dim, t, nFace, nParent
      TYPE(GaussIntegrationPoints_t) :: IntegStuff
      REAL(KIND=dp) :: hE, Normal(3), cu(3), LeftOut(3)

      TYPE(Nodes_t) :: FaceNodes, LeftParentNodes, RightParentNodes
      SAVE FaceNodes, LeftParentNodes, RightParentNodes
!------------------------------------------------------------------------------
      dim = CoordinateSystemDimension()
      STIFF = 0.0d0

      CALL GetElementNodes( FaceNodes, Face )
      CALL GetElementNodes( LeftParentNodes,  LeftParent )
      CALL GetElementNodes( RightParentNodes, RightParent )
!------------------------------------------------------------------------------
!     Numerical integration over the edge
!------------------------------------------------------------------------------
      IntegStuff = GaussPoints( Face )

      LeftOut(1) = SUM(LeftParentNodes % x(1:n1)) / n1
      LeftOut(2) = SUM(LeftParentNodes % y(1:n1)) / n1
      LeftOut(3) = SUM(LeftParentNodes % z(1:n1)) / n1
      LeftOut(1) = SUM(FaceNodes % x(1:n)) / n - LeftOut(1)
      LeftOut(2) = SUM(FaceNodes % y(1:n)) / n - LeftOut(2)
      LeftOut(3) = SUM(FaceNodes % z(1:n)) / n - LeftOut(3)

      DO t=1,IntegStuff % n
        U = IntegStuff % u(t)
        V = IntegStuff % v(t)
        W = IntegStuff % w(t)
        S = IntegStuff % s(t)

        ! Basis function values & derivatives at the integration point:
        !--------------------------------------------------------------
        stat = ElementInfo( Face, FaceNodes, U, V, W, detJ, &
             FaceBasis, FacedBasisdx )

        S = S * detJ

        Normal = NormalVector( Face, FaceNodes, U, V, .FALSE. )
        IF ( SUM( LeftOut*Normal ) < 0 ) Normal = -Normal

        ! Find basis functions for the parent elements:
        ! ---------------------------------------------
        CALL FindParentUVW( Face,n,LeftParent,n1,U,V,W,FaceBasis )
        stat = ElementInfo( LeftParent, LeftParentNodes, U, V, W, detJ, &
                LeftBasis, LeftdBasisdx )

        CALL FindParentUVW( Face,n,RightParent,n2,U,V,W,FaceBasis )
        stat = ElementInfo( RightParent, RightParentNodes, U, V, W, detJ, &
              RightBasis, RightdBasisdx )

        ! Integrate jump terms:
        ! ---------------------
        Jump(1:n1) = LeftBasis(1:n1)
        Jump(n1+1:n1+n2) = -RightBasis(1:n2)

        Average(1:n1) = LeftBasis(1:n1) / 2
        Average(n1+1:n1+n2) = RightBasis(1:n2) / 2

        cu = 0.0d0
        DO i=1,dim
          cu(i) = SUM( Velo(i,1:n) * FaceBasis(1:n) )
        END DO
        Udotn = SUM( Normal * cu )

        DO p=1,n1+n2
          DO q=1,n1+n2
            STIFF(p,q) = STIFF(p,q) + s * Udotn * Average(q) * Jump(p)
            STIFF(p,q) = STIFF(p,q) + s * ABS(Udotn)/2 * Jump(q) * Jump(p)
          END DO
        END DO
      END DO
!------------------------------------------------------------------------------
    END SUBROUTINE LocalJumps
!------------------------------------------------------------------------------



!------------------------------------------------------------------------------
    SUBROUTINE LocalMatrixBoundary( STIFF, FORCE, LOAD, &
        Element, n, ParentElement, np, Velo, InFlowBC )
!------------------------------------------------------------------------------
     REAL(KIND=dp) :: STIFF(:,:),  FORCE(:), LOAD(:), Velo(:,:)
     INTEGER :: n, np
     LOGICAL :: InFlowBC
     TYPE(Element_t), POINTER :: Element, ParentElement
!------------------------------------------------------------------------------
     REAL(KIND=dp) :: Basis(n), dBasisdx(n,3)
     REAL(KIND=dp) :: ParentBasis(np), ParentdBasisdx(np,3)
     INTEGER :: i,j,p,q,t,dim

     REAL(KIND=dp) :: Normal(3), g, L, Udotn, cu(3), cu1(3), detJ,U,V,W,S
     LOGICAL :: Stat, Inflow
     TYPE(GaussIntegrationPoints_t) :: IntegStuff

     TYPE(Nodes_t) :: Nodes, ParentNodes
     SAVE Nodes, ParentNodes
!------------------------------------------------------------------------------
     dim = CoordinateSystemDimension()
     FORCE = 0.0d0
     STIFF = 0.0d0
 
     CALL GetElementNodes( Nodes, Element )
     CALL GetElementNodes( ParentNodes, ParentElement )

     Normal = NormalVector( Element, Nodes, 0.0d0, 0.0d0, .TRUE. ) 
     DO i=1,3
       cu(i) = SUM( Velo(i,1:n) ) / n
     END DO
     Inflow = InFlowBC .AND. SUM( Normal * cu ) < 0.0d0

     ! Numerical integration:
     !-----------------------
     IntegStuff = GaussPoints( Element )

     DO t=1,IntegStuff % n
       U = IntegStuff % u(t)
       V = IntegStuff % v(t)
       W = IntegStuff % w(t)
       S = IntegStuff % s(t)

       Normal = NormalVector( Element, Nodes, U, V, .TRUE. ) 

       ! Basis function values & derivatives at the integration point:
       ! -------------------------------------------------------------
       stat = ElementInfo( Element, Nodes, U, V, W, detJ, &
               Basis, dBasisdx )
       S = S * detJ

       CALL FindParentUVW( Element, n, ParentElement, np, U, V, W, Basis )
       stat = ElementInfo( ParentElement, ParentNodes, U, V, W, &
            detJ, ParentBasis, ParentdBasisdx )

       L = SUM( LOAD(1:n) * Basis(1:n) )
       cu = 0.0d0
       DO i=1,dim
          cu(i)  = SUM( Velo(i,1:n) * Basis(1:n) )
       END DO
       Udotn = SUM( Normal * cu )

       DO p = 1,np
         IF ( Inflow ) THEN
            FORCE(p) = FORCE(p) - s * Udotn*L*ParentBasis(p)
         ELSE
           DO q=1,np
             STIFF(p,q) = STIFF(p,q) + s*Udotn*ParentBasis(q)*ParentBasis(p)
           END DO
         END IF
       END DO
     END DO
!------------------------------------------------------------------------------
   END SUBROUTINE LocalMatrixBoundary
!------------------------------------------------------------------------------
 END SUBROUTINE AdvReactSolver
!------------------------------------------------------------------------------

!/******************************************************************************
! *
! *       ELMER, A Computational Fluid Dynamics Program.
! *
! *       Copyright 1st April 1995 - , Center for Scientific Computing,
! *                                    Finland.
! *
! *       All rights reserved. No part of this program may be used,
! *       reproduced or transmitted in any form or by any means
! *       without the written permission of CSC.
! *
! *****************************************************************************/
!
!/******************************************************************************
!*
! ******************************************************************************
! *
! *                    Author:  Juha Ruokolainen
! *
! *                    Address: Center for Scientific Computing
! *                                Tietotie 6, P.O. BOX 405
! *                                  02101 Espoo, Finland
! *
! *
!/******************************************************************************
! *
! *  iceproperties.f90  material parameters and physical models for ice flow
! *
! *
! *       Module Author:           Thomas Zwinger
! *       Address:                 Center for Scientific Computing
! *                                Tietotie 6, P.O. BOX 405
! *                                  02101 Espoo, Finland
! *                                  Tel. +358 0 457 2723
! *                                Telefax: +358 0 457 2183
! *                                EMail: Thomas.Zwinger@csc.fi
! *
! *       Modified by:             Thomas Zwinger
! *
! *       Date of modification: 11/11/2005
! *
! *****************************************************************************/
!
!
!

RECURSIVE SUBROUTINE getNetBoundaryHeatflux( Model,Solver,Timestep,TransientSimulation)
  USE DefUtils
  USE Materialmodels
!-----------------------------------------------------------
  IMPLICIT NONE
!------------ external variables ---------------------------
  TYPE(Model_t)  :: Model
  TYPE(Solver_t), TARGET :: Solver
  LOGICAL :: TransientSimulation
  REAL(KIND=dp) :: Timestep
!------------------------------------------------------------------------------
!    Local variables
!------------------------------------------------------------------------------
  TYPE(Solver_t), POINTER :: PointerToSolver
  TYPE(Nodes_t) :: Nodes
  TYPE(Element_t),POINTER :: Element
  TYPE(Variable_t), POINTER :: HFSol, TempSol
  TYPE(ValueList_t), POINTER :: Equation,Material,SolverParams,BodyForce,BC,Constants
  CHARACTER(LEN=MAX_NAME_LEN) :: TempName, SolverName
  INTEGER :: i, j, k, t, N, BN,  M, DIM, istat, material_id
  INTEGER, POINTER :: TempPerm(:), HFPerm(:),BoundaryReorder(:)
  INTEGER, ALLOCATABLE :: contributedElements(:)
  REAL(KIND=dp) ::  U, V, W, SqrtElementMetric
  REAL(KIND=dp), ALLOCATABLE ::  Basis(:),dBasisdx(:,:), ddBasisddx(:,:,:),&
       LatentHeat(:), HeatConductivity(:), Density(:), heatFlux(:,:)
  REAL(KIND=dp), POINTER :: HF(:), Temp(:), BoundaryNormals(:,:), BoundaryTangent1(:,:), BoundaryTangent2(:,:)
  LOGICAL :: GotIt, AllocationsDone=.FALSE., stat

  SAVE AllocationsDone, SolverName, DIM,  heatFlux, &
       Basis, dBasisdx, ddBasisddx, &
       LatentHeat, HeatConductivity, Density, contributedElements, &
       BoundaryNormals, BoundaryTangent1, BoundaryTangent2, BoundaryReorder, BN


  WRITE(SolverName, '(A)') 'iceproperties (getNetBoundaryHeatflux))'
  !-----------------------------------------------------------------------
  ! get solver variable
  !-----------------------------------------------------------------------
  HFSol => Solver % Variable
  IF (.NOT.ASSOCIATED(HFSol)) THEN
     CALL FATAL(SolverName,'No variable associated')
  END IF
  HFPerm  => HFSol % Perm
  HF => HFSol % Values

  
  HF = 0.0D00


  !-----------------------------------------------------------------------
  ! Allocations
  !-----------------------------------------------------------------------
  IF ( .NOT.AllocationsDone .OR. Solver % Mesh % Changed ) THEN
     DIM = CoordinateSystemDimension()
     N = Solver % Mesh % MaxElementNodes
     M = Model % Mesh % NumberOfNodes        
     IF ( AllocationsDone ) &
          DEALLOCATE( &
          Basis, &
          dBasisdx, &
          ddBasisddx, &
          LatentHeat, &
          HeatConductivity, &
          Density, &
          heatFlux,&
          Nodes % x, &
          Nodes % y, &
          Nodes % z, &
          contributedElements, &
          BoundaryReorder, &
          BoundaryNormals, &
          BoundaryTangent1, &
          BoundaryTangent2)
     CALL CheckNormalTangentialBoundary( Model, &
          'Basal Melting', BN, &
          BoundaryReorder, BoundaryNormals, BoundaryTangent1, &
          BoundaryTangent2, DIM )
      WRITE(Message,'(A,i6)') &
          'Number of boundary nodes on boundaries associated with melting:',&
           BN
      CALL INFO(SolverName,Message,Level=3)
      CALL AverageBoundaryNormals(Model, &
           'Basal Melting', BN, &
           BoundaryReorder, BoundaryNormals, BoundaryTangent1, &
           BoundaryTangent2, DIM )
     ALLOCATE( &
          Basis(N), &
          dBasisdx(N,3), &
          ddBasisddx(N,3,3), &
          LatentHeat(N), &
          HeatConductivity(N), &
          Density(N), &
          heatFlux(M,3),& 
          Nodes % x(N), &
          Nodes % y(N), &
          Nodes % z(N), &
          contributedElements(M), &
          STAT = istat)
     AllocationsDone = .TRUE.
  END IF
  !-------------------------------------------------------------------------
  ! Calculate element-wise heat flux contributions for each point of element
  !-------------------------------------------------------------------------
  contributedElements = 0
  heatFlux = 0.0D00  

  DO t=1,Solver % NumberOfActiveElements
     Element => GetActiveElement(t)
     Model % CurrentElement => Element
     N = Element % Type % NumberOfNodes
     CALL GetElementNodes( Nodes )
     !-----------------------------------------------------------------------
     ! get material pointer
     !-----------------------------------------------------------------------
     Material => GetMaterial()
     IF (.NOT.ASSOCIATED(Material)) THEN
        WRITE (Message,'(A,I3)') 'No Material found for boundary element no. ', t
        CALL FATAL(SolverName,Message)
     ELSE
        material_id = GetMaterialId( Element, GotIt)
        IF(.NOT.GotIt) THEN
           WRITE (Message,'(A,I3)') 'No Material ID found for boundary element no. ', t
           CALL FATAL(SolverName,Message)
        END IF
     END IF
     !-----------------------------------------------------------------------
     ! get temperature variable
     !-----------------------------------------------------------------------
     TempName =  GetString(Material,'Temperature Name', GotIt)
     IF (.NOT.GotIt) THEN
        CALL FATAL(SolverName,'No Temperature Name found')
     ELSE
        WRITE(Message,'(a,a)') 'Variable Name for temperature: ', TempName
        CALL INFO(SolverName,Message,Level=12)
     END IF
     TempSol => VariableGet( Solver % Mesh % Variables, TRIM(TempName) )
     IF ( ASSOCIATED( TempSol ) ) THEN
        TempPerm => TempSol % Perm
        Temp => TempSol % Values
     ELSE
        WRITE(Message, '(A,A)') 'Could not find temperature field variable ',  TRIM(TempName)
        CALL FATAL(SolverName,Message)
     END IF 
     !-----------------------
     ! get material parameter
     !-----------------------
     HeatConductivity(1:N) =  ListGetReal( Material,  TRIM(TempName) // &
          ' Heat Conductivity', n, Element % NodeIndexes, GotIt )
     IF (.NOT.GotIt) THEN
        HeatConductivity = 0.0D00
        WRITE(Message,'(a,a,a,i5,a,i5,a)') 'Keyword >', TRIM(TempName) // &
          ' Heat Conductivity', '< not found for element ', t, ' material ', material_id
        CALL WARN(SolverName,Message)
     END IF
     !--------------------------
     ! loop all nodes in element
     !--------------------------
     DO i=1,N
        U = Element % Type % NodeU(i)
        V = Element % Type % NodeV(i)
        W = Element % Type % NodeW(i)
        stat = ElementInfo( Element,Nodes,U,V,W,SqrtElementMetric, &
             Basis,dBasisdx,ddBasisddx,.FALSE.,.FALSE. )
        !--------------------
        ! loop all dimensions
        !--------------------
        DO j=1,DIM
           DO k=1,N
              heatFlux(Element % NodeIndexes(i),j) = & 
                   heatFlux(Element % NodeIndexes(i),j) - HeatConductivity(k)*dBasisdx(k,j)*Temp(TempPerm(k))
           END DO
        END DO
        contributedElements(Element % NodeIndexes(i)) = contributedElements(Element % NodeIndexes(i)) + 1
     END DO
  END DO
  
  !----------------------------------------------------------
  ! averaged internal flux for each point of element
  !----------------------------------------------------------
  DO i=1,Solver % Mesh % NumberOfNodes
     IF (contributedElements(i) > 0) THEN
        heatFlux(i,1:DIM) = heatFlux(i,1:DIM)/contributedElements(i)
        j = BoundaryReorder(i)
        IF (j>0) THEN
           HF(HFPerm(i)) = SUM(heatFlux(i,1:DIM)*BoundaryNormals(j,1:DIM))
        ELSE
!           HF(HFPerm(i)) = SQRT(SUM(heatFlux(i,1:DIM)*heatFlux(i,1:DIM)))
           HF(HFPerm(i)) = 0.0D00
        END IF
     ELSE
        WRITE(Message,'(A,i6,A)') 'Node no. ',i,' appears not to be part of any element.'
        CALL WARN(SolverName,Message)
        HF(HFPerm(i)) = 0.0
     END IF     
  END DO

END SUBROUTINE getNetBoundaryHeatflux

!**************************************************************************
!*
!*  basal melting velocity  as a function of heat flux (provided externaly)
!*
!**************************************************************************
FUNCTION getBasalMeltingVelocity( Model, Node, HeatFlux ) RESULT(basalMeltingvelocity)

!-----------------------------------------------------------
  USE DefUtils
  USE SolverUtils
!-----------------------------------------------------------
  IMPLICIT NONE
!-----------------------------------------------------------
  !external variables
  TYPE(Model_t), TARGET :: Model
  INTEGER :: Node
  REAL(KIND=dp) :: HeatFlux, basalMeltingvelocity

  !internal variables
  TYPE(ValueList_t), POINTER :: ParentMaterial, BC
  TYPE(Element_t), POINTER :: BoundaryElement, ParentElement 
  TYPE(Variable_t), POINTER :: VarHomTemp
  INTEGER :: i, N, DIM, NBoundary, NParent, BoundaryElementNode, ParentElementNode, body_id, other_body_id, material_id, istat
  REAL(KIND=dp), ALLOCATABLE :: LatentHeat(:), Density(:), HomTemp(:),ExternalHF(:)
  CHARACTER(LEN=MAX_NAME_LEN) :: TempName, SolverName
  LOGICAL ::  FirstTime = .TRUE., GotIt, stat

  SAVE FirstTime, LatentHeat, Density, HomTemp, DIM, N, ExternalHF

  WRITE(SolverName, '(A)') 'iceproperties (getBasalMeltingVelocity))'
  !--------------------------------
  ! Allocations
  !--------------------------------
  IF ( FirstTime .OR. Model % Mesh % Changed) THEN
      DIM = CoordinateSystemDimension()
      N = Model % MaxElementNodes 

      IF (.NOT.FirstTime) THEN
         DEALLOCATE( &
              LatentHeat,&        
              Density,&
              HomTemp,&
              ExternalHF)
      END IF
      ALLOCATE( &
           LatentHeat( N ),&
           Density( N ),&
           HomTemp( N ),&
           ExternalHF( N ),&
           STAT = istat)
      IF (istat /= 0) THEN
         CALL FATAL(SolverName,'Allocations failed')
      ELSE 
         CALL INFO(SolverName,'Allocations done')
      END IF

      FirstTime = .FALSE.
   END IF



  !-----------------------------------------------------------------
  ! get some information upon active boundary element and its parent
  !-----------------------------------------------------------------
  BoundaryElement => Model % CurrentElement
  IF ( .NOT. ASSOCIATED(BoundaryElement) ) THEN
     CALL FATAL(SolverName,'No boundary element found')
  END IF  
  NBoundary = BoundaryElement % Type % NumberOfNodes
  DO BoundaryElementNode=1,NBoundary
     IF (Node .EQ. BoundaryElement % NodeIndexes(BoundaryElementNode)) THEN
        GotIt = .TRUE.
        EXIT
     END IF
  END DO
  IF (.NOT.GotIt) THEN
     CALL WARN(SolverName,'Node not found in Current Element')
     basalMeltingVelocity = 0.0D00
     RETURN
  END IF
  other_body_id = BoundaryElement % BoundaryInfo % outbody
  IF (other_body_id < 1) THEN ! only one body in calculation
     ParentElement => BoundaryElement % BoundaryInfo % Right
     IF ( .NOT. ASSOCIATED(ParentElement) ) ParentElement => BoundaryElement % BoundaryInfo % Left
  ELSE ! we are dealing with a body-body boundary and asume that the normal is pointing outwards
     ParentElement => BoundaryElement % BoundaryInfo % Right
     IF (ParentElement % BodyId == other_body_id) ParentElement => BoundaryElement % BoundaryInfo % Left
  END IF
  ! just to be on the save side, check again
  IF ( .NOT. ASSOCIATED(ParentElement) ) THEN
     WRITE(Message,'(A,I10,A)')&
          'Parent Element for Boundary element no. ',&
          BoundaryElement % ElementIndex, ' not found'
     CALL FATAL(SolverName,Message)
  END IF  

  body_id = ParentElement % BodyId
  material_id = ListGetInteger(Model % Bodies(body_id) % Values, 'Material', GotIt)
  ParentMaterial => Model % Materials(material_id) % Values
  IF ((.NOT. ASSOCIATED(ParentMaterial)) .OR. (.NOT. GotIt)) THEN
     WRITE(Message,'(A,I10,A,I10)')&
          'No material values found for body no ', body_id,&
          ' under material id ', material_id
     CALL FATAL(SolverName,Message)
  END IF 
  NParent = ParentElement % Type % NumberOfNodes
  DO ParentElementNode=1,NParent
     IF ( Node == ParentElement % NodeIndexes(ParentElementNode) ) EXIT
  END DO

  !-----------------------------------------------------------------------
  ! get temperature variable
  !-----------------------------------------------------------------------
  TempName =  GetString(ParentMaterial ,'Temperature Name', GotIt)
  IF (.NOT.GotIt) THEN
     CALL FATAL(SolverName,'No Temperature Name found')
  ELSE
     WRITE(Message,'(a,a)') 'Variable Name for temperature: ', TempName
     CALL INFO(SolverName,Message,Level=12)
  END IF

  !-------------------------
  ! Get material parameters
  !-------------------------
  Model % CurrentElement => ParentElement
  LatentHeat(1:NParent) = ListGetReal(ParentMaterial, 'Latent Heat', NParent, ParentElement % NodeIndexes, GotIt)
  IF (.NOT. GotIt) THEN
     CALL FATAL(SolverName,'No value for Latent Heat found')
  END IF
  Density(1:NParent) = ListGetReal( ParentMaterial, 'Density', NParent, ParentElement % NodeIndexes)
  IF (.NOT. GotIt) THEN
     CALL FATAL(SolverName,'No value for Density found')
  END IF
  !-------------------------
  ! Get boundary parameters
  !-------------------------
  Model % CurrentElement => BoundaryElement
  BC => GetBC()
  IF (.NOT.ASSOCIATED(BC)) THEN
     CALL FATAL(SolverName,'No Boundary Condition associated')
  ELSE
     ExternalHF(1:NBoundary) = GetReal(BC, TRIM(TempName) // ' Heat Flux', GotIt)
     IF (.NOT. GotIt) THEN
        WRITE(Message,'(a,a,a)') 'Keyword >', TRIM(TempName) // ' Heat Flux','< not found'
        CALL WARN(SolverName,Message)
        ExternalHF(1:NBoundary) = 0.0D00
     END IF
  END IF

  !---------------------------------
  ! Get homologous temperature field
  !---------------------------------
!  TempName =  GetString(Model % Constants ,'Temperature Name', GotIt)
!  IF (.NOT.GotIt) THEN
!     CALL FATAL(SolverName,'No Temperature Name found')
!  ELSE
!     WRITE(Message,'(a,a)') 'Variable Name for temperature: ', TempName
!     CALL INFO(SolverName,Message,Level=12)
!  END IF

  Model % CurrentElement => ParentElement
  VarHomTemp => VariableGet( Model % Variables, TRIM(TempName) // ' Homologous', .TRUE. )
  IF ( ASSOCIATED( VarHomTemp ) ) THEN
     DO i = 1, NParent
        HomTemp(i) = MIN(VarHomTemp % Values(VarHomTemp % Perm(ParentElement % NodeIndexes(i))),1.0D-06)
     END DO
  ELSE
    WRITE(Message,'(A,A,A)') 'Variable ', TRIM(TempName) // ' Homologous', ' not found'
     CALL INFO(SolverName,Message,Level=12)
     HomTemp(1:NParent) = -1.0D-06
  END IF
 
  !------------------------------------
  ! Get basal melting rate and velocity
  !------------------------------------
  IF (HomTemp(BoundaryElementNode) > -1.0D-03) THEN
     basalMeltingvelocity = MAX((HeatFlux + ExternalHF(BoundaryElementNode)) &
          /(LatentHeat(BoundaryElementNode) * Density(BoundaryElementNode)),1.0D-12)

  ELSE
     basalMeltingvelocity = 0.0D00
  END IF
  Model % CurrentElement =>  BoundaryElement
END FUNCTION getBasalMeltingVelocity

!*********************************************************************************************************************************
!*
!*  basal slip coefficient as a function of temperature
!*
!*********************************************************************************************************************************

FUNCTION basalSlip( Model, Node, Temperature ) RESULT(basalSlipCoefficient)
!-----------------------------------------------------------
  USE DefUtils
!-----------------------------------------------------------
  IMPLICIT NONE
!-----------------------------------------------------------
  !external variables
  TYPE(Model_t), TARGET :: Model
  INTEGER :: Node
  REAL(KIND=dp) :: Temperature, basalSlipCoefficient
  !internal variables
  TYPE(Element_t), POINTER :: CurrentElementAtBeginning, BoundaryElement, ParentElement
  TYPE(ValueList_t), POINTER :: ParentMaterial, BC
  TYPE(Variable_t), POINTER :: varTemperature, varPressure
  INTEGER :: N, NBoundary, NParent, BoundaryElementNode, ParentElementNode, &
       i, DIM, other_body_id, body_id, material_id, istat, NSDOFs
  REAL(KIND=dp) :: TempHom, ThermalCoefficient, SlipCoefficientMax
  REAL(KIND=dp), ALLOCATABLE :: PressureMeltingPoint(:), TemperateSlipCoefficient(:)
  CHARACTER(LEN=MAX_NAME_LEN) :: TempName
  LOGICAL ::  GotIt, stat, Jump=.FALSE.

  !---------------
  ! Initialization
  !---------------
  CurrentElementAtBeginning => Model % CurrentElement 
  N = Model % MaxElementNodes 
  ALLOCATE(TemperateSlipCoefficient(N),&  
       PressureMeltingPoint(N),&
       STAT = istat)
  IF (istat /= 0) THEN
     CALL FATAL('iceproperties (basalSlip)','Allocations failed')
  END IF

  TemperateSlipCoefficient = 1.0D30 ! high value - > no slip by default
  PressureMeltingPoint = 273.16D00

  !-----------------------------------------------------------------
  ! get some information upon active boundary element and its parent
  !-----------------------------------------------------------------
  BoundaryElement => Model % CurrentElement
  IF ( .NOT. ASSOCIATED(BoundaryElement) ) THEN
     CALL FATAL('iceproperties (basalMelting)','No boundary element found')
  END IF
  other_body_id = BoundaryElement % BoundaryInfo % outbody
  IF (other_body_id < 1) THEN ! only one body in calculation
     ParentElement => BoundaryElement % BoundaryInfo % Right
     IF ( .NOT. ASSOCIATED(ParentElement) ) ParentElement => BoundaryElement % BoundaryInfo % Left
  ELSE ! we are dealing with a body-body boundary and asume that the normal is pointing outwards
     ParentElement => BoundaryElement % BoundaryInfo % Right
     IF (ParentElement % BodyId == other_body_id) ParentElement => BoundaryElement % BoundaryInfo % Left
  END IF
  ! just to be on the save side, check again
  IF ( .NOT. ASSOCIATED(ParentElement) ) THEN
     WRITE(Message,'(A,I10,A)')&
          'Parent Element for Boundary element no. ',&
          BoundaryElement % ElementIndex, ' not found'
     CALL FATAL('iceproperties (basalMelting)',Message)
  END IF  
  Model % CurrentElement => ParentElement
  body_id = ParentElement % BodyId
  material_id = ListGetInteger(Model % Bodies(body_id) % Values, 'Material', GotIt)
  ParentMaterial => Model % Materials(material_id) % Values
  IF ((.NOT. ASSOCIATED(ParentMaterial)) .OR. (.NOT. GotIt)) THEN
     WRITE(Message,'(A,I10,A,I10)')&
          'No material values found for body no ', body_id,&
          ' under material id ', material_id
     CALL FATAL('iceproperties (basalMelting)',Message)
  END IF
  ! number of nodes and node in elements
  NBoundary = BoundaryElement % Type % NumberOfNodes
  NParent = ParentElement % Type % NumberOfNodes
  DO BoundaryElementNode=1,Nboundary
     IF ( Node == BoundaryElement % NodeIndexes(BoundaryElementNode) ) EXIT
  END DO
  DO ParentElementNode=1,NParent
     IF ( Node == ParentElement % NodeIndexes(ParentElementNode) ) EXIT
  END DO
  !-------------------------
  ! Get Pressure Melting Point
  !-------------------------
  TempName =  GetString(ParentMaterial ,'Temperature Name', GotIt)
  PressureMeltingPoint(1:NParent) =&
       ListGetReal( ParentMaterial, TRIM(TempName) // ' Upper Limit',&
       NParent, ParentElement % NodeIndexes, GotIt)
  IF (.NOT. GotIt) THEN
     WRITE(Message,'(a,a,a)') 'No entry for ', TRIM(TempName) // ' Upper Limit', ' found'
     CALL FATAL('iceproperties (basalMelting)',Message)
  END IF
  !---------------------------------------------------------------------
  ! get temperate slip coefficient and upper limit for slip coefficient
  !---------------------------------------------------------------------
  Model % CurrentElement => BoundaryElement
  BC => GetBC()

  IF (.NOT.ASSOCIATED(BC)) THEN
     CALL FATAL('iceproperties (basalSlip)','No Boundary Condition associated')
  ELSE
     TemperateSlipCoefficient(1:NBoundary) = GetReal(BC, 'Temperate Slip Coefficient', GotIt)
     IF (.NOT. GotIt) THEN
        CALL WARN('iceproperties (basalSlip)','Keyword >Temperate Slip Coefficient< not found')
        CALL WARN('iceproperties (basalSlip)','Asuming Default 5.63D08 [kg /(s m^2)]')
        TemperateSlipCoefficient(1:NBoundary) = 5.63D08
     END IF
     ThermalCoefficient = GetConstReal(BC, 'Thermal Coefficient', GotIt)
     IF (.NOT. GotIt) THEN
        CALL WARN('iceproperties (basalSlip)','Keyword >Thermal Coefficient< not found')
        CALL WARN('iceproperties (basalSlip)','Asuming Default 1 [1/K]')
        ThermalCoefficient =  1.0D00
     END IF
     SlipCoefficientMax = GetConstReal(BC, 'Max Slip Coefficient', GotIt)
     IF (.NOT. GotIt) THEN
        CALL WARN('iceproperties (basalSlip)','Keyword >Max Slip Coefficient< not found')
        CALL WARN('iceproperties (basalSlip)','Asuming Default 1.0E+16 [kg /(s m^2)]')
        SlipCoefficientMax = 1.0E+16
     END IF
  END IF
  !------------------------------
  ! check homologous temperature
  !------------------------------
  TempHom = MIN(Temperature - PressureMeltingPoint(ParentElementNode),0.0D00)
  !------------------------------
  ! get the result and check it
  !------------------------------
  basalSlipCoefficient = TemperateSlipCoefficient(BoundaryElementNode)*EXP(-1.0D00*TempHom*ThermalCoefficient)
  IF (basalSlipCoefficient < TemperateSlipCoefficient(BoundaryElementNode)) THEN
     WRITE(Message,'(A,e10.4)') 'Applied lower threshold of ', &
          TemperateSlipCoefficient(BoundaryElementNode)
     CALL INFO('iceproperties (basalSlip)',Message,Level=9)
     basalSlipCoefficient =  TemperateSlipCoefficient(BoundaryElementNode)
  ELSE IF(basalSlipCoefficient > SlipCoefficientMax) THEN
     WRITE(Message,'(A,e10.4)') 'Applied upper threshold of ', SlipCoefficientMax
     CALL INFO('iceproperties (basalSlip)',Message,Level=9)
     basalSlipCoefficient = SlipCoefficientMax
  END IF
  !------------------------------
  ! clean up
  !------------------------------
  DEALLOCATE(TemperateSlipCoefficient, PressureMeltingPoint)
END FUNCTION basalSlip

!*********************************************************************************************************************************
!*
!*  projecting vertical geothermal heat flux to boundary normal
!*
!*********************************************************************************************************************************
FUNCTION getNormalFlux( Model, Node, dummyArgument ) RESULT(NormalFlux)
!-----------------------------------------------------------
  USE DefUtils
!-----------------------------------------------------------
  IMPLICIT NONE
!-----------------------------------------------------------
  !external variables
  TYPE(Model_t), TARGET :: Model
  INTEGER :: Node
  REAL(KIND=dp) :: dummyArgument, NormalFlux
  !internal variables
  TYPE(Element_t), POINTER :: BoundaryElement
  TYPE(Nodes_t) :: Nodes
  TYPE(ValueList_t), POINTER :: BC
  INTEGER :: N, NBoundary, BoundaryElementNode, i, DIM, body_id, NumberOfBoundaryNodes, istat
  INTEGER, POINTER :: BoundaryReorder(:)
  REAL(KIND=dp) :: U, V, W, Normal(3), Gravity(3), direction(3),&
       HeatFlux, SqrtElementMetric
  REAL(KIND=dp), ALLOCATABLE ::  ExternalHeatFlux(:)
  REAL(KIND=dp), DIMENSION(:,:),  POINTER :: Work, BoundaryNormals,BoundaryTangent1, &
       BoundaryTangent2
  LOGICAL ::  FirstTime = .TRUE., GotIt, stat
!-----------------------------------------------------------
  SAVE FirstTime, NumberOfBoundaryNodes,BoundaryReorder,BoundaryNormals, &
       BoundaryTangent1, BoundaryTangent2, DIM

  IF (FirstTime) THEN 
     DIM = CoordinateSystemDimension()
     CALL CheckNormalTangentialBoundary( Model, &
          'Basal Melting', NumberOfBoundaryNodes, &
          BoundaryReorder, BoundaryNormals, BoundaryTangent1, &
          BoundaryTangent2, DIM )

     WRITE(Message,'(A,i6)') &
          'Number of boundary nodes on boundaries associated with melting:',&
          NumberOfBoundaryNodes
     CALL INFO('iceproperties (getNormalHeatFlux)','Message',Level=3)
     
     IF(NumberOfBoundaryNodes < 1) THEN
        CALL FATAL('iceproperties (getNormalHeatFlux)','No Points for basal melting found')
     END IF

     CALL AverageBoundaryNormals( Model, &
          'Basal Melting', NumberOfBoundaryNodes, &
          BoundaryReorder, BoundaryNormals, BoundaryTangent1, &
          BoundaryTangent2, DIM )
     FirstTime = .FALSE.
  END IF


  !--------------------------------
  ! Allocations
  !--------------------------------
  N = Model % MaxElementNodes 
  ALLOCATE(Nodes % x(N), Nodes % y(N), Nodes % z(N),&
       ExternalHeatFlux( N ),&
       STAT = istat)
  IF (istat /= 0) THEN
     CALL FATAL('iceproperties (etNormalHeatFlux)','Allocations failed')
  END IF

  !-----------------------------------------------------------------
  ! get some information upon active boundary element and its parent
  !-----------------------------------------------------------------
  BoundaryElement => Model % CurrentElement
  IF ( .NOT. ASSOCIATED(BoundaryElement) ) THEN
     CALL FATAL('iceproperties (normalFlux)','No boundary element found')
  END IF
  !-------------------------------------------
  ! Get normal of the boundary element at node
  !-------------------------------------------
  Nboundary = BoundaryElement % Type % NumberOfNodes
  DO BoundaryElementNode=1,Nboundary
     IF ( Node == BoundaryElement % NodeIndexes(BoundaryElementNode) ) EXIT
  END DO
  Normal(1:DIM) = BoundaryNormals(BoundaryReorder(Node),1:DIM)
  !-------------------------------
  ! get gravitational acceleration
  !-------------------------------
  Work => ListGetConstRealArray( Model % Constants,'Gravity',GotIt)
  IF ( GotIt ) THEN
     Gravity = Work(1:3,1)
  ELSE
     Gravity = 0.0D00
     CALL INFO('iceproperties (normalFlux)','No vector for Gravity (Constants) found', level=1)
     IF (DIM == 1) THEN
        Gravity(1) = -1.0D00
        CALL INFO('iceproperties (normalFlux)','setting direction to -1', level=1)
     ELSE IF (DIM == 2) THEN
        Gravity    =  0.00D0
        Gravity(2) = -1.0D00
        CALL INFO('iceproperties (normalFlux)','setting direction to (0,-1)', level=1)
     ELSE
        Gravity    =  0.00D00
        Gravity(3) = -1.0D00
        CALL INFO('iceproperties (normalFlux)','setting direction to (0,0,-1)', level=1)
     END IF
  END IF
  !------------------------
  ! get external heat flux
  !------------------------
  BC => GetBC()
  ExternalHeatFlux = 0.0D00  
  ExternalHeatFlux(1:NBoundary) = GetReal(BC, 'External Heat Flux', GotIt)
  IF (.NOT. GotIt) THEN
     CALL INFO('iceproperties (normalFlux)','No external heat flux given', Level=4)
  END IF
  !--------------------------------------------------------
  ! compute normal component of vertically aligned heatflux
  !--------------------------------------------------------
  NormalFlux = ExternalHeatFlux(BoundaryElementNode) * ABS(SUM(Gravity(1:DIM)*Normal(1:DIM)))
  !----------------------------------------------
  ! clean up before leaving
  !----------------------------------------------
  DEALLOCATE( Nodes % x,&
       Nodes % y,&
       Nodes % z,&
       ExternalHeatFlux)
END FUNCTION getNormalFlux

!*********************************************************************************************************************************
!*
!* heat conductivity of ice as a function of temperature (K):  k = c_1 * exp(c_2 * T[K]); c_2 < 0 
!*
!*********************************************************************************************************************************
FUNCTION getHeatConductivity( Model, N, temperature ) RESULT(conductivity)
  USE types
  USE CoordinateSystems
  USE SolverUtils
  USE ElementDescription
!-----------------------------------------------------------
  IMPLICIT NONE
!------------ external variables ---------------------------
  TYPE(Model_t) :: Model
  INTEGER :: N
  REAL(KIND=dp) :: temperature, conductivity
!------------ internal variables----------------------------
  TYPE(ValueList_t), POINTER :: Material
  INTEGER :: nMax,i,j,body_id,material_id,elementNodes,nodeInElement,istat
  REAL (KIND=dp), ALLOCATABLE :: conductivityExponentFactor(:), conductivityFactor(:)
  LOGICAL :: FirstTime = .TRUE., GotIt
!------------ remember this -------------------------------
  Save FirstTime, conductivityExponentFactor, conductivityFactor
  !-------------------------------------------
  ! Allocations 
  !------------------------------------------- 
  IF (FirstTime) THEN
     nMax = Model % MaxElementNodes
     ALLOCATE(conductivityExponentFactor(nMax),&
          conductivityFactor(nMax),&
          STAT=istat)
     IF ( istat /= 0 ) THEN
        CALL FATAL('iceproperties (getHeatConductivity)','Memory allocation error, Aborting.')
     END IF
     FirstTime = .FALSE.
     CALL INFO('iceproperties (getHeatConductivity)','Memory allocation done', level=3)
  END IF
  !-------------------------------------------
  ! get element properties
  !-------------------------------------------   
  IF ( .NOT. ASSOCIATED(Model % CurrentElement) ) THEN
     CALL FATAL('iceproperties (getHeatConductivity)', 'Model % CurrentElement not associated')
  END IF
  body_id = Model % CurrentElement % BodyId
  material_id = ListGetInteger(Model % Bodies(body_id) % Values, 'Material', GotIt)
  elementNodes = Model % CurrentElement % Type % NumberOfNodes
  IF (.NOT. GotIt) THEN
     WRITE(Message,'(a,I2,a,I2,a)') 'No material id for current element of node ',n,', body ',body_id,' found'
     CALL FATAL('iceproperties (getHeatConductivity)', Message)
  END IF
  DO nodeInElement=1,elementNodes
     IF ( N == Model % CurrentElement % NodeIndexes(nodeInElement) ) EXIT
  END DO
  Material => Model % Materials(material_id) % Values
  !-------------------------------------------
  ! get material properties
  !-------------------------------------------
  conductivityExponentFactor(1:elementNodes) = ListGetReal( Material,'Conductivity Exponent Factor', elementNodes, &
       Model % CurrentElement % NodeIndexes, GotIt )
  IF (.NOT. GotIt) THEN
     WRITE(Message,'(a,I2,a,I2,a)') 'No Conductivity Exponent Factor found in Material ', &
          material_id,' for node ', n, '.setting E=1'
     CALL FATAL('iceproperties (getHeatConductivity)', Message)
  END IF
  conductivityFactor(1:elementNodes) = ListGetReal( Material,'Conductivity Factor', elementNodes, &
       Model % CurrentElement % NodeIndexes, GotIt )
  IF (.NOT. GotIt) THEN
     WRITE(Message,'(a,I2,a,I2,a)') 'No Conductivity Factor found in Material ', material_id,' for node ', n, '.setting E=1'
     CALL FATAL('iceproperties (getHeatConductivity)', Message)
  END IF
  !-------------------------------------------
  ! compute heat conductivity
  !-------------------------------------------
  conductivity = conductivityFactor(nodeInElement)*EXP(conductivityExponentFactor(nodeInElement)*temperature)
END FUNCTION getHeatConductivity

!*********************************************************************************************************************************
!*
!* heat capacity of ice as a function of temperature (K):  k = c_1 + c_2 * T[C];
!*
!*********************************************************************************************************************************
FUNCTION getHeatCapacity( Model, N, temperature ) RESULT(capacity)
  USE types
  USE CoordinateSystems
  USE SolverUtils
  USE ElementDescription
  USE DefUtils
!-----------------------------------------------------------
  IMPLICIT NONE
!------------ external variables ---------------------------
  TYPE(Model_t) :: Model
  INTEGER :: N
  REAL(KIND=dp) :: temperature, capacity
!------------ internal variables----------------------------
  REAL(KIND=dp) :: celsius
  INTEGER :: body_id, material_id
  TYPE(ValueList_t), POINTER :: Material
  LOGICAL :: UseCelsius = .FALSE., GotIt

  body_id = Model % CurrentElement % BodyId
  material_id = ListGetInteger(Model % Bodies(body_id) % Values, 'Material', GotIt)
  IF (.NOT.GotIt) CALL FATAL('iceproperties (getHeatCapacity)','No Material ID found')
  Material => Model % Materials(material_id) % Values
  UseCelsius = GetLogical( Material,'Use Celsius',GotIt )
  IF (.NOT.GotIt) UseCelsius = .FALSE.

  !-------------------------------------------
  ! compute celsius temperature and limit it 
  ! to 0 deg
  !------------------------------------------- 
  IF (UseCelsius) THEN
     celsius = MIN(temperature, 0.0d00)
  ELSE
     celsius = MIN(temperature - 2.7316D02,0.0d00)
  END IF
  !-------------------------------------------
  ! compute heat capacity
  !-------------------------------------------  
  capacity = 2.1275D03 + 7.253D00*celsius
END FUNCTION getHeatCapacity

!****************************************************************************************************************
!*
!* viscosity factor as a function of temperature
!*
!****************************************************************************************************************
FUNCTION getViscosityFactor( Model, n, temperature ) RESULT(visFact)
  USE types
  USE CoordinateSystems
  USE SolverUtils
  USE ElementDescription
  USE DefUtils
!-----------------------------------------------------------
  IMPLICIT NONE
!------------ external variables ---------------------------
  TYPE(Model_t) :: Model
  INTEGER :: n
  REAL(KIND=dp) :: temperature, visFact
!------------ internal variables----------------------------
  TYPE(ValueList_t), POINTER :: Material
  INTEGER :: DIM,nMax,i,j,body_id,material_id,elementNodes,nodeInElement,istat
  REAL(KIND=dp) ::&
       rateFactor, aToMinusOneThird, gasconst, temphom
  REAL(KIND=dp), POINTER :: Hwrk(:,:,:)
  REAL (KIND=dp), ALLOCATABLE :: activationEnergy(:,:), arrheniusFactor(:,:),&
       enhancementFactor(:), viscosityExponent(:), PressureMeltingPoint(:),&
       Ux(:), Uy(:), Uz(:), LimitTemp(:)
  LOGICAL :: FirstTime = .TRUE., GotIt
  CHARACTER(LEN=MAX_NAME_LEN) :: TempName
!------------ remember this -------------------------------
  Save DIM, FirstTime, gasconst, activationEnergy, arrheniusFactor,&
       enhancementFactor, viscosityExponent, Hwrk, PressureMeltingPoint, &
       Ux, Uy, Uz, LimitTemp
!-----------------------------------------------------------
  !-----------------------------------------------------------
  ! Read in constants from SIF file and do some allocations
  !-----------------------------------------------------------
  IF (FirstTime) THEN
     ! inquire coordinate system dimensions  and degrees of freedom from NS-Solver
     ! ---------------------------------------------------------------------------
     DIM = CoordinateSystemDimension()
     ! inquire minimum temperature
     !------------------------- 
     gasconst = ListGetConstReal( Model % Constants,'Gas Constant',GotIt)
     IF (.NOT. GotIt) THEN
        gasconst = 8.314D00 ! m-k-s
        WRITE(Message,'(a,e10.4,a)') 'No entry for Gas Constant (Constants) in input file found. Setting to ',&
             gasconst,' (J/mol)'
        CALL INFO('iceproperties (getViscosityFactor)', Message, level=4)
     END IF
     nMax = Model % MaxElementNodes
     ALLOCATE(activationEnergy(2,nMax),&
          arrheniusFactor(2,nMax),&
          enhancementFactor(nMax),&
          LimitTemp( nMax),&
          PressureMeltingPoint( nMax ),&
          viscosityExponent(nMax),&
          Ux(nMax),&
          Uy(nMax),&
          Uz(nMax),&
          STAT=istat)
     IF ( istat /= 0 ) THEN
        CALL Fatal('iceproperties (getViscosityFactor)','Memory allocation error, Aborting.')
     END IF
     NULLIFY( Hwrk )
     FirstTime = .FALSE.
     CALL Info('iceproperties (getViscosityFactor)','Memory allocations done', Level=3)
  END IF
  !-------------------------------------------
  ! get element properties
  !-------------------------------------------   
  body_id = Model % CurrentElement % BodyId
  material_id = ListGetInteger(Model % Bodies(body_id) % Values, 'Material', GotIt)
  IF (.NOT.GotIt) CALL FATAL('iceproperties (getViscosityFactor)','No Material ID found')
  elementNodes = Model % CurrentElement % Type % NumberOfNodes
  IF (.NOT. GotIt) THEN
     WRITE(Message,'(a,I2,a,I2,a)') 'No material id for current element of node ',n,', body ',body_id,' found'
     CALL FATAL('iceproperties (getViscosityFactor)', Message)
  END IF
  DO nodeInElement=1,elementNodes
     IF ( N == Model % CurrentElement % NodeIndexes(nodeInElement) ) EXIT
  END DO
  Material => Model % Materials(material_id) % Values
  IF (.NOT.ASSOCIATED(Material)) THEN 
     WRITE(Message,'(a,I2,a,I2,a)') 'No Material for current element of node ',n,', body ',body_id,' found'
     CALL FATAL('iceproperties (getViscosityFactor)',Message)
  END IF
  !-------------------------------------------
  ! get material properties
  !-------------------------------------------
  ! activation energies
  !--------------------
  CALL ListGetRealArray( Material,'Activation Energies',Hwrk,elementNodes, &
       Model % CurrentElement % NodeIndexes, GotIt )
  IF (.NOT. GotIt) THEN
     WRITE(Message,'(a,I2,a,I2)') 'No Value for Activation Energy  found in Material ', material_id,' for node ', n
     CALL FATAL('iceproperties (getViscosityFactor)',Message)
  END IF
  IF ( SIZE(Hwrk,2) == 1 ) THEN
     DO i=1,MIN(3,SIZE(Hwrk,1))
        activationEnergy(i,1:elementNodes) = Hwrk(i,1,1:elementNodes)
     END DO
  ELSE
     WRITE(Message,'(a,I2,a,I2)') 'Incorrect array size for Activation Energy in Material ', material_id,' for node ', n
     CALL FATAL('iceproperties (getViscosityFactor)',Message)
  END IF
  ! Arrhenius Factors
  !------------------
  CALL ListGetRealArray( Material,'Arrhenius Factors',Hwrk,elementNodes, &
       Model % CurrentElement % NodeIndexes, GotIt )
  IF (.NOT. GotIt) THEN
     WRITE(Message,'(a,I2,a,I2)') 'No Value for Arrhenius Factors  found in Material ', material_id,' for node ', n
     CALL FATAL('iceproperties (getViscosityFactor)',Message)
  END IF
  IF ( SIZE(Hwrk,2) == 1 ) THEN
     DO i=1,MIN(3,SIZE(Hwrk,1))
        arrheniusFactor(i,1:elementNodes) = Hwrk(i,1,1:elementNodes)
     END DO
  ELSE
     WRITE(Message,'(a,I2,a,I2)') 'Incorrect array size for Arrhenius Factors in Material ', material_id,' for node ', n
     CALL FATAL('iceproperties (getViscosityFactor)',Message)
  END IF
  ! Enhancement Factor
  !-------------------
  enhancementFactor(1:elementNodes) = ListGetReal( Material,'Enhancement Factor', elementNodes, &
       Model % CurrentElement % NodeIndexes, GotIt )
  IF (.NOT. GotIt) THEN
     enhancementFactor(1:elementNodes) = 1.0D00
     WRITE(Message,'(a,I2,a,I2,a)') 'No Enhancement Factor found in Material ', material_id,' for node ', n, '.setting E=1'
     CALL INFO('iceproperties (getViscosityFactor)', Message, level=9)
  END IF
  ! Threshold temperature for switching activation energies and Arrhenius factors
  !------------------------------------------------------------------------------
  LimitTemp(1:elementNodes) = ListGetReal( Material,'Limit Temperature', elementNodes, &
       Model % CurrentElement % NodeIndexes, GotIt )
  IF (.NOT. GotIt) THEN
     LimitTemp(1:elementNodes) = -1.0D01
     WRITE(Message,'(a,I2,a,I2,a)') 'No keyword >Limit Temperature< found in Material ',&
          material_id,' for node ', n, '.setting to -10'
     CALL INFO('iceproperties (getFluidity)', Message, level=9)
  END IF
  ! Viscosity Exponent
  !-------------------
  viscosityExponent(1:elementNodes) = ListGetReal( Material,'Viscosity Exponent', elementNodes, &
       Model % CurrentElement % NodeIndexes, GotIt )
  IF (.NOT. GotIt) THEN
     viscosityExponent(1:elementNodes) = 1.0D00/3.0D00
     WRITE(Message,'(a,I2,a,I2,a)') 'No Viscosity Exponent found in Material ', material_id,' for node ', n, '.setting k=1/3'
     CALL INFO('iceproperties (getViscosityFactor)', Message, level=9)
  END IF
  ! Pressure Melting Point and homologous temperature
  !--------------------------------------------------
  TempName =  GetString(Material  ,'Temperature Name', GotIt)
  IF (.NOT.GotIt) CALL FATAL('iceproperties (getViscosityFactor)','No Temperature Name found')
  PressureMeltingPoint(1:elementNodes) =&
       ListGetReal( Material, TRIM(TempName) // ' Upper Limit',&
       elementNodes, Model % CurrentElement % NodeIndexes, GotIt )
  IF (.NOT.GotIt) THEN
     temphom = 0.0d00
     WRITE(Message,'(A,A,A,i3,A)') 'No entry for ',TRIM(TempName) // ' Upper Limit',&
          ' found in material no. ', material_id,'. Using 273.16 K.'
     CALL WARN('iceproperties (getViscosityFactor)',Message)
  ELSE
     temphom = MIN(temperature - PressureMeltingPoint(nodeInElement), 0.0d00)
  END IF
  !-------------------------------------------
  ! homologous Temperature is below 10 degrees
  !-------------------------------------------
  IF (temphom < LimitTemp(nodeInElement)) THEN
     i=1
     !-------------------------------------------
     ! homologous Temperature is above 10 degrees
     !-------------------------------------------
  ELSE
     i=2
  END IF
  rateFactor =&
       arrheniusFactor(i,nodeInElement)*exp(-1.0D00*activationEnergy(i,nodeInElement)/(gasconst*(2.7316D02 + temphom)))
  visFact = 0.5D00*(enhancementFactor(nodeInElement)*rateFactor)**(-1.0e00*viscosityExponent(nodeInElement))
END FUNCTION getViscosityFactor

!****************************************************************************************************************
!*
!* fluidity as a function of homologous temperature
!*
!****************************************************************************************************************
FUNCTION getFluidity( Model, n, temperature ) RESULT(fluidity)
  USE types
  USE CoordinateSystems
  USE SolverUtils
  USE ElementDescription
  USE DefUtils
!-----------------------------------------------------------
  IMPLICIT NONE
!------------ external variables ---------------------------
  TYPE(Model_t) :: Model
  INTEGER :: n
  REAL(KIND=dp) :: temperature, fluidity
!------------ internal variables----------------------------
  TYPE(ValueList_t), POINTER :: Material
  INTEGER :: DIM,nMax,i,j,body_id,material_id,elementNodes,nodeInElement,istat
  REAL(KIND=dp) ::&
       rateFactor, aToMinusOneThird, gasconst, temphom
  REAL(KIND=dp), POINTER :: Hwrk(:,:,:)
  REAL (KIND=dp), ALLOCATABLE :: activationEnergy(:,:), arrheniusFactor(:,:),&
       enhancementFactor(:), viscosityExponent(:), PressureMeltingPoint(:),&
       LimitTemp(:)
  LOGICAL :: FirstTime = .TRUE., GotIt
  CHARACTER(LEN=MAX_NAME_LEN) :: TempName
!------------ remember this -------------------------------
  Save DIM, FirstTime, gasconst, activationEnergy, arrheniusFactor,&
       enhancementFactor,  Hwrk, PressureMeltingPoint, LimitTemp
!-----------------------------------------------------------
  !-----------------------------------------------------------
  ! Read in constants from SIF file and do some allocations
  !-----------------------------------------------------------
  IF (FirstTime) THEN
     ! inquire coordinate system dimensions  and degrees of freedom from NS-Solver
     ! ---------------------------------------------------------------------------
     DIM = CoordinateSystemDimension()
     ! inquire minimum temperature
     !------------------------- 
     gasconst = ListGetConstReal( Model % Constants,'Gas Constant',GotIt)
     IF (.NOT. GotIt) THEN
        gasconst = 8.314D00 ! m-k-s
        WRITE(Message,'(a,e10.4,a)') 'No entry for Gas Constant (Constants) in input file found. Setting to ',&
             gasconst,' (J/mol)'
        CALL INFO('iceproperties (getFluidity)', Message, level=4)
     END IF
     nMax = Model % MaxElementNodes
     ALLOCATE(activationEnergy(2,nMax),&
          arrheniusFactor(2,nMax),&
          enhancementFactor(nMax),&
          PressureMeltingPoint( nMax ),&
          LimitTemp( nMax ), &
          STAT=istat)
     IF ( istat /= 0 ) THEN
        CALL Fatal('iceproperties (getFluidity)','Memory allocation error, Aborting.')
     END IF
     NULLIFY( Hwrk )
     FirstTime = .FALSE.
     CALL Info('iceproperties (getFluidity)','Memory allocations done', Level=3)
  END IF
  !-------------------------------------------
  ! get element properties
  !-------------------------------------------   
  body_id = Model % CurrentElement % BodyId
  material_id = ListGetInteger(Model % Bodies(body_id) % Values, 'Material', GotIt)
  IF (.NOT.GotIt) CALL FATAL('iceproperties (getFluidity)','No Material ID found')
  elementNodes = Model % CurrentElement % Type % NumberOfNodes
  IF (.NOT. GotIt) THEN
     WRITE(Message,'(a,I2,a,I2,a)') 'No material id for current element of node ',n,', body ',body_id,' found'
     CALL FATAL('iceproperties (getFluidity)', Message)
  END IF
  DO nodeInElement=1,elementNodes
     IF ( N == Model % CurrentElement % NodeIndexes(nodeInElement) ) EXIT
  END DO
  Material => Model % Materials(material_id) % Values
  IF (.NOT.ASSOCIATED(Material)) THEN 
     WRITE(Message,'(a,I2,a,I2,a)') 'No Material for current element of node ',n,', body ',body_id,' found'
     CALL FATAL('iceproperties (getFluidity)',Message)
  END IF
  !-------------------------------------------
  ! get material properties
  !-------------------------------------------
  ! activation energies
  !--------------------
  CALL ListGetRealArray( Material,'Activation Energies',Hwrk,elementNodes, &
       Model % CurrentElement % NodeIndexes, GotIt )
  IF (.NOT. GotIt) THEN
     WRITE(Message,'(a,I2,a,I2)') 'No Value for Activation Energy  found in Material ', material_id,' for node ', n
     CALL FATAL('iceproperties (getFluidity)',Message)
  END IF
  IF ( SIZE(Hwrk,2) == 1 ) THEN
     DO i=1,MIN(3,SIZE(Hwrk,1))
        activationEnergy(i,1:elementNodes) = Hwrk(i,1,1:elementNodes)
     END DO
  ELSE
     WRITE(Message,'(a,I2,a,I2)') 'Incorrect array size for Activation Energy in Material ', material_id,' for node ', n
     CALL FATAL('iceproperties (getFluidity)',Message)
  END IF
  ! Arrhenius Factors
  !------------------
  CALL ListGetRealArray( Material,'Arrhenius Factors',Hwrk,elementNodes, &
       Model % CurrentElement % NodeIndexes, GotIt )
  IF (.NOT. GotIt) THEN
     WRITE(Message,'(a,I2,a,I2)') 'No Value for Arrhenius Factors  found in Material ', material_id,' for node ', n
     CALL FATAL('iceproperties (getFluidity)',Message)
  END IF
  IF ( SIZE(Hwrk,2) == 1 ) THEN
     DO i=1,MIN(3,SIZE(Hwrk,1))
        arrheniusFactor(i,1:elementNodes) = Hwrk(i,1,1:elementNodes)
     END DO
  ELSE
     WRITE(Message,'(a,I2,a,I2)') 'Incorrect array size for Arrhenius Factors in Material ', material_id,' for node ', n
     CALL FATAL('iceproperties (getFluidity)',Message)
  END IF
  ! Enhancement Factor
  !-------------------
  enhancementFactor(1:elementNodes) = ListGetReal( Material,'Enhancement Factor', elementNodes, &
       Model % CurrentElement % NodeIndexes, GotIt )
  IF (.NOT. GotIt) THEN
     enhancementFactor(1:elementNodes) = 1.0D00
     WRITE(Message,'(a,I2,a,I2,a)') 'No Enhancement Factor found in Material ', material_id,' for node ', n, '.setting E=1'
     CALL INFO('iceproperties (getFluidity)', Message, level=9)
  END IF
  ! Threshold temperature for switching activation energies and Arrhenius factors
  !------------------------------------------------------------------------------
  LimitTemp(1:elementNodes) = ListGetReal( Material,'Limit Temperature', elementNodes, &
       Model % CurrentElement % NodeIndexes, GotIt )
  IF (.NOT. GotIt) THEN
     LimitTemp(1:elementNodes) = -1.0D01
     WRITE(Message,'(a,I2,a,I2,a)') 'No keyword >Limit Temperature< found in Material ',&
          material_id,' for node ', n, '.setting to -10'
     CALL INFO('iceproperties (getFluidity)', Message, level=9)
  END IF
  ! Pressure Melting Point and homologous temperature
  !--------------------------------------------------
  TempName =  GetString(Material,'Temperature Name', GotIt)
  IF (.NOT.GotIt) CALL FATAL('iceproperties (getFluidity)','No Temperature Name found')
  PressureMeltingPoint(1:elementNodes) =&
       ListGetReal( Material, TRIM(TempName) // ' Upper Limit',&
       elementNodes, Model % CurrentElement % NodeIndexes, GotIt )
  IF (.NOT.GotIt) THEN
     temphom = 0.0d00
     WRITE(Message,'(A,A,A,i3,A)') 'No entry for ',TRIM(TempName) // ' Upper Limit',&
          ' found in material no. ', material_id,'. Using 273.16 K.'
     CALL WARN('iceproperties (getFluidity)',Message)
  ELSE
     temphom = MIN(temperature - PressureMeltingPoint(nodeInElement), 0.0d00)
  END IF
  !-----------------------------------------------------
  ! homologous Temperature is below temperature treshold
  !----------------------------------------------------
  IF (temphom < LimitTemp(nodeInElement))THEN
     i=1
     !-----------------------------------------------------
     ! homologous Temperature is above temperature treshold
     !-----------------------------------------------------
  ELSE
     i=2
  END IF
  rateFactor =&
       arrheniusFactor(i,nodeInElement)*exp(-1.0D00*activationEnergy(i,nodeInElement)/(gasconst*(2.7316D02 + temphom)))
  fluidity = 2.0D00*enhancementFactor(nodeInElement)*rateFactor
END FUNCTION getFluidity


!*********************************************************************************************************************************
RECURSIVE SUBROUTINE getTotalViscosity(Model,Solver,Timestep,TransientSimulation)
  USE DefUtils
  USE Materialmodels
!-----------------------------------------------------------
  IMPLICIT NONE
!------------ external variables ---------------------------
  TYPE(Model_t)  :: Model
  TYPE(Solver_t), TARGET :: Solver
  LOGICAL :: TransientSimulation
  REAL(KIND=dp) :: Timestep
!------------------------------------------------------------------------------
!    Local variables
!------------------------------------------------------------------------------
  TYPE(GaussIntegrationPoints_t) :: IP
  TYPE(ValueList_t), POINTER :: Material, SolverParams
  TYPE(Variable_t), POINTER :: TotViscSol
  TYPE(Element_t), POINTER :: Element
  TYPE(Nodes_t) :: Nodes
  INTEGER :: DIM,nMax,i,p,q,t,N,body_id,material_id,nodeInElement,istat
  INTEGER, POINTER :: TotViscPerm(:)
  REAL(KIND=dp) ::  LocalDensity, LocalViscosity,effVisc,detJ,Norm
  REAL(KIND=dp), POINTER :: Hwrk(:,:,:)
  REAL(KIND=dp), POINTER :: TotVisc(:)
  REAL (KIND=dp), ALLOCATABLE ::  Ux(:), Uy(:), Uz(:), Density(:), Viscosity(:),&
       STIFF(:,:),FORCE(:),Basis(:),dBasisdx(:,:),ddBasisddx(:,:,:)
  LOGICAL :: FirstTime = .TRUE., GotIt, stat, limitation
!------------ remember this -------------------------------
  Save DIM, FirstTime, Nodes, Density, Ux, Uy, Uz, Viscosity, STIFF, FORCE, Basis,dBasisdx,ddBasisddx
  

  IF (FirstTime) THEN
     ! inquire coordinate system dimensions  and degrees of freedom from NS-Solver
     ! ---------------------------------------------------------------------------
     DIM = CoordinateSystemDimension()
     nMax = Model % MaxElementNodes 
     ALLOCATE(Ux(nMax),&
          Uy(nMax),&
          Uz(nMax),&
          Density(nMax),&
          Viscosity(nMax),&
          FORCE(nMax), &
          STIFF(nMax,nMax),&
          Nodes % x(nMax), &
          Nodes % y(nMax), &
          Nodes % z(nMax), &
          Basis(nMax),&
          dBasisdx(nMax,3),&
          ddBasisddx(nMax,3,3),&
          STAT=istat)
     IF ( istat /= 0 ) THEN
        CALL Fatal('iceproperties (getTotalViscosity)','Memory allocation error, Aborting.')
     END IF
     NULLIFY( Hwrk )
     FirstTime = .FALSE.
     CALL Info('iceproperties (getTotalViscosity)','Memory allocations done', Level=3)
  END IF

  CALL DefaultInitialize()

  DO t=1,Solver % NumberOfActiveElements 
     !-------------------------------------------
     ! get element properties
     !------------------------------------------- 
     Element => GetActiveElement(t)
     N = GetElementNOFNodes()
     body_id = Element % BodyId
     material_id = ListGetInteger(Model % Bodies(body_id) % Values, 'Material', GotIt)
     IF (.NOT. GotIt) THEN
        WRITE(Message,'(a,I2,a,I2,a)') &
             'No material id for current element of node ',n,', body ',body_id,' found'
        CALL FATAL('iceproperties (getTotalViscosity)', Message)
     
     END IF

     !-----------------------------------------
     ! get Material properties
     !-----------------------------------------
     Material => GetMaterial()
     IF (.NOT.ASSOCIATED(Material)) THEN 
        WRITE(Message,'(a,I2,a,I2,a)') &
             'No Material for current element of node ',n,', body ',body_id,' found'
        CALL FATAL('iceproperties (getTotalViscosit)',Message)
     END IF
     Density = ListGetReal( Material,'Density', N, Element % NodeIndexes, GotIt )
     IF (.NOT. GotIt) THEN
        WRITE(Message,'(a,I2,a,I2)') 'No Value for Density found in Material ', material_id,' for node ', n
        CALL FATAL('iceproperties (getTotalViscosity)',Message)
     END IF
     Viscosity = ListGetReal( Material,'Viscosity', N, Element % NodeIndexes, GotIt )
     IF (.NOT. GotIt) THEN
        WRITE(Message,'(a,I2,a,I2)') 'No Value for Viscosity found in Material ', material_id,' for node ', n
        CALL FATAL('iceproperties (getTotalViscosity)',Message)
     END IF

     !-----------------------------------------
     ! Velocity Field
     !----------------------------------------
     Ux = 0.0d00
     Uy = 0.0d00
     Uz = 0.0d00
  
     CALL GetScalarLocalSolution( Ux, 'Velocity 1')
     IF (DIM>1) THEN
        CALL GetScalarLocalSolution( Uy, 'Velocity 2')
        IF (DIM == 3) CALL GetScalarLocalSolution( Uz, 'Velocity 3')
     END IF
     

     STIFF = 0.0d00
     FORCE = 0.0d00

     IP = GaussPoints( Element )
     CALL GetElementNodes( Nodes )

     DO i=1,IP % n
        stat = ElementInfo( Element, Nodes, IP % U(i), IP % V(i), &
             IP % W(i),  detJ, Basis, dBasisdx, ddBasisddx, .FALSE. )
        !
        ! get local Material parameters at Gauss-point
        !
        LocalDensity = SUM(Density(1:n)*Basis(1:n))
        LocalViscosity = SUM(Viscosity(1:n)*Basis(1:n))
        !
        ! get effective Viscosity at Integration point
        !
        effVisc = EffectiveViscosity( LocalViscosity, LocalDensity,&
             Ux, Uy, Uz, &
             Element, Nodes, N, N,&
             IP % U(i), IP % V(i), IP % W(i))
         IF (effVisc .le. 0.0E00) THEN
           WRITE(Message,'(A,i10,A,i10,A,e13.3)')&
                'effective viscosity for Gauss point no. ', i, ' in element no. ', t,' is negative:', effVisc
           CALL WARN('iceproperties (getTotalViscosity)',Message)
        END IF
        DO p=1,n
           FORCE(p) = FORCE(p) + IP % S(i) * DetJ * effVisc * Basis(p)
           DO q=1,n
              STIFF(p,q) = STIFF(p,q) + IP % S(i) * detJ * Basis(q)*Basis(p)
           END DO
        END DO
     END DO
     CALL DefaultUpdateEquations( STIFF, FORCE )
  END DO
  CALL DefaultFinishAssembly()
!   CALL DefaultDirichletBCs()
  Norm = DefaultSolve()
  SolverParams => GetSolverParams()
  limitation = GetLogical( SolverParams,'Positive Values',GotIt )
  IF (.NOT. GotIt) limitation = .FALSE.
  IF (limitation) THEN
     CALL INFO('iceproperties (getTotalViscosity)','Results limited to positive values',Level=1)
     TotViscSol => Solver % Variable
     TotViscPerm  => TotViscSol % Perm
     TotVisc => TotViscSol % Values
     DO i= 1,Solver % Mesh % NumberOfNodes
        TotVisc(i) = MAX(TotVisc(i),0.0D00)
     END DO
  END IF
END SUBROUTINE getTotalViscosity



!*********************************************************************************************************************************
!*
!* viscosity as a function of the viscosity factor
!*
!*********************************************************************************************************************************
FUNCTION getCriticalShearRate( Model, n, temperature ) RESULT(critShear)
   USE types
   USE CoordinateSystems
   USE SolverUtils
   USE ElementDescription
!-----------------------------------------------------------
   IMPLICIT NONE
!------------ external variables ---------------------------
   TYPE(Model_t) :: Model
   INTEGER :: n
   REAL(KIND=dp) :: critShear, temperature
!------------ internal variables----------------------------
   TYPE(Element_t), POINTER :: Element
   TYPE(ValueList_t),POINTER :: Material
   INTEGER :: DIM, body_id, material_id
   REAL(KIND=dp) ::&
        visFact, cuttofViscosity, power, rateFactor, aToMinusOneThird,&
        activationEnergy, gasconst, enhancementFactor
   LOGICAL :: GotIt, FirstTime = .TRUE. 
!------------ remember this -------------------------------
   Save DIM, FirstTime
!-----------------------------------------------------------
! Read in constants from SIF file
!-----------------------------------------------------------
   IF (FirstTime) THEN
      ! inquire coordinate system dimensions  and degrees of freedom from NS-Solver
      ! ---------------------------------------------------------------------------
      DIM = CoordinateSystemDimension()
      gasconst = ListGetConstReal( Model % Constants,'Gas Constant',GotIt)
      IF (.NOT. GotIt) THEN
         gasconst = 8.314 ! m-k-s
         WRITE(Message,'(a,e10.4,a)') 'No entry for Gas Constant (Constants) in input file found. Setting to ',&
              gasconst,' (J/mol)'
         CALL INFO('iceproperties (getCriticalShearRate)', Message, level=9)
      END IF
      FirstTime = .FALSE.
   END IF
   ! inquire Model parameters
   !-------------------------
   Element => Model % CurrentElement
   body_id = Element % BodyId
   material_id = ListGetInteger( Model % Bodies(body_id) % Values,&
        'Material', Gotit, minv=1, maxv=Model % NumberOFMaterials)
   Material => Model % Materials(material_id) % Values
   power=  ListGetConstReal( Material, 'Viscosity Exponent', Gotit)
   IF (.NOT.Gotit) THEN
      CALL FATAL('iceproperties (getCriticalShearRate)', 'Viscosity Exponent not found')
   ELSE
      WRITE(Message,'(a,e10.4)') 'Viscosity Exponent =', power
      CALL INFO('iceproperties (getCriticalShearRate)', Message, level=9)
   END IF
   cuttofViscosity =  ListGetConstReal(Material, 'Cutoff Viscosity', Gotit)
   IF (.NOT.Gotit) THEN
      CALL FATAL('iceproperties (getCriticalShearRate)', 'Cutoff Viscosity not found')
   ELSE
      WRITE(Message,'(a,e10.4)') 'Cutoff Viscosity =', cuttofViscosity
      CALL INFO('iceproperties (getCriticalShearRate)', Message, level=9) 
   END IF

   ! get viscosity factor for local node
   ! -----------------------------------
!   visFact = ListGetReal(Material, 'Viscosity Factor',1, n, GotIt)
!   IF (.NOT.Gotit) THEN
!      WRITE(Message,'(a,i4,a)') 'Viscosity Factor for point no. ', n, ' not found' 
!      CALL FATAL('iceproperties (getCriticalShearRate)', 'Cutoff Viscosity not found'Message)
!   ELSE
!      WRITE(Message,'(a,i4,a,e10.4)') 'Viscosity Factor for point no. ',&
!           n, ' = ', visFact
!      CALL INFO('iceproperties (getCriticalShearRate)', Message, level=4) 
!   END IF

   IF (temperature < 263.15) THEN
      activationEnergy = 6.0e04 ! m-k-s
      aToMinusOneThird = 4.42577e16
      enhancementFactor = 1.0e00
   ELSE 
      activationEnergy = 1.39e05
      aToMinusOneThird = 2.62508e09
      enhancementFactor = 1.0e00
   END IF
   rateFactor = exp(-activationEnergy/(gasconst*temperature))
   visFact = 0.5*aToMinusOneThird*(enhancementFactor*rateFactor)**(-1.0e00/3.00e00)
   IF (visFact .NE. 0.0e0) THEN
      critShear = (cuttofViscosity/visFact)**(1.0e0/(1.0e0 - power))
   ELSE
      critShear = 0.0d0
   END IF
END FUNCTION getCriticalShearRate


!*********************************************************************************************************************************
!*
!* heat conductivity factor 
!*
!*********************************************************************************************************************************
FUNCTION getHeatConductivityFactorNew( Model, Node, relativeDensity ) RESULT(heatCondFact)
  USE types
  USE CoordinateSystems
  USE SolverUtils
  USE ElementDescription
!-----------------------------------------------------------
  IMPLICIT NONE
!------------ external variables ---------------------------
  TYPE(Model_t) :: Model
  INTEGER :: Node
  REAL(KIND=dp) :: relativeDensity, heatCondFact
  REAL(KIND=dp) :: volumefraction
  heatCondFact = 9.828D00 * (7.1306D-02 - 4.7908D-01 * relativeDensity + 1.40778D00 * relativeDensity * relativeDensity)
END FUNCTION getHeatConductivityFactorNew


!*********************************************************************************************************************************
!*
!* pressure melting point
!*
!*********************************************************************************************************************************
FUNCTION getPressureMeltingPoint( Model, n, Pressure ) RESULT(PressureMeltingPoint)
   USE types
   USE CoordinateSystems
   USE SolverUtils
   USE ElementDescription
   USE DefUtils
!-----------------------------------------------------------
   IMPLICIT NONE
!------------ external variables ---------------------------
   TYPE(Model_t) :: Model
   INTEGER :: n
   REAL(KIND=dp) :: PressureMeltingPoint, Pressure
!------------ internal variables----------------------------
   TYPE(Element_t), POINTER :: Element
   TYPE(ValueList_t),POINTER :: Material
   INTEGER :: body_id, material_id, nodeInElement, istat, elementNodes
   REAL(KIND=dp), ALLOCATABLE :: ClausiusClapeyron(:)
   LOGICAL :: GotIt, FirstTime = .TRUE., UseCelsius = .FALSE.
!------------ remember this -------------------------------
   Save FirstTime, ClausiusClapeyron
  !-------------------------------------------
  ! Allocations 
  !------------------------------------------- 
  IF (FirstTime) THEN
     ALLOCATE(ClausiusClapeyron(Model % MaxElementNodes),&
          STAT=istat)
     IF ( istat /= 0 ) THEN
        CALL FATAL('iceproperties (getPressureMeltingPoint)','Memory allocation error, Aborting.')
     END IF
     FirstTime = .FALSE.
     CALL INFO('iceproperties (getPressureMeltingPoint)','Memory allocation done', level=3)
  END IF
  !-------------------------------------------
  ! get element properties
  !-------------------------------------------   
  IF ( .NOT. ASSOCIATED(Model % CurrentElement) ) THEN
     CALL FATAL('iceproperties (getPressureMeltingPoint)', 'Model % CurrentElement not associated')
  ELSE
     Element => Model % CurrentElement
  END IF
  body_id = Element % BodyId
  material_id = ListGetInteger(Model % Bodies(body_id) % Values, 'Material', GotIt)
  elementNodes = Element % Type % NumberOfNodes
  IF (.NOT. GotIt) THEN
     WRITE(Message,'(a,I2,a,I2,a)') 'No material id for current element of node ',elementNodes,', body ',body_id,' found'
     CALL FATAL('iceproperties (getPressureMeltingPoint)', Message)
  END IF
  DO nodeInElement=1,elementNodes
     IF ( N == Model % CurrentElement % NodeIndexes(nodeInElement) ) EXIT
  END DO
  Material => Model % Materials(material_id) % Values
  !-------------------------
  ! get material parameters
  !-------------------------
  ClausiusClapeyron(1:elementNodes) = &
       ListGetReal( Material, 'Clausius Clapeyron', elementNodes, Element % NodeIndexes, GotIt)
  IF (.NOT. GotIt) THEN
     CALL FATAL('iceproperties (getPressureMeltingPoint)','No value for Clausius Clapeyron parameter found')
  END IF
  UseCelsius = GetLogical(Material,'Use Celsius',GotIt )
  IF (.NOT.GotIt) UseCelsius = .FALSE.
  !-------------------------------
  ! compute pressure melting point
  !-------------------------------
  PressureMeltingPoint = 2.7316D02 - ClausiusClapeyron(nodeInElement)*MAX(Pressure,0.0d00)
END FUNCTION getPressureMeltingPoint

!
!
!  Function a(D) and b(D) from Gagliardini and Meyssonier, 1997.
!  modified to fulfill the condition 3x a(D) >= 2x b(D) for D > 0.1 
!  for n=3 only 

FUNCTION OldParameterA ( Model, nodenumber, D ) RESULT(a)
   USE types
   USE CoordinateSystems
   USE SolverUtils
   USE ElementDescription
   USE DefUtils
   IMPLICIT NONE
   TYPE(Model_t) :: Model
   INTEGER :: nodenumber
   REAL(KIND=dp) :: a, D, DD     

    IF (D >= 1.0_dp) THEN
      a = 1.0_dp           

    ELSE IF (D <= 0.81) THEN
      DD = D
      IF (D < 0.1 ) DD = 0.1_dp
      a = EXP( 16.02784497_dp - 19.25_dp * DD )

    ELSE
      a =  1.0_dp  + 2.0/3.0 * (1.0_dp - D) 
      a = a / ( D**1.5 )

    End If
  END FUNCTION OldParameterA


FUNCTION OldParameterB ( Model, nodenumber, D ) RESULT(b)
   USE types
   USE CoordinateSystems
   USE SolverUtils
   USE ElementDescription
   USE DefUtils
   IMPLICIT NONE
   TYPE(Model_t) :: Model
   INTEGER :: nodenumber
   REAL(KIND=dp) :: b, D, DD 

    IF (D >= 1.0_dp) THEN
      b = 0.0_dp           

    ELSE IF (D <= 0.81) THEN
      DD = D
      IF (D < 0.1 ) DD = 0.1_dp
      b = EXP( 16.75024378_dp - 22.51_dp * DD )

    ELSE
      b = (1.0_dp - D)**(1.0/3.0) 
      b = 3.0/4.0 * ( b / (3.0 * (1 - b)) )**1.5

    End If
END FUNCTION OldParameterB

!
!  Function a(D) and b(D) from Gagliardini and Meyssonier, 1997.
!  modified to fulfill the condition 3x a(D) >= 2x b(D) for D > 0.4 
!  Such that a(0.4) = b(0.4) = 10^3
!  for n=3 only 

FUNCTION ParameterA ( Model, nodenumber, D ) RESULT(a)
   USE types
   USE CoordinateSystems
   USE SolverUtils
   USE ElementDescription
   USE DefUtils
   IMPLICIT NONE
   TYPE(Model_t) :: Model
   INTEGER :: nodenumber
   REAL(KIND=dp) :: a, D, DD     

    IF (D >= 1.0_dp) THEN
      a = 1.0_dp           

    ELSE IF (D <= 0.81) THEN
      DD = D
      IF (D < 0.4 ) DD = 0.4_dp
      a = EXP( 13.2224_dp - 15.78652_dp * DD )

    ELSE
      a =  1.0_dp  + 2.0/3.0 * (1.0_dp - D) 
      a = a / ( D**1.5 )

    End If
!    write(*,*)DD,a
END FUNCTION ParameterA 


FUNCTION ParameterB ( Model, nodenumber, D ) RESULT(b)
   USE types
   USE CoordinateSystems
   USE SolverUtils
   USE ElementDescription
   USE DefUtils
   IMPLICIT NONE
   TYPE(Model_t) :: Model
   INTEGER :: nodenumber
   REAL(KIND=dp) :: b, D, DD 

    IF (D >= 1.0_dp) THEN
      b = 0.0_dp           

    ELSE IF (D <= 0.81) THEN
      DD = D
      IF (D < 0.4 ) DD = 0.4_dp
      b = EXP( 15.09371_dp - 20.46489_dp * DD )

    ELSE
      b = (1.0_dp - D)**(1.0/3.0) 
      b = 3.0/4.0 * ( b / (3.0 * (1 - b)) )**1.5

    End If
!    write(*,*)DD,b
END FUNCTION ParameterB 


! *****************************************************************************
! calculates the SIA stress components on the free boundaries
!
! *****************************************************************************
RECURSIVE SUBROUTINE getSIAstress( Model,Solver,Timestep,TransientSimulation)
  USE DefUtils
  USE Materialmodels
!-----------------------------------------------------------
  IMPLICIT NONE
!------------ external variables ---------------------------
  TYPE(Model_t)  :: Model
  TYPE(Solver_t), TARGET :: Solver
  LOGICAL :: TransientSimulation
  REAL(KIND=dp) :: Timestep
!------------------------------------------------------------------------------
!    Local variables
!------------------------------------------------------------------------------
  TYPE(Solver_t), POINTER :: PointerToSolver
  TYPE(Nodes_t) :: Nodes
  TYPE(Element_t),POINTER :: Element
  TYPE(Variable_t), POINTER :: SIASol, DepthSol, SurfSol1, SurfSol2
  TYPE(ValueList_t), POINTER :: Equation,Material,SolverParams,BodyForce,BC,Constants
  CHARACTER(LEN=MAX_NAME_LEN) :: TempName, SolverName
  INTEGER :: i, j, k, l, t, N, BN,  M, DIM, SIADOFs, istat, material_id
  INTEGER, POINTER :: DepthSolPerm(:), SurfSol1Perm(:), SurfSol2Perm(:),&
       SIAPerm(:),BoundaryReorder(:)
  REAL(KIND=dp) ::  U, V, W, SqrtElementMetric, SIAstress(2), HydrostaticPressure
  REAL(KIND=dp), POINTER :: SIA(:), Depth(:), Surf1(:), Surf2(:), &
       BoundaryNormals(:,:), BoundaryTangent1(:,:), BoundaryTangent2(:,:)
  LOGICAL :: GotIt, FirstTimeAround=.TRUE., stat

  SAVE FirstTimeAround, SolverName, DIM, &
       BoundaryNormals, BoundaryTangent1, BoundaryTangent2, BoundaryReorder, BN

  ! assign solver name for communicative output
  !-----------------------------------------------------------------------
  WRITE(SolverName, '(A)') 'iceproperties (getSIAstress))'
  !-----------------------------------------------------------------------
  ! get solver variable
  !-----------------------------------------------------------------------
  SIASol => Solver % Variable
  IF (.NOT.ASSOCIATED(SIASol)) THEN
     CALL FATAL(SolverName,'No variable associated')
  END IF
  SIAPerm  => SIASol % Perm
  SIA => SIASol % Values
  SIADOFs =  SIASol % DOFs
  SIA = 0.0d00
  !-----------------------------------------------------------------------
  ! 
  !-----------------------------------------------------------------------
  IF ( FirstTimeAround .OR. Solver % Mesh % Changed ) THEN
     DIM = CoordinateSystemDimension()
     N = Solver % Mesh % MaxElementNodes
     M = Model % Mesh % NumberOfNodes        
     IF ( .NOT.FirstTimeAround ) &
          DEALLOCATE( &
          BoundaryReorder, &
          BoundaryNormals, &
          BoundaryTangent1, &
          BoundaryTangent2)
     ! check boundaries for calculation of SIA-stress and allocate necessary 
     ! space for averaged Normal and Tangentials
     !-----------------------------------------------------------------------
     CALL CheckNormalTangentialBoundary( Model, &
          'Calc SIA', BN, &
          BoundaryReorder, BoundaryNormals, BoundaryTangent1, &
          BoundaryTangent2, DIM )
     WRITE(Message,'(A,i6)') &
          'Number of boundary nodes on boundaries associated with SIA stresses:',&
          BN
     CALL INFO(SolverName,Message,Level=3)
     ! compute averaged normals and tangentials for  boundaries designated for
     ! SIA-stress boundary elements
     !-----------------------------------------------------------------------
     CALL AverageBoundaryNormals(Model, &
          'Calc SIA', BN, &
          BoundaryReorder, BoundaryNormals, BoundaryTangent1, &
          BoundaryTangent2, DIM )

     ! read in variables for flow depth and for free surface gradients
     !-----------------------------------------------------------------------
     DepthSol => VariableGet( Solver % Mesh % Variables, "Depth" )
     IF ( ASSOCIATED( DepthSol ) ) THEN
        DepthSolPerm => DepthSol % Perm
        Depth => DepthSol % Values
     ELSE
        WRITE(Message, '(A)') 'Could not find surface Gradient 1 field variable '
        CALL FATAL(SolverName,Message)
     END IF

     SurfSol1 => VariableGet( Solver % Mesh % Variables, "FreeSurfGrad1" )
     IF ( ASSOCIATED( SurfSol1 ) ) THEN
        SurfSol1Perm => SurfSol1 % Perm
        Surf1 => SurfSol1 % Values
     ELSE
        WRITE(Message, '(A)') 'Could not find Surface Gradient 1 field variable '
        CALL FATAL(SolverName,Message)
     END IF
     IF (DIM > 2) THEN
        SurfSol2 => VariableGet( Solver % Mesh % Variables, "FreeSurfGrad2" )
        IF ( ASSOCIATED( SurfSol2 ) ) THEN
           SurfSol2Perm => SurfSol2 % Perm
           Surf2 => SurfSol2 % Values
        ELSE
           WRITE(Message, '(A)') 'Could not find Surface Gradient 2 field variable '
           CALL FATAL(SolverName,Message)
        END IF
     END IF
     !-----------------------------------------------------------------------
     ! loop over all nodes in mesh
     !-----------------------------------------------------------------------
     DO i=1,Solver % Mesh % NumberOfNodes
        j = BoundaryReorder(i) ! projection from real space to SIA-stress 
        ! boundary space
        k = SIAPerm(i) ! projection from real space to solver matrix coordinate

        ! if boundary element node with SIA-stress condition enabled
        !-----------------------------------------------------------------------
        IF (j > 0) THEN
           HydrostaticPressure = -9.18D02 * 0.981E01 * Depth(DepthSolPerm(i))        
           SIAstress(1) =  HydrostaticPressure * Surf1(SurfSol1Perm(i))
           IF (DIM > 2) THEN
              SIAstress(2) = HydrostaticPressure * Surf2(SurfSol2Perm(i))
           ELSE
              SIAstress(2) = 0.0D00
           END IF

           ! vector product between Cauchy-stress tensor and surface normal
           !  = stress vector
           !-----------------------------------------------------------------------
           !Compute first element of the stress vector P*n(1)+txy*n(2) For  DIM=2 (two dimensions)
           !Compute first element of the stress vector P*n(1)+txz*n(3) for  Dim=3 (three-dimensions)
           SIA(SIADOFs*(k-1)+1)= HydrostaticPressure * BoundaryNormals(BoundaryReorder(i),1) &
                + SIAstress(1) * BoundaryNormals(BoundaryReorder(i),DIM)
           !Compute the second element of the stress vector in three-dimension P*n(2)+tyz*n(3)
           SIA(SIADOFs*(k-1)+2)= HydrostaticPressure * BoundaryNormals(BoundaryReorder(i),2) &
                + SIAstress(2) * BoundaryNormals(BoundaryReorder(i),3) ! this line doesn't contribute if 2d
           !If DIM=2, compute the second element of the stress vector in two-dimensions P*n(2)+txy*n(1)
           IF (DIM == 2) &
                SIA(SIADOFs*(k-1)+2)= SIA(SIADOFs*(k-1)+2) &
                + SIAstress(1) * BoundaryNormals(BoundaryReorder(i),1)
           !If DIM=3, compute the third element of the stress vector in three-dimensions P*n(3)+txz*n(1)+tyz*n(2)
           IF (DIM > 2) &
                SIA(SIADOFs*(k-1)+3)= HydrostaticPressure * BoundaryNormals(BoundaryReorder(i),3) &
                + SIAstress(1) * BoundaryNormals(BoundaryReorder(i),1) &
                + SIAstress(2) * BoundaryNormals(BoundaryReorder(i),2)   
        END IF
     END DO
     FirstTimeAround = .FALSE.
  END IF
END SUBROUTINE getSIAstress

!*********************************************************************************************************************************
!* Computation of component of the SIA stress vector. This code is  used for a rectangular type geometry where the automatic solution "getSIAstres" does not provide good results at the corner. Here we compute the components Pressure i in the sif file independantly for each side, North, Est, South and West. 
!*
!*********************************************************************************************************************************

!----------------------------------------------------------------------------------------------
!StressSIA: Compute the corresponding shallow-ice shear stress
!----------------------------------------------------------------------------------------------
FUNCTION StressSIA( Model, Node, surfaceGrad) RESULT(shearstress)
  USE Types
  USE CoordinateSystems
  USE SolverUtils
  USe ElementDescription
!-------------------------------------------------------------------
IMPLICIT NONE
!-------------------------external variables-----------------------
TYPE(Model_t) :: Model 
INTEGER :: Node
INTEGER, POINTER :: DepthPermutation(:)
REAL(KIND=dp) :: surfaceGrad, shearstress
TYPE(Variable_t), POINTER :: DepthSolution 

!Find variable for flow depth 
DepthSolution  => VariableGet(Model % Variables, 'Depth', .TRUE.)
DepthPermutation  => DepthSolution % Perm 
shearstress = -918.0D00*9.81D00*DepthSolution % Values(DepthPermutation(Node))*surfaceGrad
END FUNCTION StressSIA

!--------------------------------------------------------------------------------------------

FUNCTION invStressSIA( Model, Node, surfaceGrad) RESULT(shearstress)
  USE Types
  USE CoordinateSystems
  USE SolverUtils
  USe ElementDescription
!-------------------------------------------------------------------
IMPLICIT NONE
!-------------------------external variables-----------------------
TYPE(Model_t) :: Model 
INTEGER :: Node
INTEGER, POINTER :: DepthPermutation(:)
REAL(KIND=dp) :: surfaceGrad, shearstress
TYPE(Variable_t), POINTER :: DepthSolution 

!Find variable for flow depth 
DepthSolution  => VariableGet(Model % Variables, 'Depth', .TRUE.)
DepthPermutation  => DepthSolution % Perm 
shearstress = 918.0D00*9.81D00*DepthSolution % Values(DepthPermutation(Node))*surfaceGrad
END FUNCTION invStressSIA

!/******************************************************************************
! *
! *       ELMER, A Computational Fluid Dynamics Program.
! *
! *       Copyright 1st April 1995 - , Center for Scientific Computing,
! *                                    Finland.
! *
! *       All rights reserved. No part of this program may be used,
! *       reproduced or transmitted in any form or by any means
! *       without the written permission of CSC.
! *
! *****************************************************************************/
!
!/******************************************************************************
! *
! * Module containing a solver for a genral advection diffusion problem
! *
! ******************************************************************************
! *
! *                     Author:       Juha Ruokolainen
! *
! *                    Address: Center for Scientific Computing
! *                                Tietotie 6, P.O. BOX 405
! *                                  02101 Espoo, Finland
! *                                  Tel. +358 0 457 2723
! *                                Telefax: +358 0 457 2302
! *                              EMail: Juha.Ruokolainen@csc.fi
! *
! *                       Date: 08 Jun 1997
! *
! *                Modified by: Thomas Zwinger
! *
! *       Date of modification: 28 Nov 2005
! *
! *****************************************************************************/

!------------------------------------------------------------------------------
   RECURSIVE SUBROUTINE LimitedDiffusionSolver( Model,Solver,Timestep,TransientSimulation )
!DLLEXPORT LimitedDiffusionSolver
!------------------------------------------------------------------------------
!******************************************************************************
!
!  Solve the convection diffusion equation with limiters!
!
!  ARGUMENTS:
!
!  TYPE(Model_t) :: Model,  
!     INPUT: All model information (mesh,materials,BCs,etc...)
!
!  TYPE(Solver_t) :: Solver
!     INPUT: Linear equation solver options
!
!  REAL(KIND=dp) :: Timestep
!     INPUT: Timestep size for time dependent simulations
!
!******************************************************************************
     USE DiffuseConvective
     USE DiffuseConvectiveGeneral
     USE Differentials
     USE MaterialModels
!     USE Adaptive
     USE DefUtils

!------------------------------------------------------------------------------
     IMPLICIT NONE
!------------------------------------------------------------------------------

     TYPE(Model_t)  :: Model
     TYPE(Solver_t), TARGET :: Solver

     LOGICAL :: TransientSimulation
     REAL(KIND=dp) :: Timestep
!------------------------------------------------------------------------------
!    Local variables
!------------------------------------------------------------------------------
     TYPE(Solver_t), POINTER :: PointerToSolver
     TYPE(Matrix_t), POINTER :: Systemmatrix
     TYPE(Nodes_t) :: ElementNodes
     TYPE(Element_t),POINTER :: Element
     TYPE(Variable_t), POINTER :: TempSol,FlowSol,CurrentSol, MeshSol
     TYPE(ValueList_t), POINTER :: Equation,Material,SolverParams,BodyForce,BC,Constants

     INTEGER :: i,j,k,l,m,n,t,iter,body_id,eq_id,material_id, &
          istat, LocalNodes,bf_id, bc_id,  DIM, &
          NSDOFs, UzawaAfterIterations, NonlinearIter
     INTEGER, POINTER :: NodeIndexes(:), TempPerm(:),FlowPerm(:),CurrentPerm(:),MeshPerm(:)

     CHARACTER(LEN=MAX_NAME_LEN) :: ConvectionFlag, VariableName, SolverName, FlowSolName

     LOGICAL :: Stabilize = .TRUE., Bubbles = .TRUE., UseBubbles, &
          Found, FluxBC, Permeable=.TRUE., IsPeriodicBC=.FALSE.,&
          AllocationsDone = .FALSE.,  SubroutineVisited = .FALSE., FirstTime=.TRUE.,&
          LimitSolution, ApplyUzawa=.FALSE., ApplyDirichlet, UzawaAnyways, FlowSolutionFound
     LOGICAL, ALLOCATABLE ::  LimitedSolution(:), ActiveNode(:)

     REAL(KIND=dp) :: NonlinearTol, LinearTol, UzawaTol, Relax, &
          SaveRelax,dt,CumulativeTime, RelativeChange, &
          Norm,PrevNorm,S,C, &
          ReferencePressure=0.0d0, UzawaParameter, &
          HeatCapacityGradient(3), round = 0.0D00
     
     REAL(KIND=dp), ALLOCATABLE :: OldValues(:), OldRHS(:)

     REAL(KIND=dp), POINTER :: Temp(:), FlowSolution(:), &
          ForceVector(:), PrevSolution(:), HC(:), Hwrk(:,:,:),&
          LagrangeMultiplier(:), PointerToResidualVector(:), ResidualVector(:), TempHomologous(:)
     
     REAL(KIND=dp), ALLOCATABLE :: MASS(:,:), &
       STIFF(:,:), LOAD(:), HeatConductivity(:,:,:), &
         FORCE(:), Pressure(:),  MeshVelocity(:,:),&
         TempVeloU(:),TempVeloV(:),TempVeloW(:),TimeForce(:), &
         TransferCoeff(:), LocalTemp(:), Work(:), C1(:), C0(:), Zero(:), Viscosity(:),&
         UpperLimit(:), HeatCapacity(:),  Density(:), TempExt(:), &
         StiffVector(:)
     REAL(KIND=dp) :: at,at0,totat,st,totst,t1,CPUTime,RealTime

     SAVE &
          OldValues,             &
          OldRHS,                &
          MeshVelocity,          &
          TempVeloU,             &
          TempVeloV,             &
          TempVeloW,             &
          Pressure,              &
          ElementNodes    ,      &
          Work,Zero,             &
          Viscosity,             &
          HeatCapacity,          &
          Density,               &
          TempExt,               &
          C1,                    &
          C0,                    &
          TransferCoeff,         &
          LocalTemp,             &
          HeatConductivity,      &
          MASS,                  &
          STIFF,LOAD,            &
          FORCE,                 &
          TimeForce,             &
          LagrangeMultiplier,    &
          ResidualVector,        &
          TempHomologous,        &
          StiffVector,           &
          UpperLimit,            &
          LimitedSolution,       &
          ActiveNode,            &
          AllocationsDone, FirstTime, Hwrk, VariableName, SolverName, NonLinearTol, M, round

!------------------------------------------------------------------------------
!    Get variables needed for solution
!------------------------------------------------------------------------------
     DIM = CoordinateSystemDimension()
     SolverName = 'LimitDiffusion ('// TRIM(Solver % Variable % Name) // ')'
     VariableName = TRIM(Solver % Variable % Name)

     IF ( .NOT. ASSOCIATED( Solver % Matrix ) ) RETURN
     SystemMatrix => Solver % Matrix
     ForceVector => Solver % Matrix % RHS

     PointerToSolver => Solver

     TempSol => Solver % Variable
     TempPerm  => TempSol % Perm
     Temp => TempSol % Values
     
     LocalNodes = COUNT( TempPerm > 0 )
     IF ( LocalNodes <= 0 ) RETURN

     

!------------------------------------------------------------------------------
!    Allocate some permanent storage, this is done first time only
!------------------------------------------------------------------------------
     IF ( .NOT. AllocationsDone .OR. Solver % Mesh % Changed ) THEN
        N = Solver % Mesh % MaxElementNodes
        M = Model % Mesh % NumberOfNodes
        K = SIZE( SystemMatrix % Values )
        L = SIZE( SystemMatrix % RHS )

        IF ( AllocationsDone ) THEN
           DEALLOCATE(                    &
                OldValues,                &
                OldRHS,                   &
                MeshVelocity,             &
                TempVeloU,                &
                TempVeloV,                &
                TempVeloW,                &
                Pressure,                 &
                ElementNodes % x,         &
                ElementNodes % y,         &
                ElementNodes % z,         &
                Work,Zero,                &
                Viscosity,                &
                HeatCapacity,             &
                Density,                  &
                TempExt,                  &
                C1,                       &
                C0,                       &
                TransferCoeff,            &
                LocalTemp,                &
                HeatConductivity,         &
                MASS,                     &
                STIFF,LOAD,               &
                FORCE,                    &
                TimeForce,                &
                LagrangeMultiplier,       &
                ResidualVector,           &
                TempHomologous,           &
                StiffVector,              &
                UpperLimit,               &
                LimitedSolution,          &
                ActiveNode)              
        END IF                           
        
        ALLOCATE(                                  &
             OldValues( K ), &
             OldRHS( L ), &
             MeshVelocity( 3,N ),                  &
             TempVeloU( N ),                       &
             TempVeloV( N ),                       &
             TempVeloW( N ),                       &
             Pressure( N ),                        &
             ElementNodes % x( N ),                &
             ElementNodes % y( N ),                &
             ElementNodes % z( N ),                &
             Work( N ), Zero( N ),                 &
             Viscosity( N ),                       &
             HeatCapacity( M ),                    &
             Density( N ),                         &
             TempExt( N ),                         &
             C1( N ),                              &
             C0( N ),                              &
             TransferCoeff( N ),                   &
             LocalTemp( N ),                       &
             HeatConductivity( 3,3,N ),            &
             MASS(  2*N,2*N ),                     &
             STIFF( 2*N,2*N ),LOAD( N ),           &
             FORCE( 2*N ),                         &
             TimeForce( 2*N ),                     &
             LagrangeMultiplier( M ),              &
             ResidualVector( L ),                  &
             TempHomologous( M ),                  &
             StiffVector( M ),                     &
             UpperLimit( M ),                      &
             LimitedSolution( M ),                 &
             ActiveNode( M ),                      &
             STAT=istat )


        IF ( istat /= 0 ) THEN
           CALL Fatal( SolverName, 'Memory allocation error' )
        ELSE
           CALL INFO(SolverName, 'Memory allocation done', level=1 )
        END IF
        
        
        LagrangeMultiplier = 0.0d0



        ! Assign Variable for Residual (i.e., heat flux at boundaries)
        !-------------------------------------------------------------
        CALL VariableAdd( Solver % Mesh % Variables, Solver % Mesh, PointerToSolver, &
                TRIM(VariableName) //   ' Residual', 1, ResidualVector, TempPerm )
        CALL VariableAdd( Solver % Mesh % Variables, Solver % Mesh, PointerToSolver, &
                TRIM(VariableName) //   ' Homologous', 1, TempHomologous, TempPerm )

        AllocationsDone = .TRUE.
     END IF

!------------------------------------------------------------------------------
!    Say hello
!------------------------------------------------------------------------------
     WRITE(Message,'(A,A)')&
          'Limited diffusion Solver for variable ', VariableName
     CALL INFO(SolverName,Message,Level=1)

!------------------------------------------------------------------------------
!    Read physical and numerical constants and initialize 
!------------------------------------------------------------------------------
     Constants => GetConstants()
     SolverParams => GetSolverParams()

     Stabilize = GetLogical( SolverParams,'Stabilize',Found )
     IF (.NOT. Found) Stabilize = .FALSE.
     UseBubbles = GetLogical( SolverParams,'Bubbles',Found )
     IF ( .NOT.Found .AND. (.NOT.Stabilize)) UseBubbles = .TRUE.

     LinearTol = GetConstReal( SolverParams, &
          'Linear System Convergence Tolerance',    Found )
     IF ( .NOT.Found ) THEN
        CALL FATAL(SolverName, 'No >Linear System Convergence Tolerance< found')
     END IF


     NonlinearIter = GetInteger(   SolverParams, &
                     'Nonlinear System Max Iterations', Found )
     IF ( .NOT.Found ) NonlinearIter = 1


     NonlinearTol  = GetConstReal( SolverParams, &
          'Nonlinear System Convergence Tolerance',    Found )

     Relax = GetConstReal( SolverParams, &
               'Nonlinear System Relaxation Factor',Found )

     IF ( .NOT.Found ) Relax = 1.0D00

     UzawaParameter = GetConstReal( SolverParams, &
               'Uzawa Parameter', Found)



     IF (.NOT.Found) THEN                
        CALL INFO(SolverName, 'No >Uzawa Parameter< found. No Uzawa iteration will be made', level=1)
        UzawaParameter = -1.0D00
     ELSE
        WRITE(Message,'(a,e13.4)') 'Uzawa Parameter:',  UzawaParameter
        CALL INFO(SolverName, Message, level=1)
     END IF

     UzawaAfterIterations = GetInteger(SolverParams, &
          'Uzawa After Iterations', Found )
     IF ( .NOT.Found ) THEN
        UzawaAfterIterations = NonlinearIter + 1
        UzawaParameter = -1.0D00
     END IF


     ApplyDirichlet = GetLogical( SolverParams, &
          'Apply Dirichlet', Found)
     IF ( .NOT.Found ) THEN
        ApplyDirichlet = .FALSE.
        IF (UzawaParameter > 0.0D00) UzawaAfterIterations = 1
     END IF
     UzawaTol= GetConstReal( SolverParams, 'Uzawa Tolerance',    Found )
     IF (.NOT.Found) THEN
        UzawaTol = NonlinearTol
     END IF
     UzawaAnyways = GetLogical( SolverParams, &
          'Uzawa Anyways', Found)
     IF (( .NOT.Found ) .OR. (UzawaParameter <= 0.0D00)) THEN
        UzawaAnyways = .FALSE.
     END IF


     SaveRelax = Relax
     dt = Timestep
     CumulativeTime = 0.0d0
     ActiveNode = .FALSE.

!------------------------------------------------------------------------------
!   time stepping loop.
!------------------------------------------------------------------------------
     DO WHILE( CumulativeTime < Timestep-1.0d-12 .OR. .NOT. TransientSimulation )
        round = round +1.0D00
!------------------------------------------------------------------------------
!       The first time around this has been done by the caller...
!------------------------------------------------------------------------------
        IF ( TransientSimulation .AND. .NOT.FirstTime ) THEN
           CALL InitializeTimestep( Solver )
        END IF

!------------------------------------------------------------------------------
!       Save current solution
!------------------------------------------------------------------------------
        ALLOCATE( PrevSolution(LocalNodes) )
        PrevSolution = Temp(1:LocalNodes)

        totat = 0.0d0
        totst = 0.0d0

        IF (.NOT.ApplyDirichlet) ActiveNode = .FALSE.
        ResidualVector = 0.0D00
!------------------------------------------------------------------------------
!       non-linear system iteration loop
!------------------------------------------------------------------------------
        DO iter=1,NonlinearIter
           FirstTime = .FALSE.           
           !------------------------------------------------------------------------------
           ! print out some information
           !------------------------------------------------------------------------------
           at  = CPUTime()
           at0 = RealTime()

           CALL Info( SolverName, ' ', Level=4 )
           CALL Info( SolverName, ' ', Level=4 )
           CALL Info( SolverName, '-------------------------------------',Level=4 )
           WRITE( Message,'(A,A,I3,A,I3)') &
                TRIM(Solver % Variable % Name),  ' iteration no.', iter,' of ',NonlinearIter
           CALL Info( SolverName, Message, Level=4 )
           CALL Info( SolverName, '-------------------------------------',Level=4 )
           CALL Info( SolverName, ' ', Level=4 )
           CALL Info( SolverName, 'Starting Assembly...', Level=4 )
           !------------------------------------------------------------------------------
           ! lets start
           !------------------------------------------------------------------------------
           CALL DefaultInitialize()
           !-----------------------------------------------------------------------------
           ! Check, whether we apply Dirichlet or Uzawa method
           !-----------------------------------------------------------------------------
           IF (UzawaAfterIterations == iter) THEN
              CALL INFO(SolverName,'#############################' ,level=1)
              CALL INFO(SolverName,'# Switching to Uzawa method #' ,level=1)
              CALL INFO(SolverName,'#############################' ,level=1)
              ApplyDirichlet = .FALSE.
              ApplyUzawa = .TRUE.
!              IF (iter > 1) THEN
!                 DO i=1,Model % Mesh % NumberOfNodes
!                    LagrangeMultiplier(i) = ResidualVector(i)
!                 END DO
!              ELSE
!                 LagrangeMultiplier = 0.0D00
!             END IF
              NonlinearTol = UzawaTol
           END IF
           !-----------------------------------------------------------------------------
           ! Get lower and Upper limit:
           !-----------------------------------------------------------------------------
           DO t=1,Solver % NumberOfActiveElements
              Element => GetActiveElement(t)
              n = GetElementNOFNodes()
              CALL GetElementNodes( ElementNodes )
              Material => GetMaterial()
              ! upper limit
              !------------
              UpperLimit(Element % Nodeindexes(1:N)) = ListGetReal(Material,TRIM(VariableName) // & 
                   ' Upper Limit',n,Element % NodeIndexes, Found)
              IF (.NOT. Found) THEN
                 LimitedSolution(Element % Nodeindexes(1:N)) = .FALSE.
                 WRITE(Message,'(a,i10)') 'No upper limit of solution for element no. ', t
                 CALL INFO(SolverName, Message, level=10)
              ELSE
                 LimitedSolution(Element % Nodeindexes(1:N)) = .TRUE.
              END IF
           END DO

           !-----------------------------------------------------------------------------
           !Update Lagrange multiplier:
           !-----------------------------------------------------------------------------
           IF (ApplyUzawa) THEN
!              UpperLimit = 0.0d00
              !-------------------------
              ! get Lagrange Multipliers
              ! ------------------------
              DO i = 1,M
                 IF (LimitedSolution(i)) THEN
                    LagrangeMultiplier(i) = MAX( 0.0d0, LagrangeMultiplier(i) + UzawaParameter * &
                         (Temp(TempPerm(i)) - UpperLimit(i)))
!                    Print *, LagrangeMultiplier(i), UzawaParameter,Temp(TempPerm(i)), UpperLimit(i)
                 ELSE 
                    LagrangeMultiplier(i) = 0.0d00
                 END IF
              END DO
              CALL INFO(SolverName,'Max/min values Lagrange multiplier ...',Level=4)
              WRITE(Message,'(a,e13.6,a,e13.6)') &
                   '... for upper constraint:', MAXVAL( LagrangeMultiplier(:) ),'/',MINVAL( LagrangeMultiplier(:) )
              CALL INFO(SolverName,Message,Level=4)
           END IF
           !------------------------------------------------------------------------------
           ! write some info on max/min values
           !------------------------------------------------------------------------------
           WRITE(Message,'(a,e13.6,a,e13.6)') &
                'Max/min values Temperature:', MAXVAL( Temp(:)),'/',MINVAL( Temp(:))
           CALL INFO(SolverName,Message,Level=4)
           !------------------------------------------------------------------------------
           body_id = -1
           NULLIFY(Material)
           !------------------------------------------------------------------------------
           ! Bulk elements
           !------------------------------------------------------------------------------
           DO t=1,Solver % NumberOfActiveElements
              !------------------------------------------------------------------------------
              ! write some info on status of assembly
              !------------------------------------------------------------------------------
              IF ( RealTime() - at0 > 1.0 ) THEN
                 WRITE(Message,'(a,i3,a)' ) '   Assembly: ', INT(100.0 - 100.0 * &
                      (Solver % NumberOfActiveElements-t) / &
                      (1.0*Solver % NumberOfActiveElements)), ' % done'

                 CALL Info( SolverName, Message, Level=5 )

                 at0 = RealTime()
              END IF
              !------------------------------------------------------------------------------
              ! Check if this element belongs to a body where scalar equation
              ! should be calculated
              !------------------------------------------------------------------------------
              Element => GetActiveElement(t,Solver)
              IF (.NOT.ASSOCIATED(Element)) CYCLE
              IF ( Element % BodyId /= body_id ) THEN
                 Equation => GetEquation()
                 IF (.NOT.ASSOCIATED(Equation)) THEN
                    WRITE (Message,'(A,I3)') 'No Equation  found for boundary element no. ', t
                    CALL FATAL(SolverName,Message)
                 END IF

                 ConvectionFlag = GetString( Equation, 'Convection', Found )

                 Material => GetMaterial()
                 IF (.NOT.ASSOCIATED(Material)) THEN
                    WRITE (Message,'(A,I3)') 'No Material found for boundary element no. ', t
                    CALL FATAL(SolverName,Message)
                 ELSE
                    material_id = GetMaterialId( Element, Found)
                    IF(.NOT.Found) THEN
                       WRITE (Message,'(A,I3)') 'No Material ID found for boundary element no. ', t
                       CALL FATAL(SolverName,Message)
                    END IF
                 END IF
              END IF


              k = ListGetInteger( Model % Bodies(Element % BodyId) % Values, 'Equation', &
                   minv=1, maxv=Model % NumberOFEquations )

              SELECT CASE( ListGetString( Model % Equations(k) % Values, &
                   'Convection', Found ) )

                 !-----------------
              CASE( 'computed' )
                 !-----------------

                 FlowSolName =  GetString( Model % Equations(k) % Values,'Flow Solution Name', Found)
                 IF(.NOT.Found) THEN        
                    CALL WARN(SolverName,'Keyword >Flow Solution Name< not found in section >Equation<')
                    CALL WARN(SolverName,'Taking default value >Flow Solution<')
                    WRITE(FlowSolName,'(A)') 'Flow Solution'
                 END IF


                 FlowSol => VariableGet( Solver % Mesh % Variables, FlowSolName )
                 IF ( ASSOCIATED( FlowSol ) ) THEN
                    FlowPerm     => FlowSol % Perm
                    NSDOFs       =  FlowSol % DOFs
                    FlowSolution => FlowSol % Values
                    FlowSolutionFound = .TRUE.
                 ELSE
                    CALL INFO(SolverName,'No Flow Solution associated',Level=1)
                    FlowSolutionFound = .FALSE.
                 END IF
              CASE( "none")
                 FlowSolutionFound = .FALSE.

              END SELECT

              !------------------------------------------------------------------------------
              ! Get element material parameters
              !------------------------------------------------------------------------------              
              N = GetElementNOFNodes(Element)
              CALL GetElementNodes( ElementNodes )
              CALL ListGetRealArray( Material,TRIM(Solver % Variable % Name) // &
                   ' Heat Conductivity',Hwrk,n, Element % NodeIndexes )
              HeatConductivity = 0.0d0
              IF ( SIZE(Hwrk,1) == 1 ) THEN
                 DO i=1,3
                    HeatConductivity( i,i,1:N ) = Hwrk( 1,1,1:N)
                 END DO
              ELSE IF ( SIZE(Hwrk,2) == 1 ) THEN
                 DO i=1,MIN(3,SIZE(Hwrk,1))
                    HeatConductivity(i,i,1:N) = Hwrk(i,1,1:N)
                 END DO
              ELSE
                 DO i=1,MIN(3,SIZE(Hwrk,1))
                    DO j=1,MIN(3,SIZE(Hwrk,2))
                       HeatConductivity(i,j,1:N) = Hwrk(i,j,1:N)
                    END DO
                 END DO
              END IF              
              HeatCapacity(1:N) =  ListGetReal( Material,  TRIM(Solver % Variable % Name) // &
                   ' Heat Capacity', n, Element % NodeIndexes, Found )
              IF (.NOT.Found) THEN
                 HeatCapacity = 0.0D00
                 WRITE(Message,'(a,a,a,i5,a,i5,a)') 'Keyword >', TRIM(Solver % Variable % Name) // &
                   ' Heat Capacity', '< not found for element ', t, ' material ', material_id
                 CALL INFO(SolverName,Message,Level=4)
              END IF

              Density(1:N) = ListGetReal( Material, 'Density',  N, Element % NodeIndexes, Found )
              IF (.NOT.Found) THEN
                 Density = 0.0D00
                 WRITE(Message,'(a,i5,a,i5,a)') 'Keyword >Density< not found for element ',&
                      t, ' material ', material_id
                 CALL INFO(SolverName,Message,Level=4)
              END IF
              !------------------------------------------
              ! NB.: viscosity needed for strain heating
              !      but Newtonian flow is assumed
              !------------------------------------------
              Viscosity = 0.0D00
              !------------------------------------------------------------------------------
              ! Get mesh velocity
              !------------------------------------------------------------------------------
              MeshVelocity = 0.0d0
              CALL GetVectorLocalSolution( MeshVelocity, 'Mesh Velocity')
              !------------------------------------------------------------------------------         
              ! asuming convection or ALE mesh contribution by default
              !------------------------------------------------------------------------------         
              DO i=1,N
                 C1(i) = Density(i) * HeatCapacity(i)
!                 C1(i) = HeatCapacity(i)
!                 PRINT *, 'C1(',i,')=',C1(i)
              END DO
              !------------------------------------------------------------------------------
              ! Get scalar velocity
              !------------------------------------------------------------------------------         
              TempVeloU = 0.0d00
              TempVeloV = 0.0d00
              TempVeloW = 0.0d00
              ! constant (i.e., in section Material given) velocity
              !---------------------------------------------------
              IF ( ConvectionFlag == 'constant' ) THEN
                 TempVeloU(1:N)= GetReal( Material, 'Convection Velocity 1', Found )
                 TempVeloV(1:N) = GetReal( Material, 'Convection Velocity 2', Found )
                 TempVeloW(1:N) = GetReal( Material, 'Convection Velocity 3', Found )                 
              ! computed velocity
              !------------------
              ELSE IF (( ConvectionFlag == 'computed' ) .AND. FlowSolutionFound) THEN
                 DO i=1,n
                    k = FlowPerm(Element % NodeIndexes(i))
                    IF ( k > 0 ) THEN
                       Pressure(i) = FlowSolution(NSDOFs*k) + ReferencePressure
                       SELECT CASE( NSDOFs )
                       CASE(3)
                          TempVeloU(i) = FlowSolution( NSDOFs*k-2 )
                          TempVeloV(i) = FlowSolution( NSDOFs*k-1 )
                          TempVeloW(i) = 0.0D0
                       CASE(4)
                          TempVeloU(i) = FlowSolution( NSDOFs*k-3 )
                          TempVeloV(i) = FlowSolution( NSDOFs*k-2 )
                          TempVeloW(i) = FlowSolution( NSDOFs*k-1 )
                       END SELECT
                    END IF
                 END DO
                 WRITE(Message,'(a,i5, a, i5)') 'Convection in element ', t, &
                      ' material ',  material_id
              ELSE  ! Conduction and ALE contribution only
                 IF (ANY( MeshVelocity /= 0.0d0 )) THEN
                    WRITE(Message,'(a,i5, a, i5)') 'Only mesh deformation in element ', t,&
                         ' material ',  material_id
                 ELSE ! neither convection nor ALE mesh deformation contribution -> all C1(1:N)=0
                    C1 = 0.0D0 
                    WRITE(Message,'(a,i5, a, i5)') 'No convection and mesh deformation in element ', t,&
                         ' material ',  material_id
                 END IF                 
              END IF
              CALL INFO(SolverName,Message,Level=10)
              !------------------------------------------------------------------------------
              ! no contribution proportional to temperature by default
              !------------------------------------------------------------------------------
              C0=0.0d00
              !------------------------------------------------------------------------------
              ! Add body forces
              !------------------------------------------------------------------------------
              LOAD = 0.0D00
              BodyForce => GetBodyForce()
              IF ( ASSOCIATED( BodyForce ) ) THEN
                 bf_id = GetBodyForceId()
                 LOAD(1:N) = LOAD(1:N) +   &
                      GetReal( BodyForce, TRIM(Solver % Variable % Name) // ' Volume Source', Found )
              END IF
              !------------------------------------------------------------------------------
              ! Lagrange multipliers
              !------------------------------------------------------------------------------
              IF (ApplyUzawa) THEN
                 LOAD(1:N) = LOAD(1:N) &
                      - LagrangeMultiplier(Element % NodeIndexes(1:N))
              END IF
              !------------------------------------------------------------------------------
              ! dummy input array for faking   heat capacity, density, temperature, 
              !                                enthalpy and viscosity
              !------------------------------------------------------------------------------
              Work = 1.0d00
              Zero = 0.0D00
              !------------------------------------------------------------------------------
              ! Do we really need residual free Bubbles
              !------------------------------------------------------------------------------
              Bubbles = UseBubbles  .AND. &
                   ( ConvectionFlag == 'computed' .OR. ConvectionFlag == 'constant' )         
              !------------------------------------------------------------------------------
              ! Get element local matrices, and RHS vectors
              !------------------------------------------------------------------------------
              MASS = 0.0d00
              STIFF = 0.0d00
              FORCE = 0.0D00
              ! cartesian coords
              !----------------
              IF ( CurrentCoordinateSystem() == Cartesian ) THEN
                 CALL DiffuseConvectiveCompose( &
                      MASS, STIFF, FORCE, LOAD, &
                      HeatCapacity, C0, C1(1:N), HeatConductivity, &
                      .FALSE., Zero, Zero, TempVeloU, TempVeloV, TempVeloW, &
                      MeshVelocity(1,1:N),MeshVelocity(2,1:N),MeshVelocity(3,1:N),&
                      Viscosity, Density, Pressure, Zero, Zero,&
                      .FALSE., Stabilize, Bubbles, Element, n, ElementNodes )
              ! special coords (account for metric)
              !-----------------------------------
              ELSE
                 CALL DiffuseConvectiveGenCompose( &
                      MASS, STIFF, FORCE, LOAD, &
                      HeatCapacity, C0, C1(1:N), HeatConductivity, &
                      .FALSE., Zero, Zero, TempVeloU, TempVeloV, TempVeloW, &
                      MeshVelocity(1,1:N),MeshVelocity(2,1:N),MeshVelocity(3,1:N), Viscosity,&
                      Density, Pressure, Zero, Zero,.FALSE.,&
                      Stabilize, Element, n, ElementNodes )

              END IF              
              !------------------------------------------------------------------------------
              ! If time dependent simulation add mass matrix to stiff matrix
              !------------------------------------------------------------------------------
              TimeForce  = FORCE
              IF ( TransientSimulation ) THEN
                 IF ( Bubbles ) FORCE = 0.0d0
                 CALL Default1stOrderTime( MASS,STIFF,FORCE )
              END IF
              !------------------------------------------------------------------------------
              !  Update global matrices from local matrices
              !------------------------------------------------------------------------------
              IF (  Bubbles ) THEN
                 CALL Condensate( N, STIFF, FORCE, TimeForce )
                 IF (TransientSimulation) CALL DefaultUpdateForce( TimeForce )
              END IF

              CALL DefaultUpdateEquations( STIFF, FORCE )
           END DO     !  Bulk elements


           !------------------------------------------------------------------------------
           ! Neumann & Newton boundary conditions
           !------------------------------------------------------------------------------
           DO t=1, Solver % Mesh % NumberOfBoundaryElements

              ! get element information
              Element => GetBoundaryElement(t)
              IF ( .NOT.ActiveBoundaryElement() ) CYCLE
              n = GetElementNOFNodes()
              IF ( GetElementFamily() == 1 ) CYCLE
              BC => GetBC()
              bc_id = GetBCId( Element )
              CALL GetElementNodes( ElementNodes )


              IF ( ASSOCIATED( BC ) ) THEN            
                 ! Check that we are on the correct boundary part!
                 STIFF=0.0D00
                 FORCE=0.0D00
                 MASS=0.0D00
                 LOAD=0.0D00
                 TransferCoeff = 0.0D00
                 TempExt = 0.0D00
                 FluxBC = .FALSE.
                 FluxBC =  GetLogical(BC,TRIM(Solver % Variable % Name) // ' Flux BC', Found)

                 IF (FluxBC) THEN
                    !------------------------------
                    !BC: -k@T/@n = \alpha(T - TempExt)
                    !------------------------------
                    TransferCoeff(1:N) = GetReal( BC, TRIM(Solver % Variable % Name) //  ' Transfer Coefficient',Found )
                    IF ( ANY(TransferCoeff(1:N) /= 0.0d0) ) THEN
                       TempExt(1:N) = GetReal( BC, TRIM(Solver % Variable % Name) // ' External Value',Found )   
                       DO j=1,n
                          LOAD(j) = LOAD(j) +  TransferCoeff(j) * TempExt(j)
                       END DO
                    END IF
                    !---------------
                    !BC: -k@T/@n = q
                    !---------------
                    LOAD(1:N)  = LOAD(1:N) + &
                         GetReal( BC, TRIM(Solver % Variable % Name) // ' Heat Flux', Found )
                    ! -------------------------------------
                    ! set boundary due to coordinate system
                    ! -------------------------------------
                    IF ( CurrentCoordinateSystem() == Cartesian ) THEN
                       CALL DiffuseConvectiveBoundary( STIFF,FORCE, &
                            LOAD,TransferCoeff,Element,n,ElementNodes )
                    ELSE
                       CALL DiffuseConvectiveGenBoundary(STIFF,FORCE,&
                            LOAD,TransferCoeff,Element,n,ElementNodes ) 
                    END IF
                 END IF
              END IF

              !------------------------------------------------------------------------------
              ! Update global matrices from local matrices
              !------------------------------------------------------------------------------
              IF ( TransientSimulation ) THEN
                 MASS = 0.d0
                 CALL Default1stOrderTime( MASS, STIFF, FORCE )
              END IF
          
              CALL DefaultUpdateEquations( STIFF, FORCE )
           END DO   ! Neumann & Newton BCs
           !------------------------------------------------------------------------------

           CALL DefaultFinishAssembly()
           CALL DefaultDirichletBCs()


           OldValues = SystemMatrix % Values
           OldRHS = ForceVector

           !------------------------------------------------------------------------------
           ! Dirichlet method - matrix and force-vector manipulation
           !------------------------------------------------------------------------------
           IF (ApplyDirichlet) THEN
              ! manipulation of the matrix
              !---------------------------


              DO i=1,Model % Mesh % NumberOfNodes
                 k = TempPerm(i)           
                 IF (ActiveNode(i) .AND. (k > 0)) THEN
                    CALL ZeroRow( SystemMatrix, k ) 
                    CALL SetMatrixElement( SystemMatrix, k, k, 1.0D00)
                    SystemMatrix % RHS(k) = UpperLimit(i)
                 END IF
              END DO
           END IF


           CALL Info( SolverName, 'Assembly done', Level=4 )

           !------------------------------------------------------------------------------
           !     Solve the system and check for convergence
           !------------------------------------------------------------------------------
           at = CPUTime() - at
           st = CPUTime()

           PrevNorm = Solver % Variable % Norm

           Norm = DefaultSolve()

           st = CPUTIme()-st
           totat = totat + at
           totst = totst + st
           WRITE(Message,'(a,i4,a,F8.2,F8.2)') 'iter: ',iter,' Assembly: (s)', at, totat
           CALL Info( SolverName, Message, Level=4 )
           WRITE(Message,'(a,i4,a,F8.2,F8.2)') 'iter: ',iter,' Solve:    (s)', st, totst
           CALL Info( SolverName, Message, Level=4 )


           IF ( PrevNorm + Norm /= 0.0d0 ) THEN
              RelativeChange = 2.0d0 * ABS( PrevNorm-Norm ) / (PrevNorm + Norm)
           ELSE
              RelativeChange = 0.0d0
           END IF

           WRITE( Message, * ) 'Result Norm   : ',Norm
           CALL Info( SolverName, Message, Level=4 )
           WRITE( Message, * ) 'Relative Change : ',RelativeChange
           CALL Info( SolverName, Message, Level=4 )


           SystemMatrix % Values = OldValues
           ForceVector = OldRHS
           

!           CALL ListAddConstReal(Solver % Values,  &
!                'Nonlinear System Relaxation Factor', Relax )

           !------------------------------------------------------------------------------
           ! compute residual
           !------------------------------------------------------------------------------
           CALL CRS_MatrixVectorMultiply( SystemMatrix, Temp, StiffVector)
!           PRINT *, Solver % Matrix % RHS(1:10), SIZE(Solver % Matrix % RHS), SIZE(StiffVector), SIZE(ResidualVector)
           ResidualVector =  StiffVector - Solver % Matrix % RHS
 

           DO i=1,Model % Mesh % NumberOfNodes
              k = TempPerm(i)
              TempHomologous(k) = Temp(k) - UpperLimit(i)
              IF (ApplyDirichlet) THEN

                 ! if upper limit is exceeded, manipulate matrix in any case
                 !----------------------------------------------------------
                 IF (TempHomologous(k) .GE. 0.0D00 ) THEN
                    ActiveNode(i) = .TRUE.
                 END IF                 

                 ! if there is "heating", don't manipulate the matrix
                 !---------------------------------------------------
                 IF (ResidualVector(k) > -LinearTol .AND. iter > 1) ActiveNode(i) = .FALSE.



              END IF
           END DO
           ! special treatment for periodic boundaries
           !------------------------------------------
           k=0
           DO t=1, Solver % Mesh % NumberOfBoundaryElements

              ! get element information
              Element => GetBoundaryElement(t)
              IF ( .NOT.ActiveBoundaryElement() ) CYCLE
              n = GetElementNOFNodes()
              IF ( GetElementFamily() == 1 ) CYCLE
              BC => GetBC()
              bc_id = GetBCId( Element )
              CALL GetElementNodes( ElementNodes )


              IF ( ASSOCIATED( BC ) ) THEN    
!                 PRINT *, 'Periodic BC ' // TRIM(Solver % Variable % Name)
                 IsPeriodicBC = GetLogical(BC,'Periodic BC ' // TRIM(Solver % Variable % Name),Found)
                 IF (.NOT.Found) IsPeriodicBC = .FALSE.
                 IF (IsPeriodicBC) THEN 
                    DO i=1,N
                       IF  (ActiveNode(Element % NodeIndexes(i))) THEN
                          k = k + 1
                          ActiveNode(Element % NodeIndexes(i)) = .FALSE.
                       END IF
                    END DO
                 END IF
              END IF
           END DO

           ! check for convergence
           !----------------------
           IF ( RelativeChange < NonlinearTol ) THEN
              EXIT
           ELSE
              IF (ApplyDirichlet) THEN
                 WRITE(Message,'(a,i10)') 'Deactivated Periodic BC nodes:', k
                 CALL INFO(SolverName,Message,Level=1)
                 WRITE(Message,'(a,i10)') 'Number of constrained points:', COUNT(ActiveNode)
                 CALL INFO(SolverName,Message,Level=1)
              END IF
           END IF
           


        END DO ! of the nonlinear iteration
        !------------------------------------------------------------------------------

        !------------------------------------------------------------------------------
        !   Compute cumulative time done by now and time remaining
        !------------------------------------------------------------------------------
        IF ( .NOT. TransientSimulation ) EXIT
        CumulativeTime = CumulativeTime + dt
        dt = Timestep - CumulativeTime
     END DO ! time interval
     !------------------------------------------------------------------------------



     DEALLOCATE( PrevSolution )

!   IF ( ListGetLogical( Solver % Values, 'Adaptive Mesh Refinement', Found ) ) &
!      CALL RefineMesh( Model,Solver,Temp,TempPerm, &
!            HeatInsideResidual, HeatEdgeResidual, HeatBoundaryResidual )

     SubroutineVisited = .TRUE.

!------------------------------------------------------------------------------
   END SUBROUTINE LimitedDiffusionSolver
!------------------------------------------------------------------------------

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c  Interpolation quadratique d'une quantite Q definie en x1,x2,x3
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      Function InterP(t,x,Q)

      use defgrid
c
      Implicit None
      Real(kind=dp), Dimension(3) :: x,Q
      Real(kind=dp) :: t,InterP,d12,d23
      Real(kind=dp) :: Ip

c
      d12=x(2)-x(1)
      d23=x(3)-x(2)
      Ip=Q(1)*(x(2)-t)*(x(3)-t)/((d12+d23)*d12)
      Ip=Ip+Q(2)*(t-x(1))*(x(3)-t)/(d12*d23)
      Ip=Ip+Q(3)*(t-x(1))*(t-x(2))/((d12+d23)*d23)

      InterP = Ip
      Return
      End

  FUNCTION InitSquare( Model, n, t ) RESULT(f)
    USE Types
    USE SolverUtils
    IMPLICIT NONE
    
    TYPE(Model_t) :: Model
    LOGICAL :: Visited = .FALSE., GotIt
    INTEGER :: n,i,j
    REAL(KIND=dp) :: t,x,y,r,Lx,Ly,dist(4),f,a1,a2,b1,b2
    
    SAVE Visited, a1, a2, b1, b2
    
    IF(.NOT. Visited) THEN
      Lx = 1.0
      Ly = 1.0
      
      a1 = 0.25 * Lx 
      a2 = 0.75 * Lx
      b1 = 0.25 * Ly
      b2 = 0.75 * Ly
      Visited = .TRUE.
    END IF
    
    x = Model % Nodes % x(n)
    y = Model % Nodes % y(n)    
    
    ! distance from horizontal lines
    IF( x < a1 ) THEN
      dist(1) = SQRT( (x-a1)**2.0 + (y-b1)**2.0)
      dist(2) = SQRT( (x-a1)**2.0 + (y-b2)**2.0)
    ELSE IF( x > a2 ) THEN     
      dist(1) = SQRT( (x-a2)**2.0 + (y-b1)**2.0)
      dist(2) = SQRT( (x-a2)**2.0 + (y-b2)**2.0)
    ELSE     
      dist(1) = ABS(y - b1)
      dist(2) = ABS(y - b2)
    END IF
    
    ! distance from vertical lines
    IF( y < b1 ) THEN
      dist(3) = SQRT( (x-a1)**2.0 + (y-b1)**2.0)
      dist(4) = SQRT( (x-a2)**2.0 + (y-b1)**2.0)
    ELSE IF( y > b2 ) THEN     
      dist(3) = SQRT( (x-a1)**2.0 + (y-b2)**2.0)
      dist(4) = SQRT( (x-a2)**2.0 + (y-b2)**2.0)
    ELSE     
      dist(3) = ABS(x - a1)
      dist(4) = ABS(x - a2)
    END IF
    
    ! minimum distance to the sides of the rectangle
    f = MINVAL( ABS( dist ) )
    
    ! set negative sign inside the rectangle 
    IF( .NOT. (x > a1 .AND. x < a2 .AND. y > b1 .AND. y < b2) ) THEN
      f = -f
    END IF

  END FUNCTION InitSquare

! *****************************************************************************/
! *
! *       ELMER, A Computational Fluid Dynamics Program.
! *
! *       Copyright 1st April 1995 - , Center for Scientific Computing,
! *                                    Finland.
! *
! *       All rights reserved. No part of this program may be used,
! *       reproduced or transmitted in any form or by any means
! *       without the written permission of CSC.
! *
! *****************************************************************************/
!
!/******************************************************************************
! *
! * Module containing a solver for (primarily thermal) Porous material flow
! *  include the mass conservation equation d D / dt + div (D.u) = 0
! *  variables u, v, (w), p, D
! *
! ******************************************************************************
! *
! *                     Author:       Juha Ruokolainen
! *
! *                    Address: Center for Scientific Computing
! *                            Tietotie 6, P.O. Box 405
! *                              02101 Espoo, Finland
! *                              Tel. +358 0 457 2723
! *                            Telefax: +358 0 457 2302
! *                          EMail: Juha.Ruokolainen@csc.fi
! *
! *                       Date: 08 Jun 1997
! *
! *                Modified by:  OG 
! *
! *       Date of modification: 
! *
! *****************************************************************************/
!------------------------------------------------------------------------------
   RECURSIVE SUBROUTINE LumiSolver( Model,Solver,dt,TransientSimulation )
!------------------------------------------------------------------------------

    USE DefUtils

    IMPLICIT NONE

!------------------------------------------------------------------------------
!******************************************************************************
!
!  Solve stress equations for one timestep
!
!  ARGUMENTS:
!
!  TYPE(Model_t) :: Model,  
!     INPUT: All model information (mesh,materials,BCs,etc...)
!
!  TYPE(Solver_t) :: Solver
!     INPUT: Linear equation solver options
!
!  REAL(KIND=dp) :: dt,
!     INPUT: Timestep size for time dependent simulations (NOTE: Not used
!            currently)
!
!
!    Solve:  -p,j + Sij,j + D.fi = 0 and ui,i + Kcp.p = 0
!        and d D/dt + div(D.u)  = 0
!    with 
!       Sij = 2 eta ( Eij - Ekk / 3 delta_ij) 
!       Kcp = b(D) B^(1/n) ED^{(n-1)/n}
!       ED^2 = 2 eij.eij/a(D) + Ekk^2/b(D)
!       eta = 2/a(D) B^{-1/n} ED^{(1-n)/n}
!       The relative density D is computed within this solver 
!   From Gagliardini and Meyssonnier, 1997. Annals of Glaciology 24.
!
!
!******************************************************************************

     TYPE(Model_t)  :: Model
     TYPE(Solver_t), TARGET :: Solver

     LOGICAL ::  TransientSimulation
     REAL(KIND=dp) :: dt
!------------------------------------------------------------------------------
!    Local variables
!------------------------------------------------------------------------------
     TYPE(Solver_t), POINTER :: PSolver

     TYPE(Matrix_t),POINTER :: StiffMatrix

     INTEGER :: i, j, k, l, n, t, iter, NDeg, STDOFs, LocalNodes, istat
     INTEGER :: dim,  nComp, nd, nb 

     TYPE(ValueList_t),POINTER :: Material, BC, BodyForce
     TYPE(Nodes_t) :: ElementNodes
     TYPE(Element_t),POINTER :: CurrentElement

     REAL(KIND=dp) :: RelativeChange, UNorm, PrevUNorm, &
         Normal(3), NewtonTol, NonlinearTol, s, Wn(2), MinSRInvariant, &
         IceDensity
         

     REAL(KIND=dp), ALLOCATABLE :: Basis(:),ddBasisddx(:,:,:)
     REAL(KIND=dp), ALLOCATABLE :: dBasisdx(:,:), SlipCoeff(:,:)
     REAL(KIND=dp) :: u,v,w,detJ
     
     LOGICAL :: stat, CSymmetry 
       
     INTEGER, PARAMETER :: INDi(1:6) = (/ 1, 2, 3, 1, 2, 3 /) ,&
           INDj(1:6)=(/ 1, 2, 3, 2, 3, 1 /)

     INTEGER :: NewtonIter, NonlinearIter

     TYPE(Variable_t), POINTER :: LumiSol, DensityVariable

     REAL(KIND=dp), POINTER ::  Lumi(:),  &
           ForceVector(:),  NodalLumi(:), LumiComp(:), &
           DensityValues(:)


     INTEGER, POINTER :: LumiPerm(:), NodeIndexes(:), &
                         DensityPerm(:)

     LOGICAL :: GotForceBC, GotIt, NewtonLinearization = .FALSE., &
                NormalTangential=.FALSE.

     INTEGER :: body_id,bf_id
     INTEGER :: old_body = -1
     LOGICAL :: AllocationsDone = .FALSE., FreeSurface, &
                Requal0
           
     REAL(KIND=dp), ALLOCATABLE:: LocalMassMatrix(:,:), &
       LocalStiffMatrix(:,:), LoadVector(:,:), LocalForce(:), &
       Alpha(:,:), Beta(:), SOL(:,:), & 
       BoundaryDispl(:), TimeForce(:), RefS(:), RefD(:), RefSpin(:), &
       LocalFluidity(:), Localfa(:), Localfb(:)
            
     INTEGER :: NumberOfBoundaryNodes
     INTEGER, POINTER :: BoundaryReorder(:)

     REAL(KIND=dp) :: Bu, Bv, Bw, RM(3,3)
     REAL(KIND=dp), POINTER :: BoundaryNormals(:,:), &
         BoundaryTangent1(:,:), BoundaryTangent2(:,:)

     REAL(KIND=dp) :: at, at0, CPUTime, RealTime

     LOGICAL, ALLOCATABLE :: ActiveList(:)
     REAL(KIND=dp), ALLOCATABLE ::  SaveValues(:), SaveRHS(:), Residual(:)

     TYPE(variable_t), POINTER :: var

!------------------------------------------------------------------------------
     SAVE NumberOfBoundaryNodes,BoundaryReorder,BoundaryNormals, &
              BoundaryTangent1, BoundaryTangent2

     SAVE TimeForce, Basis, dBasisdx, ddBasisddx
     SAVE LocalMassMatrix, LocalStiffMatrix, LoadVector, &
       LocalForce, ElementNodes, Alpha, Beta,  &
       AllocationsDone, BoundaryDispl, SOL, &
       NodalLumi, Wn, MinSRInvariant, old_body, &
       LocalFluidity, Localfa, Localfb, dim, IceDensity, nComp

     SAVE RefD, RefS, RefSpin, SlipCoeff, ActiveList, SaveValues, SaveRHS, Residual
              
!------------------------------------------------------------------------------
!  Read constants from constants section of SIF file
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
!    Get variables needed for solution
!------------------------------------------------------------------------------
      IF ( .NOT. ASSOCIATED( Solver % Matrix ) ) RETURN

      LumiSol => Solver % Variable
      LumiPerm => LumiSol % Perm
      STDOFs =  LumiSol % DOFs
      Lumi => LumiSol % Values

      LocalNodes = COUNT( LumiPerm > 0 )
      IF ( LocalNodes <= 0 ) RETURN


      StiffMatrix => Solver % Matrix
      ForceVector => StiffMatrix % RHS
      UNorm = Solver % Variable % Norm


!------------------------------------------------------------------------------
!     Allocate some permanent storage, this is done first time only
!------------------------------------------------------------------------------
      IF ( .NOT. AllocationsDone .OR. Solver % Mesh % Changed) THEN
        N = Solver % Mesh % MaxElementDOFs
        dim = CoordinateSystemDimension()
        nComp = STDOFs

       IF ( AllocationsDone ) THEN
         DEALLOCATE( ElementNodes % x,     &
                     ElementNodes % y,     &
                     ElementNodes % z,     &
                     BoundaryDispl,        &
                     LocalForce,           &
                     RefD, RefS, RefSpin,  &
                     LocalMassMatrix,      &
                     LocalStiffMatrix,     &
                     LoadVector, Alpha, Beta, &
                     SlipCoeff, LocalFluidity , &
                     Localfa, Localfb )
       END IF

       ALLOCATE( BoundaryDispl( N ), &
                 SOL( nComp, N ), &
                 LocalForce( STDOFs*N ),&
                 RefS(2*dim*LocalNodes ),&                              
                 RefD(2*dim*LocalNodes ),&                              
                 RefSpin((2*dim-3)*LocalNodes ),&                       
                 Basis( N ), dBasisdx( N,3 ), &
                 TimeForce( STDOFs*N ), &
                 LocalMassMatrix( STDOFs*N,STDOFs*N ),  &
                 LocalStiffMatrix( STDOFs*N,STDOFs*N ),  &
                 LoadVector( 4,N ), Alpha( 3,N ), Beta( N ), &
                 SlipCoeff(3,N), LocalFluidity(N), &
                 Localfa( N ), Localfb( N ),  STAT=istat )

       IF ( istat /= 0 ) THEN
          CALL Fatal( 'LumiSolve', 'Memory allocation error.' )
       END IF

       IF ( AllocationsDone ) THEN
         DEALLOCATE( ActiveList, SaveValues, SaveRHS, Residual )
       END IF
       ALLOCATE( ActiveList( Solver % Mesh % NumberOfNodes ),   &
                 SaveValues( SIZE( Solver % Matrix % Values) ), &
                 SaveRHS( Solver % Matrix % NumberOfRows ),     &
                 Residual( Solver % Matrix % NumberOfRows ), STAT=istat )

       IF ( istat /= 0 ) THEN
          CALL Fatal( 'LumiSolve', 'Memory allocation error.' )
       END IF

       AllocationsDone = .TRUE.
      END IF

!------------------------------------------------------------------------------
!    Do some additional initialization, and go for it
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
      NonlinearTol = GetConstReal( Solver % Values, &
        'Nonlinear System Convergence Tolerance' )

      NewtonTol = GetConstReal( Solver % Values, &
        'Nonlinear System Newton After Tolerance' )

      NewtonIter = GetInteger( Solver % Values, &
        'Nonlinear System Newton After Iterations' )

      NonlinearIter = GetInteger( Solver % Values, &
         'Nonlinear System Max Iterations',GotIt )

      IF ( .NOT.GotIt ) NonlinearIter = 1
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------

      FreeSurface = .FALSE.
      ActiveList = .FALSE.

      DO iter=1,NonlinearIter

       at  = CPUTime()
       at0 = RealTime()

       CALL Info( 'LumiSolve', ' ', Level=4 )
       CALL Info( 'LumiSolve', ' ', Level=4 )
       CALL Info( 'LumiSolve', &
                   '-------------------------------------',Level=4 )
       WRITE( Message, * ) 'POROUS MATERIAL FLOW SOLVER ITERATION', iter
       CALL Info( 'LumiSolve', Message,Level=4 )
       CALL Info( 'LumiSolve', &
                   '-------------------------------------',Level=4 )
       CALL Info( 'LumiSolve', ' ', Level=4 )
       CALL Info( 'LumiSolve', 'Starting assembly...',Level=4 )


!------------------------------------------------------------------------------
       CALL DefaultInitialize()
!------------------------------------------------------------------------------
       DO t=1,Solver % NumberOFActiveElements

         IF ( RealTime() - at0 > 1.0 ) THEN
           WRITE(Message,'(a,i3,a)' ) '   Assembly: ',  &
             INT(100.0 - 100.0 * (Solver % NumberOfActiveElements-t) / &
             (1.0*Solver % NumberOfActiveElements)), ' % done'
           CALL Info( 'LumiSolve', Message, Level=5 )
           at0 = RealTime()
         END IF

         CurrentElement => GetActiveElement(t)
         n = GetElementNOFNodes()
         nd = GetElementNOFDOFs()
         nb = GetElementNOFBDOFs()

         CALL GetElementNodes( ElementNodes )
         Material => GetMaterial()

!------------------------------------------------------------------------------
!    Read in material constants from Material section
!------------------------------------------------------------------------------
         body_id = CurrentElement % BodyId
         IF (body_id /= old_body) Then 
            old_body = body_id
            Call  GetMaterialDefs()
        END IF

        LocalFluidity(1:n) = GetReal( Material, &
                         'Fluidity Parameter', GotIt )
        IF (.NOT.GotIt) THEN
         WRITE(Message,'(A)') 'Variable Fluidity Parameter not found. &
                            &Setting to 1.0'
         CALL INFO('LumiSolve', Message, Level = 20)
         LocalFluidity(1:n) = 1.0
        END IF

         Localfa(1:n) = 1.0
         Localfb(1:n) = 0.0
!
! Function a(D) (=1 if incompressible)
! 
!       Localfa(1:n) = GetReal( Material, &
!                        'FunctionA', n, NodeIndexes, GotIt )
!       IF (.NOT.GotIt) THEN
!        WRITE(Message,'(A)') 'FunctionA not found. &
!                           &Setting to 1.0'
!        CALL INFO('LumiSolve', Message, Level = 20)
!       END IF
!
! Function b(D) (=0 if incompressible)
! 
!       Localfb(1:n) = GetReal( Material, &
!                        'FunctionB', n, NodeIndexes, GotIt )
!       IF (.NOT.GotIt) THEN
!        WRITE(Message,'(A)') 'FunctionB not found. &
!                           &Setting to 0.0'
!        CALL INFO('LumiSolve', Message, Level = 20)
!       END IF

!------------------------------------------------------------------------------
!        Set body forces
!------------------------------------------------------------------------------
         LoadVector = 0.0D0

         BodyForce => GetBodyForce()
         IF ( ASSOCIATED( BodyForce ) ) THEN
           LoadVector(1,1:n) = LoadVector(1,1:n) + GetReal( &
                   BodyForce, 'Lumi Force 1', gotIt )
           LoadVector(2,1:n) = LoadVector(2,1:n) + GetReal( &
                   BodyForce, 'Lumi Force 2', gotIt )
           LoadVector(3,1:n) = LoadVector(3,1:n) + GetReal( & 
                   BodyForce, 'Lumi Force 3', gotIt )
         END IF
!------------------------------------------------------------------------------
!        Get element local stiffness & mass matrices
!------------------------------------------------------------------------------

         CALL GetVectorLocalSolution( SOL )

         CALL LocalMatrix( LocalMassMatrix, LocalStiffMatrix, &
              LocalForce, LoadVector, SOL, LocalFluidity, CurrentElement, n, &
              ElementNodes, Wn, MinSRInvariant, IceDensity, Localfa, Localfb, &
              nComp, dim )

          IF ( nb>0 ) CALL LCondensate( nd, nb, nComp, dim+1, &
                 LocalStiffMatrix, LocalForce )

!------------------------------------------------------------------------------
!        Update global matrices from local matrices 
!------------------------------------------------------------------------------
         IF ( TransientSimulation ) THEN 
           CALL Default1stOrderTime( LocalMassMatrix, &
                LocalStiffMatrix, LocalForce )
         END IF
         CALL DefaultUpdateEquations( LocalStiffMatrix, LocalForce )
      END DO

      CALL Info( 'LumiSolve', 'Assembly done', Level=4 )

#if 1
!------------------------------------------------------------------------------
!     Neumann & Newton boundary conditions
!------------------------------------------------------------------------------
      DO t = 1, Model % NumberOFBoundaryElements

        CurrentElement => GetBoundaryElement(t)
        IF ( GetElementFamily() == 101 ) CYCLE
        IF ( .NOT. ActiveBoundaryElement() ) CYCLE

        n = GetElementNOFNodes()
        CALL GetElementNodes( ElementNodes )

        BC => GetBC()
        IF ( ASSOCIATED( BC ) ) THEN
            LoadVector = 0.0D0
            Alpha      = 0.0D0
            Beta       = 0.0D0
!------------------------------------------------------------------------------
!           Force in given direction BC: \tau\cdot n = F
!------------------------------------------------------------------------------
            GotForceBC = .FALSE.

            LoadVector(1,1:n) = GetReal( BC, 'Force 1', gotIt )
            GotForceBC = GotForceBC .OR. gotIt
            LoadVector(2,1:n) = GetReal( BC, 'Force 2', gotIt )
            GotForceBC = GotForceBC .OR. gotIt
            LoadVector(3,1:n) = GetReal( BC, 'Force 3', gotIt )
            GotForceBC = GotForceBC .OR. gotIt

            Beta(1:n) = GetReal( BC, 'Normal Force', gotIt )
            GotForceBC = GotForceBC .OR. gotIt

!------------------------------------------------------------------------------
!             slip boundary condition BC: \tau\cdot n = R_k u_k
!------------------------------------------------------------------------------

              SlipCoeff = 0.0d0
              SlipCoeff(1,1:n) =  GetReal( BC, 'Lumi Slip Coeff 1', gotit )
              GotForceBC = GotForceBC .OR. gotIt
              SlipCoeff(2,1:n) =  GetReal( BC, 'Lumi Slip Coeff 2', GotIt )
              GotForceBC = GotForceBC .OR. gotIt
              SlipCoeff(3,1:n) =  GetReal( BC, 'Lumi Slip Coeff 3', gotIt )
              GotForceBC = GotForceBC .OR. gotIt

              NormalTangential = GetLogical( BC, &
                     'Normal-Tangential Lumi', GotIt )
               
            IF ( .NOT.GotForceBC ) CYCLE
!------------------------------------------------------------------------------
            CALL LocalMatrixBoundary( LocalStiffMatrix, LocalForce, &
                 LoadVector, Alpha, Beta, SlipCoeff, NormalTangential, &
                 CurrentElement, n, ElementNodes, nComp )
!------------------------------------------------------------------------------
!           Update global matrices from local matrices (will also affect
!           LocalStiffMatrix and LocalForce if transientsimulation is on).
!------------------------------------------------------------------------------
            LocalMassMatrix = 0.0_dp
            IF ( TransientSimulation ) THEN
              CALL Default1stOrderTime( LocalMassMatrix, & 
                   LocalStiffMatrix, LocalForce )
            END IF
            CALL DefaultUpdateEquations( LocalStiffMatrix, LocalForce )
!------------------------------------------------------------------------------
         END IF
      END DO
#endif
!------------------------------------------------------------------------------

      CALL DefaultFinishAssembly()
      CALL DefaultDirichletBCs()

      n = Solver % Mesh % NumberOfNodes
      ActiveList = ActiveList .OR. Solver % Variable % Values( &
              nComp*Solver % Variable % Perm(1:n) )>1.0

      SaveValues = Solver % Matrix % Values
      SaveRHS    = Solver % Matrix % RHS
      DO i=1,Solver % Mesh % NumberOfNodes
        IF ( ActiveList(i) ) THEN
          j = nComp * Solver % Variable % Perm(i)
          CALL ZeroRow( Solver % Matrix, j )
          CALL SetMatrixElement( Solver % Matrix, j,j,1.0d0 )
          Solver % Matrix % RHS(j) = 1.0d0
        END IF
      END DO
      PRINT*, 'NOF Constrained values: ', COUNT(ActiveList)

      CALL Info( 'LumiSolve', 'Set boundaries done', Level=4 )

!------------------------------------------------------------------------------
!     Solve the system and check for convergence
!------------------------------------------------------------------------------
      PrevUNorm = UNorm

      UNorm = DefaultSolve()

      Residual = 0
      DO i=1, Solver % Mesh % NumberOfNodes
         k = nComp*Solver % Variable % Perm(i)
         DO j=Solver % Matrix % Rows(k),Solver % Matrix % Rows(k+1)-1
           Residual(i) = Residual(i) + SaveValues(j) * &
             Solver % Variable % Values(Solver % Matrix % Cols(j))
         END DO
         Residual(i) = Residual(i) - SaveRHS(k)
         IF ( Residual(i) > 100*AEPS ) ActiveList(i) = .FALSE.
      END DO
      PRINT*,SUM(Residual**2)
      
      UNorm = 0.0_dp
      n = Solver % Variable % DOFs
      DO i=1,n-2
        UNorm = UNorm + SUM( Solver % Variable % Values(i::n)**2 )
      END DO
      UNorm = SQRT(UNorm)
      Solver % Variable % norm = UNorm

      IF ( PrevUNorm + UNorm /= 0.0d0 ) THEN
         RelativeChange = 2.0d0 * ABS( PrevUNorm - UNorm) / ( PrevUnorm + UNorm)
      ELSE
         RelativeChange = 0.0d0
      END IF

      WRITE( Message, * ) 'Result Norm   : ',UNorm, PrevUNorm
      CALL Info( 'LumiSolve', Message, Level=4 )
      WRITE( Message, * ) 'Relative Change : ',RelativeChange
      CALL Info( 'LumiSolve', Message, Level=4 )

!------------------------------------------------------------------------------
      IF ( RelativeChange < NewtonTol .OR. &
             iter > NewtonIter ) NewtonLinearization = .TRUE.

      IF ( RelativeChange < NonLinearTol ) EXIT

!------------------------------------------------------------------------------
    END DO ! of nonlinear iter
!------------------------------------------------------------------------------

var => variableGet( Solver % Mesh % Variables, 'Residual' )
var % values(var % Perm(1:Solver % mesh % numberofnodes)) = Residual

      
CONTAINS

      SUBROUTINE GetMaterialDefs()

      Wn(2) = GetConstReal( Material , 'Powerlaw Exponent', GotIt )
      IF (.NOT.GotIt) THEN
         WRITE(Message,'(A)') 'Variable  Powerlaw Exponent not found. &
                                    & Setting to 1.0'
         CALL INFO('LumiSolve', Message, Level = 20)
         Wn(2) = 1.0
      ELSE
       WRITE(Message,'(A,F10.4)') 'Powerlaw Exponent = ',   Wn(2)
       CALL INFO('LumiSolve', Message, Level = 20)
       END IF

! Get the Minimum value of the Effective Strain rate 
      MinSRInvariant = 10e-20_dp 
      IF ( Wn(2) > 1.0 ) THEN
        MinSRInvariant =  &
             GetConstReal( Material, 'Min Second Invariant', GotIt )
        IF (.NOT.GotIt) THEN
          WRITE(Message,'(A)') 'Variable Min Second Invariant not &
                    &found. Setting to 10.0^-20 )'
          CALL INFO('LumiSolve', Message, Level = 20)
        ELSE
          WRITE(Message,'(A,E14.8)') 'Min Second Invariant = ', MinSRInvariant
          CALL INFO('LumiSolve', Message, Level = 20)
        END IF
      END IF

! Get the absolute ice density
      IceDensity = GetConstReal( Material , 'Ice Density', GotIt )
      IF (.NOT.GotIt) THEN
         WRITE(Message,'(A)') 'Variable  Ice Density not found. &
                                    & Setting to 910.0'
         CALL INFO('LumiSolve', Message, Level = 20)
         IceDensity = 910.0_dp 
      ELSE
       WRITE(Message,'(A,F10.4)') ' Ice Density = ', IceDensity 
       CALL INFO('LumiSolve', Message, Level = 20)
       END IF

!------------------------------------------------------------------------------
      END SUBROUTINE GetMaterialDefs
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
      SUBROUTINE LocalMatrix( MASS, STIFF, FORCE,       &
              LoadVector, SOL, NodalFluidity, Element, n, Nodes, Wn, MinSRInvariant, &
              IceDensity, Nodalfa, Nodalfb, nComp, dim )
!------------------------------------------------------------------------------

     REAL(KIND=dp) :: STIFF(:,:), MASS(:,:), FORCE(:), SOL(:,:)
     REAL(KIND=dp) :: LoadVector(:,:)
     REAL(KIND=dp) :: Wn(2), MinSRInvariant, IceDensity
     REAL(KIND=dp), DIMENSION(:) :: NodalFluidity, Nodalfa, Nodalfb
     TYPE(Nodes_t) :: Nodes
     TYPE(Element_t) :: Element
     INTEGER :: n
!------------------------------------------------------------------------------
!
     REAL(KIND=dp) :: Basis(nd)
     REAL(KIND=dp) :: dBasisdx(nd,3), DetJ

     REAL(KIND=dp) :: Load(3), density, fa, fb 
     REAL(kind=dp) :: Bg, BGlenT
     REAL(KIND=dp) :: A(nComp,nComp), M(nComp,nComp), F(nComp)

     REAL(KIND=dp) :: nn, ss, LGrad(3,3), SR(3,3), Velo(3)

     INTEGER :: i, j, k, p, q, t, dim, NBasis, ind(3)

     REAL(KIND=dp) :: s, u, v ,w, Radius
  
     REAL(KIND=dp) :: Em, eta, Kcp, ParameterA, ParameterB
     TYPE(GaussIntegrationPoints_t), TARGET :: IntegStuff

     INTEGER :: N_Integ, iP, iRho,nComp
     LOGICAL :: stat, CSymmetry
!------------------------------------------------------------------------------
      CSymmetry = CurrentCoordinateSystem() == AxisSymmetric
      dim = CoordinateSystemDimension()

      iP    = dim+1
      iRho  = dim+2

      FORCE = 0.0d0
      STIFF = 0.0d0
      MASS  = 0.0d0

!    
!    Integration stuff
!    
!     NBasis = 2*n
!     IntegStuff = GaussPoints( Element, Element % Type % GaussPoints2 )

      NBasis = nd+nb
      IntegStuff = GaussPoints( Element )

      !
      ! Now we start integrating:
      ! -------------------------
      DO t=1,IntegStuff % n

         u = IntegStuff % u(t)
         v = IntegStuff % v(t)
         w = IntegStuff % w(t)

         stat = ElementInfo( Element,Nodes,u,v,w,DetJ,Basis,dBasisdx )
         s = DetJ * IntegStuff % s(t)
         IF ( CSymmetry ) THEN
            Radius = SUM( Nodes % x(1:n) * Basis(1:n) )
            s = s * Radius
         END IF

         !  
         ! Force at integration point:
         ! ---------------------------
         Load = 0.0d0
         DO i=1,dim
           Load(i) = SUM( LoadVector(i,1:n)*Basis(1:n) )
         END DO

         !
         ! Variables at the integration point:
         ! -----------------------------------
         !     Density = SUM( NodalDensity(1:n)*Basis(1:n) )
         Density = SUM( SOL(iRho,1:n)*Basis(1:n) )
         Velo(1:dim) = MATMUL( SOL(1:dim,1:n), Basis(1:n) )

         !     fa = SUM( Nodalfa(1:n)*Basis(1:n) )
         !     fb = SUM( Nodalfb(1:n)*Basis(1:n) )
         fa = ParameterA(Density)
         fb = ParameterB(Density)

         Wn(1) = SUM( NodalFluidity(1:n)*Basis(1:n) )
         Bg=Wn(1)                      

         !
         ! Case non-linear calculate E_D^2 = gamma_e^2/fa + E_m^2/fb
         ! ----------------------------------------------------------
         ss = 1.0_dp
         IF ( Wn(2) > 1.0 ) THEN
           LGrad = 0
           LGrad(1:dim,1:dim) = MATMUL( SOL(1:dim,1:nd), dBasisdx(1:nd,1:dim) )
           SR = 0.5 * ( LGrad + TRANSPOSE(LGrad) )
      
              IF ( CSymmetry ) THEN
             SR(1,3) = 0.0
             SR(2,3) = 0.0
             SR(3,1) = 0.0
             SR(3,2) = 0.0
             SR(3,3) = 0.0
             IF ( Radius > 10*AEPS ) THEN
               SR(3,3) = SUM( SOL(1,1:nd) * Basis(1:nd) ) /Radius
             END IF
           END IF

           Em = SR(1,1)+SR(2,2)+SR(3,3)
           DO i = 1, 3
             SR(i,i) = SR(i,i) - Em/3.0
           END DO

           ss = 0.0_dp
           DO i = 1, 3
             DO j = 1, 3
               ss = ss + SR(i,j)**2
             END DO
           END DO
           ss = 2.0*ss / fa
           IF ( fb /= 0.0_dp ) ss = ss + Em**2 / fb

           nn =(1.0 - Wn(2))/Wn(2)

              ss = SQRT(ss)
           IF (ss < MinSRInvariant ) ss = MinSRInvariant
           ss =  ss**nn 
         END IF

         !
         ! Bulk effective viscosity and Compressibility parameter Kcp :
         ! ------------------------------------------------------------     
         eta = ss / (fa * Bg**( 1.0 / Wn( 2 ) ) ) 
         Kcp = fb * Bg**( 1.0 / Wn( 2 ) ) / ss 

         !
         ! Loop over basis functions (of both unknowns and weights):
         ! ---------------------------------------------------------
         DO p=1,NBasis
          DO q=1,NBasis
            A = 0.0_dp
            M = 0.0_dp
            DO i=1,dim
              M(i,i) = M(i,i) + IceDensity*Density*Basis(q)*Basis(p) 
              DO j=1,dim

! terms 2 eta Eij dEij
                A(i,i) = A(i,i) + eta * dbasisdx(q,j)*dbasisdx(p,j)
                A(i,j) = A(i,j) + eta * dbasisdx(q,i)*dbasisdx(p,j)

! terms 2 / 3 eta Eii dEii
                A(i,j) = A(i,j) - 2.0d0/3.0d0 * eta*dbasisdx(q,j)*dbasisdx(p,i)
              END DO

! Pressure gradient, Continuity equation
              A(i,iP) = A(i,iP) - dBasisdx(p,i) * Basis(q)
              A(iP,i) = A(iP,i) + dBasisdx(q,i) * Basis(p)
            END DO
            A(iP,iP) = A(iP,iP) +  Kcp * Basis(q) * Basis(p)

            IF ( CSymmetry ) A(1,iP) =  A(1,iP) - Basis(p) * Basis(q) / Radius
            IF ( CSymmetry ) A(iP,1) =  A(iP,1) + Basis(p) * Basis(q) / Radius
!
! Mass conservation equation dD/dt + div(Du) = 0 (Integrated by parts)
! 0.5 + 0.5 = 1 (should try other decomposition ...
!
            M(iRho,iRho) = M(iRho,iRho) + Basis(q) * Basis(p) 
            DO i=1,dim
              A(iRho,i) = A(iRho,i) + Density * dBasisdx(q,i) * Basis(p)
              A(iRho,iRho) = A(iRho,iRho) + Velo(i) * dBasisdx(q,i) * Basis(p)
            END DO

! Add Nodal Matrix to Element Marix
            DO i=1, nComp
              DO j=1, nComp
                STIFF(nComp*(p-1)+i,nComp*(q-1)+j) = &
                     STIFF(nComp*(p-1)+i,nComp*(q-1)+j) + s * A(i,j)
                MASS(nComp*(p-1)+i,nComp*(q-1)+j) = &
                     MASS(nComp*(p-1)+i,nComp*(q-1)+j) + s * M(i,j)
              END DO
            END DO

          END DO !of q

! The righthand side...
           F = 0.0_dp
           DO i=1,dim
              F(i) = F(i) + Load(i) * Density * Basis(p)
           END DO
           DO i=1, nComp
             FORCE(nComp*(p-1)+i) = FORCE(nComp*(p-1)+i) + s * F(i)
           END DO
         END DO !of p
      END DO !of N_integ 

      DO j=n+1,nd
        i = nComp*(j-1) + iP
        STIFF(i,:) = 0.0_dp
        STIFF(:,i) = 0.0_dp
        STIFF(i,i) = 1.0_dp
        MASS(:,i)  = 0.0_dp
        MASS(i,:)  = 0.0_dp
        FORCE(i)   = 0.0_dp
!       i = nComp*(j-1) + iRho
!       STIFF(i,:) = 0.0_dp
!       STIFF(:,i) = 0.0_dp
!       STIFF(i,i) = 1.0_dp
!       MASS(:,i)  = 0.0_dp
!       MASS(i,:)  = 0.0_dp
!       FORCE(i)   = 0.0_dp
      END DO

!------------------------------------------------------------------------------
      END SUBROUTINE LocalMatrix
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
      SUBROUTINE LocalMatrixBoundary( BoundaryMatrix, BoundaryVector, &
                 LoadVector, NodalAlpha, NodalBeta, NodalSlipCoeff, & 
                  NormalTangential, Element, n, Nodes, nComp )
                      
!------------------------------------------------------------------------------
     REAL(KIND=dp) :: BoundaryMatrix(:,:),BoundaryVector(:)
     REAL(KIND=dp) :: NodalAlpha(:,:),NodalBeta(:),LoadVector(:,:)
     REAL(KIND=dp) :: NodalSlipCoeff(:,:)
     TYPE(Element_t),POINTER  :: Element
     TYPE(Nodes_t)    :: Nodes
     LOGICAL :: NormalTangential
     INTEGER :: n, nComp
!------------------------------------------------------------------------------
     REAL(KIND=dp) :: Basis(n),ddBasisddx(1,1,1)
     REAL(KIND=dp) :: dBasisdx(n,3),DetJ

     REAL(KIND=dp) :: u,v,w,s
     REAL(KIND=dp) :: Force(3), Alpha(3), Beta, Normal(3)
     REAL(KIND=dp), POINTER :: U_Integ(:), V_Integ(:), W_Integ(:), S_Integ(:)

     REAL(KIND=dp) :: Tangent(3),Tangent2(3),Vect(3), SlipCoeff
     INTEGER :: i,t,q,p,dim,N_Integ, c

     LOGICAL :: stat

     TYPE(GaussIntegrationPoints_t), TARGET :: IntegStuff
!------------------------------------------------------------------------------

      dim = CoordinateSystemDimension()
      c=nComp

      BoundaryVector = 0.0D0
      BoundaryMatrix = 0.0D0
!
!  Integration stuff
!
      IntegStuff = GaussPoints( element )
      U_Integ => IntegStuff % u
      V_Integ => IntegStuff % v
      W_Integ => IntegStuff % w
      S_Integ => IntegStuff % s
      N_Integ =  IntegStuff % n
!
!  Now we start integrating
!
      DO t=1,N_Integ

       u = U_Integ(t)
       v = V_Integ(t)
       w = W_Integ(t)

!------------------------------------------------------------------------------
!    Basis function values & derivatives at the integration point
!------------------------------------------------------------------------------
       stat = ElementInfo( Element, Nodes, u, v, w, DetJ, &
                Basis, dBasisdx, ddBasisddx, .FALSE. )

       s = DetJ * S_Integ(t)
       IF ( CurrentCoordinateSystem() == AxisSymmetric ) &
        s = s * SUM( Nodes % x(1:n) * Basis(1:n) )
!------------------------------------------------------------------------------
       Force = 0.0D0
       DO i=1,dim
         Force(i) = SUM( LoadVector(i,1:n)*Basis(1:n) )
         Alpha(i) = SUM( NodalAlpha(i,1:n)*Basis(1:n) )
       END DO

       Normal = NormalVector( Element,Nodes,u,v,.TRUE. )
       Force = Force + SUM( NodalBeta(1:n)*Basis(1:n) ) * Normal

       SELECT CASE( Element % TYPE % DIMENSION )
       CASE(1)
        Tangent(1) =  Normal(2)
        Tangent(2) = -Normal(1)
        Tangent(3) =  0.0d0
       CASE(2)
        CALL TangentDirections( Normal, Tangent, Tangent2 ) 
       END SELECT
  
       IF ( ANY( NodalSlipCoeff(:,:) /= 0.0d0 ) ) THEN
         DO p=1,n
           DO q=1,n
             DO i=1,DIM
              SlipCoeff = SUM( NodalSlipCoeff(i,1:n) * Basis(1:n) )
  
              IF (NormalTangential ) THEN
                SELECT CASE(i)
                   CASE(1)
                     Vect = Normal
                   CASE(2)
                     Vect = Tangent
                   CASE(3)
                     Vect = Tangent2
                END SELECT
  
                DO j=1,DIM
                   DO k=1,DIM
                      BoundaryMatrix( (p-1)*c+j,(q-1)*c+k ) = &
                         BoundaryMatrix( (p-1)*c+j,(q-1)*c+k ) + &
                          s * SlipCoeff * Basis(q) * Basis(p) * Vect(j) * Vect(k)
                   END DO
                END DO
               ELSE
                 BoundaryMatrix( (p-1)*c+i,(q-1)*c+i ) = &
                     BoundaryMatrix( (p-1)*c+i,(q-1)*c+i ) + &
                          s * SlipCoeff * Basis(q) * Basis(p)
               END IF
             END DO
           END DO
         END DO
       END IF



      DO p=1,N
       DO q=1,N
         DO i=1,dim
           BoundaryMatrix((p-1)*c+i,(q-1)*c+i) =  &
             BoundaryMatrix((p-1)*c+i,(q-1)*c+i) + &
               s * Alpha(i) * Basis(q) * Basis(p)
         END DO
       END DO
      END DO

      DO q=1,N
       DO i=1,dim
         BoundaryVector((q-1)*c+i) = BoundaryVector((q-1)*c+i) + &
                   s * Basis(q) * Force(i)
       END DO
      END DO

      END DO
!------------------------------------------------------------------------------
      END SUBROUTINE LocalMatrixBoundary
!------------------------------------------------------------------------------


!------------------------------------------------------------------------------
    SUBROUTINE LCondensate( N, nb, nComp, nRemove, K, F )
!------------------------------------------------------------------------------
      USE LinearAlgebra
      INTEGER :: N, nb, nComp, nRemove
      REAL(KIND=dp) :: K(:,:),F(:), Kbb(Nb*(nComp-1),Nb*(nComp-1)), &
       Kbl(nb*(nComp-1),n*nComp),Klb(n*nComp,nb*(nComp-1)),Fb(nb*(nComp-1))

      INTEGER :: m, i, j, l, p, Cdofs(nComp*n), Bdofs((nComp-1)*nb)

      m = 0
      DO p = 1,n
        DO i = 1,nComp
          m = m + 1
          Cdofs(m) = nComp*(p-1) + i
        END DO
      END DO
      
      m = 0
      DO p = 1,nb
        DO i = 1,nComp
          IF ( i==nRemove ) CYCLE
          m = m + 1
          Bdofs(m) = nComp*(p-1) + i + n*nComp
        END DO
      END DO

      Kbb = K(Bdofs,Bdofs)
      Kbl = K(Bdofs,Cdofs)
      Klb = K(Cdofs,Bdofs)
      Fb  = F(Bdofs)
      CALL InvertMatrix( Kbb,Nb*(nComp-1) )

      F(1:nComp*n) = F(1:nComp*n) - MATMUL( Klb, MATMUL( Kbb, Fb ) )
      K(1:nComp*n,1:nComp*n) = &
           K(1:nComp*n,1:nComp*n) - MATMUL( Klb, MATMUL( Kbb,Kbl ) )
!------------------------------------------------------------------------------
    END SUBROUTINE LCondensate
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
      END SUBROUTINE LumiSolver
!------------------------------------------------------------------------------

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!ccccc									cccc
!ccccc       subroutine de calcul des viscosites Analytiques            cccc
!ccccc       Les viscosites ont ete calculees sur une grille            cccc
!ccccc       avec le sous-prog makeEtaI.f                               cccc
!ccccc         Elles passent dans etaI(6*814)=EtaI(4884)                cccc
!ccccc 									cccc      
!ccccc      !!! En entree a1,a2,a3 les valeurs propres du tenseur       cccc
!ccccc                                          d'orientation           cccc
!ccccc 									cccc      
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc       
       
       Subroutine ViscMat_ai(ai0,eta6,etaI)
       
       USE defGrid
       
       Implicit None
       Real(kind=dp), Intent(in), Dimension(3) :: ai0
       Real(kind=dp), Intent(out), Dimension(6) :: eta6
       Real(kind=dp), Intent(in), Dimension(NetaI) :: etaI
       Real(kind=dp), Dimension(3) :: a1i,a2i
       Real(kind=dp) :: InterQ9
       Real(kind=dp), Dimension(3) :: ai 
       Real(kind=dp), Dimension(9) :: etaN
       Real(kind=dp) :: Delta
       Real(kind=dp) ::  a1,a2
       Real(kind=dp), parameter ::  UnTier = 0.3333333333333333333333333333333333333333_dp  
       Integer, Dimension(3) :: ordre
       Integer :: i,j,n
       Integer :: ik1,ik2
       Integer :: N4,N5,N6
              
       
       Delta = UnTier / Ndiv
!
! tri des ki 
! pour avoir k1 < k2 < k3 
!
!
        Call triki(ai0,ai,eta6,ordre,1)
!
        a1 = ai(1)
        a2 = ai(2)
!
! Position de a1,a2 dans EtaI
! calcul des indices ik1,ik2      
! ik1,ik2 indice du noeud en haut a droite du pt (a1,a2) 
!
         ik1 = Int((a1 + Delta)/Delta) + 1
         ik2 = Int((a2 + Delta)/Delta) + 1

! Si ik1 + 2ik2 -3(Ndiv+1) >0 => on est sur la frontiere a2=a3
! ( a1+2a2=1)
!  => ik1=ik1-1 sauf si ik1=2 , ik2=ik2-1         
!         
         If ((ik1+2*ik2-3*(Ndiv+1)).GE.0) Then
          If ((ik1.NE.2).And.((ik1+2*ik2-3*(Ndiv+1)).NE.0).And.  &
          (abs((a1-Delta*(ik1-1))/a1).GT.1.0E-5))  ik1=ik1-1
          ik2=ik2-1 
         End If
         If (ik1.EQ.1) ik1=2
!
! Indice N4,N5 et N6 des points 4,5 et 6 dans EtaI
!  
         
         N4 = Nk2(ik1-1) + ik2 - ik1 + 3         
         N5 = Nk2(ik1) + ik2 - ik1 + 2         
         N6 = Nk2(ik1+1) + ik2 - ik1 + 1         

!
! Remplissage etaN(1 a 9)
!  7 - 8 - 9  
!  4 - 5 - 6 
!  1 - 2 - 3
!
       Do i=1,3
       a1i(i)=Delta*(ik1-3+i)
       a2i(i)=Delta*(ik2-3+i)
       End Do
!
       Do n=1,6
         Do i=1,3              
           etaN(1+(i-1)*3) = etaI(6*(N4-3+i)+n)
           etaN(2+(i-1)*3) = etaI(6*(N5-3+i)+n)
           etaN(3+(i-1)*3) = etaI(6*(N6-3+i)+n)
         End Do
!
! interpolation sur le Q9  
!
!        If ( (a1 < a1i(1)) .OR. &
!             (a1 > a1i(3)) .OR. &
!             (a2 < a2i(1)) .OR. &
!             (a2 > a2i(3)) ) Then
!           write(*,*)a1,a1i
!           write(*,*)a2,a2i
!           Stop
!         End If
            
         eta6(n)=InterQ9(a1,a2,a1i,a2i,etaN)

       End Do
!
! tri des eta
!
        Call triki(ai0,ai,eta6,ordre,-1)

       Return 
       End

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!
!  Interpolation quadratique d'une quantite Q definie en 9 points 
!
!         y3 ---     Q7 ---- Q8 ------ Q9
!                    |        |         | 
!                    |        |         |
!         y2 ---     Q4 ----- Q5 ----- Q6
!                    |        |         | 
!                    |        |         |
!         y1 ---     Q1 ----- Q2 ----- Q3
!
!                    |        |         |
!                   x1        x2       x3
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!
      Function InterQ9(x,y,xi,yi,Q)

      use defgrid
!
      Implicit None
      Real(KIND=dp), Dimension(3) ::  xi,yi,a
      Real(kind=dp), Dimension(9) ::  Q
      Real(kind=dp) ::  InterQ9,InterP
      Real(kind=dp) ::  Ip,x,y
      Integer  i

!
         a(1)=InterP(x,xi,Q(1))
         a(2)=InterP(x,xi,Q(4))
         a(3)=InterP(x,xi,Q(7))
         Ip=InterP(y,yi,a)

         InterQ9 = Ip

      Return
      End

SUBROUTINE WaveSolver( Model,Solver,dt,TransientSimulation )
!------------------------------------------------------------------------------
!******************************************************************************
!
!  Solve the Poisson equation!
!
!  ARGUMENTS:
!
!  TYPE(Model_t) :: Model,  
!     INPUT: All model information (mesh, materials, BCs, etc...)
!
!  TYPE(Solver_t) :: Solver
!     INPUT: Linear & nonlinear equation solver options
!
!  REAL(KIND=dp) :: dt,
!     INPUT: Timestep size for time dependent simulations
!
!  LOGICAL :: TransientSimulation
!     INPUT: Steady state or transient simulation
!
!******************************************************************************
  USE DefUtils

  IMPLICIT NONE
!------------------------------------------------------------------------------
  TYPE(Solver_t) :: Solver
  TYPE(Model_t) :: Model

  REAL(KIND=dp) :: dt
  LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
! Local variables
!------------------------------------------------------------------------------
  LOGICAL :: AllocationsDone = .FALSE., Found
  TYPE(Element_t),POINTER :: Element

  REAL(KIND=dp) :: Norm
  INTEGER :: n, nb, nd, t, istat, active
  TYPE(Mesh_t), POINTER :: Mesh
  TYPE(ValueList_t), POINTER :: BodyForce
  REAL(KIND=dp), ALLOCATABLE :: MASS(:,:), DAMP(:,:), STIFF(:,:), LOAD(:), FORCE(:)

  SAVE MASS, DAMP, STIFF, LOAD, FORCE, AllocationsDone
!------------------------------------------------------------------------------

  !Allocate some permanent storage, this is done first time only:
  !--------------------------------------------------------------
  Mesh => GetMesh()

  IF ( .NOT. AllocationsDone ) THEN
     N = Solver % Mesh % MaxElementDOFs  ! just big enough for elemental arrays
     ALLOCATE( FORCE(N), LOAD(N), STIFF(N,N), DAMP(n,n), MASS(n,n), STAT=istat )
     IF ( istat /= 0 ) THEN
        CALL Fatal( 'PoissonSolve', 'Memory allocation error.' )
     END IF
     AllocationsDone = .TRUE.
  END IF

   !System assembly:
   !----------------
   Active = GetNOFActive()
   CALL DefaultInitialize()
   DO t=1,Active
      Element => GetActiveElement(t)
      n  = GetElementNOFNodes()
      nd = GetElementNOFDOFs()
      nb = GetElementNOFBDOFs()

      LOAD = 0.0d0
      BodyForce => GetBodyForce()
      IF ( ASSOCIATED(BodyForce) ) &
         Load(1:n) = GetReal( BodyForce, 'Source', Found )

      !Get element local matrix and rhs vector:
      !----------------------------------------
      CALL LocalMatrix(  MASS, DAMP, STIFF, FORCE, LOAD, Element, n, nd+nb )
      IF( TransientSimulation ) THEN
        CALL Default2ndOrderTime( MASS, DAMP, STIFF, FORCE )
      END IF
      CALL DefaultUpdateEquations( STIFF, FORCE )
   END DO
   CALL DefaultFinishAssembly()
   CALL DefaultDirichletBCs()


   ! And finally, solve:
   !--------------------
   Norm = DefaultSolve()

CONTAINS

!------------------------------------------------------------------------------
  SUBROUTINE LocalMatrix(  MASS, DAMP, STIFF, FORCE, LOAD, Element, n, nd )
!------------------------------------------------------------------------------
    REAL(KIND=dp) :: MASS(:,:), DAMP(:,:), STIFF(:,:), FORCE(:), LOAD(:)
    INTEGER :: n, nd
    TYPE(Element_t), POINTER :: Element
!------------------------------------------------------------------------------
    REAL(KIND=dp) :: Basis(nd),dBasisdx(nd,3),DetJ,LoadAtIP
    LOGICAL :: Stat
    INTEGER :: i,t,p,q
    TYPE(GaussIntegrationPoints_t) :: IP

    TYPE(Nodes_t) :: Nodes
    SAVE Nodes
!------------------------------------------------------------------------------
    CALL GetElementNodes( Nodes )
    MASS = 0.0d0
    DAMP = 0.0d0
    STIFF = 0.0d0
    FORCE = 0.0d0

    !Numerical integration:
    !----------------------
    IP = GaussPoints( Element )
    DO t=1,IP % n
      ! Basis function values & derivatives at the integration point:
      !--------------------------------------------------------------
      stat = ElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
       IP % W(t), detJ, Basis, dBasisdx )

      ! The source term at the integration point:
      !------------------------------------------
      LoadAtIP = SUM( Basis(1:n) * LOAD(1:n) )

      ! Finally, the elemental matrix & vector:
      !----------------------------------------
      DO p=1,nd
        DO q=1,nd
          MASS(p,q) = MASS(p,q) + IP % s(t) * DetJ * Basis(p) * Basis(q)
        END DO
      END DO
      STIFF(1:nd,1:nd) = STIFF(1:nd,1:nd) + IP % s(t) * DetJ * &
             MATMUL( dBasisdx, TRANSPOSE( dBasisdx ) )
      FORCE(1:nd) = FORCE(1:nd) + IP % s(t) * DetJ * LoadAtIP * Basis(1:nd)
    END DO
!------------------------------------------------------------------------------
  END SUBROUTINE LocalMatrix
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
END SUBROUTINE WaveSolver
!------------------------------------------------------------------------------

!/******************************************************************************
! * 
! *       ELMER, A Computational Fluid Dynamics Program.
! *
! *       Copyright 1st April 1995 - , Center for Scientific Computing,
! *                                    Finland.
! *
! *       All rights reserved. No part of this program may be used,
! *       reproduced or transmitted in any form or by any means
! *       without the written permission of CSC.
! *
! *****************************************************************************/
!
!/******************************************************************************
! *
! * Module containing a solver for fabric parameter equations  
! *
! ******************************************************************************
! *
! *                     Author:       Juha Ruokolainen
! *
! *                    Address: Center for Scientific Computing
! *                            Tietotie 6, P.O. Box 405
! *                              02101 Espoo, Finland
! *                              Tel. +358 0 457 2723
! *                            Telefax: +358 0 457 2302
! *                          EMail: Juha.Ruokolainen@csc.fi
! *
! *                       Date: 08 Jun 1997
! *
! *                Modified by: Fabien Gillet
! *
! *       Date of modification: 03/05
! *
! *****************************************************************************/

!------------------------------------------------------------------------------
      RECURSIVE SUBROUTINE FabricSolver( Model,Solver,dt,TransientSimulation )
!------------------------------------------------------------------------------

      USE DefUtils

      IMPLICIT NONE
!------------------------------------------------------------------------------
!******************************************************************************
!
!  Solve stress equations for one timestep
!
!  ARGUMENTS:
!
!  TYPE(Model_t) :: Model,  
!     INPUT: All model information (mesh,materials,BCs,etc...)
!
!  TYPE(Solver_t) :: Solver
!     INPUT: Linear equation solver options
!
!  REAL(KIND=dp) :: dt,
!     INPUT: Timestep size for time dependent simulations (NOTE: Not used
!            currently)
!
!******************************************************************************

     TYPE(Model_t)  :: Model
     TYPE(Solver_t), TARGET :: Solver

     LOGICAL ::  TransientSimulation
     REAL(KIND=dp) :: dt
!------------------------------------------------------------------------------
!    Local variables
!------------------------------------------------------------------------------
     TYPE(Solver_t), POINTER :: PSolver

     TYPE(Matrix_t),POINTER :: StiffMatrix

     INTEGER :: dim,n1,n2,i,j,k,l,n,t,iter,NDeg,STDOFs,LocalNodes,istat

     TYPE(ValueList_t),POINTER :: Material, BC
     TYPE(Nodes_t) :: ElementNodes
     TYPE(Element_t),POINTER :: CurrentElement, Element, &
              ParentElement, LeftParent, RightParent, Edge

     REAL(KIND=dp) :: RelativeChange,UNorm,PrevUNorm,Gravity(3), &
         Tdiff,Normal(3),NewtonTol,NonlinearTol,s,Wn(7)


     INTEGER :: NewtonIter,NonlinearIter

     TYPE(Variable_t), POINTER :: FabricSol, TempSol, FabricVariable, FlowVariable, &
                                  EigenFabricVariable, MeshVeloVariable

     REAL(KIND=dp), POINTER :: Temperature(:),Fabric(:), &
           FabricValues(:), FlowValues(:), EigenFabricValues(:), &
           MeshVeloValues(:), Solution(:), Ref(:)

     INTEGER, POINTER :: TempPerm(:),FabricPerm(:),NodeIndexes(:), &
                        FlowPerm(:), MeshVeloPerm(:), EigenFabricPerm(:)

     REAL(KIND=dp) :: rho,lambda   !Interaction parameter,diffusion parameter
     REAL(KIND=dp) :: A1plusA2
     Real(KIND=dp), parameter :: Rad2deg=180._dp/Pi
     REAL(KIND=dp) :: a2(6)
     REAL(KIND=dp) :: ai(3), Angle(3)

     LOGICAL :: GotForceBC,GotIt,NewtonLinearization = .FALSE.

     INTEGER :: body_id,bf_id,eq_id, comp, Indexes(128)
!
     INTEGER :: old_body = -1

     REAL(KIND=dp) :: FabricGrid(4879)                   
                        
     LOGICAL :: AllocationsDone = .FALSE., FreeSurface

     TYPE(Variable_t), POINTER :: TimeVar

     REAL(KIND=dp), ALLOCATABLE:: MASS(:,:), STIFF(:,:),  &
       LocalFluidity(:), LOAD(:,:),Force(:), LocalTemperature(:), &
       Alpha(:,:),Beta(:), K1(:), K2(:), E1(:), E2(:), E3(:), &
       Velocity(:,:), MeshVelocity(:,:)

     SAVE MASS, STIFF, LOAD, Force,ElementNodes,Alpha,Beta, & 
          LocalTemperature, LocalFluidity,  AllocationsDone, K1, K2, &
          E1, E2, E3, Wn,  FabricGrid, rho, lambda, Velocity, &
          MeshVelocity, old_body, dim, comp
!------------------------------------------------------------------------------
     CHARACTER(LEN=MAX_NAME_LEN) :: viscosityFile

     REAL(KIND=dp) :: Bu,Bv,Bw,RM(3,3), SaveTime = -1
     REAL(KIND=dp), POINTER :: PrevFabric(:),CurrFabric(:),TempFabVal(:)

     SAVE  ViscosityFile, PrevFabric, CurrFabric,TempFabVal
     REAL(KIND=dp) :: at, at0, CPUTime, RealTime
!------------------------------------------------------------------------------
      INTERFACE
        Subroutine R2Ro(a2,dim,ai,angle)
        USE Types
        REAL(KIND=dp),intent(in) :: a2(6)
        Integer :: dim
        REAL(KIND=dp),intent(out) :: ai(3), Angle(3)
       End Subroutine R2Ro
      End Interface                                                       
!------------------------------------------------------------------------------
!  Read constants from constants section of SIF file
!------------------------------------------------------------------------------
         
      Wn(7) = ListGetConstReal( Model % Constants, 'Gas Constant', GotIt )
      IF (.NOT.GotIt) THEN
        WRITE(Message,'(A)')'VariableGas Constant not found. &
                                     &Setting to 8.314'
        CALL INFO('FabricSolve',Message,Level=4)
        Wn(7) = 8.314
      ELSE
        WRITE(Message,'(A,F10.4)')'Gas Constant =',Wn(7)
        CALL INFO('FabricSolve',Message,Level=4)
      END IF  
!------------------------------------------------------------------------------
!    Get variables needed for solution
!------------------------------------------------------------------------------
      IF ( .NOT. ASSOCIATED( Solver % Matrix ) ) RETURN

      Solution => Solver % Variable % Values
      STDOFs   =  Solver % Variable % DOFs

      FabricSol    => VariableGet( Solver % Mesh % Variables, 'Fabric' )
      FabricPerm   => FabricSol % Perm
      FabricValues => FabricSol % Values

      TempSol => VariableGet( Solver % Mesh % Variables, 'Temperature' )
      IF ( ASSOCIATED( TempSol) ) THEN
       TempPerm    => TempSol % Perm
       Temperature => TempSol % Values
      END IF

      FlowVariable => VariableGet( Solver % Mesh % Variables, 'AIFlow' )
      IF ( ASSOCIATED( FlowVariable ) ) THEN
       FlowPerm    => FlowVariable % Perm
       FlowValues  => FlowVariable % Values
      END IF
      
!!!!! Mesh Velo
     MeshVeloVariable => VariableGet( Solver % Mesh % Variables, &
            'Mesh Velocity' )

     IF ( ASSOCIATED( MeshVeloVariable ) ) THEN
       MeshVeloPerm    => MeshVeloVariable % Perm
       MeshVeloValues  => MeshVeloVariable % Values
     END IF
       
                                       
      StiffMatrix => Solver % Matrix
      ! UNorm = Solver % Variable % Norm
      Unorm = SQRT( SUM( FabricValues**2 ) / SIZE(FabricValues) )
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
!     Allocate some permanent storage, this is done first time only
!------------------------------------------------------------------------------
      IF ( .NOT. AllocationsDone .OR. Solver % Mesh % Changed) THEN
        N = Model % MaxElementNodes

       dim = CoordinateSystemDimension()
       
       IF ( AllocationsDone ) THEN
         DEALLOCATE( LocalTemperature, &
                     K1,K2,E1,E2,E3, &
                     Force, LocalFluidity, &
                     Velocity,MeshVelocity, &
                     MASS,STIFF,      &
                     LOAD, Alpha, Beta, &
                     CurrFabric, TempFabVal )
       END IF

       ALLOCATE( LocalTemperature( N ), LocalFluidity( N ), &
                 K1( N ), K2( N ), E1( N ), E2( N ), E3( N ), &
                 Force( 2*STDOFs*N ), &
                 Velocity(4, N ),MeshVelocity(3,N), &
                 MASS( 2*STDOFs*N,2*STDOFs*N ),  &
                 STIFF( 2*STDOFs*N,2*STDOFs*N ),  &
                 LOAD( 4,N ), Alpha( 3,N ), Beta( N ), &
                 CurrFabric( 5*SIZE(Solver % Variable % Values)), &
                 TempFabVal( 5*SIZE(Solver % Variable % Values)), &
                 STAT=istat )


       IF ( istat /= 0 ) THEN
          CALL Fatal( 'FabricSolve', 'Memory allocation error.' )
       END IF

       CurrFabric = 0.
       TempFabVal = 0.
       IF ( TransientSimulation ) THEN
          IF (AllocationsDone ) DEALLOCATE (PrevFabric)
          ALLOCATE( PrevFabric( 5*SIZE(Solver % Variable % Values)) )
         PrevFabric = 0.
       END IF

       DO i=1,Solver % NumberOFActiveElements
          CurrentElement => GetActiveElement(i)   
          n = GetElementDOFs( Indexes )
          n = GetElementNOFNodes()
          NodeIndexes => CurrentElement % NodeIndexes
          Indexes(1:n) = Solver % Variable % Perm( Indexes(1:n) )
          DO COMP=1,5
            IF ( TransientSimulation ) THEN
               PrevFabric(5*(Indexes(1:n)-1)+COMP) = &
                   FabricValues(5*(FabricPerm(NodeIndexes(1:n))-1)+COMP)
            END IF
               CurrFabric(5*(Indexes(1:n)-1)+COMP) = &
                   FabricValues(5*(FabricPerm(NodeIndexes(1:n))-1)+COMP)
          END DO
       END DO

       AllocationsDone = .TRUE.
      END IF

      IF( TransientSimulation ) THEN
        TimeVar => VariableGet( Solver % Mesh % Variables, 'Time' )
        IF ( SaveTime /= TimeVar % Values(1) ) THEN
           SaveTime = TimeVar % Values(1)
           PrevFabric = CurrFabric
        END IF
      END IF

!------------------------------------------------------------------------------
!    Do some additional initialization, and go for it
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
      NonlinearTol = ListGetConstReal( Solver % Values, &
        'Nonlinear System Convergence Tolerance' )

      NewtonTol = ListGetConstReal( Solver % Values, &
        'Nonlinear System Newton After Tolerance' )

      NewtonIter = ListGetInteger( Solver % Values, &
        'Nonlinear System Newton After Iterations' )

      NonlinearIter = ListGetInteger( Solver % Values, &
         'Nonlinear System Max Iterations',GotIt )

      IF ( .NOT.GotIt ) NonlinearIter = 1
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
      DO iter=1,NonlinearIter
!------------------------------------------------------------------------------
       at  = CPUTime()
       at0 = RealTime()


       CALL Info( 'FabricSolve', ' ', Level=4 )
       CALL Info( 'FabricSolve', ' ', Level=4 )
       CALL Info( 'FabricSolve', &
                    '-------------------------------------',Level=4 )
       WRITE( Message, * ) 'Fabric solver  iteration', iter
       CALL Info( 'FabricSolve', Message,Level=4 )
       CALL Info( 'FabricSolve', &
                     '-------------------------------------',Level=4 )
       CALL Info( 'FabricSolve', ' ', Level=4 )
       CALL Info( 'FabricSolve', 'Starting assembly...',Level=4 )

!------------------------------------------------------------------------------

       PrevUNorm = UNorm
       
       DO COMP=1,2*dim-1

       Solver % Variable % Values = CurrFabric( COMP::5 )
       IF ( TransientSimulation ) THEN
          Solver % Variable % PrevValues(:,1) = PrevFabric( COMP::5 )
       END IF

       CALL DefaultInitialize()
!------------------------------------------------------------------------------
       DO t=1,Solver % NumberOFActiveElements
!------------------------------------------------------------------------------

         IF ( RealTime() - at0 > 1.0 ) THEN
           WRITE(Message,'(a,i3,a)' ) '   Assembly: ', INT(100.0 - 100.0 * &
            (Solver % NumberOfActiveElements-t) / &
               (1.0*Solver % NumberOfActiveElements)), ' % done'
                       
           CALL Info( 'FabricSolve', Message, Level=5 )
           at0 = RealTime()
         END IF

         CurrentElement => GetActiveElement(t)
         CALL GetElementNodes( ElementNodes )
         n = GetElementDOFs( Indexes )
         n = GetElementNOFNodes()
         NodeIndexes => CurrentElement % NodeIndexes

         
         Material => GetMaterial()
         body_id = CurrentElement % BodyId
!------------------------------------------------------------------------------
!        Read in material constants from Material section
!------------------------------------------------------------------------------
         IF (body_id /= old_body) Then 
           old_body = body_id
           CALL GetMaterialDefs()
         END IF
      
         LocalFluidity(1:n) = ListGetReal( Material, &
                         'Fluidity Parameter', n, NodeIndexes, GotIt )
        IF (.NOT.GotIt) THEN
         WRITE(Message,'(A)') 'Variable Fluidity Parameter not found. &
                            &Setting to 1.0'
         CALL INFO('AIFlowSolve', Message, Level = 4)
         LocalFluidity(1:n) = 1.0
        END IF
!------------------------------------------------------------------------------
!        Get element local stiffness & mass matrices
!------------------------------------------------------------------------------
         LocalTemperature = 0.0D0
         IF ( ASSOCIATED(TempSol) ) THEN
            DO i=1,n
               k = TempPerm(NodeIndexes(i))
               LocalTemperature(i) = Temperature(k)
            END DO
         ELSE
            LocalTemperature(1:n) = 0.0d0
         END IF

         K1(1:n) = CurrFabric( 5*(Solver % Variable % Perm(Indexes(1:n))-1)+1 )
         K2(1:n) = CurrFabric( 5*(Solver % Variable % Perm(Indexes(1:n))-1)+2 )
         E1(1:n) = CurrFabric( 5*(Solver % Variable % Perm(Indexes(1:n))-1)+3 )
         E2(1:n) = CurrFabric( 5*(Solver % Variable % Perm(Indexes(1:n))-1)+4 )
         E3(1:n) = CurrFabric( 5*(Solver % Variable % Perm(Indexes(1:n))-1)+5 )

         k = FlowVariable % DOFs
         Velocity = 0.0d0
         DO i=1,k
            Velocity(i,1:n) = FlowValues(k*(FlowPerm(NodeIndexes)-1)+i)
         END DO

!------------meshvelocity
         MeshVelocity=0._dp
         IF (ASSOCIATED(MeshVeloVariable)) Then
           k = MeshVeloVariable % DOFs
           DO i=1,k
              MeshVelocity(i,1:n) = MeshVeloValues(k*(MeshVeloPerm(NodeIndexes)-1)+i)
           END DO
         EndIF
!----------------------------------

         CALL LocalMatrix( COMP, MASS, STIFF, FORCE, LOAD, K1, K2, E1, &
           E2, E3, LocalTemperature, LocalFluidity,  Velocity, &
           MeshVelocity, CurrentElement, n, ElementNodes, Wn, rho, lambda )

!------------------------------------------------------------------------------
!        Update global matrices from local matrices 
!------------------------------------------------------------------------------
         IF ( TransientSimulation )  CALL Default1stOrderTime(MASS,STIFF,FORCE)
         CALL DefaultUpdateEquations( STIFF, FORCE )
!------------------------------------------------------------------------------
      END DO
      CALL Info( 'FabricSolve', 'Assembly done', Level=4 )
!------------------------------------------------------------------------------
   
!------------------------------------------------------------------------------
!     Assembly of the edge terms
!------------------------------------------------------------------------------
!
!3D => Edges => Faces
      If (dim.eq.3) then 
      DO t=1,Solver % Mesh % NumberOfFaces
         Edge => Solver % Mesh % Faces(t)
         IF ( .NOT. ActiveBoundaryElement(Edge) ) CYCLE
       
         LeftParent  => Edge % BoundaryInfo % Left
         RightParent => Edge % BoundaryInfo % Right
         IF ( ASSOCIATED(RightParent) .AND. ASSOCIATED(LeftParent) ) THEN
            n  = GetElementNOFNodes( Edge )
            n1 = GetElementNOFNodes( LeftParent )
            n2 = GetElementNOFNodes( RightParent )

            k = FlowVariable % DOFs
            Velocity = 0.0d0
            DO i=1,k
               Velocity(i,1:n) = FlowValues(k*(FlowPerm(Edge % NodeIndexes)-1)+i)
            END DO

     !-------------------mesh velo
         MeshVelocity=0._dp
      IF ( ASSOCIATED( MeshVeloVariable ) ) THEN
            k = MeshVeloVariable % DOFs
            DO i=1,k
               MeshVelocity(i,1:n) = MeshVeloValues(k*(MeshVeloPerm(Edge % NodeIndexes)-1)+i)
            END DO
      END IF
     !--------------------------

            FORCE = 0.0d0
            MASS  = 0.0d0
            CALL LocalJumps( STIFF,Edge,n,LeftParent,n1,RightParent,n2,Velocity,MeshVelocity )
            IF ( TransientSimulation )  CALL Default1stOrderTime(MASS, STIFF, FORCE)
            CALL DefaultUpdateEquations( STIFF, FORCE, Edge )
         END IF
      END DO
!
!  2D
      Else

      DO t=1,Solver % Mesh % NumberOfEdges
         Edge => Solver % Mesh % Edges(t)
         IF ( .NOT. ActiveBoundaryElement(Edge) ) CYCLE
       
         LeftParent  => Edge % BoundaryInfo % Left
         RightParent => Edge % BoundaryInfo % Right
         IF ( ASSOCIATED(RightParent) .AND. ASSOCIATED(LeftParent) ) THEN
            n  = GetElementNOFNodes( Edge )
            n1 = GetElementNOFNodes( LeftParent )
            n2 = GetElementNOFNodes( RightParent )

            k = FlowVariable % DOFs
            Velocity = 0.0d0
            DO i=1,k
               Velocity(i,1:n) = FlowValues(k*(FlowPerm(Edge % NodeIndexes(1:n))-1)+i)
            END DO

     !-------------------mesh velo
         MeshVelocity=0._dp
      IF ( ASSOCIATED( MeshVeloVariable ) ) THEN
            k = MeshVeloVariable % DOFs
            DO i=1,k
               MeshVelocity(i,1:n) = MeshVeloValues(k*(MeshVeloPerm(Edge % NodeIndexes)-1)+i)
            END DO
      END IF
     !--------------------------

            FORCE = 0.0d0
            MASS  = 0.0d0
            CALL LocalJumps( STIFF,Edge,n,LeftParent,n1,RightParent,n2,Velocity,MeshVelocity )
            IF ( TransientSimulation )  CALL Default1stOrderTime(MASS, STIFF, FORCE)
            CALL DefaultUpdateEquations( STIFF, FORCE, Edge )
         END IF
       END DO

      END IF

!------------------------------------------------------------------------------
!     Loop over the boundary elements
!------------------------------------------------------------------------------
      DO t = 1, Solver % Mesh % NumberOfBoundaryElements
!------------------------------------------------------------------------------

         Element => GetBoundaryElement(t)
         IF( .NOT. ActiveBoundaryElement() )  CYCLE
         IF( GetElementFamily(Element) == 1 ) CYCLE

         ParentElement => Element % BoundaryInfo % Left
         IF ( .NOT. ASSOCIATED( ParentElement ) ) &
            ParentElement => Element % BoundaryInfo % Right
          
         n  = GetElementNOFNodes( Element )
         n1 = GetElementNOFnodes( ParentElement )
       
         k = FlowVariable % DOFs
         Velocity = 0.0d0
         DO i=1,k
            Velocity(i,1:n) = FlowValues(k*(FlowPerm(Element % NodeIndexes(1:n))-1)+i)
         END DO

!-------------------mesh velo
         MeshVelocity=0._dp
      IF ( ASSOCIATED( MeshVeloVariable ) ) THEN
        k = MeshVeloVariable % DOFs
        DO i=1,k
         MeshVelocity(i,1:n) = MeshVeloValues(k*(MeshVeloPerm(Element % NodeIndexes)-1)+i)
        End do
      END IF
!--------------------------


         BC => GetBC()
         LOAD = 0.0d0
         GotIt = .FALSE.
         IF ( ASSOCIATED(BC) ) THEN
            LOAD(1,1:n) = GetReal( BC, ComponentName('Fabric', Comp) , GotIt )
         END IF

         MASS = 0.0d0
         CALL LocalMatrixBoundary(  STIFF, FORCE, LOAD(1,1:n), &
                              Element, n, ParentElement, n1, Velocity,MeshVelocity, GotIt )

         IF ( TransientSimulation )  CALL Default1stOrderTime(MASS, STIFF, FORCE)
         CALL DefaultUpdateEquations( STIFF, FORCE )
      END DO

      CALL DefaultFinishAssembly()
!------------------------------------------------------------------------------
      CALL Info( 'FabricSolve', 'Set boundaries done', Level=4 )

!------------------------------------------------------------------------------
!     Solve the system and check for convergence
!------------------------------------------------------------------------------
      Unorm = DefaultSolve()
!      CurrFabric( COMP::5 ) = Solver % Variable % Values
      WRITE(Message,*) 'solve done', minval( solver % variable % values), maxval( Solver % variable % values)
      CALL Info( 'FabricSolve', Message, Level=4 )
      
      n1 = Solver % Mesh % NumberOfNodes
      ALLOCATE( Ref(n1) )
      Ref = 0
      !
      ! FabricValues( COMP::5 ) = 0 !fab sinon remet toutes les
      ! fabriques à 0 dans le cas ou on a 2 domaines dont l'un a la
      ! fabrique fixe
      TempFabVal(COMP::5 ) = 0. !fab
      
      DO t=1,Solver % NumberOfActiveElements
         Element => GetActiveElement(t) 
         n = GetElementDOFs( Indexes )
         n = GetElementNOFNodes()
         
         DO i=1,n
            k = Element % NodeIndexes(i)
            TempFabVal( 5*(FabricPerm(k)-1) + COMP ) =    & 
            TempFabVal( 5*(FabricPerm(k)-1) + COMP ) + &
            Solver % Variable % Values( Solver % Variable % Perm(Indexes(i)) )
            FabricValues( 5*(FabricPerm(k)-1) + COMP ) = &
                          TempFabVal(5*(FabricPerm(k)-1) + COMP ) 
            Ref(k) = Ref(k) + 1
         END DO
      END DO

      DO i=1,n1
         j=FabricPerm(i)
         IF (j < 1) CYCLE
         IF ( Ref(i) > 0 ) THEN
            FabricValues( 5*(j-1)+COMP ) = &
                   FabricValues( 5*(j-1)+COMP ) / Ref(i)
         END IF
      END DO

      DEALLOCATE( Ref )

      SELECT CASE( Comp ) 
      CASE(1)
      FabricValues( COMP:SIZE(FabricValues):5 ) = &
          MIN(MAX( FabricValues( COMP:SIZE(FabricValues):5 ) , 0._dp),1._dp)
          
      CASE(2)
       FabricValues( COMP:SIZE(FabricValues):5 ) = &
       MIN(MAX( FabricValues( COMP:SIZE(FabricValues):5 ) , 0._dp),1._dp)
       
       !DO i=1,SIZE(FabricValues),5 
       !  IF((FabricValues(i)+FabricValues(i+1)).GT.1._dp) THEN
       !      A1plusA2=FabricValues(i)+FabricValues(i+1)
       !      FabricValues(i)= &
       !        FabricValues(i)/A1plusA2
       !      FabricValues(i+1)= &
       !        FabricValues(i+1)/A1plusA2
       !   END IF
       ! END DO
        

      CASE(3:5)
       DO i=COMP,SIZE(FabricValues),5
         IF(FabricValues(i).GT.0._dp) THEN
               FabricValues(i) = MIN( FabricValues(i) , 0.5_dp)
         ELSE
               FabricValues(i) = MAX( FabricValues(i) , -0.5_dp)
         END IF
       END DO
      END SELECT

      END DO ! End DO Comp

       DO i=1,Solver % NumberOFActiveElements
          CurrentElement => GetActiveElement(i)   
          n = GetElementDOFs( Indexes )
          n = GetElementNOFNodes()
          NodeIndexes => CurrentElement % NodeIndexes
          Indexes(1:n) = Solver % Variable % Perm( Indexes(1:n) )
          DO COMP=1,5
            CurrFabric(5*(Indexes(1:n)-1)+COMP) = &
                        FabricValues(5*(FabricPerm(NodeIndexes(1:n))-1)+COMP)
          END DO
       END DO


      Unorm = SQRT( SUM( FabricValues**2 ) / SIZE(FabricValues) )
      Solver % Variable % Norm = Unorm  

      IF ( PrevUNorm + UNorm /= 0.0d0 ) THEN
         RelativeChange = 2.0d0 * ABS( PrevUNorm - UNorm) / ( PrevUnorm + UNorm)
      ELSE
         RelativeChange = 0.0d0
      END IF

      WRITE( Message, * ) 'Result Norm   : ',UNorm
      CALL Info( 'FabricSolve', Message, Level=4 )
      WRITE( Message, * ) 'Relative Change : ',RelativeChange
      CALL Info( 'FabricSolve', Message, Level=4 )

      
!------------------------------------------------------------------------------
      IF ( RelativeChange < NewtonTol .OR. &
            iter > NewtonIter ) NewtonLinearization = .TRUE.

      IF ( RelativeChange < NonLinearTol ) EXIT

!------------------------------------------------------------------------------
      EigenFabricVariable => &
       VariableGet( Solver % Mesh % Variables, 'EigenV' )
     IF ( ASSOCIATED( EigenFabricVariable ) ) THEN
         EigenFabricPerm    => EigenFabricVariable % Perm
         EigenFabricValues => EigenFabricVariable % Values
      
         DO t=1,Solver % NumberOFActiveElements

           CurrentElement => GetActiveElement(t)
           n = GetElementNOFNodes()
           NodeIndexes => CurrentElement % NodeIndexes

           K1(1:n) = FabricValues( 5*(FabricPerm(NodeIndexes(1:n))-1)+1 )
           K2(1:n) = FabricValues( 5*(FabricPerm(NodeIndexes(1:n))-1)+2 )
           E1(1:n) = FabricValues( 5*(FabricPerm(NodeIndexes(1:n))-1)+3 )
           E2(1:n) = FabricValues( 5*(FabricPerm(NodeIndexes(1:n))-1)+4 )
           E3(1:n) = FabricValues( 5*(FabricPerm(NodeIndexes(1:n))-1)+5 )
         
           Do i=1,n
            a2(1)=K1(i)
            a2(2)=K2(i)
            a2(3)=1._dp-a2(1)-a2(2)
            a2(4)=E1(i)
            a2(5)=E2(i)
            a2(6)=E3(i)

            call R2Ro(a2,dim,ai,angle)

            angle(:)=angle(:)*rad2deg
            If (angle(1).gt.90._dp) angle(1)=angle(1)-180._dp
            If (angle(1).lt.-90._dp) angle(1)=angle(1)+180._dp
          
           EigenFabricValues( 6 * (EigenFabricPerm(NodeIndexes(i))-1) + 1)=ai(1)
           EigenFabricValues( 6 * (EigenFabricPerm(NodeIndexes(i))-1) + 2)=ai(2)
           EigenFabricValues( 6 * (EigenFabricPerm(NodeIndexes(i))-1) + 3 )=ai(3)
           EigenFabricValues( 6 * (EigenFabricPerm(NodeIndexes(i))-1) + 4 )=angle(1)
           EigenFabricValues( 6 * (EigenFabricPerm(NodeIndexes(i))-1) + 5 )=angle(2)
           EigenFabricValues( 6 * (EigenFabricPerm(NodeIndexes(i))-1) + 6 )=angle(3)
           End do
        END DO

      END IF
!------------------------------------------------------------------------------
    END DO ! of nonlinear iter
!------------------------------------------------------------------------------
CONTAINS

      SUBROUTINE GetMaterialDefs()

      viscosityFile = ListGetString( Material ,'Viscosity File',GotIt )
      IF (.NOT.GotIt) THEN
          WRITE(Message,'(3A)') &
                      'Viscosity File ', viscosityFile, ' not found'
         CALL FATAL('AIFlowSolve',Message)
      ELSE
         OPEN( 1, File = viscosityFile)
         DO i=1,813
            READ( 1, '(6(e14.8))' ) FabricGrid( 6*(i-1)+1:6*(i-1)+6 )
         END DO
         READ(1 , '(e14.8)' ) FabricGrid(4879)
         CLOSE(1)
      END IF

       rho = ListGetConstReal(Material, 'Interaction Parameter', GotIt )
       IF (.NOT.GotIt) THEN
           WRITE(Message,'(A)') 'Interaction  Parameter notfound. &
                         &Setting to the value in ViscosityFile'
           CALL INFO('AIFlowSolve', Message, Level = 20)
           rho = FabricGrid(4879)
       ELSE
           WRITE(Message,'(A,F10.4)') 'Interaction Parameter = ', rho
           CALL INFO('AIFlowSolve', Message, Level = 20)
       END IF

       lambda = ListGetConstReal( Material, 'Diffusion Parameter', GotIt )
       IF (.NOT.GotIt) THEN
           WRITE(Message,'(A)') 'Diffusion  Parameter not found. &
                                 &Setting to 0'
           CALL INFO('AIFlowSolve', Message, Level = 20)
           lambda = 0.0_dp
       ELSE
           WRITE(Message,'(A,F10.4)') 'Diffusion Parameter = ', lambda
           CALL INFO('AIFlowSolve', Message, Level = 20)
       END IF
      Wn(2) = ListGetConstReal( Material , 'Powerlaw Exponent', GotIt )
      IF (.NOT.GotIt) THEN
         WRITE(Message,'(A)') 'Variable  Powerlaw Exponent not found. &
                                    & Setting to 1.0'
         CALL INFO('AIFlowSolve', Message, Level = 20)
         Wn(2) = 1.0
      ELSE
       WRITE(Message,'(A,F10.4)') 'Powerlaw Exponent = ',   Wn(2)
       CALL INFO('AIFlowSolve', Message, Level = 20)
       END IF

      Wn(3) = ListGetConstReal( Material, 'Activation Energy 1', GotIt )
      IF (.NOT.GotIt) THEN
         WRITE(Message,'(A)') 'Variable Activation Energy 1 not found.&
                            & Setting to 1.0'
         CALL INFO('AIFlowSolve', Message, Level = 20)
         Wn(3) = 1.0
      ELSE
         WRITE(Message,'(A,F10.4)') 'Activation Energy 1 = ',   Wn(3)
         CALL INFO('AIFlowSolve', Message, Level = 20)
      END IF

      Wn(4) = ListGetConstReal( Material, 'Activation Energy 2', GotIt )
      IF (.NOT.GotIt) THEN
         WRITE(Message,'(A)') 'Variable Activation Energy 2 not found. &
                               &Setting to 1.0'
         CALL INFO('AIFlowSolve', Message, Level = 20)
         Wn(4) = 1.0
      ELSE
         WRITE(Message,'(A,F10.4)') 'Activation Energy 2 = ',   Wn(4)
         CALL INFO('AIFlowSolve', Message, Level = 20)
      END IF

      Wn(5) = ListGetConstReal(Material, 'Reference Temperature', GotIt)
      IF (.NOT.GotIt) THEN
         WRITE(Message,'(A)') 'Variable Reference Temperature not found. &
                               &Setting to -10.0 (Celsius)'
         CALL INFO('AIFlowSolve', Message, Level = 20)
         Wn(5) = -10.0
      ELSE
         WRITE(Message,'(A,F10.4)') 'Reference Temperature = ',   Wn(5)
         CALL INFO('AIFlowSolve', Message, Level = 20)
      END IF

      Wn(6) = ListGetConstReal( Material, 'Limit Temperature', GotIt )
      IF (.NOT.GotIt) THEN
         WRITE(Message,'(A)') 'Variable Limit Temperature not found. &
                               &Setting to -10.0 (Celsius)'
         CALL INFO('AIFlowSolve', Message, Level = 20)
         Wn(6) = -10.0
      ELSE
         WRITE(Message,'(A,F10.4)') 'Limit Temperature = ',   Wn(6)
         CALL INFO('AIFlowSolve', Message, Level = 20)
      END IF
!------------------------------------------------------------------------------
      END SUBROUTINE GetMaterialDefs
!------------------------------------------------------------------------------


!------------------------------------------------------------------------------
      SUBROUTINE LocalMatrix( Comp, MASS, STIFF, FORCE, LOAD, &
          NodalK1, NodalK2, NodalEuler1, NodalEuler2, NodalEuler3, & 
          NodalTemperature, NodalFluidity, NodalVelo, NodMeshVel, &
          Element, n, Nodes, Wn, rho,lambda )
!------------------------------------------------------------------------------

     REAL(KIND=dp) :: STIFF(:,:),MASS(:,:)
     REAL(KIND=dp) :: LOAD(:,:), NodalVelo(:,:),NodMeshVel(:,:)
     REAL(KIND=dp), DIMENSION(:) :: FORCE, NodalK1, NodalK2, NodalEuler1, &
               NodalEuler2, NodalEuler3, NodalTemperature, NodalFluidity

     TYPE(Nodes_t) :: Nodes
     TYPE(Element_t) :: Element
     INTEGER :: n, Comp
!------------------------------------------------------------------------------
!
     REAL(KIND=dp) :: Basis(2*n),ddBasisddx(1,1,1)
     REAL(KIND=dp) :: dBasisdx(2*n,3),SqrtElementMetric

     REAL(KIND=dp) :: A1, A2, A3, E1, E2, E3, Theta

     REAL(KIND=dp) :: A,M, hK,tau,pe1,pe2,unorm,C0, SU(n), SW(n)
     REAL(KIND=dp) :: LoadAtIp, Temperature
     REAL(KIND=dp) :: rho,lambda,Deq, ai(6),a4(9),hmax

     INTEGER :: i,j,k,p,q,t,dim,NBasis,ind(3), DOFs = 1

     REAL(KIND=dp) :: s,u,v,w, Radius, B(6,3), G(3,6), C44,C55,C66
     REAL(KIND=dp) :: Wn(:),Velo(3),DStress(6),StrainR(6),Spin(3),SD(6)

     REAL(KIND=dp) :: LGrad(3,3),StrainRate(3,3),D(6),angle(3),epsi
     REAL(KIND=dp) :: ap(3),C(6,6),Spin1(3,3),Stress(3,3)
     Integer :: INDi(6),INDj(6)
     LOGICAL :: CSymmetry
     
     LOGICAL :: Fond
              
!              
     INTEGER :: N_Integ
     REAL(KIND=dp), DIMENSION(:), POINTER :: U_Integ,V_Integ,W_Integ,S_Integ

     LOGICAL :: stat
     TYPE(GaussIntegrationPoints_t), TARGET :: IntegStuff

     INTERFACE
        FUNCTION BGlenT( Tc, W)
           USE Types
           REAL(KIND=dp) :: BGlenT,Tc,W(7)
        END FUNCTION
        
        SUBROUTINE IBOF(ai,a4)
           USE Types
           REAL(KIND=dp),intent(in) :: ai(6)
           REAL(KIND=dp),intent(out) :: a4(9)
        END SUBROUTINE

        Subroutine R2Ro(ai,dim,a2,angle)
         USE Types
         REAL(KIND=dp),intent(in) :: ai(6)
         Integer :: dim
         REAL(KIND=dp),intent(out) :: a2(3), Angle(3)
        End Subroutine R2Ro

        Subroutine OPILGGE_ai(a2,Angle,Tc,W,etaI,eta36)
         USE Types
         REAL(KIND=dp) :: a2(3), Angle(3), Tc, W(7),EtaI(:),Eta36(6,6)
        END SUBROUTINE OPILGGE_ai
        
      END INTERFACE
!------------------------------------------------------------------------------
      Fond=.False.
      hmax = maxval (Nodes % y(1:n))
        
     dim = CoordinateSystemDimension()

      FORCE = 0.0D0
      MASS  = 0.0D0
      STIFF = 0.0D0
!    
!    Integration stuff:
!    ------------------
      NBasis = n
      IntegStuff = GaussPoints( Element  )

      U_Integ => IntegStuff % u
      V_Integ => IntegStuff % v
      W_Integ => IntegStuff % w
      S_Integ => IntegStuff % s
      N_Integ =  IntegStuff % n

      hk = ElementDiameter( Element, Nodes )
!
!   Now we start integrating:
!   -------------------------
      DO t=1,N_Integ

      u = U_Integ(t)
      v = V_Integ(t)
      w = W_Integ(t)

!------------------------------------------------------------------------------
!     Basis function values & derivatives at the integration point
!------------------------------------------------------------------------------
      stat = ElementInfo( Element,Nodes,u,v,w,SqrtElementMetric, &
               Basis, dBasisdx, ddBasisddx, .FALSE. )

      s = SqrtElementMetric * S_Integ(t)
!------------------------------------------------------------------------------
!
!     Orientation parameters at the integration point:
!     ------------------------------------------------
      A1 = SUM( NodalK1(1:n) * Basis(1:n) ) 
      A2 = SUM( NodalK2(1:n) * Basis(1:n) )
      A3 = 1._dp - A1 - A2

      E1 = SUM( NodalEuler1(1:n) * Basis(1:n) )
      E2 = SUM( NodalEuler2(1:n) * Basis(1:n) )
      E3 = SUM( NodalEuler3(1:n) * Basis(1:n) )
!
!      Fluidity  at the integration point:
!---------------------------------------------
       Wn(1)=SUM( NodalFluidity(1:n)*Basis(1:n) )
!
!     Temperature at the integration point:
!     -------------------------------------
      Temperature = SUM( NodalTemperature(1:n)*Basis(1:n) )
!
!     Get theta parameter: (the (fluidity in the basal plane)/2, 
!     function of the Temperature )
!     -----------------------------------------------------
      Theta = 1._dp / ( FabricGrid(5) + FabricGrid(6) )
      Theta = Theta * BGlenT( Temperature, Wn )

!      Strain-Rate, Stresses and Spin

      CSymmetry = CurrentCoordinateSystem() == AxisSymmetric
      
      Stress = 0.0
      StrainRate = 0.0
      Spin1 = 0.0
!
!    Material parameters at that point
!    ---------------------------------
!
      ai(1)=A1
      ai(2)=A2
      ai(3)=A3
      ai(4)=E1
      ai(5)=E2
      ai(6)=E3

!    fourth order orientation tensor
      call IBOF(ai,a4)
      
!     A2 expressed in the orthotropic frame
!
      call R2Ro(ai,dim,ap,angle)

!     Get viscosity

      CALL OPILGGE_ai(ap, Angle, Temperature, Wn, FabricGrid, C)

!    Compute strainRate and Spin :
!    -----------------------------

      LGrad = MATMUL( NodalVelo(:,1:n), dBasisdx(1:n,:) )

      StrainRate = 0.5 * ( LGrad + TRANSPOSE(LGrad) )

      Spin1 = 0.5 * ( LGrad - TRANSPOSE(LGrad) )

      IF ( CSymmetry ) THEN
        StrainRate(1,3) = 0.0
        StrainRate(2,3) = 0.0
        StrainRate(3,1) = 0.0
        StrainRate(3,2) = 0.0
        StrainRate(3,3) = 0.0

        Radius = SUM( Nodes % x(1:n) * Basis(1:n) )

        IF ( Radius > 10*AEPS ) THEN
         StrainRate(3,3) = SUM( Nodalvelo(1,1:n) * Basis(1:n) ) / Radius
        END IF

        epsi = StrainRate(1,1)+StrainRate(2,2)+StrainRate(3,3)
        DO i=1,3   
          StrainRate(i,i) = StrainRate(i,i) - epsi/3.0
        END DO

      ELSE
        epsi = StrainRate(1,1)+StrainRate(2,2)+StrainRate(3,3)
        DO i=1,dim 
          StrainRate(i,i) = StrainRate(i,i) - epsi/dim
        END DO

      END IF
      
!
!    Compute deviatoric stresses: 
!    ----------------------------
      D(1) = StrainRate(1,1)
      D(2) = StrainRate(2,2)
      D(3) = StrainRate(3,3)
      D(4) = 2. * StrainRate(1,2)
      D(5) = 2. * StrainRate(2,3)
      D(6) = 2. * StrainRate(3,1)
      
      INDi(1:6) = (/ 1, 2, 3, 1, 2, 3 /)
      INDj(1:6) = (/ 1, 2, 3, 2, 3, 1 /)
      DO k = 1, 2*dim
       DO j = 1, 2*dim
        Stress( INDi(k),INDj(k) ) = &
        Stress( INDi(k),INDj(k) ) + C(k,j) * D(j)
       END DO
       IF (k > 3)  Stress( INDj(k),INDi(k) ) = Stress( INDi(k),INDj(k) )
      END DO


!     SD=(1-r)D + r psi/2 S :
!     -----------------------
      SD=0._dp
      DO i=1,2*dim
        SD(i)= (1._dp - rho)*StrainRate(INDi(i),INDj(i)) + rho *&
                                   Theta *  Stress(INDi(i),INDj(i))
      END DO
      Do i=1,2*dim-3
        Spin(i)=Spin1(INDi(i+3),INDj(i+3))
      End do

      Deq=sqrt(2._dp*(SD(1)*SD(1)+SD(2)*SD(2)+SD(3)*SD(3)+2._dp* &
                            (SD(4)*SD(4)+SD(5)*SD(5)+SD(6)*SD(6)))/3._dp)
!
!     Velocity :
!     ----------
      Velo = 0.0d0
      DO i=1,dim
         Velo(i) = SUM( Basis(1:n) * (NodalVelo(i,1:n) - NodMeshVel(i,1:n)) )
      END DO
      Unorm = SQRT( SUM( Velo**2._dp ) )

!
!     Reaction coefficient:
!     ---------------------
      SELECT CASE(comp)
      CASE(1)
        !C0 = -2._dp*(SD(1)-SD(3))
        C0=-2._dp*SD(1)-3._dp*lambda*Deq

      CASE(2)
        !C0 = -2._dp*(SD(2)-SD(3))
        C0 = -2._dp*SD(2)-3._dp*lambda*Deq
       
      CASE(3)
        !C0 = -(SD(1)+SD(2)-2._dp*SD(3))
        C0 = -(SD(1)+SD(2))-3._dp*lambda*Deq
        
      CASE(4)
        C0 = -(SD(1)-SD(3))

      CASE(5)
        C0 = -(SD(2)-SD(3))
        
      END SELECT

      If (Fond) C0=0._dp

!     Loop over basis functions (of both unknowns and weights):
!     ---------------------------------------------------------
      DO p=1,NBasis
         DO q=1,NBasis
            A = 0.0d0
            M = Basis(p) * Basis(q)
!
!           Reaction terms:
!           ---------------
            A = A - C0 * Basis(q) * Basis(p)

            !
            ! Advection terms:
            ! ----------------
            DO j=1,dim
               A = A - Velo(j) * Basis(q) * dBasisdx(p,j)
            END DO

!           Add nodal matrix to element matrix:
!           -----------------------------------
            MASS( p,q )  = MASS( p,q )  + s * M
            STIFF( p,q ) = STIFF( p,q ) + s * A
         END DO


!
!        The righthand side...:
!        ----------------------
         SELECT CASE(comp)
         
         CASE(1)
         
          LoadAtIp = 2._dp*( Spin(1)*E1 + SD(4)*(2._dp*a4(7)-E1) + &
          SD(1)*a4(1) + SD(2)*a4(3) - SD(3)*(-A1+a4(1)+a4(3)) ) + & 
                      lambda*Deq

          IF(dim == 3) THEN
            LoadAtIp =  LoadAtIp + 2._dp*( -Spin(3)*E3 + &
            SD(6)*(2._dp*a4(6)-E3) + 2._dp*SD(5)*a4(4) )
          END IF
          
         
         CASE(2)
          LoadAtIp = 2._dp*( -Spin(1)*E1 + SD(4)*(2._dp*a4(9)-E1) + &
          SD(2)*a4(2) + SD(1)*a4(3) - SD(3)*(-A2+a4(2)+a4(3)) )  +  &
                        lambda*Deq
          
          IF(dim == 3) THEN
            LoadAtIp =  LoadAtIp + 2._dp*( Spin(2)*E2 + &
            SD(5)*(2._dp*a4(8)-E2) + 2._dp*SD(6)*a4(5) )
          END IF


         CASE(3)
          LoadAtIp = Spin(1)*(A2-A1)  +  SD(4)*(4._dp*a4(3)-A1-A2) + &
          2._dp* ( SD(1)*a4(7) + SD(2)*a4(9) - SD(3)*(-E1+a4(7)+a4(9)) )
          
          IF(dim == 3) THEN
           LoadAtIp =  LoadAtIp - Spin(3)*E2 + Spin(2)*E3  &
           + SD(6)*(4._dp*a4(4)-E2) + SD(5)*(4._dp*a4(5)-E3)  
          END IF
           
         CASE(4)
          LoadAtIp = Spin(3)*(A1-A3) +  Spin(1)*E2 - Spin(2)*E1 +&
           SD(4)*(4._dp*a4(4)-E2) + &
          SD(6)*(3._dp*A1-A3-4.*(a4(1)+a4(3))) + SD(5)*(-E1+4._dp*a4(5)) + &
          2._dp*( SD(1)*a4(6) + SD(2)*a4(5) - SD(3)*(a4(6)+a4(5)) )

         CASE(5)
          LoadAtIp = Spin(2)*(A3-A2) +  Spin(3)*E1 - Spin(1)*E3 +&
          SD(4)*(4._dp*a4(5)-E3) + SD(5)*(3._dp*A2-A3-4._dp*(a4(2)+a4(3))) &
          + SD(6)*(3._dp*E1-4._dp*(a4(7)+a4(9))) + &
          2._dp*( SD(1)*a4(4) + SD(2)*a4(8) - SD(3)*(a4(4)+a4(8)) )


         END SELECT

        If (Fond) LoadAtIp=0._dp
        LoadAtIp= LoadAtIp * Basis(p)
        FORCE(p) = FORCE(p) + s*LoadAtIp
      END DO

              
      END DO 

 1000 FORMAT((a),x,i2,x,6(e13.5,x)) 
 1001 FORMAT(6(e13.5,x))
!------------------------------------------------------------------------------
       END SUBROUTINE LocalMatrix
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
    SUBROUTINE FindParentUVW( Edge, nEdge, Parent, nParent, U, V, W, Basis )
!------------------------------------------------------------------------------
      IMPLICIT NONE
      TYPE(Element_t), POINTER :: Edge, Parent
      INTEGER :: nEdge, nParent
      REAL( KIND=dp ) :: U, V, W, Basis(:)
!------------------------------------------------------------------------------
      INTEGER :: i, j,l
      REAL(KIND=dp) :: NodalParentU(nEdge),NodalParentV(nEdge),NodalParentW(nEdge)
!------------------------------------------------------------------------------
      DO i = 1,nEdge
        DO j = 1,nParent
          IF ( Edge % NodeIndexes(i) == Parent % NodeIndexes(j) ) THEN
            NodalParentU(i) = Parent % Type % NodeU(j)
            NodalParentV(i) = Parent % Type % NodeV(j)
            NodalParentW(i) = Parent % Type % NodeW(j)
            EXIT
          END IF
        END DO
      END DO
      U = SUM( Basis(1:nEdge) * NodalParentU(1:nEdge) )
      V = SUM( Basis(1:nEdge) * NodalParentV(1:nEdge) )
      W = SUM( Basis(1:nEdge) * NodalParentW(1:nEdge) )
!------------------------------------------------------------------------------      
    END SUBROUTINE FindParentUVW
!------------------------------------------------------------------------------      


!------------------------------------------------------------------------------
    SUBROUTINE LocalJumps( STIFF,Edge,n,LeftParent,n1,RightParent,n2,Velo,MeshVelo )
!------------------------------------------------------------------------------
      REAL(KIND=dp) :: STIFF(:,:), Velo(:,:),MeshVelo(:,:)
      INTEGER :: n,n1,n2
      TYPE(Element_t), POINTER :: Edge, LeftParent, RightParent
!------------------------------------------------------------------------------
      REAL(KIND=dp) :: EdgeBasis(n), EdgedBasisdx(n,3), EdgeddBasisddx(n,3,3)
      REAL(KIND=dp) :: LeftBasis(n1), LeftdBasisdx(n1,3), LeftddBasisddx(n1,3,3)
      REAL(KIND=dp) :: RightBasis(n2), RightdBasisdx(n2,3), RightddBasisddx(n2,3,3)
      REAL(KIND=dp) :: Jump(n1+n2), Average(n1+n2)
      REAL(KIND=dp) :: detJ, U, V, W, S, Udotn, xx, yy
      LOGICAL :: Stat
      INTEGER :: i, j, p, q, dim, t, nEdge, nParent
      TYPE(GaussIntegrationPoints_t) :: IntegStuff
      REAL(KIND=dp) :: hE, Normal(3), cu(3), LeftOut(3)

      TYPE(Nodes_t) :: EdgeNodes, LeftParentNodes, RightParentNodes

      Save EdgeNodes, LeftParentNodes, RightParentNodes
!------------------------------------------------------------------------------
      dim = CoordinateSystemDimension()
      STIFF = 0.0d0

      CALL GetElementNodes( EdgeNodes, Edge )
      CALL GetElementNodes( LeftParentNodes,  LeftParent )
      CALL GetElementNodes( RightParentNodes, RightParent )
!------------------------------------------------------------------------------
!     Numerical integration over the edge
!------------------------------------------------------------------------------
      IntegStuff = GaussPoints( Edge )

      LeftOut(1) = SUM( LeftParentNodes % x(1:n1) ) / n1
      LeftOut(2) = SUM( LeftParentNodes % y(1:n1) ) / n1
      LeftOut(3) = SUM( LeftParentNodes % z(1:n1) ) / n1
      LeftOut(1) = SUM( EdgeNodes % x(1:n) ) / n - LeftOut(1)
      LeftOut(2) = SUM( EdgeNodes % y(1:n) ) / n - LeftOut(2)
      LeftOut(3) = SUM( EdgeNodes % z(1:n) ) / n - LeftOut(3)

      DO t=1,IntegStuff % n
        U = IntegStuff % u(t)
        V = IntegStuff % v(t)
        W = IntegStuff % w(t)
        S = IntegStuff % s(t)

        ! Basis function values & derivatives at the integration point:
        !--------------------------------------------------------------
        stat = ElementInfo( Edge, EdgeNodes, U, V, W, detJ, &
             EdgeBasis, EdgedBasisdx, EdgeddBasisddx, .FALSE. )

        S = S * detJ

        Normal = NormalVector( Edge, EdgeNodes, U, V, .FALSE. )
        IF ( SUM( LeftOut*Normal ) < 0 ) Normal = -Normal

        ! Find basis functions for the parent elements:
        ! ---------------------------------------------
        CALL FindParentUVW( Edge,n,LeftParent,n1,U,V,W,EdgeBasis )
        stat = ElementInfo( LeftParent, LeftParentNodes, U, V, W, detJ, &
                LeftBasis, LeftdBasisdx, LeftddBasisddx, .FALSE. )

        CALL FindParentUVW( Edge,n,RightParent,n2,U,V,W,EdgeBasis )
        stat = ElementInfo( RightParent, RightParentNodes, U, V, W, detJ, &
              RightBasis, RightdBasisdx, RightddBasisddx, .FALSE. )

        ! Integrate jump terms:
        ! ---------------------
        Jump(1:n1) = LeftBasis(1:n1)
        Jump(n1+1:n1+n2) = -RightBasis(1:n2)

        Average(1:n1) = LeftBasis(1:n1) / 2
        Average(n1+1:n1+n2) = RightBasis(1:n2) / 2

        cu = 0.0d0
        DO i=1,dim
          cu(i) = SUM( (Velo(i,1:n)-MeshVelo(i,1:n)) * EdgeBasis(1:n) )
        END DO
        Udotn = SUM( Normal * cu )

        DO p=1,n1+n2
          DO q=1,n1+n2
            STIFF(p,q) = STIFF(p,q) + s * Udotn * Average(q) * Jump(p)
            STIFF(p,q) = STIFF(p,q) + s * ABS(Udotn)/2 * Jump(q) * Jump(p)
          END DO
        END DO
     END DO
!------------------------------------------------------------------------------
   END SUBROUTINE LocalJumps
!------------------------------------------------------------------------------



!------------------------------------------------------------------------------
   SUBROUTINE LocalMatrixBoundary( STIFF, FORCE, LOAD, &
        Element, n, ParentElement, np, Velo,MeshVelo, InFlowBC )
!------------------------------------------------------------------------------
     REAL(KIND=dp) :: STIFF(:,:),  FORCE(:), LOAD(:), Velo(:,:),MeshVelo(:,:)
     INTEGER :: n, np
     LOGICAL :: InFlowBC
     TYPE(Element_t), POINTER :: Element, ParentElement
!------------------------------------------------------------------------------
     REAL(KIND=dp) :: Basis(n), dBasisdx(n,3), ddBasisddx(n,3,3)
     REAL(KIND=dp) :: ParentBasis(np), ParentdBasisdx(np,3), ParentddBasisddx(np,3,3)
     INTEGER :: i,j,p,q,t,dim

     REAL(KIND=dp) :: Normal(3), g, L, Udotn, UdotnA, cu(3), detJ,U,V,W,S
     LOGICAL :: Stat
     TYPE(GaussIntegrationPoints_t) :: IntegStuff

     TYPE(Nodes_t) :: Nodes, ParentNodes
     SAVE Nodes, ParentNodes
!------------------------------------------------------------------------------
     dim = CoordinateSystemDimension()
     FORCE = 0.0d0
     STIFF = 0.0d0

     CALL GetElementNodes( Nodes, Element )
     CALL GetElementNodes( ParentNodes, ParentElement )

     ! Numerical integration:
     !-----------------------
     IntegStuff = GaussPoints( Element )
!
! Compute the average velocity.dot.Normal        
!        
     UdotnA = 0.0   
     DO t=1,IntegStuff % n
       U = IntegStuff % u(t)
       V = IntegStuff % v(t)
       W = IntegStuff % w(t)
       S = IntegStuff % s(t)

       Normal = NormalVector( Element, Nodes, U, V, .TRUE. ) 

       ! Basis function values & derivatives at the integration point:
       ! -------------------------------------------------------------
       stat = ElementInfo( Element, Nodes, U, V, W, detJ, &
               Basis, dBasisdx, ddBasisddx, .FALSE. )
       S = S * detJ
       cu = 0.0d0
       DO i=1,dim
          cu(i) = SUM( (Velo(i,1:n)-MeshVelo(i,1:n)) * Basis(1:n) )
       END DO
       UdotnA = UdotnA + s*SUM( Normal * cu )

     END DO

     DO t=1,IntegStuff % n
       U = IntegStuff % u(t)
       V = IntegStuff % v(t)
       W = IntegStuff % w(t)
       S = IntegStuff % s(t)

       Normal = NormalVector( Element, Nodes, U, V, .TRUE. ) 

       ! Basis function values & derivatives at the integration point:
       ! -------------------------------------------------------------
       stat = ElementInfo( Element, Nodes, U, V, W, detJ, &
               Basis, dBasisdx, ddBasisddx, .FALSE. )
       S = S * detJ

       CALL FindParentUVW( Element, n, ParentElement, np, U, V, W, Basis )
       stat = ElementInfo( ParentElement, ParentNodes, U, V, W, &
           detJ,  ParentBasis, ParentdBasisdx, ParentddBasisddx, .FALSE. )

       L = SUM( LOAD(1:n) * Basis(1:n) )
       cu = 0.0d0
       DO i=1,dim
          cu(i) = SUM( (Velo(i,1:n)-MeshVelo(i,1:n)) * Basis(1:n) )
       END DO
       Udotn = SUM( Normal * cu )

       DO p = 1,np
        IF (InFlowBC .And. (UdotnA < 0.) ) THEN
            FORCE(p) = FORCE(p) - s * Udotn*L*ParentBasis(p)
         ELSE
           DO q=1,np
             STIFF(p,q) = STIFF(p,q) + s*Udotn*ParentBasis(q)*ParentBasis(p)
           END DO
         END IF
       END DO
     END DO
!------------------------------------------------------------------------------
   END SUBROUTINE LocalMatrixBoundary
!------------------------------------------------------------------------------



!------------------------------------------------------------------------------
 END SUBROUTINE FabricSolver
!------------------------------------------------------------------------------

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!							              !!!!!!
!!!!!!       Non-relative viscosities and Temperature dependancy      !!!!!!
!!!!!! 							              !!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
       
       Function BGlenT(Tc,W)
       
       USE defGrid
       
       Implicit None
       Real(kind=dp) :: BGlenT
       Real(kind=dp), Intent(in) :: Tc                     ! Temperature en d Celsius
       Real(kind=dp), Intent(in), Dimension(7) :: W        ! Glen law parameters
       ! W(1)=B0 Glen's fluidity parameter
       ! W(2)=n Glen's law exponent
       ! W(3)=Q1 Energy activation for Tc<Tl
       ! W(4)=Q2 Energy activation for Tc>Tl
       ! W(5)=T0 temperature reference for B0
       ! W(6)=Tl temperature for Q1->Q2
       Real(kind=dp), parameter :: Tzero=273.15
       Real(kind=dp) :: Q, DT
       
       
       Q= W(3)
       If (Tc.GT.W(6)) Q=W(4)
       Q=Q/W(7)
       DT=-1./(Tc+Tzero)+1./(W(5)+Tzero)

       BGlenT=W(1)*Exp(Q*DT)

       End

SUBROUTINE FlowdepthSolver( Model,Solver,dt,TransientSimulation )
!DEC$ATTRIBUTES DLLEXPORT :: FlowdepthSolver
!------------------------------------------------------------------------------
!******************************************************************************
!
!  Solve the Flowdepth equation!
!
!  ARGUMENTS:
!
!  TYPE(Model_t) :: Model,  
!     INPUT: All model information (mesh, materials, BCs, etc...)
!
!  TYPE(Solver_t) :: Solver
!     INPUT: Linear & nonlinear equation solver options
!
!  REAL(KIND=dp) :: dt,
!     INPUT: Timestep size for time dependent simulations
!
!  LOGICAL :: TransientSimulation
!     INPUT: Steady state or transient simulation
!
!******************************************************************************
  USE DefUtils

  IMPLICIT NONE
!------------------------------------------------------------------------------
  TYPE(Solver_t) :: Solver
  TYPE(Model_t) :: Model

  REAL(KIND=dp) :: dt
  LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
! Local variables
!------------------------------------------------------------------------------
  TYPE(Element_t),POINTER :: Element
  TYPE(ValueList_t), POINTER :: SolverParams
  TYPE(Variable_t), POINTER :: PointerToVariable
  TYPE(Solver_t), POINTER :: PointerToSolver

  LOGICAL :: AllocationsDone = .FALSE., Found, CalcFree = .FALSE.

  INTEGER :: i, n, m, t, istat
  INTEGER, POINTER :: Permutation(:), NumberOfVisits(:)

  REAL(KIND=dp), POINTER :: VariableValues(:), Surface(:), GradSurface1(:),GradSurface2(:)
  REAL(KIND=dp) :: Norm, Gradient,GradSurface(3)

  REAL(KIND=dp), ALLOCATABLE :: STIFF(:,:), LOAD(:), FORCE(:)
       

  SAVE STIFF, LOAD, FORCE, Surface, GradSurface, AllocationsDone
!------------------------------------------------------------------------------
  PointerToVariable => Solver % Variable
  Permutation  => PointerToVariable % Perm
  VariableValues => PointerToVariable % Values

  ! get Gradient (change of property
  ! with respect to unit-length of
  ! vertical direction
  !----------------------------------
  SolverParams => GetSolverParams()
  Gradient = GetConstReal( SolverParams, &
                      'Gradient',  Found )
  IF (.NOT. Found) THEN
     CALL WARN('FlowdepthSolve', 'No keyword >Gradient< found in section Solver')
     CALL WARN('FlowdepthSolve', 'Assuming value of -1')
     Gradient = -1.0D00
  ELSE
     WRITE(Message,'(A e12.4,A)') 'Gradient of ',Gradient,' applied'
     CALL INFO('FlowdepthSolve', Message,Level=1)
  END IF

  CalcFree = GetLogical(SolverParams, 'Calc Free Surface', Found)
  IF (.NOT. Found) THEN
     CalcFree = .FALSE.
  ELSE
     CALL INFO('FlowdepthSolve', 'Free surface variable will be calculated', Level=1)
  END IF

  !Allocate some permanent storage, this is done first time only:
  !--------------------------------------------------------------
  IF ( (.NOT. AllocationsDone) .OR. Solver % Mesh % Changed  ) THEN
     N = Solver % Mesh % MaxElementNodes ! just big enough for elemental arrays
     M = Model % Mesh % NumberOfNodes
     IF (AllocationsDone) DEALLOCATE(FORCE, LOAD, STIFF,&
          Surface, GradSurface1, GradSurface2, NumberOfVisits)

     ALLOCATE( FORCE(N), LOAD(N), STIFF(N,N),&
          Surface(M), GradSurface1(M), GradSurface2(M), NumberOfVisits(M),&
          STAT=istat )
     IF ( istat /= 0 ) THEN
        CALL Fatal( 'FlowdepthSolve', 'Memory allocation error.' )
     END IF
     
     IF (CalcFree) THEN
     ! Assign Variable for Residual (i.e., heat flux at boundaries)
     !-------------------------------------------------------------
        CALL VariableAdd( Solver % Mesh % Variables, Solver % Mesh, PointerToSolver, &
             'FreeSurf', 1, Surface, Permutation )
        CALL VariableAdd( Solver % Mesh % Variables, Solver % Mesh, PointerToSolver, &
             'FreeSurfGrad1', 1, GradSurface1, Permutation )
        CALL VariableAdd( Solver % Mesh % Variables, Solver % Mesh, PointerToSolver, &
             'FreeSurfGrad2', 1, GradSurface2, Permutation )
     END IF

     AllocationsDone = .TRUE.
  END IF

  Surface = 1.0D00
  GradSurface1 = 2.0D00
  GradSurface2 = 3.0D00


  !Initialize the system and do the assembly:
  !------------------------------------------
  CALL DefaultInitialize()

  ! bulk assembly
  DO t=1,Solver % NumberOfActiveElements
     Element => GetActiveElement(t)
     n = GetElementNOFNodes()
     CALL LocalMatrix(  STIFF, FORCE, Element, n)
     CALL DefaultUpdateEquations( STIFF, FORCE )
  END DO
  
  ! vN. conditions
  DO t=1,Solver % Mesh % NUmberOfBoundaryElements
     Element => GetBoundaryElement(t)
     n = GetElementNOFNodes()
     IF ( GetElementFamily() /= 1 ) THEN
        CALL LocalMatrixBC(  STIFF, FORCE, Element, n, Gradient )
        CALL DefaultUpdateEquations( STIFF, FORCE )
     END IF
  END DO
  CALL DefaultFinishAssembly()

  ! Dirichlet 
  CALL DefaultDirichletBCs()
  !Solve the system
  Norm = DefaultSolve()

  IF (Calcfree) THEN   
     Surface = 0.0D00
     GradSurface1 = 0.0D00
     GradSurface2 = 0.0D00
     NumberOfVisits = 0
     DO t=1,Solver % NumberOfActiveElements
        Element => GetActiveElement(t)
        n = GetElementNOFNodes()
        CALL GetSurfaceValue(Model, Surface, GradSurface1, GradSurface2,&
             VariableValues, Permutation, NumberOfVisits, Element, n)
     END DO
     DO i=1,Model % Mesh % NumberOfNodes
        GradSurface1(Permutation(i)) = GradSurface1(Permutation(i))/NumberOfVisits(i)
        GradSurface2(Permutation(i)) = GradSurface2(Permutation(i))/NumberOfVisits(i)
     END DO
  END IF
CONTAINS

!------------------------------------------------------------------------------
  SUBROUTINE GetSurfaceValue(Model, Surface, GradSurface1, GradSurface2,&
       VariableValues, Permutation, NumberOfVisits, Element, n)
!------------------------------------------------------------------------------
    TYPE(Model_t) :: Model
    REAL(KIND=dp) :: LocalSurf, GradSurface(3), Depth
    INTEGER :: n
    INTEGER, POINTER :: Permutation(:), NumberOfVisits(:)
    REAL(KIND=dp), POINTER :: Surface(:), GradSurface1(:), GradSurface2(:), VariableValues(:)
    TYPE(Element_t), POINTER :: Element
!------------------------------------------------------------------------------
    REAL(KIND=dp) :: Basis(n),dBasisdx(n,3),ddBasisddx(n,3,3),DetJ, z, U, V, W, SqrtElementMetric
    LOGICAL :: Stat
    INTEGER :: i,j,k,dim
    LOGICAL :: FirstTime
    TYPE(Nodes_t) :: Nodes
    SAVE Nodes
!------------------------------------------------------------------------------
    CALL GetElementNodes( Nodes )

    dim = CoordinateSystemDimension()
    ! loop over all nodes in Element
    DO i=1,N

       j = Element % NodeIndexes(i) ! get number of node in element in physical space
       NumberOfVisits(j) = NumberOfVisits(j) + 1

       ! get local coordinates of the point i inside the element
       U = Element % Type % NodeU(i)
       V = Element % Type % NodeV(i)
       W = Element % Type % NodeW(i)

       ! get local information on test-functions and derivatives of the point i
       stat = ElementInfo( Element,Nodes,U,V,W,SqrtElementMetric, &
            Basis,dBasisdx,ddBasisddx,.FALSE.,.FALSE. )  
       IF (DIM == 2) THEN 
          z = Model % Nodes % y(j)
       ELSE IF (DIM == 3) THEN
          z = Model % Nodes % z(j)
       ELSE
          CALL FATAL('FlowdepthSolve', 'Flow depth for one-dimensional problem not defined!')
       END IF

       IF (NumberOfVisits(j) == 1) &
            Surface(Permutation(j)) = z + VariableValues(Permutation(j))  
!       DO k=1,n
!          GradSurface1(Permutation(j)) = GradSurface1(Permutation(j)) + dBasisdx(k,1)*VariableValues(Permutation(Element % NodeIndexes(k)))
!       END DO
       GradSurface1(Permutation(j)) = GradSurface1(Permutation(j)) +&
            SUM(dBasisdx(1:N,1)*VariableValues(Permutation(Element % NodeIndexes(1:N))))
       IF (DIM > 2) &
            GradSurface2(Permutation(j)) = GradSurface2(Permutation(j)) +&
            SUM(dBasisdx(1:N,2)*VariableValues(Permutation(Element % NodeIndexes(1:N))))
    END DO
!------------------------------------------------------------------------------
  END SUBROUTINE GetSurfaceValue
!------------------------------------------------------------------------------


!------------------------------------------------------------------------------
  SUBROUTINE LocalMatrix(  STIFF, FORCE, Element, n)
!------------------------------------------------------------------------------
    REAL(KIND=dp) :: STIFF(:,:), FORCE(:)
    INTEGER :: n
    TYPE(Element_t), POINTER :: Element
!------------------------------------------------------------------------------
    REAL(KIND=dp) :: Basis(n),dBasisdx(n,3),ddBasisddx(n,3,3),DetJ
    LOGICAL :: Stat
    INTEGER :: t, p,q ,dim
    TYPE(GaussIntegrationPoints_t) :: IP

    TYPE(Nodes_t) :: Nodes
    SAVE Nodes
!------------------------------------------------------------------------------
    CALL GetElementNodes( Nodes )
    STIFF = 0.0d0
    FORCE = 0.0d0

    dim = CoordinateSystemDimension()

    IP = GaussPoints( Element )
    DO t=1,IP % n
       stat = ElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
        IP % W(t),  detJ, Basis, dBasisdx, ddBasisddx, .FALSE. )

       DO p=1,n
         DO q=1,n
           STIFF(p,q) = STIFF(p,q) + IP % S(t) * detJ * dBasisdx(q,dim)*dBasisdx(p,dim)
         END DO
       END DO
    END DO
!------------------------------------------------------------------------------
  END SUBROUTINE LocalMatrix
!------------------------------------------------------------------------------


!------------------------------------------------------------------------------
  SUBROUTINE LocalMatrixBC(  STIFF, FORCE, Element, n, Gradient)
!------------------------------------------------------------------------------
    REAL(KIND=dp) :: STIFF(:,:), FORCE(:), Gradient
    INTEGER :: n
    TYPE(Element_t), POINTER :: Element
!------------------------------------------------------------------------------
    REAL(KIND=dp) :: Basis(n),dBasisdx(n,3),ddBasisddx(n,3,3), &
                      DetJ,Normal(3)
    LOGICAL :: Stat
    INTEGER :: t, dim
    TYPE(GaussIntegrationPoints_t) :: IP

    TYPE(Nodes_t) :: Nodes
    SAVE Nodes
!------------------------------------------------------------------------------
    CALL GetElementNodes( Nodes )
    STIFF = 0.0d0
    FORCE = 0.0d0

    dim = CoordinateSystemDimension()

    IP = GaussPoints( Element )
    DO t=1,IP % n
      stat = ElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
       IP % W(t),  detJ, Basis, dBasisdx, ddBasisddx, .FALSE. )

      Normal = NormalVector( Element, Nodes, IP % U(t), IP % V(t), .TRUE.)
      FORCE(1:n) = FORCE(1:n) + Gradient * IP % s(t) * DetJ * Normal(dim) * Basis(1:n)
    END DO
!------------------------------------------------------------------------------
  END SUBROUTINE LocalMatrixBC
!------------------------------------------------------------------------------
END SUBROUTINE FlowdepthSolver
!------------------------------------------------------------------------------

SUBROUTINE getDistance( Model,Solver,dt,TransientSimulation )

  USE DefUtils

  IMPLICIT NONE
!------------------------------------------------------------------------------
  TYPE(Solver_t) :: Solver
  TYPE(Model_t) :: Model

  REAL(KIND=dp) :: dt
  LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
! Local variables
!------------------------------------------------------------------------------
  TYPE(Element_t),POINTER :: Element

  LOGICAL :: AllocationsDone = .FALSE., Found, Converged

  INTEGER :: n, t, istat, other_body_id
  REAL(KIND=dp) :: Norm, NormalGradient

  TYPE(ValueList_t), POINTER :: BodyForce, Material, BC, SolverParams
  REAL(KIND=dp), ALLOCATABLE :: MASS(:,:), STIFF(:,:), LOAD(:), FORCE(:)

  CHARACTER(LEN=MAX_NAME_LEN) :: BoundaryType

  SAVE MASS, STIFF, LOAD, FORCE, AllocationsDone
!------------------------------------------------------------------------------


  !Allocate some permanent storage, this is done first time only:
  !--------------------------------------------------------------
  IF ( .NOT. AllocationsDone ) THEN
     N = Solver % Mesh % MaxElementNodes ! just big enough for elemental arrays

     ALLOCATE( FORCE(N), LOAD(N), MASS(N,N), STIFF(N,N), STAT=istat )

     IF ( istat /= 0 ) THEN
        CALL Fatal( 'getDistance',&
             'Memory allocation error for matrix/vectors.' )
     END IF

     AllocationsDone = .TRUE.
  END IF

  !Read in solver parameters
  !-------------------------
  SolverParams => GetSolverParams()
  IF (.NOT. ASSOCIATED(SolverParams))&
       CALL FATAL('getDistance','No Solver section found')
  
  !Initialize the system and do the assembly:
  !------------------------------------------
  CALL DefaultInitialize()
  
  ! Assembly for the domain
  !------------------------
  DO t=1,Solver % NumberOfActiveElements
     
     Element => GetActiveElement(t)
     n = GetElementNOFNodes()
     
     ! get material parameters
     Material => GetMaterial()
     IF (.NOT. ASSOCIATED(Material)) THEN
        WRITE(Message,'(A,I5,A)') 'No material for bulk element no. ',t,' found.'
        CALL FATAL('getDistance',Message)
     END IF
     
     ! get load for force vector
     LOAD = 1.0d00
     
     !Get element local matrix and rhs vector:
     !----------------------------------------
     CALL LocalMatrix( MASS, STIFF, FORCE, LOAD, Element, n, TransientSimulation)
     
     !Update global matrix and rhs vector from local matrix & vector:
     !---------------------------------------------------------------
     CALL DefaultUpdateEquations( STIFF, FORCE )
      
     !------------------------------------------------------------------------------
  END DO
!------------------------------------------------------------------------------
!     assembly of von Neumann boundary conditions
!------------------------------------------------------------------------------
  DO t=1, Solver % Mesh % NumberOfBoundaryElements
     
     Element => GetBoundaryElement(t)
     IF ( .NOT.ActiveBoundaryElement() ) CYCLE
     n = GetElementNOFNodes()
     IF ( GetElementFamily() == 1 ) CYCLE ! no von Neumann BC's on points
     BC => GetBC()
     
     FORCE = 0.0d00
     MASS = 0.0d00
     STIFF = 0.0d00
     LOAD = 0.0d00
     
     NormalGradient = GetConstReal(BC,'Normal Gradient', Found) 
     ! natural boundary condition
     IF (.NOT. Found) CYCLE
     ! natural boundary condition
     LOAD(1:n) = LOAD(1:n) + NormalGradient            
     ! do the assembly of the force vector
     CALL BoundaryCondition(LOAD, FORCE, Element, n)
     IF ( TransientSimulation ) THEN
        MASS = 0.0d00
        CALL Default1stOrderTime( MASS, STIFF, FORCE )
     END IF
     
     CALL DefaultUpdateEquations( STIFF, FORCE )
!------------------------------------------------------------------------------
  END DO ! end of assembly of von Neumann boundary conditions
!------------------------------------------------------------------------------
  CALL DefaultFinishAssembly()
!
!    Dirichlet BCs:
!    --------------
  CALL DefaultDirichletBCs()

  ! Solve the system
  ! ----------------
  Norm = DefaultSolve()
     
  WRITE( Message, * ) 'Result Norm   : ',Norm
  CALL Info( 'getDistance', Message, Level=4 )

!------------------------------------------------------------------------------


CONTAINS
!------------------------------------------------------------------------------
  SUBROUTINE LocalMatrix(MASS, STIFF, FORCE, LOAD, Element, n, TransientSimulation)
    IMPLICIT NONE
!------------------------------------------------------------------------------
    REAL(KIND=dp), DIMENSION(:,:) :: MASS, STIFF
    REAL(KIND=dp), DIMENSION(:) :: FORCE, LOAD
!    REAL(KIND=dp) :: HeatCapacity(:), HeatConductivity(:), Density(:)
    INTEGER :: n
    TYPE(Element_t), POINTER :: Element
    LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
    REAL(KIND=dp) :: Basis(n),dBasisdx(n,3),ddBasisddx(n,3,3)
    REAL(KIND=dp) :: detJ, LoadAtIP
    LOGICAL :: Stat, getSecondDerivatives
    INTEGER :: t,i,j,DIM
    TYPE(GaussIntegrationPoints_t) :: IP

    TYPE(Nodes_t) :: Nodes
    SAVE Nodes
!------------------------------------------------------------------------------
    DIM = CoordinateSystemDimension()

    CALL GetElementNodes( Nodes )

    STIFF = 0.0d0
    FORCE = 0.0d0
    MASS = 0.0d0

    !Numerical integration:
    !----------------------
    IP = GaussPoints( Element )
!-----------------------------------------------------------------
!   Loop over Gauss-points (element Integration)
!-----------------------------------------------------------------
    DO t=1,IP % n
       !Basis function values & derivatives at the integration point:
       !-------------------------------------------------------------
       getSecondDerivatives = .FALSE.
       stat = ElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
            IP % W(t),  detJ, Basis, dBasisdx, ddBasisddx, getSecondDerivatives)
       !The source term at the integration point:
       !-----------------------------------------
       LoadAtIP = SUM( Basis(1:n) * LOAD(1:n) )
!-----------------------------------------------------------------    
!      Loop over j-components of matrices and over force vector
!-----------------------------------------------------------------    
       DO j=1,n
          FORCE(j) = FORCE(j) + IP % s(t) * DetJ * LoadAtIP * Basis(j)
!-----------------------------------------------------------------    
!         Loop over i-components of matrices
!-----------------------------------------------------------------    
          DO i=1,n
             !The mass matrix, if needed
             !--------------------------
             IF (TransientSimulation) THEN
                MASS(i,j) = MASS(i,j)+ IP % s(t) * DetJ * &
                     Basis(i)*Basis(j)
             END IF

             !Finally, the stiffnes matrix:
             !------------------------------
             STIFF(i,j) = STIFF(i,j) + IP % s(t) * DetJ * &
                  SUM(dBasisdx(i,1:DIM) * dBasisdx(j,1:DIM))
!----------------------------------------------------------------- 
          END DO ! end Loop over i-components of matrices
!----------------------------------------------------------------- 
       END DO ! end Loop over j-components of matrices and vector
!----------------------------------------------------------------- 
!-----------------------------------------------------------------
    END DO ! end Loop over Gauss-points (element Integration)
!-----------------------------------------------------------------
  END SUBROUTINE LocalMatrix
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
  SUBROUTINE BoundaryCondition(LOAD, FORCE, Element, n)
    IMPLICIT NONE
!------------------------------------------------------------------------------
    REAL(KIND=dp), DIMENSION(:) :: FORCE, LOAD
    INTEGER :: n
    TYPE(Element_t), POINTER :: Element
!------------------------------------------------------------------------------
    REAL(KIND=dp) :: Basis(n),dBasisdx(n,3),ddBasisddx(n,3,3)
    REAL(KIND=dp) :: detJ, LoadAtIP,&
         LocalHeatCapacity, LocalDensity
    LOGICAL :: stat, getSecondDerivatives
    INTEGER :: t,j
    TYPE(GaussIntegrationPoints_t) :: IP

    TYPE(Nodes_t) :: Nodes
    SAVE Nodes
!------------------------------------------------------------------------------

    CALL GetElementNodes( Nodes )

    FORCE = 0.0d0

    !Numerical integration:
    !----------------------
    IP = GaussPoints( Element )
!-----------------------------------------------------------------
!   Loop over Gauss-points (boundary element Integration)
!-----------------------------------------------------------------
    DO t=1,IP % n
       !Basis function values & derivatives at the integration point:
       !-------------------------------------------------------------
       getSecondDerivatives = .FALSE.
       stat = ElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
            IP % W(t),  detJ, Basis, dBasisdx, ddBasisddx, getSecondDerivatives)
       !The source term at the integration point:
       !-----------------------------------------
       LoadAtIP = SUM( Basis(1:n) * LOAD(1:n) )
!-----------------------------------------------------------------    
!      Loop over j-components of matrices and over force vector
!-----------------------------------------------------------------    
       DO j=1,n
          FORCE(j) = FORCE(j) + IP % s(t) * DetJ * LoadAtIP * Basis(j)
       END DO
    END DO
!------------------------------------------------------------------------------
  END SUBROUTINE BoundaryCondition
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
END SUBROUTINE getDistance


SUBROUTINE signedDistance1( Model,Solver,dt,TransientSimulation )

  USE DefUtils

  IMPLICIT NONE
!------------------------------------------------------------------------------
  TYPE(Solver_t) :: Solver
  TYPE(Model_t) :: Model

  REAL(KIND=dp) :: dt
  LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
! Local variables
!------------------------------------------------------------------------------
  TYPE(Element_t),POINTER :: Element
  TYPE(Variable_t), POINTER :: DistanceSol

  LOGICAL :: AllocationsDone = .FALSE., Found, Converged

  INTEGER ::i,  n, t, istat, other_body_id, iter, NonlinearIter
  INTEGER, POINTER :: DistancePerm(:)
  REAL(KIND=dp) :: Norm, PrevNorm=0.0d00, NonlinearTol, RelativeChange, NonlinearRelax
  REAL(KIND=dp), POINTER :: Distance(:), PrevDistance(:)

  TYPE(ValueList_t), POINTER :: BodyForce, Material, BC, SolverParams
  REAL(KIND=dp), ALLOCATABLE :: MASS(:,:), STIFF(:,:), LOAD(:), FORCE(:), PrevDistanceElem(:)

  CHARACTER(LEN=MAX_NAME_LEN) :: BoundaryType

  SAVE MASS, STIFF, LOAD, FORCE,&
       AllocationsDone, PrevNorm, PrevDistanceElem, PrevDistance
!------------------------------------------------------------------------------


  DistanceSol => Solver % Variable
  DistancePerm  => DistanceSol % Perm
  Distance => DistanceSol % Values
  !Allocate some permanent storage, this is done first time only:
  !--------------------------------------------------------------
  IF ( .NOT. AllocationsDone ) THEN
     N = Solver % Mesh % MaxElementNodes ! just big enough for elemental arrays
     

     ALLOCATE( FORCE(N), LOAD(N), MASS(N,N), STIFF(N,N),&
          PrevDistanceElem(N), PrevDistance(SIZE(Solver % Variable % Values)),&
          STAT=istat )

     IF ( istat /= 0 ) THEN
        CALL Fatal( 'signedDistance',&
             'Memory allocation error for matrix/vectors.' )
     END IF

     PrevDistance = 1.0D-01

     AllocationsDone = .TRUE.
  END IF

  !Read in solver parameters
  !-------------------------
  SolverParams => GetSolverParams()
  IF (.NOT. ASSOCIATED(SolverParams))&
       CALL FATAL('signedDistance','No Solver section found')
  NonlinearIter = GetInteger(SolverParams, &
                     'Nonlinear System Max Iterations', Found)
  IF ( .NOT.Found ) NonlinearIter = 1
  NonlinearTol  = GetConstReal( SolverParams, &
       'Nonlinear System Convergence Tolerance',    Found )
  IF ( .NOT.Found ) NonlinearTol = 1.0D-03
  NonlinearRelax  = GetConstReal( SolverParams, &
       'Nonlinear System Relaxation Factor',    Found )
  IF ( .NOT.Found ) &
       NonlinearRelax  = 1.0D00
     

  !loop as long non-linear system is converged or
  ! max iterations have been exceeded
  !-----------------------------------------------
  DO iter=1,NonlinearIter
     Converged = .FALSE.
     WRITE(Message,'(A,I5,A,I5)') 'Nonlinear iteration no.',iter,&
          ' of max. ', NonlinearIter
     CALL INFO('signedDistance',Message,level=1)

     !Initialize the system and do the assembly:
     !------------------------------------------
     CALL DefaultInitialize()

     ! Assembly for the domain
     !------------------------
     DO t=1,Solver % NumberOfActiveElements
     
        Element => GetActiveElement(t)
        n = GetElementNOFNodes()

        PrevDistanceElem = PrevDistance(DistancePerm(Element % NodeIndexes))
        ! get load for force vector
        LOAD = 0.0d0
        BodyForce => GetBodyForce()
        IF ( ASSOCIATED(BodyForce) ) &
             LOAD(1:n) = GetReal( BodyForce, 'Distance Gradient', Found )      
     
        !Get element local matrix and rhs vector:
        !----------------------------------------
        CALL LocalMatrix( MASS, STIFF, FORCE, LOAD, PrevDistanceElem, Element, n, TransientSimulation)
     
        !Update global matrix and rhs vector from local matrix & vector:
        !---------------------------------------------------------------
!        IF ( TransientSimulation ) THEN
!           CALL Default1stOrderTime( MASS,STIFF,FORCE )
!        END IF
        CALL DefaultUpdateEquations( STIFF, FORCE )
      
!------------------------------------------------------------------------------
     END DO
!------------------------------------------------------------------------------
!     assembly of von Neumann boundary conditions
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
     CALL DefaultFinishAssembly()
!
!    Dirichlet BCs:
!    --------------
     CALL DefaultDirichletBCs()

     ! Solve the system
     ! ----------------
     Norm = DefaultSolve()
     
     ! compute relative change of norm
     ! -------------------------------
     IF ( PrevNorm + Norm /= 0.0d0 ) THEN
        RelativeChange = 2.0d0 * ABS( PrevNorm-Norm ) / (PrevNorm + Norm)
     ELSE
        RelativeChange = 0.0d0
     END IF

     WRITE( Message, * ) 'Result Norm   : ',Norm
     CALL Info( 'signedDistance', Message, Level=4 )
     WRITE( Message, * ) 'Relative Change : ',RelativeChange
     CALL Info( 'signedDistance', Message, Level=4 )


     ! do we have do another round?
     ! ----------------------------
     IF ( RelativeChange < NonlinearTol ) THEN  ! no
        Converged = .TRUE.
        EXIT
     ELSE ! yes
        PrevNorm = Norm        
     END IF

     ! store actual values
     !--------------------
     DO i=1,SIZE(Solver % Variable % Values)
        PrevDistance(i) = NonlinearRelax * Distance(i)&
             + (1.0D00 - NonlinearRelax) *  PrevDistance(i)
     END DO
!------------------------------------------------------------------------------
  END DO ! of the nonlinear iteration
!------------------------------------------------------------------------------

  ! has non-linear solution converged?
  ! ----------------------------------
  IF ((.NOT.Converged) .AND. (NonlinearIter > 1)) THEN 
     WRITE( Message, * ) 'Nonlinear solution has not converged.',&
          ' Relative Change=',RelativeChange,'>',NonlinearTol
     CALL Warn('signedDistance', Message)
  ELSE
     WRITE( Message, * ) 'Nonlinear solution has converged after ',&
          iter,' steps.'
     CALL Info('signedDistance',Message,Level=1)
  END IF
     

!------------------------------------------------------------------------------

CONTAINS
!------------------------------------------------------------------------------
  SUBROUTINE LocalMatrix(MASS, STIFF, FORCE, LOAD, PrevDistanceElem, Element, n, TransientSimulation)
    IMPLICIT NONE
!------------------------------------------------------------------------------
    REAL(KIND=dp), DIMENSION(:,:) :: MASS, STIFF
    REAL(KIND=dp), DIMENSION(:) :: FORCE, LOAD, PrevDistanceElem
    INTEGER :: n
    TYPE(Element_t), POINTER :: Element
    LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
    REAL(KIND=dp) :: Basis(n),dBasisdx(n,3),ddBasisddx(n,3,3), PrevDistanceGradientAtIP(3)
    REAL(KIND=dp) :: detJ, LoadAtIP,&
         LocalHeatCapacity, LocalHeatConductivity, LocalDensity
    LOGICAL :: Stat, getSecondDerivatives
    INTEGER :: t,i,j,DIM
    TYPE(GaussIntegrationPoints_t) :: IP

    TYPE(Nodes_t) :: Nodes
    SAVE Nodes
!------------------------------------------------------------------------------
    DIM = CoordinateSystemDimension()

    CALL GetElementNodes( Nodes )

    STIFF = 0.0d0
    FORCE = 0.0d0
    MASS = 0.0d0

    !Numerical integration:
    !----------------------
    IP = GaussPoints( Element )
!-----------------------------------------------------------------
!   Loop over Gauss-points (element Integration)
!-----------------------------------------------------------------
    DO t=1,IP % n
       !Basis function values & derivatives at the integration point:
       !-------------------------------------------------------------
       getSecondDerivatives = .FALSE.
       stat = ElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
            IP % W(t),  detJ, Basis, dBasisdx, ddBasisddx, getSecondDerivatives)
       !The source term at the integration point:
       !-----------------------------------------
       LoadAtIP = SUM( Basis(1:n) * LOAD(1:n) )
       DO i=1,DIM
          PrevDistanceGradientAtIP(i) = SUM(dBasisdx(1:n,i)*PrevDistanceElem(1:n))
       END DO
!-----------------------------------------------------------------    
!      Loop over j-components of matrices and over force vector
!-----------------------------------------------------------------    
       DO j=1,n
          FORCE(j) = FORCE(j) + IP % s(t) * DetJ * LoadAtIP * Basis(j)
!-----------------------------------------------------------------    
!         Loop over i-components of matrices
!-----------------------------------------------------------------    
          DO i=1,n
             !The mass matrix, if needed
             !--------------------------
!             IF (TransientSimulation) THEN
!                MASS(i,j) = MASS(i,j)+ IP % s(t) * DetJ * &
!                     Basis(i)*Basis(j)
!             END IF

             !Finally, the stiffnes matrix:
             !------------------------------
             STIFF(i,j) = STIFF(i,j) + IP % s(t) * DetJ *&
                  Basis(j) * SUM(dBasisdx(i,1:DIM) * PrevDistanceGradientAtIP(1:DIM))
 !----------------------------------------------------------------- 
          END DO ! end Loop over i-components of matrices
!----------------------------------------------------------------- 
       END DO ! end Loop over j-components of matrices and vector
!----------------------------------------------------------------- 
!-----------------------------------------------------------------
    END DO ! end Loop over Gauss-points (element Integration)
!-----------------------------------------------------------------
  END SUBROUTINE LocalMatrix
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
END SUBROUTINE signedDistance1
!------------------------------------------------------------------------------

!***********************
!***********************
SUBROUTINE signedDistance( Model,Solver,dt,TransientSimulation )

  USE DefUtils

  IMPLICIT NONE
!------------------------------------------------------------------------------
  TYPE(Solver_t) :: Solver
  TYPE(Model_t) :: Model

  REAL(KIND=dp) :: dt
  LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
! Local variables
!------------------------------------------------------------------------------
  TYPE(Element_t),POINTER :: Element
  TYPE(Variable_t), POINTER :: DistanceSol

  LOGICAL :: AllocationsDone = .FALSE., Found, Converged

  INTEGER ::i,  n, t, istat, other_body_id, iter, NonlinearIter
  INTEGER, POINTER :: DistancePerm(:)
  REAL(KIND=dp) :: Norm, PrevNorm=0.0d00, NonlinearTol, RelativeChange, NonlinearRelax
  REAL(KIND=dp), POINTER :: Distance(:), PrevDistance(:)

  TYPE(ValueList_t), POINTER :: BodyForce, Material, BC, SolverParams
  REAL(KIND=dp), ALLOCATABLE :: MASS(:,:), STIFF(:,:), LOAD(:), FORCE(:), PrevDistanceElem(:)

  CHARACTER(LEN=MAX_NAME_LEN) :: BoundaryType

  SAVE MASS, STIFF, LOAD, FORCE,&
       AllocationsDone, PrevNorm, PrevDistanceElem, PrevDistance
!------------------------------------------------------------------------------


  DistanceSol => Solver % Variable
  DistancePerm  => DistanceSol % Perm
  Distance => DistanceSol % Values
  !Allocate some permanent storage, this is done first time only:
  !--------------------------------------------------------------
  IF ( .NOT. AllocationsDone ) THEN
     N = Solver % Mesh % MaxElementNodes ! just big enough for elemental arrays
     

     ALLOCATE( FORCE(N), LOAD(N), MASS(N,N), STIFF(N,N),&
          PrevDistanceElem(N), PrevDistance(SIZE(Solver % Variable % Values)),&
          STAT=istat )

     IF ( istat /= 0 ) THEN
        CALL Fatal( 'signedDistance',&
             'Memory allocation error for matrix/vectors.' )
     END IF

     PrevDistance = 1.0D-01

     AllocationsDone = .TRUE.
  END IF

  !Read in solver parameters
  !-------------------------
  SolverParams => GetSolverParams()
  IF (.NOT. ASSOCIATED(SolverParams))&
       CALL FATAL('signedDistance','No Solver section found')
  NonlinearIter = GetInteger(SolverParams, &
                     'Nonlinear System Max Iterations', Found)
  IF ( .NOT.Found ) NonlinearIter = 1
  NonlinearTol  = GetConstReal( SolverParams, &
       'Nonlinear System Convergence Tolerance',    Found )
  IF ( .NOT.Found ) NonlinearTol = 1.0D-03
  NonlinearRelax  = GetConstReal( SolverParams, &
       'Nonlinear System Relaxation Factor',    Found )
  IF ( .NOT.Found ) &
       NonlinearRelax  = 1.0D00
     

  !loop as long non-linear system is converged or
  ! max iterations have been exceeded
  !-----------------------------------------------
  DO iter=1,NonlinearIter
     Converged = .FALSE.
     WRITE(Message,'(A,I5,A,I5)') 'Nonlinear iteration no.',iter,&
          ' of max. ', NonlinearIter
     CALL INFO('signedDistance',Message,level=1)

     !Initialize the system and do the assembly:
     !------------------------------------------
     CALL DefaultInitialize()

     ! Assembly for the domain
     !------------------------
     DO t=1,Solver % NumberOfActiveElements
     
        Element => GetActiveElement(t)
        n = GetElementNOFNodes()

        PrevDistanceElem = PrevDistance(DistancePerm(Element % NodeIndexes))
        ! get load for force vector
        LOAD = 0.0d0
        BodyForce => GetBodyForce()
        IF ( ASSOCIATED(BodyForce) ) &
             LOAD(1:n) = GetReal( BodyForce, 'Distance Gradient', Found )      
     
        !Get element local matrix and rhs vector:
        !----------------------------------------
        CALL LocalMatrix( MASS, STIFF, FORCE, LOAD, PrevDistanceElem, Element, n, TransientSimulation)
     
        !Update global matrix and rhs vector from local matrix & vector:
        !---------------------------------------------------------------
!        IF ( TransientSimulation ) THEN
!           CALL Default1stOrderTime( MASS,STIFF,FORCE )
!        END IF
        CALL DefaultUpdateEquations( STIFF, FORCE )
      
!------------------------------------------------------------------------------
     END DO
!------------------------------------------------------------------------------
!     assembly of von Neumann boundary conditions
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
     CALL DefaultFinishAssembly()
!
!    Dirichlet BCs:
!    --------------
     CALL DefaultDirichletBCs()

     ! Solve the system
     ! ----------------
     Norm = DefaultSolve()
     
     ! compute relative change of norm
     ! -------------------------------
     IF ( PrevNorm + Norm /= 0.0d0 ) THEN
        RelativeChange = 2.0d0 * ABS( PrevNorm-Norm ) / (PrevNorm + Norm)
     ELSE
        RelativeChange = 0.0d0
     END IF

     WRITE( Message, * ) 'Result Norm   : ',Norm
     CALL Info( 'signedDistance', Message, Level=4 )
     WRITE( Message, * ) 'Relative Change : ',RelativeChange
     CALL Info( 'signedDistance', Message, Level=4 )


     ! do we have do another round?
     ! ----------------------------
     IF ( RelativeChange < NonlinearTol ) THEN  ! no
        Converged = .TRUE.
        EXIT
     ELSE ! yes
        PrevNorm = Norm        
     END IF

     ! store actual values
     !--------------------
     DO i=1,SIZE(Solver % Variable % Values)
        PrevDistance(i) = NonlinearRelax * Distance(i)&
             + (1.0D00 - NonlinearRelax) *  PrevDistance(i)
     END DO
!------------------------------------------------------------------------------
  END DO ! of the nonlinear iteration
!------------------------------------------------------------------------------

  ! has non-linear solution converged?
  ! ----------------------------------
  IF ((.NOT.Converged) .AND. (NonlinearIter > 1)) THEN 
     WRITE( Message, * ) 'Nonlinear solution has not converged.',&
          ' Relative Change=',RelativeChange,'>',NonlinearTol
     CALL Warn('signedDistance', Message)
  ELSE
     WRITE( Message, * ) 'Nonlinear solution has converged after ',&
          iter,' steps.'
     CALL Info('signedDistance',Message,Level=1)
  END IF
     

!------------------------------------------------------------------------------

CONTAINS
!------------------------------------------------------------------------------
  SUBROUTINE LocalMatrix(MASS, STIFF, FORCE, LOAD, PrevDistanceElem, Element, n, TransientSimulation)
    IMPLICIT NONE
!------------------------------------------------------------------------------
    REAL(KIND=dp), DIMENSION(:,:) :: MASS, STIFF
    REAL(KIND=dp), DIMENSION(:) :: FORCE, LOAD, PrevDistanceElem
    INTEGER :: n
    TYPE(Element_t), POINTER :: Element
    LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
    REAL(KIND=dp) :: Basis(n),dBasisdx(n,3),ddBasisddx(n,3,3), PrevDistanceGradientAtIP(3)
    REAL(KIND=dp) :: detJ, LoadAtIP,&
         LocalHeatCapacity, LocalHeatConductivity, LocalDensity
    LOGICAL :: Stat, getSecondDerivatives
    INTEGER :: t,i,j,DIM
    TYPE(GaussIntegrationPoints_t) :: IP

    TYPE(Nodes_t) :: Nodes
    SAVE Nodes
!------------------------------------------------------------------------------
    DIM = CoordinateSystemDimension()

    CALL GetElementNodes( Nodes )

    STIFF = 0.0d0
    FORCE = 0.0d0
    MASS = 0.0d0

    !Numerical integration:
    !----------------------
    IP = GaussPoints( Element )
!-----------------------------------------------------------------
!   Loop over Gauss-points (element Integration)
!-----------------------------------------------------------------
    DO t=1,IP % n
       !Basis function values & derivatives at the integration point:
       !-------------------------------------------------------------
       getSecondDerivatives = .FALSE.
       stat = ElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
            IP % W(t),  detJ, Basis, dBasisdx, ddBasisddx, getSecondDerivatives)
       !The source term at the integration point:
       !-----------------------------------------
       LoadAtIP = SUM( Basis(1:n) * LOAD(1:n) )
       DO i=1,DIM
          PrevDistanceGradientAtIP(i) = SUM(dBasisdx(1:n,i)*PrevDistanceElem(1:n))
       END DO
!-----------------------------------------------------------------    
!      Loop over j-components of matrices and over force vector
!-----------------------------------------------------------------    
       DO j=1,n
          FORCE(j) = FORCE(j) + IP % s(t) * DetJ * LoadAtIP * Basis(j)
!-----------------------------------------------------------------    
!         Loop over i-components of matrices
!-----------------------------------------------------------------    
          DO i=1,n
             !The mass matrix, if needed
             !--------------------------
!             IF (TransientSimulation) THEN
!                MASS(i,j) = MASS(i,j)+ IP % s(t) * DetJ * &
!                     Basis(i)*Basis(j)
!             END IF

             !Finally, the stiffnes matrix:
             !------------------------------
!             STIFF(i,j) = STIFF(i,j) + IP % s(t) * DetJ *&
 !                 Basis(j) * SUM(dBasisdx(i,1:DIM) * PrevDistanceGradientAtIP(1:DIM))
             STIFF(i,j) = STIFF(i,j) + IP % s(t) * DetJ *&
                  Basis(j) * SQRT(ABS(SUM(dBasisdx(i,1:DIM) * PrevDistanceGradientAtIP(1:DIM))))
 !----------------------------------------------------------------- 
          END DO ! end Loop over i-components of matrices
!----------------------------------------------------------------- 
       END DO ! end Loop over j-components of matrices and vector
!----------------------------------------------------------------- 
!-----------------------------------------------------------------
    END DO ! end Loop over Gauss-points (element Integration)
!-----------------------------------------------------------------
  END SUBROUTINE LocalMatrix
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
END SUBROUTINE signedDistance
!------------------------------------------------------------------------------

PROGRAM WriteTest

    USE BinIO

    IMPLICIT NONE
    INTEGER, PARAMETER :: dp = SELECTED_REAL_KIND(15)
    INTEGER, PARAMETER :: fu = 10
    INTEGER :: a, stat, i
    REAL(dp) :: v(3)
    CHARACTER(1) :: E

    a = 5
    v = (/ -7.13_DP, 0.01_DP, HUGE(v) /)

    CALL BinOpen( fu, "writetest.out", "write", stat )
    IF ( stat /= 0 ) STOP 1

    CALL BinEndianess( E )
    CALL BinWriteChar( fu,E,stat )
    IF ( stat /= 0 ) STOP 2

    CALL BinWriteInt4( fu, a, stat )
    IF ( stat /= 0) STOP 3

    CALL BinWriteString( fu, "Hello World!", stat )
    IF ( stat /= 0 ) STOP 4

    DO i = 1, SIZE( v )
        CALL BinWriteDouble( fu, v(i), stat )
        IF ( stat /= 0 ) STOP 5
    END DO

    CALL BinClose( fu, stat )
    IF ( stat /= 0 ) STOP 6

    OPEN( 10, file="writetest.out", position="append" )
    WRITE( 10, '(A)' ) ''
    WRITE( 10, '(A)' ) "Humhum"
    CLOSE( 10 )

    CALL BinOpen( fu, "writetest.out", "append", stat )
    IF ( stat /= 0 ) STOP 7

    DO i = 1, SIZE( v )
        CALL BinWriteDouble( fu, v(i), stat )
        IF ( stat /= 0 ) STOP 8
    END DO

    CALL BinClose( fu, stat )
    IF ( stat /= 0 ) STOP 9

END PROGRAM WriteTest

!/******************************************************************************
! *
! *       ELMER, A Computational Fluid Dynamics Program.
! *
! *       Copyright 1st April 1995 - , Center for Scientific Computing,
! *                                    Finland.
! *
! *       All rights reserved. No part of this program may be used,
! *       reproduced or transmitted in any form or by any means
! *       without the written permission of CSC.
! *
! *****************************************************************************/
!
!/******************************************************************************
! *
! ******************************************************************************
! *
! *                    Author:       Juha Ruokolainen
! *
! *                    Address: Center for Scientific Computing
! *                                Tietotie 6, P.O. BOX 405
! *                                  02101 Espoo, Finland
! *                                  Tel. +358 0 457 2723
! *                                Telefax: +358 0 457 2302
! *                              EMail: Juha.Ruokolainen@csc.fi
! *
! *                       Date: 08 Jun 1997
! *
! *                Modified by: Mikko Lyly
! *
! *       Date of modification: 02 Dec 2003
! *
! *****************************************************************************/
 
!------------------------------------------------------------------------------
  RECURSIVE SUBROUTINE PoissonSolver( Model,Solver,dt,TransientSimulation )
!DEC$ATTRIBUTES DLLEXPORT :: PoissonSolver
!------------------------------------------------------------------------------
!******************************************************************************
!
!  Solves the Poisson equation with discontinous Galerkin method!
!
!  ARGUMENTS:
!
!  TYPE(Model_t) :: Model,  
!     INPUT: All model information (mesh, materials, BCs, etc...)
!
!  TYPE(Solver_t) :: Solver
!     INPUT: Linear equation solver options
!
!  DOUBLE PRECISION :: dt,
!     INPUT: Timestep size for time dependent simulations
!
!  LOGICAL :: TransientSimulation
!     INPUT: Steady state or transient simulation
!
!******************************************************************************
     USE DefUtils

     IMPLICIT NONE
!------------------------------------------------------------------------------
     TYPE(Model_t) :: Model
     TYPE(Solver_t), TARGET :: Solver
     REAL(KIND=dp) :: dt
     LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
!    Local variables
!------------------------------------------------------------------------------
     TYPE(ValueList_t), POINTER :: BC, BodyForce

     TYPE(Element_t), POINTER :: Element, Edge, &
       ParentElement, LeftParent, RightParent

     LOGICAL :: AllocationsDone = .FALSE., GotIt, Stat
     INTEGER :: k, n, t, istat, i, j, Indexes(128)
     REAL(KIND=dp) :: Norm, at, st, CPUTime, Gamma
     REAL(KIND=dp), ALLOCATABLE :: STIFF(:,:), LOAD(:), &
              FORCE(:), EpsilonBoundary(:)

     SAVE STIFF, LOAD, FORCE, AllocationsDone, EpsilonBoundary
!*******************************************************************************

     TYPE( Element_t ), POINTER :: Edges(:), Faces(:)
     TYPE(Nodes_t) :: ElementNodes

     TYPE(Mesh_t), POINTER :: Mesh

     REAL(KIND=dp), POINTER :: LocalSolution(:)
     INTEGER :: Active, DOFs
!*******************************************************************************

     Mesh => GetMesh()

     Edges => Mesh % Edges
     Faces => Mesh % Faces
!------------------------------------------------------------------------------
!    Initialize & allocate some permanent storage, this is done first time only
!------------------------------------------------------------------------------
     IF ( .NOT. AllocationsDone ) THEN
        N = 2 * Mesh % MaxElementDOFs
        ALLOCATE( FORCE(N), STIFF(2*N,2*N), LOAD(N), EpsilonBoundary(N), &
             LocalSolution(N), STAT = istat )
        
       IF ( istat /= 0 ) CALL FATAL('PoissonDG','Memory allocation error.' )

       AllocationsDone = .TRUE.
     END IF
!------------------------------------------------------------------------------
!    Assembly of the bulk elements
!------------------------------------------------------------------------------
     at = CPUTime()
     Active = GetNOFActive()
     CALL DefaultInitialize()
     DO t = 1, Active
        Element => GetActiveElement( t ) 
        n = GetElementNOfNodes( Element )
        
        BodyForce => GetBodyForce( Element )
        LOAD(1:n) = GetReal( BodyForce, 'Source', GotIt )
        
        CALL LocalMatrix( STIFF, FORCE, LOAD, Element, n ) 
        CALL DefaultUpdateEquations( STIFF, FORCE )
     END DO
!------------------------------------------------------------------------------
!    Assembly of the edge terms
!------------------------------------------------------------------------------
    Gamma = ListGetConstReal( Solver % Values, 'gamma1', GotIt )
    IF( .NOT. GotIt ) Gamma = 1.0d3

    FORCE = 0.0d0
    DO t = 1, Mesh % NumberOfEdges
       Edge => Edges(t)
       IF ( .NOT. ActiveBoundaryElement(Edge) ) CYCLE
       
       LeftParent  => Edge % BoundaryInfo % Left
       RightParent => Edge % BoundaryInfo % Right
       IF ( .NOT. ASSOCIATED(RightParent) ) CYCLE

       n = GetElementNOFnodes( Edge )
       CALL LocalJumps( STIFF, Edge, n, LeftParent, RightParent, gamma )

       CALL DefaultUpdateEquations( STIFF, FORCE, Edge )
    END DO
!------------------------------------------------------------------------------
!   Loop over the boundary elements (Nitsche boundary stab. terms)
!------------------------------------------------------------------------------
    Gamma = ListGetConstReal( Solver % Values, 'gamma2', GotIt )
    IF( .NOT. GotIt ) Gamma = 1.0d-3
    
    DO t = 1, Mesh % NumberOfBoundaryElements
       Element => GetBoundaryElement(t)
       IF( .NOT. ActiveBoundaryElement() )  CYCLE
       IF( GetElementFamily(Element) == 1 ) CYCLE
       
       BC => GetBC()
       IF ( ASSOCIATED(BC) ) THEN
          ParentElement => Element % BoundaryInfo % Left
          IF ( .NOT. ASSOCIATED( ParentElement ) ) &
             ParentElement => Element % BoundaryInfo % Right
          
          n = GetElementNOFNodes( Element )
          k = GetElementNOFnodes( ParentElement )

          LOAD(1:n) = GetReal( BC, 'g', GotIt )
          EpsilonBoundary(1:n) = GetReal( BC, 'e', GotIt )
          
          CALL LocalMatrixBoundary(  STIFF, FORCE, LOAD, &
            Element, ParentElement, n, k, EpsilonBoundary, Gamma )
          
          CALL DefaultUpdateEquations( STIFF, FORCE )
       END IF
     END DO
     CALL DefaultFinishAssembly()
     PRINT*,'Assembly (s): ',CPUTime()-at

     st = CPUTime()
     Norm = DefaultSolve()
     PRINT*,'Solve (s):    ',CPUTime()-st
!------------------------------------------------------------------------------
!    Write the post file (so far works only with triangles in 2d):
!------------------------------------------------------------------------------
     PRINT *,'INFO: Writing post file "dg.ep"'
     OPEN( 10, FILE='dg.ep', STATUS='unknown' )
     
     WRITE( 10, '(i8,i8,i3,i6,a)' ) &
          3*Active, Active, 1, 1, ' scalar: Somequantity'
     
     DO t=1,Active
        Element => GetActiveElement(t) 
        n = GetElementNOFNodes( Element )
        
        DO i = 1,n
           WRITE( 10, '(3e20.12)') &
                Mesh % Nodes % x(Element % NodeIndexes(i)), &
                Mesh % Nodes % y(Element % NodeIndexes(i)), &
                Mesh % Nodes % z(Element % NodeIndexes(i))
        END DO
     END DO

     DO i=1,Active
        WRITE( 10,'(a,i6)',advance='no' ) 'body ', &
             Mesh % Elements(i) % Type % ElementCode
  
        n = Mesh % Elements(i) % Type % NumberOfNodes
        DO j=1,n
           WRITE( 10,'(i8)', ADVANCE='no' ) n*(i-1) + j - 1
        END DO
        WRITE( 10,'(a)' ) ''
     END DO
     
     WRITE( 10,* ) '#time ',1,1,1

     DO i=1,ACtive
       Element => GetActiveElement(i)
       n = GetElementDOFs( Indexes )
       DO k=1,n
          DO j=1, Solver % Variable % DOFs
             WRITE( 10, '(1e30.15)') Solver % Variable % Values( &
               Solver % Variable % DOFs*( &
                   Solver % Variable % Perm(Indexes(k))-1)+j )
          END DO
       END DO
     END DO

     CLOSE(10)

   CONTAINS

!------------------------------------------------------------------------------
    SUBROUTINE FindParentUVW( EdgeNodes, nEdge, &
         ParentNodes, nParent, U, V, W, EdgeBasis )
!------------------------------------------------------------------------------
      IMPLICIT NONE
      TYPE( Nodes_t ) :: EdgeNodes, ParentNodes
      INTEGER :: nEdge, nParent
      REAL( KIND=dp ) :: U, V, W, EdgeBasis(:)
!------------------------------------------------------------------------------
      INTEGER :: i, j, Check
      REAL(KIND=dp) :: Dist, DistTolerance
      REAL(KIND=dp) :: NodalParentU(nEdge), &
           NodalParentV(nEdge), NodalParentW(nEdge)
!------------------------------------------------------------------------------
      DistTolerance = 1.0d-12

      Check = 0
      DO i = 1,nEdge
         DO j = 1,nParent
            Dist = (EdgeNodes % x(i) - ParentNodes % x(j))**2 & 
                 + (EdgeNodes % y(i) - ParentNodes % y(j))**2 & 
                 + (EdgeNodes % z(i) - ParentNodes % z(j))**2

            IF( Dist < DistTolerance ) THEN
               Check = Check+1
               NodalParentU(i) = RightParent % Type % NodeU(j)
               NodalParentV(i) = RightParent % Type % NodeV(j)
               NodalParentW(i) = RightParent % Type % NodeW(j)
            END IF

         END DO
      END DO
      IF( Check /= nEdge ) STOP 'Error' 

      U = SUM( EdgeBasis(1:nEdge) * NodalParentU(1:nEdge) )
      V = SUM( EdgeBasis(1:nEdge) * NodalParentV(1:nEdge) )
      W = SUM( EdgeBasis(1:nEdge) * NodalParentW(1:nEdge) )
!------------------------------------------------------------------------------      
    END SUBROUTINE FindParentUVW
!------------------------------------------------------------------------------      


!------------------------------------------------------------------------------
     SUBROUTINE LocalJumps( STIFF,Edge,n,LeftParent,RightParent,gamma )
!------------------------------------------------------------------------------
       REAL(KIND=dp) :: STIFF(:,:), gamma
       INTEGER :: n
       TYPE(Element_t), POINTER :: Edge, LeftParent, RightParent

!------------------------------------------------------------------------------
       REAL(KIND=dp) :: EdgeBasis(n), EdgedBasisdx(n,3)
       REAL(KIND=dp) :: LeftBasis(n+1), LeftdBasisdx(n+1,3)
       REAL(KIND=dp) :: RightBasis(n+1), RightdBasisdx(n+1,3)
       REAL(KIND=dp) :: LeftdBasisdn(n+1), RightdBasisdn(n+1)
       REAL(KIND=dp) :: Jump(2*(n+1)), AverageFlux(2*(n+1))
       REAL(KIND=dp) :: SqrtElementMetric, U, V, W, S
       LOGICAL :: Stat
       INTEGER :: i, j, p, q, dim, t, nEdge, nParent
       TYPE(GaussIntegrationPoints_t) :: IntegStuff
       REAL(KIND=dp) :: hE, Normal(3), LeftOut(3)

       TYPE(Nodes_t) :: EdgeNodes, LeftParentNodes, RightParentNodes
       SAVE EdgeNodes, LeftParentNodes, RightParentNodes 
!------------------------------------------------------------------------------
       dim = CoordinateSystemDimension()
       nEdge = n
       nParent = n+1
       STIFF = 0.0d0

       CALL GetElementNodes( EdgeNodes, Edge )
       CALL GetElementNodes( LeftParentNodes, LeftParent )
       CALL GetElementNodes( RightParentNodes, RightParent )
       hE = ElementDiameter( Edge, EdgeNodes )

       LeftOut(1) = SUM(LeftParentNodes % x(1:nParent)) / nParent
       LeftOut(2) = SUM(LeftParentNodes % y(1:nParent)) / nParent
       LeftOut(3) = SUM(LeftParentNodes % z(1:nParent)) / nParent
       LeftOut(1) = SUM(EdgeNodes % x(1:n)) / n - LeftOut(1)
       LeftOut(2) = SUM(EdgeNodes % y(1:n)) / n - LeftOut(2)
       LeftOut(3) = SUM(EdgeNodes % z(1:n)) / n - LeftOut(3)

!------------------------------------------------------------------------------
!      Numerical integration over the edge
!------------------------------------------------------------------------------
       IntegStuff = GaussPoints( Edge )
 
       DO t=1,IntegStuff % n
         U = IntegStuff % u(t)
         V = IntegStuff % v(t)
         W = IntegStuff % w(t)
         S = IntegStuff % s(t)

!------------------------------------------------------------------------------
!        Basis function values & derivatives at the integration point
!------------------------------------------------------------------------------
         stat = ElementInfo( Edge, EdgeNodes, U, V, W, SqrtElementMetric, &
              EdgeBasis, EdgedBasisdx )

         S = S * SqrtElementMetric

         Normal = NormalVector( Edge, EdgeNodes, U, V, .FALSE. )
         IF ( SUM( LeftOut*Normal ) < 0 ) Normal = -Normal

!        Find basis functions for the parent elements:
!        ----------------------------------------------
         CALL FindParentUVW( EdgeNodes, nEdge, LeftParentNodes, &
              nParent, U, V, W, EdgeBasis )

         stat = ElementInfo( LeftParent, LeftParentNodes, &
              U, V, W, SqrtElementMetric, LeftBasis, LeftdBasisdx )

         CALL FindParentUVW( EdgeNodes, nEdge, RightParentNodes, &
              nParent, U, V, W, EdgeBasis )

         stat = ElementInfo( RightParent, RightParentNodes, &
              U, V, W, SqrtElementMetric, RightBasis, RightdBasisdx )

!        Integrate jump terms:
!        ---------------------
         Jump(1:nParent) = LeftBasis(1:nParent)
         Jump(nParent+1:2*nParent) = -RightBasis(1:nParent)

         DO i = 1,nParent
            LeftdBasisdn(i)  = SUM( LeftdBasisdx(i,:)  * Normal(:) )
            RightdBasisdn(i) = SUM( RightdBasisdx(i,:) * Normal(:) )
         END DO

         AverageFlux(1:nParent) = LeftdBasisdn(1:nParent) / 2.0d0
         AverageFlux(nParent+1:2*nParent) = RightdBasisdn(1:nParent) / 2.0d0

         DO p = 1,2*nParent
            DO q = 1,2*nParent
               STIFF(p,q) = STIFF(p,q) + (gamma/hE)*Jump(p)*Jump(q) * s
               STIFF(p,q) = STIFF(p,q) - AverageFlux(p) * Jump(q)   * s
               STIFF(p,q) = STIFF(p,q) + Jump(p) * AverageFlux(q)   * s
            END DO
         END DO
      END DO
!------------------------------------------------------------------------------
    END SUBROUTINE LocalJumps
!------------------------------------------------------------------------------


!------------------------------------------------------------------------------      
     SUBROUTINE LocalMatrix( STIFF, FORCE, LOAD, Element, n  )
!------------------------------------------------------------------------------
       REAL(KIND=dp) :: STIFF(:,:), FORCE(:), LOAD(:)
       INTEGER :: n
       TYPE(Element_t), POINTER :: Element
!------------------------------------------------------------------------------
       REAL(KIND=dp) :: Basis(n),dBasisdx(n,3)
       REAL(KIND=dp) :: SqrtElementMetric,U,V,W,S,A,L
       LOGICAL :: Stat

       INTEGER :: i,p,q,t,dim

       TYPE(Nodes_t) :: Nodes
       SAVE Nodes
 
       TYPE(GaussIntegrationPoints_t) :: IntegStuff
 
!------------------------------------------------------------------------------
       dim = CoordinateSystemDimension()
       FORCE = 0.0d0
       STIFF = 0.0d0
       CALL GetElementNodes( Nodes, Element )
!------------------------------------------------------------------------------
!      Numerical integration
!------------------------------------------------------------------------------
       IntegStuff = GaussPoints( Element )
 
       DO t=1,IntegStuff % n
         U = IntegStuff % u(t)
         V = IntegStuff % v(t)
         W = IntegStuff % w(t)
         S = IntegStuff % s(t)
!------------------------------------------------------------------------------
!        Basis function values & derivatives at the integration point
!------------------------------------------------------------------------------
         stat = ElementInfo( Element,Nodes,U,V,W,SqrtElementMetric, &
                    Basis, dBasisdx )

         S = S * SqrtElementMetric

         L = SUM( LOAD(1:n) * Basis(1:n) )

!------------------------------------------------------------------------------
!        The Poisson equation
!------------------------------------------------------------------------------
         STIFF(1:n,1:n) = STIFF(1:n,1:n) +  s * &
                MATMUL( dBasisdx, TRANSPOSE( dBasisdx ) )
         FORCE(1:n) = FORCE(1:n) + s*L*Basis(1:n)
!------------------------------------------------------------------------------
      END DO
!------------------------------------------------------------------------------
     END SUBROUTINE LocalMatrix

!==============================================================================

!------------------------------------------------------------------------------
     SUBROUTINE LocalMatrixBoundary( STIFF, FORCE, LOAD, &
          Element, ParentElement, n, k, EpsilonBoundary, Gamma )
!------------------------------------------------------------------------------
       REAL(KIND=dp) :: STIFF(:,:),  FORCE(:), &
            LOAD(:), EpsilonBoundary(:), Gamma
       INTEGER :: n, k
       TYPE(Element_t), POINTER :: Element, ParentElement
!------------------------------------------------------------------------------
       REAL(KIND=dp) :: Basis(n), dBasisdx(n,3)
       REAL(KIND=dp) :: ParentBasis(k), ParentdBasisdx(k,3), &
             ParentdBasisdn(k)
       INTEGER :: i,j,p,q,t,dim

       REAL(KIND=dp) :: Normal(3), ParentU, ParentV, ParentW
       REAL(kind=dp) :: e, g, h, c1, c2, c3, L

       REAL(KIND=dp) :: ParentNodalU(n), parentNodalV(n), ParentNodalW(n)

       TYPE(GaussIntegrationPoints_t) :: IntegStuff
       REAL(KIND=dp) :: SqrtElementMetric,U,V,W,S
       LOGICAL :: Stat

       TYPE(Nodes_t) :: Nodes, ParentNodes
       SAVE Nodes, ParentNodes
!------------------------------------------------------------------------------
       dim = CoordinateSystemDimension()
       FORCE = 0.0d0
       STIFF = 0.0d0

       CALL GetElementNodes( Nodes, Element )
       CALL GetElementNodes( ParentNodes, ParentElement )
!------------------------------------------------------------------------------
!      Numerical integration
!------------------------------------------------------------------------------
       IntegStuff = GaussPoints( Element )
 
       DO t=1,IntegStuff % n
         U = IntegStuff % u(t)
         V = IntegStuff % v(t)
         W = IntegStuff % w(t)
         S = IntegStuff % s(t)

         Normal = NormalVector( Element, Nodes, U, V, .TRUE. ) 

!------------------------------------------------------------------------------
!        Basis function values & derivatives at the integration point
!------------------------------------------------------------------------------
         stat = ElementInfo( Element,Nodes,U,V,W,SqrtElementMetric, &
                    Basis,dBasisdx )
         S = S * SqrtElementMetric

         ParentNodalU = 0.0d0
         ParentNodalV = 0.0d0
         ParentNodalW = 0.0d0
         DO i = 1,n
            DO j = 1,k
               IF( Element % NodeIndexes(i) == ParentElement % NodeIndexes(j) ) THEN
                  ParentNodalU(i) = ParentElement % Type % NodeU(j)
                  ParentNodalV(i) = ParentElement % Type % NodeV(j)
                  ParentNodalW(i) = ParentElement % Type % NodeW(j)
               END IF
            END DO
         END DO
         ParentU = SUM( Basis(1:n) * ParentNodalU(1:n) )
         ParentV = SUM( Basis(1:n) * ParentNodalV(1:n) )
         ParentW = SUM( Basis(1:n) * ParentNodalW(1:n) )

         stat = ElementInfo( ParentElement, ParentNodes, &
              ParentU, ParentV, ParentW, SqrtElementMetric, &
              ParentBasis, ParentdBasisdx )

         L = SUM( LOAD(1:n) * Basis(1:n) )
         e = SUM( EpsilonBoundary(1:n) * Basis(1:n) )

         DO p = 1,k
            ParentdBasisdn(p) = SUM( Normal(1:3) * ParentdBasisdx(p,1:3) )
         END DO
!------------------------------------------------------------------------------
!        The stabilization terms
!------------------------------------------------------------------------------
         h = ElementDiameter( Element, Nodes )
         c1 = Gamma*h/(e + Gamma*h)
         c2 = 1.0d0/(e + Gamma*h)
         c3 = (e * Gamma*h)/(e + Gamma*h)
         DO p = 1,k
           DO q = 1,k
              STIFF(p,q) = STIFF(p,q) - c1 * ParentdBasisdn(p) * ParentBasis(q) * s
              STIFF(p,q) = STIFF(p,q) - c1 * ParentBasis(p) * ParentdBasisdn(q) * s
              STIFF(p,q) = STIFF(p,q) + c2 * ParentBasis(p) * ParentBasis(q) * s
              STIFF(p,q) = STIFF(p,q) - c3 * ParentdBasisdn(p) * ParentdBasisdn(q) * s
           END DO
           FORCE(p) = FORCE(p) - c1 * ParentdBasisdn(p) * L * s
           FORCE(p) = FORCE(p) + c2 * ParentBasis(p) * L * s
         END DO
!------------------------------------------------------------------------------
       END DO
!------------------------------------------------------------------------------
     END SUBROUTINE LocalMatrixBoundary
!------------------------------------------------------------------------------
   END SUBROUTINE PoissonSolver
!------------------------------------------------------------------------------

!/******************************************************************************
! *
! *       ELMER, A Computational Fluid Dynamics Program.
! *
! *       Copyright 1st April 1995 - , Center for Scientific Computing,
! *                                    Finland.
! *
! *       All rights reserved. No part of this program may be used,
! *       reproduced or transmitted in any form or by any means
! *       without the written permission of CSC.
! *
! *****************************************************************************/
!
!/******************************************************************************
! *
! ******************************************************************************
! *
! *                    Author:       Juha Ruokolainen
! *
! *                    Address: Center for Scientific Computing
! *                                Tietotie 6, P.O. BOX 405
! *                                  02101 Espoo, Finland
! *                                  Tel. +358 0 457 2723
! *                                Telefax: +358 0 457 2302
! *                              EMail: Juha.Ruokolainen@csc.fi
! *
! *                       Date: 08 Jun 1997
! *
! *                Modified by: Thomas, Mikko, Juha
! *
! *       Date of modification: 19 Dec 2005
! *
! *****************************************************************************/
 
!------------------------------------------------------------------------------
  RECURSIVE SUBROUTINE AdvReactSolverLtd( Model,Solver,dt,TransientSimulation )
!DEC$ATTRIBUTES DLLEXPORT :: AdvReactSolver
!------------------------------------------------------------------------------
!******************************************************************************
!
! Solves the advection-reaction equation with discontinous Galerkin method!
!
!  ARGUMENTS:
!
!  TYPE(Model_t) :: Model,  
!     INPUT: All model information (mesh, materials, BCs, etc...)
!
!  TYPE(Solver_t) :: Solver
!     INPUT: Linear equation solver options
!
!  DOUBLE PRECISION :: dt,
!     INPUT: Timestep size for time dependent simulations
!
!  LOGICAL :: TransientSimulation
!     INPUT: Steady state or transient simulation
!
!******************************************************************************
     USE DefUtils

     IMPLICIT NONE
!------------------------------------------------------------------------------
! external variables
!------------------------------------------------------------------------------
     TYPE(Model_t) :: Model
     TYPE(Solver_t), TARGET :: Solver
     REAL(KIND=dp) :: dt
     LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
!    Local variables
!------------------------------------------------------------------------------
     TYPE(ValueList_t), POINTER ::&
          BC, BodyForce, Material, Constants, SolverParams
     TYPE(Element_t), POINTER ::&
          Element, Face, &
       ParentElement, LeftParent, RightParent
     LOGICAL ::&
          AllocationsDone = .FALSE., FirstTime = .TRUE., Found, Stat, LimitSolution
     LOGICAL, ALLOCATABLE ::  LimitedSolution(:,:)
     INTEGER ::&
          n1,n2, DIM, k, n, t, istat, i, j, NumberOfFAces, Indexes(128), NonlinearIter, &
          LocalNodes, iter, NumberOfModelNodes,NumberOfMeshNodes, NumberOfBoundaryNodes
     INTEGER, POINTER, DIMENSION(:) :: FlowPerm, NodeIndexes, Perm
     REAL(KIND=dp) :: &
          Norm, PrevNorm, RelativeChange, Relax, RelaxIncrease, RelaxMax, &
          UzawaParameter, UzawaParameterDegrease, UzawaParameterMin, UzawaParameterOrig, &
          NonlinearTol, NonLinearTolMin, NonLinearTolDegrease, OldNonlinearTol, &
          at,at0,totat,st,totst,t1,CPUTime,RealTime
     REAL(KIND=dp), ALLOCATABLE :: &
          MASS(:,:), STIFF(:,:), LOAD(:), &
          FORCE(:), Velocity(:,:), Gamma(:), Ref(:), PrevValues(:), &
          UpperLimit(:),LowerLimit(:),LagrangeMultiplier(:,:)
     REAL(KIND=dp), POINTER, DIMENSION(:) ::&
          FlowValues, Values
     TYPE(Variable_t), POINTER ::&
          Var, ExportVar, FlowVariable
     CHARACTER(LEN=MAX_NAME_LEN)  ::&
          SolverName, VariableName, FlowSolverName, ExportVariable
!*******************************************************************************

     TYPE( Element_t ), POINTER :: Faces(:)
     TYPE(Nodes_t) :: ElementNodes

     INTEGER :: DOFs

     SAVE MASS, STIFF, LOAD, FORCE, Velocity, Gamma, &
          SolverName, VariableName, ExportVariable,  &
          Relax, RelaxIncrease, RelaxMax, &
          UzawaParameter, UzawaParameterDegrease, UzawaParameterMin, UzawaParameterOrig, &
          OldNonlinearTol, NonLinearTolMin,NonLinearTolDegrease, &
          FirstTime, AllocationsDone, LimitSolution, DIM, &
          PrevValues, NumberOfModelNodes, NumberOfMeshNodes, &
          UpperLimit, LowerLimit, LagrangeMultiplier,LimitedSolution
!*******************************************************************************
     !-------------------------------
     ! is there something to be done?
     !-------------------------------
     IF ( .NOT. ASSOCIATED( Solver % Matrix ) ) RETURN
     
     !---------------------------
     ! stuff done the first time
     !---------------------------
     IF(FirstTime) THEN
        DIM = CoordinateSystemDimension()
        Constants => GetConstants()
        SolverParams => GetSolverParams()

        SolverName = 'AdvReactDGLtd ('// TRIM(Solver % Variable % Name) // ')'
        VariableName = TRIM(Solver % Variable % Name)

        NonlinearIter = GetInteger(   SolverParams, &
             'Nonlinear System Max Iterations', Found )
        IF ( .NOT.Found ) NonlinearIter = 1

        NonlinearTol  = GetConstReal( SolverParams, &
             'Nonlinear System Convergence Tolerance',    Found )

        OldNonlinearTol = NonlinearTol  
        NonlinearTolDegrease = GetConstReal( SolverParams, &
             'Nonlinear System Convergence Tolerance Degrease',    Found )
        IF (.NOT.Found) NonlinearTolDegrease = 1.0D00

        NonlinearTolMin  = GetConstReal( SolverParams, &
             'Nonlinear System Convergence Tolerance Min',    Found )

        Relax = GetConstReal( SolverParams, &
             'Nonlinear System Relaxation Factor',Found )

        IF ( .NOT.Found ) Relax = 1.0D00

        RelaxIncrease = GetConstReal( SolverParams, &
             'Nonlinear System Relaxation Factor Increase',Found )
        IF (.NOT.Found) RelaxIncrease = 1.0D00

        RelaxMax = GetConstReal( SolverParams, &
             'Nonlinear System Relaxation Factor Max',Found )
        IF (.NOT.Found) RelaxMax = Relax     

        UzawaParameter = GetConstReal( SolverParams, &
             'Uzawa Parameter', Found)
        IF (.NOT.Found) THEN                
           CALL INFO(SolverName, 'No Uzawa Parameter found. No limitting of solution', level=1)
           LimitSolution = .FALSE.
           CALL INFO(SolverName, 'Setting nonlinear iterations to 1.')
           NonlinearIter = 1
        ELSE
           WRITE(Message,'(a,e13.4)') 'Uzawa Parameter:',  UzawaParameter
           CALL INFO(SolverName, Message, level=1)
           LimitSolution = .TRUE.
           UzawaParameterOrig = UzawaParameter
        END IF
        IF (LimitSolution) THEN
           UzawaParameterDegrease = GetConstReal( SolverParams, &
                'Uzawa Parameter Degrease', Found)
           IF (.NOT.Found) THEN                
              CALL INFO(SolverName, 'Keyword >Uzawa Parameter Degrease< not found', Level=1)
              CALL INFO(SolverName, 'Setting to 1.',Level=1)
              UzawaParameterDegrease = 1.0
           ELSE IF(UzawaParameterDegrease > 1.0D00) THEN
              CALL INFO(SolverName, '0.0 < Uzawa Parameter Degrease < 1.0!',Level=1)
              CALL INFO(SolverName, 'Setting to 1.',Level=1)
              UzawaParameterDegrease = 1.0
           ELSE
              WRITE(Message,'(a,e13.4)') 'Uzawa Parameter Degrease:',  UzawaParameterDegrease
              CALL INFO(SolverName, Message, level=1)
           END IF
           UzawaParameterMin = GetConstReal( SolverParams, &
                'Uzawa Parameter Min', Found)
           IF (.NOT.Found) THEN                
              CALL INFO(SolverName, 'Keyword >Uzawa Parameter Min< not found', Level=9)
              CALL INFO(SolverName, 'Setting to value of Uzawa Parameter.',Level=1)
              UzawaParameterMin = UzawaParameter
           ELSE IF(UzawaParameterMin .GE. UzawaParameter) THEN
              CALL INFO(SolverName, 'Uzawa Parameter Min < Uzawa Paramter!',Level=1)
              CALL INFO(SolverName, 'Setting to value of Uzawa Parameter.',Level=1)
              UzawaParameterMin = UzawaParameter
           ELSE
              WRITE(Message,'(a,e13.4)') 'Uzawa Parameter Min:',  UzawaParameterMin
              CALL INFO(SolverName, Message, level=1)
           END IF
        END IF
     ELSE
        UzawaParameter = UzawaParameterOrig 
     END IF
     !------------------------------------------------------------------------------
     !    Get variables needed for solution
     !------------------------------------------------------------------------------  
     Var   => VariableGet( Solver % Mesh % Variables, TRIM(VariableName) )
     IF (ASSOCIATED(Var)) THEN
        Perm   => Var % Perm
        Values => Var % Values
        LocalNodes = COUNT( Perm > 0 )
     ELSE
        WRITE(Message,'(A,A)') VariableName, ' not associated.'
        CALL FATAL(Solvername,Message)
     END IF
     !----------------------------------------------
     ! Initialize & allocate some permanent storage
     !----------------------------------------------
     IF ( .NOT.AllocationsDone .OR. Solver % Mesh % Changed) THEN
        NumberOfModelNodes = SIZE(Solver % Variable % Values)
        NumberOfMeshNodes = Model % Mesh % NumberOfNodes
        N = 2 * MAX(Solver % Mesh % MaxElementDOFs, Solver % Mesh % MaxElementNodes )
        IF ( AllocationsDone ) &
             DEALLOCATE (FORCE, MASS, STIFF, LOAD,  &
             Velocity, Gamma, PrevValues,&
             LagrangeMultiplier,   &
             LowerLimit,            &
             UpperLimit,            &
             LimitedSolution)
        ALLOCATE( FORCE(N), MASS(n,n), STIFF(N,N), LOAD(N),         &
             Velocity(3,N), Gamma(n), PrevValues(NumberOfModelNodes),       &
             LagrangeMultiplier(2,NumberOfMeshNodes),             &
             LowerLimit(NumberOfMeshNodes),                        &
             UpperLimit(NumberOfMeshNodes),                        &
             LimitedSolution(2,NumberOfMeshNodes),                 & 
             STAT = istat )        
        IF ( istat /= 0 ) CALL FATAL(SolverName,'Memory allocation error.' )
        AllocationsDone = .TRUE.
        CALL INFO(SolverName,'Allocations done',Level=1)
        ExportVariable = GetString( Solver % Values, 'Exported Variable 1', Found )  
        IF (.NOT.Found) CALL FATAL(SolverName,'Mandatory keyword >Variable Variable 1< not found')
        WRITE(Message,'(A,A)') 'Exported Variable:', ExportVariable
        CALL INFO(SolverName,Message,Level=1)
        LagrangeMultiplier = 0.0d0
     END IF

    !--------------------------------------
    ! determine if interfaces are 1d or 2d
    !--------------------------------------   
     IF ( DIM  == 2 ) THEN
        Faces => Solver % Mesh % Edges
        NumberOfFaces = Solver % Mesh % NumberOfEdges
     ELSE
        Faces => Solver % Mesh % Faces
        NumberOfFaces = Solver % Mesh % NumberOfFaces
     END IF


     !---------------------
     ! Get velocity field
     !---------------------
     FlowSolverName = GetString( Solver % Values, 'Flow Solver Name', Found )    
     IF (.NOT.Found) FlowSolverName = 'flow solution'
     FlowVariable => VariableGet( Solver % Mesh % Variables, FlowSolverName )


     IF ( ASSOCIATED( FlowVariable ) ) THEN
       FlowPerm    => FlowVariable % Perm
       FlowValues  => FlowVariable % Values
     ELSE
       CALL FATAL(SolverName, 'No variable for velocity associated.')
     END IF

     !------------------------------------------------------------
     !  The first time around this has been done by the caller...
     !------------------------------------------------------------
     IF ( TransientSimulation .AND. .NOT.FirstTime ) THEN
        CALL InitializeTimestep( Solver )
     END IF

     !-----------------------
     ! Save current solution
     !-----------------------
 
     PrevValues = Values(1:LocalNodes)

     !----------------------------------
     ! Determine new Nonlinear Tolerance
     !----------------------------------
     IF (.NOT.FirstTime) THEN
        WRITE( Message, * ) 'Nonlinear Tolerance: old:',OldNonLinearTol,&
             ' new:', MAX(NonLinearTolMin,OldNonLinearTol*NonLinearTolDegrease)
        CALL Info( SolverName, Message, Level=4 )
        NonLinearTol = MAX(NonLinearTolMin,OldNonLinearTol*NonLinearTolDegrease)
        OldNonLinearTol = NonLinearTol
     ELSE
        WRITE( Message, * ) 'Nonlinear Tolerance at start:',NonLinearTol
        CALL Info( SolverName, Message, Level=4 )
        OldNonLinearTol = NonLinearTol
     END IF

     !------------------------------------------------------------------------------
     ! non-linear system iteration loop
     !------------------------------------------------------------------------------
     DO iter=1,NonlinearIter
        IF (.NOT.FirstTime) THEN
           WRITE( Message, * ) 'Relaxation Factor: old:',Relax,&
                ' new:', MIN(RelaxMax,Relax * Relaxincrease) 
           CALL Info( SolverName, Message, Level=4 )
           Relax = MIN(RelaxMax,Relax * Relaxincrease)
        ELSE
           WRITE( Message, * ) 'Relaxation Factor:',Relax
           CALL Info( SolverName, Message, Level=4 )
        END IF

        IF (UzawaParameterDegrease < 1.0D00) THEN
           WRITE( Message, * ) 'Uzawa Parameter: ', UzawaParameter
           CALL Info( SolverName, Message, Level=4 )
        END IF

        FirstTime = .FALSE.

        at  = CPUTime()
        at0 = RealTime()


        CALL DefaultInitialize()

        !----------------------------
        ! Update Lagrange multiplier:
        !----------------------------
        IF (LimitSolution) THEN
           LowerLimit = 0.0d00
           UpperLimit = 0.0d00

           LimitedSolution = .TRUE.
           !--------------------------
           ! Lagrange multipliers
           !--------------------------
           DO t=1,Solver % NumberOfActiveElements
              Element => GetActiveElement(t)
              NodeIndexes => Element % Nodeindexes
              !--------------------------
              ! get Indizi for DG-Element
              !--------------------------
              N = GetElementDOFs( Indexes )
              !--------------------------
              ! get number of mesh nodes
              !--------------------------
              N = GetElementNOFNodes(Element)
              CALL GetElementNodes( ElementNodes )
              Material => GetMaterial()
              !----------------
              ! get lower limit
              !----------------
              LowerLimit(Nodeindexes(1:N)) = ListGetReal(Material,TRIM(Solver % Variable % Name) // & 
                   ' Lower Limit',n,NodeIndexes, Found)
              IF (.NOT.Found) THEN
                 LimitedSolution(1,Nodeindexes(1:N)) = .FALSE.
                 WRITE(Message,'(a,i)') 'No lower limit of solution for element no. ', t
                 CALL INFO(SolverName, Message, level=9)
                 LagrangeMultiplier(1,Nodeindexes(1:N)) = 0.0D00
              END IF
              !----------------
              ! get upper limit
              !----------------
              UpperLimit(Nodeindexes(1:N)) = ListGetReal(Material,TRIM(Solver % Variable % Name) // & 
                   ' Upper Limit',n,NodeIndexes, Found)
              IF (.NOT. Found) THEN
                 LimitedSolution(2,Nodeindexes(1:N)) = .FALSE.
                 WRITE(Message,'(a,i)') 'No upper limit of solution for element no. ', t
                 CALL INFO(SolverName, Message, level=9)
                 LagrangeMultiplier(2,Nodeindexes(1:N)) = 0.0D00
              END IF 
              ! --------------------------------
              ! get Lagrange Multipliers for ...
              ! --------------------------------
              DO i=1,N
                 ! ... lower limit
                 !----------------
                 IF (LimitedSolution(1,Nodeindexes(i))) &
                    LagrangeMultiplier(1,Nodeindexes(i)) = MIN( 0.0d0, LagrangeMultiplier(1,Nodeindexes(i)) + UzawaParameter * &
                      (Values(Perm(Indexes(i))) - LowerLimit(NodeIndexes(i))))
                 LimitedSolution(1,Nodeindexes(i)) = .FALSE. 
                 ! ... upper limit
                 !----------------
                 IF (LimitedSolution(2,Nodeindexes(i))) &
                    LagrangeMultiplier(2,Nodeindexes(i)) = MAX( 0.0d0, LagrangeMultiplier(2,Nodeindexes(i)) + UzawaParameter * &
                      (Values(Perm(Indexes(i))) - UpperLimit(Nodeindexes(i))))
                 LimitedSolution(2,Nodeindexes(i)) = .FALSE. 
              END DO
           END DO
        END IF
        CALL INFO(SolverName,'Max/min values Lagrange multiplier ...',Level=4)
        WRITE(Message,'(a,e13.6,a,e13.6)') &
             '... for lower constraint:', MAXVAL( LagrangeMultiplier(1,1:NumberOfMeshNodes) ),&
             '/',MINVAL( LagrangeMultiplier(1,1:NumberOfMeshNodes) )
        CALL INFO(SolverName,Message,Level=4)
        WRITE(Message,'(a,e13.6,a,e13.6)') &
             '... or upper constraint:', MAXVAL( LagrangeMultiplier(2,1:NumberOfMeshNodes) ),&
             '/',MINVAL( LagrangeMultiplier(2,1:NumberOfMeshNodes) )
        CALL INFO(SolverName,Message,Level=4)
        WRITE(Message,'(a,e13.6,a,e13.6)') &
             'Max/min values:', MAXVAL( Values(:)),'/',MINVAL( Values(:))
        CALL INFO(SolverName,Message,Level=4)

        !---------------------------------------------------------------------------
        ! Assembly of the bulk elements:
        !---------------------------------------------------------------------------
        DO t = 1, Solver % NumberOfActiveElements
           Element => GetActiveElement( t )
           NodeIndexes => Element % NodeIndexes 

           n = GetElementNOfNodes( Element )
           N = GetElementDOFs( Indexes )
           
           LOAD = 0.0D00
           !-----------
           ! Body Force
           !-----------
           BodyForce => GetBodyForce( Element )
           LOAD(1:n) = GetReal( BodyForce, TRIM(Solver % Variable % Name) // ' Source', Found )

           IF (.NOT.Found) THEN
              LOAD(1:n) = 0.0D00
              CALL INFO(SolverName,'No Source term found',Level=9)
           END IF

           !---------------------
           ! Lagrange multipliers
           !---------------------
           DO j=1,N
              LOAD(j) = LOAD(j) &
                   - LagrangeMultiplier(1,NodeIndexes(j)) &
                   - LagrangeMultiplier(2,NodeIndexes(j))
           END DO
!           PRINT *,LOAD
        
           k = FlowVariable % DOFs
           Velocity = 0.0d0
           DO i=1,k-1
              DO j=1,N
                 Velocity(i,j) = FlowValues(k*(FlowPerm(NodeIndexes(j))-1)+i)
              END DO
           END DO

           Material => GetMaterial()
           Gamma(1:n)  = GetReal( Material, TRIM(Solver % Variable % Name) // ' Gamma', Found )
           IF (.NOT.Found) Gamma(1:n) = 0.0D00

           CALL LocalMatrix( MASS, STIFF, FORCE, LOAD, Velocity, Gamma, Element, n ) 
           IF ( TransientSimulation ) CALL Default1stOrderTime( MASS, STIFF, FORCE )
           CALL DefaultUpdateEquations( STIFF, FORCE )
        END DO
        !----------------------------
        ! Assembly of the face terms:
        !----------------------------
        FORCE = 0.0d0
        DO t=1,NumberOfFaces
           Face => Faces(t)           
           IF ( .NOT. ActiveBoundaryElement(Face) ) CYCLE
           NodeIndexes => Face % NodeIndexes

           LeftParent  => Face % BoundaryInfo % Left
           RightParent => Face % BoundaryInfo % Right
           IF ( ASSOCIATED(RightParent) .AND. ASSOCIATED(LeftParent) ) THEN
              n  = GetElementNOFNodes( Face )
              n1 = GetElementNOFNodes( LeftParent )
              n2 = GetElementNOFNodes( RightParent )
              
              k = FlowVariable % DOFs
              Velocity = 0.0d0
              DO i=1,k-1  
                 DO j=1,N
                    Velocity(i,j) = FlowValues(k*(FlowPerm(NodeIndexes(j))-1)+i)
                 END DO
              END DO

              CALL LocalJumps( STIFF,Face,n,LeftParent,n1,RightParent,n2,Velocity )
              CALL DefaultUpdateEquations( STIFF, FORCE, Face )
           END IF
        END DO
        !---------------------------------
        ! Loop over the boundary elements:
        !---------------------------------
        DO t=1,Solver % Mesh % NumberOfBoundaryElements
           Element => GetBoundaryElement(t)
           NodeIndexes => Element % NodeIndexes

           IF( .NOT. ActiveBoundaryElement() )  CYCLE
           IF( GetElementFamily(Element) == 1 ) CYCLE

           ParentElement => Element % BoundaryInfo % Left
           IF ( .NOT. ASSOCIATED( ParentElement ) ) &
                ParentElement => Element % BoundaryInfo % Right
        
!           N = GetElementDOFs( Indexes )
           N  = GetElementNOFNodes( Element )
           n1 = GetElementNOFnodes( ParentElement )

           k = FlowVariable % DOFs
           Velocity = 0.0d0
           DO i=1,k-1 
              DO j=1,N
                 Velocity(i,j) = FlowValues(k*(FlowPerm(NodeIndexes(j))-1)+i)
              END DO
           END DO

           BC => GetBC()
           LOAD = 0.0d0
           Found = .FALSE.
           IF ( ASSOCIATED(BC) ) THEN
              LOAD(1:n) = GetReal( BC, Solver % Variable % Name, Found )
              DO j=1,N
                 LOAD(j) = LOAD(j) &
                      - LagrangeMultiplier(1,NodeIndexes(j)) &
                      - LagrangeMultiplier(2,NodeIndexes(j))
              END DO
           END IF

           MASS = 0.0d0
           CALL LocalMatrixBoundary(  STIFF, FORCE, LOAD, &
                Element, n, ParentElement, n1, Velocity, Found )
           
           IF ( TransientSimulation ) CALL Default1stOrderTime( MASS, STIFF, FORCE )
           CALL DefaultUpdateEquations( STIFF, FORCE )
        END DO
        
        CALL DefaultFinishAssembly()
        !---------------------
        ! Solve the system ...
        !---------------------
        at = CPUTime() - at
        st = CPUTime()

        PrevNorm = Solver % Variable % Norm
        Norm = DefaultSolve()
        
        st = CPUTIme()-st
        totat = totat + at
        totst = totst + st
        WRITE(Message,'(a,i4,a,i4,a,F8.2,F8.2)') 'iter: ',iter,'/max. ', NonlinearIter,' Assembly: (s)', at, totat
        CALL Info( SolverName, Message, Level=4 )
        WRITE(Message,'(a,i4,a,i4,a,F8.2,F8.2)') 'iter: ',iter,'/max. ', NonlinearIter,' Solve:    (s)', st, totst
        CALL Info( SolverName, Message, Level=4 )


        !-------------------------------
        ! ... and check for convergence
        !-------------------------------
        IF ( PrevNorm + Norm /= 0.0d0 ) THEN
           RelativeChange = 2.0d0 * ABS( PrevNorm-Norm ) / (PrevNorm + Norm)
        ELSE
           RelativeChange = 0.0d0
        END IF
        
        WRITE( Message, * ) 'Result Norm   : ',Norm
        CALL Info( SolverName, Message, Level=4 )
        WRITE( Message, * ) 'Relative Change : ',RelativeChange
        CALL Info( SolverName, Message, Level=4 )
        
        IF ( RelativeChange < NonlinearTol ) EXIT
        
        UzawaParameter = MAX(UzawaParameter*UzawaParameterDegrease,UzawaParameterMin)
        
        CALL ListAddConstReal(Solver % Values,  &
             'Nonlinear System Relaxation Factor', Relax )
!------------------------------------------------------------------------------
     END DO ! of the nonlinear iteration
!------------------------------------------------------------------------------

     CALL ListAddConstReal(Solver % Values,  &
          'Nonlinear System Tolerance', NonlinearTol)
     !-----------------------------------------------
     ! Average the elemental results to nodal values:
     !-----------------------------------------------
     ExportVar => VariableGet( Solver % Mesh % Variables, TRIM(ExportVariable) )
     IF ( ASSOCIATED( ExportVar ) ) THEN
        n1 = Solver % Mesh % NumberOfNodes
        ALLOCATE( Ref(n1) )
        Ref = 0
           
        IF ( ASSOCIATED( ExportVar % Perm, Solver % Variable % Perm ) ) THEN
           ALLOCATE( ExportVar % Perm(SIZE(Solver % Variable % Perm))  )
           ExportVar % Perm = 0
           DO i = 1,n1
              ExportVar % Perm(i) = i
           END DO
        END IF
           
        ExportVar % Values = 0.0d0
        DO t=1,Solver % NumberOfActiveElements
           Element => GetActiveElement(t) 
           n = GetElementDOFs( Indexes )
           n = GetElementNOFNodes()
           DO i=1,n
              k = Element % NodeIndexes(i)
              ExportVar % Values(k) = ExportVar % Values(k) + &
                   Solver % Variable % Values( Solver % Variable % Perm(Indexes(i)) )
              Ref(k) = Ref(k) + 1
           END DO
        END DO
           
        WHERE( Ref > 0 )
           ExportVar % Values(1:n1) = ExportVar % Values(1:n1) / Ref
        END WHERE
        DEALLOCATE( Ref )
     ELSE
        WRITE(Message,'(A,A,A)') 'Variable >',ExportVariable,'< not found'
        CALL WARN(SolverName,Message)
     END IF

        
   CONTAINS

!------------------------------------------------------------------------------      
     SUBROUTINE LocalMatrix(MASS, STIFF, FORCE, LOAD, Velo, Gamma, Element, n)
!------------------------------------------------------------------------------
       REAL(KIND=dp) :: MASS(:,:), STIFF(:,:), FORCE(:), &
                  LOAD(:), Velo(:,:), Gamma(:)
       INTEGER :: n
       TYPE(Element_t), POINTER :: Element
!------------------------------------------------------------------------------
       REAL(KIND=dp) :: Basis(n),dBasisdx(n,3)
       REAL(KIND=dp) :: detJ,U,V,W,S,A,L,cu(3),g
       LOGICAL :: Stat
       INTEGER :: i,p,q,t,dim
       TYPE(GaussIntegrationPoints_t) :: IntegStuff
       TYPE(Nodes_t) :: Nodes
       SAVE Nodes
!------------------------------------------------------------------------------
       dim = CoordinateSystemDimension()
       FORCE = 0.0d0
       STIFF = 0.0d0
       MASS  = 0.0d0
       CALL GetElementNodes( Nodes, Element )
!------------------------------------------------------------------------------
!      Numerical integration
!------------------------------------------------------------------------------
       IntegStuff = GaussPoints( Element )
 
       DO t=1,IntegStuff % n
         U = IntegStuff % u(t)
         V = IntegStuff % v(t)
         W = IntegStuff % w(t)
         S = IntegStuff % s(t)
!------------------------------------------------------------------------------
!        Basis function values & derivatives at the integration point
!------------------------------------------------------------------------------
         stat = ElementInfo( Element, Nodes, U, V, W, detJ, &
                 Basis, dBasisdx )

         S = S * detJ
         L = SUM( LOAD(1:n) *  Basis(1:n) )
         g = SUM( Basis(1:n) * Gamma(1:n) )

         cu = 0.0d0
         DO i=1,dim
            cu(i) = SUM( Basis(1:n) * Velo(i,1:n) )
         END DO
!------------------------------------------------------------------------------
!        The advection-reaction equation
!------------------------------------------------------------------------------
         DO p=1,n
            DO q=1,n
              MASS(p,q)  = MASS(p,q)  + s * Basis(q) * Basis(p)
              STIFF(p,q) = STIFF(p,q) + s * g * Basis(q) * Basis(p)
              DO i=1,dim
                STIFF(p,q) = STIFF(p,q) - s * cu(i) * Basis(q) * dBasisdx(p,i)
              END DO
            END DO
         END DO
         FORCE(1:n) = FORCE(1:n) + s*L*Basis(1:n)
!------------------------------------------------------------------------------
      END DO
!------------------------------------------------------------------------------
     END SUBROUTINE LocalMatrix
!------------------------------------------------------------------------------


!------------------------------------------------------------------------------
    SUBROUTINE FindParentUVW(Face, nFace, Parent, nParent, U, V, W, Basis)
!------------------------------------------------------------------------------
      IMPLICIT NONE
      TYPE(Element_t) :: Face, Parent
      INTEGER :: nFace, nParent
      REAL( KIND=dp ) :: U, V, W, Basis(:)
!------------------------------------------------------------------------------
      INTEGER :: i,j
      REAL(KIND=dp) :: ParentU(nFace), ParentV(nFace), ParentW(nFace)
!------------------------------------------------------------------------------
      DO i = 1,nFace
        DO j = 1,nParent
          IF ( Face % NodeIndexes(i) == Parent % NodeIndexes(j) ) THEN
            ParentU(i) = Parent % Type % NodeU(j)
            ParentV(i) = Parent % Type % NodeV(j)
            ParentW(i) = Parent % Type % NodeW(j)
            EXIT
          END IF
        END DO
      END DO
      U = SUM( Basis(1:nFace) * ParentU(1:nFace) )
      V = SUM( Basis(1:nFace) * ParentV(1:nFace) )
      W = SUM( Basis(1:nFace) * ParentW(1:nFace) )
!------------------------------------------------------------------------------      
    END SUBROUTINE FindParentUVW
!------------------------------------------------------------------------------      


!------------------------------------------------------------------------------
    SUBROUTINE LocalJumps( STIFF,Face,n,LeftParent,n1,RightParent,n2,Velo )
!------------------------------------------------------------------------------
      IMPLICIT NONE
      REAL(KIND=dp) :: STIFF(:,:), Velo(:,:)
      INTEGER :: n,n1,n2
      TYPE(Element_t), POINTER :: Face, LeftParent, RightParent
!------------------------------------------------------------------------------
      REAL(KIND=dp) :: FaceBasis(n), FacedBasisdx(n,3)
      REAL(KIND=dp) :: LeftBasis(n1), LeftdBasisdx(n1,3)
      REAL(KIND=dp) :: RightBasis(n2), RightdBasisdx(n2,3)
      REAL(KIND=dp) :: Jump(n1+n2), Average(n1+n2)
      REAL(KIND=dp) :: detJ, U, V, W, S, Udotn, xx, yy
      LOGICAL :: Stat
      INTEGER :: i, j, p, q, dim, t, nFace, nParent
      TYPE(GaussIntegrationPoints_t) :: IntegStuff
      REAL(KIND=dp) :: hE, Normal(3), cu(3), LeftOut(3)

      TYPE(Nodes_t) :: FaceNodes, LeftParentNodes, RightParentNodes
      SAVE FaceNodes, LeftParentNodes, RightParentNodes
!------------------------------------------------------------------------------
      dim = CoordinateSystemDimension()
      STIFF = 0.0d0

      CALL GetElementNodes( FaceNodes, Face )
      CALL GetElementNodes( LeftParentNodes,  LeftParent )
      CALL GetElementNodes( RightParentNodes, RightParent )
!------------------------------------------------------------------------------
!     Numerical integration over the edge
!------------------------------------------------------------------------------
      IntegStuff = GaussPoints( Face )

      LeftOut(1) = SUM(LeftParentNodes % x(1:n1)) / n1
      LeftOut(2) = SUM(LeftParentNodes % y(1:n1)) / n1
      LeftOut(3) = SUM(LeftParentNodes % z(1:n1)) / n1
      LeftOut(1) = SUM(FaceNodes % x(1:n)) / n - LeftOut(1)
      LeftOut(2) = SUM(FaceNodes % y(1:n)) / n - LeftOut(2)
      LeftOut(3) = SUM(FaceNodes % z(1:n)) / n - LeftOut(3)

      DO t=1,IntegStuff % n
        U = IntegStuff % u(t)
        V = IntegStuff % v(t)
        W = IntegStuff % w(t)
        S = IntegStuff % s(t)

        ! Basis function values & derivatives at the integration point:
        !--------------------------------------------------------------
        stat = ElementInfo( Face, FaceNodes, U, V, W, detJ, &
             FaceBasis, FacedBasisdx )

        S = S * detJ

        Normal = NormalVector( Face, FaceNodes, U, V, .FALSE. )
        IF ( SUM( LeftOut*Normal ) < 0 ) Normal = -Normal

        ! Find basis functions for the parent elements:
        ! ---------------------------------------------
        CALL FindParentUVW( Face,n,LeftParent,n1,U,V,W,FaceBasis )
        stat = ElementInfo( LeftParent, LeftParentNodes, U, V, W, detJ, &
                LeftBasis, LeftdBasisdx )

        CALL FindParentUVW( Face,n,RightParent,n2,U,V,W,FaceBasis )
        stat = ElementInfo( RightParent, RightParentNodes, U, V, W, detJ, &
              RightBasis, RightdBasisdx )

        ! Integrate jump terms:
        ! ---------------------
        Jump(1:n1) = LeftBasis(1:n1)
        Jump(n1+1:n1+n2) = -RightBasis(1:n2)

        Average(1:n1) = LeftBasis(1:n1) / 2
        Average(n1+1:n1+n2) = RightBasis(1:n2) / 2

        cu = 0.0d0
        DO i=1,dim
          cu(i) = SUM( Velo(i,1:n) * FaceBasis(1:n) )
        END DO
        Udotn = SUM( Normal * cu )

        DO p=1,n1+n2
          DO q=1,n1+n2
            STIFF(p,q) = STIFF(p,q) + s * Udotn * Average(q) * Jump(p)
            STIFF(p,q) = STIFF(p,q) + s * ABS(Udotn)/2 * Jump(q) * Jump(p)
          END DO
        END DO
      END DO
!------------------------------------------------------------------------------
    END SUBROUTINE LocalJumps
!------------------------------------------------------------------------------



!------------------------------------------------------------------------------
    SUBROUTINE LocalMatrixBoundary( STIFF, FORCE, LOAD, &
        Element, n, ParentElement, np, Velo, InFlowBC )
!------------------------------------------------------------------------------
     REAL(KIND=dp) :: STIFF(:,:),  FORCE(:), LOAD(:), Velo(:,:)
     INTEGER :: n, np
     LOGICAL :: InFlowBC
     TYPE(Element_t), POINTER :: Element, ParentElement
!------------------------------------------------------------------------------
     REAL(KIND=dp) :: Basis(n), dBasisdx(n,3)
     REAL(KIND=dp) :: ParentBasis(np), ParentdBasisdx(np,3)
     INTEGER :: i,j,p,q,t,dim

     REAL(KIND=dp) :: Normal(3), g, L, Udotn, cu(3), cu1(3), detJ,U,V,W,S
     LOGICAL :: Stat, Inflow
     TYPE(GaussIntegrationPoints_t) :: IntegStuff

     TYPE(Nodes_t) :: Nodes, ParentNodes
     SAVE Nodes, ParentNodes
!------------------------------------------------------------------------------
     dim = CoordinateSystemDimension()
     FORCE = 0.0d0
     STIFF = 0.0d0
 
     CALL GetElementNodes( Nodes, Element )
     CALL GetElementNodes( ParentNodes, ParentElement )

     Normal = NormalVector( Element, Nodes, 0.0d0, 0.0d0, .TRUE. ) 
     DO i=1,3
       cu(i) = SUM( Velo(i,1:n) ) / n
     END DO
     Inflow = InFlowBC .AND. SUM( Normal * cu ) < 0.0d0

     ! Numerical integration:
     !-----------------------
     IntegStuff = GaussPoints( Element )

     DO t=1,IntegStuff % n
       U = IntegStuff % u(t)
       V = IntegStuff % v(t)
       W = IntegStuff % w(t)
       S = IntegStuff % s(t)

       Normal = NormalVector( Element, Nodes, U, V, .TRUE. ) 

       ! Basis function values & derivatives at the integration point:
       ! -------------------------------------------------------------
       stat = ElementInfo( Element, Nodes, U, V, W, detJ, &
               Basis, dBasisdx )
       S = S * detJ

       CALL FindParentUVW( Element, n, ParentElement, np, U, V, W, Basis )
       stat = ElementInfo( ParentElement, ParentNodes, U, V, W, &
            detJ, ParentBasis, ParentdBasisdx )

       L = SUM( LOAD(1:n) * Basis(1:n) )
       cu = 0.0d0
       DO i=1,dim
          cu(i)  = SUM( Velo(i,1:n) * Basis(1:n) )
       END DO
       Udotn = SUM( Normal * cu )

       DO p = 1,np
         IF ( Inflow ) THEN
            FORCE(p) = FORCE(p) - s * Udotn*L*ParentBasis(p)
         ELSE
           DO q=1,np
             STIFF(p,q) = STIFF(p,q) + s*Udotn*ParentBasis(q)*ParentBasis(p)
           END DO
         END IF
       END DO
     END DO
!------------------------------------------------------------------------------
   END SUBROUTINE LocalMatrixBoundary
!------------------------------------------------------------------------------
 END SUBROUTINE AdvReactSolverLtd
!------------------------------------------------------------------------------

      !
      ! Definition of the interpolation grid 
      !
  
      Module DefGrid

!     INTEGER, PARAMETER :: dp = SELECTED_REAL_KIND(12)  ! If not using
                                                         ! with Elmer   
      USE Types    ! If using with Elmer 
      
      Real, Parameter :: kmin=0.002_dp ! valeur de ki mimum
      Integer, Parameter :: Ndiv=30    ! Ndiv+2 Number of points along ik1
      Integer, Parameter :: Ntot=813   ! Total number of points
      Integer, Parameter :: NetaI=4878 ! 6*4884 length of EtaI
      Integer, Parameter, Dimension(32) :: Nk2 = & 
                (/ -1,  46,  93, 139, 183, 226, 267, 307, 345, 382,&
                 417, 451, 483, 514, 543, 571, 597, 622, 645, 667,& 
                 687, 706, 723, 739, 753, 766, 777, 787, 795, 802,&
                 807, 811/) 
      
      End Module DefGrid
      

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!							              !!!!!!
!!!!!!       Orthotropic Polycrystalline Ice Law from LGGE            !!!!!!
!!!!!! 							              !!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!   give the Voigt viscosity matrix eta36 expressed 
!                                    in the general reference frame
!     Si = Aij dj 
!     Aij = eta36(i,j) i=1,6; j=1,6 non-symetric matrix 
!      where S=(S11,S22,S33,S12,S23,S31)      
!      and   d=(d11,d22,d33,2d12,2d23,2d31)      
!         as in Elmer
!
       
       Subroutine OPILGGE_ai(ki,Angle,Tc,W,etaI,eta36)
       
       USE DEFGRID
       
       Implicit None
       Real(kind=dp), Intent(in), Dimension(3) :: ki       ! Texture parameters 
       Real(kind=dp), Intent(in), Dimension(3) :: Angle    ! Euler Angles        
       Real(kind=dp), Intent(in) :: Tc                     ! Temperature en d Celsius
       Real(kind=dp), Intent(in), Dimension(7) :: W        ! Glen law parameters
       ! W(1)=B0 Glen's fluidity parameter
       ! W(2)=n Glen's law exponent
       ! W(3)=Q1 Energy activation for Tc<Tl
       ! W(4)=Q2 Energy activation for Tc>Tl
       ! W(5)=T0 temperature reference for B0
       ! W(6)=Tl temperature limite for Q1->Q2
       ! W(7)=R  Gas constant
       Real(kind=dp), Intent(in), Dimension(:) :: etaI ! Grid Viscosities 
       Real(kind=dp), Intent(out), Dimension(6,6) :: eta36
       Real(kind=dp), Dimension(6) :: eta6
       Real(kind=dp) :: Bg,BGlenT
       Integer :: i
        
       
       ! Value of the 6 relative viscosities in the orthotropic frame

       Call ViscMat_ai(ki,eta6,etaI)

       ! Non-relative viscosities and temperature dependency

       Bg=BGlenT(Tc,W)

       Do i=1,6
         eta6(i)=eta6(i)/Bg
       End Do


       ! Viscosities in the reference frame

       Call ViscGene(eta6,Angle,eta36)

       End

! Scie (saw) bed 
!
! y = bed(x) and y = d bed(x) / dx
!
! --------------------------------------------------------
      FUNCTION fbed(x)
        USE types
        USE DefUtils
      IMPLICIT NONE
      REAL(KIND=dp) :: fbed,x
      REAL(KIND=dp) :: x0,h,p
      LOGICAL :: FirstTime=.TRUE.
      CHARACTER(len=1) :: Rien
      INTEGER :: i
     
      SAVE FirstTime, x0, h, p
     
      IF (FirstTime) THEN
        FirstTime = .FALSE.
        write(*,*)'----------------------------------------------------'
        write(*,*)'YOU ARE SOLVING THE SCIE/SAW PROBLEM (scie.geo mesh)'
        write(*,*)'----------------------------------------------------'
        Open(10,file='scie0.geo')
        DO i = 1, 5
          Read(10,*)Rien
        END DO
        Read(10,'(5x,e14.8)')x0
        Read(10,'(5x,e14.8)')h 
        Read(10,'(5x,e14.8)')p 
        Close(10)
      END IF

      IF (x<=x0)  THEN
         fbed = p*x
      ELSE
         fbed = p*x - h
      END IF

      END FUNCTION fbed
! --------------------------------------------------------
      FUNCTION dbed(x)
        USE types
        USE DefUtils
      IMPLICIT NONE
      REAL(KIND=dp) :: dbed,x
      REAL(KIND=dp) :: x0,h,p
      LOGICAL :: FirstTime=.TRUE.
      CHARACTER(len=1) :: Rien
      INTEGER :: i
     
      SAVE FirstTime, p
     
      IF (FirstTime) THEN
        FirstTime = .FALSE.
        Open(10,file='scie0.geo')
        DO i = 1, 5
          Read(10,*)Rien
        END DO
        Read(10,'(5x,e14.8)')x0
        Read(10,'(5x,e14.8)')h 
        Read(10,'(5x,e14.8)')p 
        Close(10)
      END IF

      dbed = p 

      END FUNCTION dbed
! --------------------------------------------------------

!
!
!  Function a(D) and b(D) from Gagliardini and Meyssonier, 1997.
!  modified to fulfill the condition 3x a(D) >= 2x b(D) for D > 0.1 
!  for n=3 only 

FUNCTION ParameterA ( Model, nodenumber, D ) RESULT(a)
   USE types
   USE CoordinateSystems
   USE SolverUtils
   USE ElementDescription
   USE DefUtils
   IMPLICIT NONE
   TYPE(Model_t) :: Model
   INTEGER :: nodenumber
   REAL(KIND=dp) :: a, D, DD     

    IF (D >= 1.0_dp) THEN
      a = 1.0_dp           

    ELSE IF (D <= 0.81) THEN
      DD = D
      IF (D < 0.1 ) DD = 0.1_dp
      a = EXP( 16.02784497_dp - 19.25_dp * DD )

    ELSE
      a =  1.0_dp  + 2.0/3.0 * (1.0_dp - D) 
      a = a / ( D**1.5 )

    End If
END FUNCTION ParameterA 


FUNCTION ParameterB ( Model, nodenumber, D ) RESULT(b)
   USE types
   USE CoordinateSystems
   USE SolverUtils
   USE ElementDescription
   USE DefUtils
   IMPLICIT NONE
   TYPE(Model_t) :: Model
   INTEGER :: nodenumber
   REAL(KIND=dp) :: b, D, DD 

    IF (D >= 1.0_dp) THEN
      b = 0.0_dp           

    ELSE IF (D <= 0.81) THEN
      DD = D
      IF (D < 0.1 ) DD = 0.1_dp
      b = EXP( 16.75024378_dp - 22.51_dp * DD )

    ELSE
      b = (1.0_dp - D)**(1.0/3.0) 
      b = 3.0/4.0 * ( b / (3.0 * (1 - b)) )**1.5

    End If
END FUNCTION ParameterB 

MODULE Kinds

    ! IntOff_k is the kind of the file offsets used by ftello and fseeko,
    ! corresponds to a C off_t.
    INTEGER, PARAMETER :: IntOff_k = selected_int_kind(9)

    INTEGER, PARAMETER :: Int4_k = selected_int_kind(9)
    INTEGER, PARAMETER :: Int8_k = selected_int_kind(18)

END MODULE Kinds

!  Copyright (c) December 5 2006 - , CSC - Scientific Computing Ltd., Finland
! 
!  This program is free software; you can redistribute it and/or
!  modify it under the terms of the GNU General Public License
!  as published by the Free Software Foundation; either version 2
!  of the License, or (at your option) any later version.
! 
!  This program is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with this program (in file fem/GPL-2); if not, write to the 
!  Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, 
!  Boston, MA 02110-1301, USA.
!
!
! Wrappers for a bunch of C functions defined in binio.c to read/write
! from/to a binary stream in a portable (independent of endianess) manner.
!
! The OPTIONAL 'Status' argument, if PRESENT, will be set to > 0 for error (use
! StrErrorF to create meaningful error messages), 0 for sucess and (for the
! BinRead* procedures) -1 for end-of-file.  If .NOT.PRESENT(Status), then, on
! error, an error message will be written and the program terminated.
!
MODULE BinIO

    USE Kinds

    IMPLICIT NONE

    ! TODO: Use some kind of autoconf magic to set these to the C parameters
    ! SEEK_SET etc. That way we could pass the directly onwards to fseeko in the
    ! C code.
    INTEGER, PARAMETER :: BIN_SEEK_SET = 0, BIN_SEEK_CUR = 1, BIN_SEEK_END = 2

    INTERFACE
        FUNCTION BinFTell( Unit )
            USE Kinds
            INTEGER, INTENT(IN) :: Unit
            INTEGER(IntOff_k) :: BinFTell
        END FUNCTION BinFTell

        SUBROUTINE BinFSeek( Unit, Offset, Whence )
            USE Kinds
            INTEGER, INTENT(IN) :: Unit
            INTEGER(IntOff_k), INTENT(IN) :: Offset
            INTEGER, INTENT(IN) :: Whence
        END SUBROUTINE BinFSeek

        SUBROUTINE BinEndianess(e)
            CHARACTER(len=1), INTENT(OUT) :: e
        END SUBROUTINE BinEndianess
    END INTERFACE

    PRIVATE :: HandleStatus

CONTAINS

    SUBROUTINE HandleStatus( Status, Status_, MsgPrefix )
        INTEGER, OPTIONAL, INTENT(OUT) :: Status
        INTEGER, INTENT(IN) :: Status_
        CHARACTER(LEN=*), INTENT(IN) :: MsgPrefix
        CHARACTER(LEN=100) :: Msg
        INTEGER, PARAMETER :: STDERR = 0

        IF ( PRESENT( Status ) ) THEN
            Status = Status_
        ELSE
            IF ( Status_ > 0 ) THEN
                CALL StrErrorF( Status_, Msg )
                WRITE( STDERR, * ) TRIM(MsgPrefix) // ": " // TRIM(Msg)
                STOP
            END IF
        END IF
    END SUBROUTINE HandleStatus


    SUBROUTINE BinOpen( Unit, File, Action, Status )
        INTEGER, INTENT(IN) :: Unit
        CHARACTER(*), INTENT(IN) :: File
        CHARACTER(*), INTENT(IN) :: Action ! "write", "append" or "read"
        INTEGER, OPTIONAL, INTENT(OUT) :: Status
        INTEGER :: Status_

        CALL BinOpen_( Unit,TRIM(File),LEN_TRIM(File),Action,Status_ )
        CALL HandleStatus( Status, Status_, "BINIO: Can't open file " &
                                            // TRIM(File) )
    END SUBROUTINE BinOpen


    SUBROUTINE BinClose( Unit, Status )
        INTEGER, INTENT(IN) :: Unit
        INTEGER, OPTIONAL, INTENT(OUT) :: Status
        INTEGER :: Status_
        
        CALL BinClose_( Unit, Status_ )
        CALL HandleStatus( Status, Status_, "BINIO: Can't close file" )
    END SUBROUTINE BinClose


    SUBROUTINE BinWriteInt4( Unit, a, Status )
        INTEGER, INTENT(IN) :: Unit
        INTEGER(Int4_k), INTENT(IN) :: a
        INTEGER, OPTIONAL, INTENT(OUT) :: Status
        INTEGER :: Status_

        CALL BinWriteInt4_( Unit, a, Status_ )
        CALL HandleStatus( Status, Status_, "BINIO: Error writing Int4" )
    END SUBROUTINE BinWriteInt4


    SUBROUTINE BinReadInt4( Unit, a, Status )
        INTEGER, INTENT(IN) :: Unit
        INTEGER(Int4_k), INTENT(OUT) :: a
        INTEGER, OPTIONAL, INTENT(OUT) :: Status
        INTEGER :: Status_

        CALL BinReadInt4_( Unit, a, Status_ )
        CALL HandleStatus( Status, Status_, "BINIO: Error reading Int4" )
    END SUBROUTINE BinReadInt4


    SUBROUTINE BinWriteInt8( Unit, a, Status )
        INTEGER, INTENT(IN) :: Unit
        INTEGER(Int8_k), INTENT(IN) :: a
        INTEGER, OPTIONAL, INTENT(OUT) :: Status
        INTEGER :: Status_

        CALL BinWriteInt8_( Unit, a, Status_ )
        CALL HandleStatus( Status, Status_, "BINIO: Error writing Int8" )
    END SUBROUTINE BinWriteInt8


    SUBROUTINE BinReadInt8( Unit, a, Status )
        INTEGER, INTENT(IN) :: Unit
        INTEGER(Int8_k), INTENT(OUT) :: a
        INTEGER, OPTIONAL, INTENT(OUT) :: Status
        INTEGER :: Status_

        CALL BinReadInt8_( Unit, a, Status_ )
        CALL HandleStatus( Status, Status_, "BINIO: Error reading Int8" )
    END SUBROUTINE BinReadInt8


    SUBROUTINE BinWriteDouble( Unit, a, Status )
        INTEGER, INTENT(IN) :: Unit
        DOUBLE PRECISION, INTENT(IN) :: a
        INTEGER, OPTIONAL, INTENT(OUT) :: Status
        INTEGER :: Status_

        CALL BinWriteDouble_( Unit, a, Status_ )
        CALL HandleStatus( Status, Status_, "BINIO: Error writing Double" )
    END SUBROUTINE BinWriteDouble


    SUBROUTINE BinReadDouble( Unit, a, Status )
        INTEGER, INTENT(IN) :: Unit
        DOUBLE PRECISION, INTENT(OUT) :: a
        INTEGER, OPTIONAL, INTENT(OUT) :: Status
        INTEGER :: Status_

        CALL BinReadDouble_( Unit, a, Status_ )
        CALL HandleStatus( Status, Status_, "BINIO: Error reading Double" )
    END SUBROUTINE BinReadDouble


    ! Write a CHARACTER(1).  (Note: to read a CHARACTER(1), with no '\0' at the
    ! end, just use BinReadString with a CHARACTER(1) as argument.
    SUBROUTINE BinWriteChar( UNIT, c, Status )
        INTEGER, INTENT(IN) :: Unit
        CHARACTER, INTENT(IN) :: c
        INTEGER, OPTIONAL, INTENT(OUT) :: Status
        INTEGER :: Status_

        CALL BinWriteChar_( Unit, c, Status_ )
        CALL HandleStatus( Status, Status_, "BINIO: Error writing char" )
    END SUBROUTINE BinWriteChar


    ! Write 's' to file pointed to by 'unit', and append a '\0'.
    SUBROUTINE BinWriteString( UNIT, s, Status )
        INTEGER, INTENT(IN) :: Unit
        CHARACTER(*), INTENT(IN) :: s
        INTEGER, OPTIONAL, INTENT(OUT) :: Status
        INTEGER :: Status_

        CALL BinWriteString_( Unit, s, LEN(s), Status_ )
        CALL HandleStatus( Status, Status_, "BINIO: Error writing string" )
    END SUBROUTINE BinWriteString

    ! Read bytes up to next NULL byte (but no more than len(s)) into 's'
    ! from file pointed to by 'unit', and pad with spaces. The NULL byte
    ! will be removed from the stream, but not added to 's'.
    SUBROUTINE BinReadString( Unit, s, Status )
        INTEGER, INTENT(IN) :: Unit
        CHARACTER(*), INTENT(OUT) :: s
        INTEGER, OPTIONAL, INTENT(OUT) :: Status
        INTEGER :: Status_

        CALL BinReadString_( Unit, s, LEN(s), Status_ )
        CALL HandleStatus( Status, Status_, "BINIO: Error reading string" )
    END SUBROUTINE BinReadString

    ! Return a string representation of the error code 'e' (as returned in a
    ! status variable) in 's'. (Actually just a wrapper to the C function
    ! strerror().)
    SUBROUTINE StrErrorF( e, s )
        INTEGER, INTENT(IN) :: e
        CHARACTER(*), INTENT(OUT) :: s

        CALL StrErrorF_( e, s, LEN(s) )
    END SUBROUTINE StrErrorF

END MODULE BinIO

! Sinus bed 
!
! y = bed(x) and y = d bed(x) / dx
!
! --------------------------------------------------------
      FUNCTION fbed(x)
        USE types
        USE DefUtils
      IMPLICIT NONE
      REAL(KIND=dp) :: fbed,x
      REAL(KIND=dp) :: x0,h,Lf
      LOGICAL :: FirstTime=.TRUE.
      CHARACTER(len=1) :: Rien
      INTEGER :: i
     
      SAVE FirstTime, x0, h, Lf
     
      IF (FirstTime) THEN
        FirstTime = .FALSE.
        write(*,*)'--------------------------------------------------'
        write(*,*)'YOU ARE SOLVING THE SINUS PROBLEM (sinus.geo mesh)'
        write(*,*)'--------------------------------------------------'
        Open(10,file='sinus0.geo')
        DO i = 1, 5
          Read(10,*)Rien
        END DO
        Read(10,'(5x,e14.8)')x0
        Read(10,'(5x,e14.8)')h 
        Read(10,'(5x,e14.8)')Lf
        Close(10)
      END IF

         fbed = 0.5*h*cos(2.*Pi/Lf*(x-x0)) 

      END FUNCTION fbed
! --------------------------------------------------------
      FUNCTION dbed(x)
        USE types
        USE DefUtils
      IMPLICIT NONE
      REAL(KIND=dp) :: dbed,x
      REAL(KIND=dp) :: x0,h,Lf
      LOGICAL :: FirstTime=.TRUE.
      CHARACTER(len=1) :: Rien
      INTEGER :: i
     
      SAVE FirstTime, x0, h, Lf
     
      IF (FirstTime) THEN
        FirstTime = .FALSE.
        Open(10,file='sinus0.geo')
        DO i = 1, 5
          Read(10,*)Rien
        END DO
        Read(10,'(5x,e14.8)')x0
        Read(10,'(5x,e14.8)')h 
        Read(10,'(5x,e14.8)')Lf
        Close(10)
      END IF

      dbed = -h*Pi/Lf*sin(2.*Pi/Lf*(x-x0)) 

      END FUNCTION dbed
! --------------------------------------------------------

FUNCTION Youngs( Model, n, x ) RESULT( s )
!DEC$ATTRIBUTES DLLEXPORT :: Youngs
  USE Types
  TYPE(Model_t) :: Model
  INTEGER :: n
  REAL(KIND=dp) :: x,s,s1,s2,s3,xx,yy
  
  xx = Model % Nodes % x(n)
  yy = Model % Nodes % y(n)
  
  s =  1.0d0 / SQRT( (xx-11.0)**2 + (yy-4.9)**2 )
  
END FUNCTION Youngs


FUNCTION InFlow( Model, n, x ) RESULT( vin )
!DEC$ATTRIBUTES DLLEXPORT :: InFlow
  USE Types
  TYPE(Model_t) :: Model
  INTEGER :: n
  REAL(KIND=dp) :: yy,x,vin,v0,vt
  
  xx = Model % Nodes % x(n)
  yy = Model % Nodes % y(n)
  
  v0 = (-(yy**2)+10*yy)/25
  
  IF(x < 8.0) THEN
    vt = x/8.0
  ELSE
    vt = 1.0
  END IF
  
  vin = v0*vt
END FUNCTION InFlow

!/******************************************************************************
! *
! *       ELMER, A Computational Fluid Dynamics Program.
! *
! *       Copyright 1st April 1995 - , Center for Scientific Computing,
! *                                    Finland.
! *
! *       All rights reserved. No part of this program may be used,
! *       reproduced or transmitted in any form or by any means
! *       without the written permission of CSC.
! *
! *****************************************************************************/
!
!/******************************************************************************
! *
! * Module containing a solver for a genral advection diffusion problem
! *
! ******************************************************************************
! *
! *                     Author:       Juha Ruokolainen
! *
! *                    Address: Center for Scientific Computing
! *                                Tietotie 6, P.O. BOX 405
! *                                  02101 Espoo, Finland
! *                                  Tel. +358 0 457 2723
! *                                Telefax: +358 0 457 2302
! *                              EMail: Juha.Ruokolainen@csc.fi
! *
! *                       Date: 08 Jun 1997
! *
! *                Modified by: Thomas Zwinger
! *
! *       Date of modification: 28 Nov 2005
! *
! *****************************************************************************/

!------------------------------------------------------------------------------
   RECURSIVE SUBROUTINE HomologousTempSolver( Model,Solver,Timestep,TransientSimulation )
!DLLEXPORT HomologousTempSolver
!------------------------------------------------------------------------------
!******************************************************************************
!
!  Solve the convection diffusion equation with limiters!
!
!  ARGUMENTS:
!
!  TYPE(Model_t) :: Model,  
!     INPUT: All model information (mesh,materials,BCs,etc...)
!
!  TYPE(Solver_t) :: Solver
!     INPUT: Linear equation solver options
!
!  REAL(KIND=dp) :: Timestep
!     INPUT: Timestep size for time dependent simulations
!
!******************************************************************************
     USE DiffuseConvective
     USE DiffuseConvectiveGeneral
     USE Differentials
     USE MaterialModels

!     USE Adaptive
     USE DefUtils

!------------------------------------------------------------------------------
     IMPLICIT NONE
!------------------------------------------------------------------------------

     TYPE(Model_t)  :: Model
     TYPE(Solver_t), TARGET :: Solver

     LOGICAL :: TransientSimulation
     REAL(KIND=dp) :: Timestep
!------------------------------------------------------------------------------
!    Local variables
!------------------------------------------------------------------------------
     TYPE(Solver_t), POINTER :: PointerToSolver
     TYPE(Matrix_t), POINTER :: StiffMatrix
     TYPE(Nodes_t)   :: ElementNodes
     TYPE(Element_t),POINTER :: Element,ParentElement
     TYPE(Variable_t), POINTER :: TempSol,FlowSol,CurrentSol, MeshSol
     TYPE(ValueList_t), POINTER :: Equation,Material,SolverParams,BodyForce,BC,Constants

     INTEGER :: i,j,k,l,m,n,t,tt,iter,k1,k2,body_id,eq_id,material_id, &
          istat, LocalNodes,bf_id, bc_id, other_body_id, DIM, &
          NSDOFs,NewtonIter,NonlinearIter, NOFControlHeaters, &
          NumberOfBoundaryNodes
     INTEGER, POINTER :: NodeIndexes(:), TempPerm(:),FlowPerm(:),CurrentPerm(:),MeshPerm(:)
     INTEGER, ALLOCATABLE :: BoundaryMap(:)

     CHARACTER(LEN=MAX_NAME_LEN) :: ConvectionFlag, VariableName, SolverName

     LOGICAL :: Stabilize = .TRUE., Bubbles = .TRUE., UseBubbles, &
          NewtonLinearization = .FALSE., Found, FluxBC, Permeable=.TRUE., &
          AllocationsDone = .FALSE.,  SubroutineVisited = .FALSE., FirstTime=.TRUE.,&
          CorrectNegative, LimitSolution
     LOGICAL, ALLOCATABLE :: IsBoundaryNode(:), LimitedSolution(:,:)

     REAL(KIND=dp) :: NonlinearTol,NewtonTol,NonLinearTolMin,NonLinearTolDegrease, &
           OldNonlinearTol, Relax, RelaxIncrease, RelaxMax, &
          SaveRelax,dt,CumulativeTime, RelativeChange, &
          Norm,PrevNorm,S,C, &
          ReferencePressure=0.0d0, UzawaParameter, &
          HeatCapacityGradient(3)
     

     REAL(KIND=dp), POINTER :: Temp(:),FlowSolution(:), &
          ForceVector(:), &
          PrevSolution(:), HC(:), Hwrk(:,:,:), &
          SlipVelocityX(:), SlipVelocityY(:), SlipVelocityZ(:), PointerOnSlipVelocity(:), &
          PointerOnLagrange(:)
     
     REAL(KIND=dp), ALLOCATABLE :: MASS(:,:), &
       STIFF(:,:), LOAD(:), HeatConductivity(:,:,:), &
         FORCE(:), Pressure(:),  MeshVelocity(:,:),&
         TempVeloU(:),TempVeloV(:),TempVeloW(:),TimeForce(:), &
         TransferCoeff(:), LocalTemp(:), Work(:), C1(:), C0(:), Zero(:), Viscosity(:),&
         UpperLimit(:),LowerLimit(:),LagrangeMultiplier1(:),LagrangeMultiplier2(:), &
         HeatCapacity(:), PrevHeatCapacity(:), Density(:), TempExt(:)
     REAL(KIND=dp), ALLOCATABLE, TARGET :: VarSlipVelocity(:)
     REAL(KIND=dp) :: at,at0,totat,st,totst,t1,CPUTime,RealTime

     SAVE MeshVelocity,  &
          TempVeloU, TempVeloV, TempVeloW,&
          MASS, STIFF, LOAD, FORCE,&
          ElementNodes, Hwrk, HeatConductivity, TransferCoeff, &
          AllocationsDone, FirstTime, TimeForce, &
          LocalNodes, LocalTemp, Work, Zero, Viscosity, Dim, Norm, &
          C0, C1, Pressure, CorrectNegative, VariableName, SolverName, &
          UpperLimit, LowerLimit,LagrangeMultiplier1, LagrangeMultiplier2, &
          IsBoundaryNode, BoundaryMap, NumberOfBoundaryNodes, &
          LimitSolution, LimitedSolution, M, HeatCapacity, PrevHeatCapacity, Density, &
          TempExt, OldNonlinearTol, NonLinearTolMin,NonLinearTolDegrease

!------------------------------------------------------------------------------
!    Get variables needed for solution
!------------------------------------------------------------------------------
     IF ( .NOT. ASSOCIATED( Solver % Matrix ) ) RETURN
     StiffMatrix => Solver % Matrix
     ForceVector => Solver % Matrix % RHS

     PointerToSolver => Solver

     TempSol => Solver % Variable
     TempPerm  => TempSol % Perm
     Temp => TempSol % Values
     
     LocalNodes = COUNT( TempPerm > 0 )
     IF ( LocalNodes <= 0 ) RETURN
     
     FlowSol => VariableGet( Solver % Mesh % Variables, 'Flow Solution' )
     IF ( ASSOCIATED( FlowSol ) ) THEN
        FlowPerm     => FlowSol % Perm
        NSDOFs       =  FlowSol % DOFs
        FlowSolution => FlowSol % Values
     END IF

!------------------------------------------------------------------------------
!    Allocate some permanent storage, this is done first time only
!------------------------------------------------------------------------------
     IF ( .NOT. AllocationsDone .OR. Solver % Mesh % Changed ) THEN
        N = Solver % Mesh % MaxElementNodes
        M = Model % Mesh % NumberOfNodes
        DIM = CoordinateSystemDimension()
        SolverName = 'HomologousTemp ('// TRIM(Solver % Variable % Name) // ')'
        VariableName = TRIM(Solver % Variable % Name)

        IF ( AllocationsDone ) THEN
           DEALLOCATE(                 &
                MeshVelocity,          &
                TempVeloU,             &
                TempVeloV,             &
                TempVeloW,             &
                Pressure,              &
                ElementNodes % x,      &
                ElementNodes % y,      &
                ElementNodes % z,      &
                Work,Zero,             &
                Viscosity,             &
                HeatCapacity,          &
                PrevHeatCapacity,      &
                Density,               &
                TempExt,                  &
                C1,                    &
                C0,                    &
                TransferCoeff,         &
                LocalTemp,             &
                HeatConductivity,      &
                MASS,                  &
                STIFF,LOAD,            &
                FORCE,                 &
                TimeForce,             &
                LagrangeMultiplier1,   &
                LagrangeMultiplier2,   &
                LowerLimit,            &
                UpperLimit,            &
                IsBoundaryNode,        &
                LimitedSolution,       &
                BoundaryMap)
        END IF
        
        ALLOCATE(                                  &
             MeshVelocity( 3,N ),                  &
             TempVeloU( N ),                       &
             TempVeloV( N ),                       &
             TempVeloW( N ),                       &
             Pressure( N ),                        &
             ElementNodes % x( N ),                &
             ElementNodes % y( N ),                &
             ElementNodes % z( N ),                &
             Work( N ), Zero( N ),                 &
             Viscosity( N ),                       &
             HeatCapacity( M ),                    &
             PrevHeatCapacity( M ),                &
             Density( N ),                         &
             TempExt( N ),                         &
             C1(N),                                &
             C0(N),                                &
             TransferCoeff( N ),                   &
             LocalTemp( N ),                       &
             HeatConductivity( 3,3,N ),            &
             MASS(  2*N,2*N ),                     &
             STIFF( 2*N,2*N ),LOAD( N ),           &
             FORCE( 2*N ), TimeForce(2*N),         &
             LagrangeMultiplier1(M),               &
             LagrangeMultiplier2(M),               &
             LowerLimit(M),                        &
             UpperLimit(M),                        &
             IsBoundaryNode(M),                    &
             LimitedSolution(2,M),                 &
             BoundaryMap(M),                       &
             STAT=istat )


        IF ( istat /= 0 ) THEN
           CALL Fatal( SolverName, 'Memory allocation error' )
        ELSE
           CALL INFO(SolverName, 'Memory allocation done', level=1 )
        END IF
        
        
        LagrangeMultiplier1 = 0.0d0
        LagrangeMultiplier2 = 0.0d0

       
        ! Assign Variable for Lagrangemultiplier1
        !       PointerOnLagrange => LagrangeMultiplier1(1:LocalNodes)
!        CALL VariableAdd( Solver % Mesh % Variables, Solver % Mesh, PointerToSolver, &
!             TRIM(Solver % Variable % Name) // ' Lower Limit Lagrange', 1, LagrangeMultiplier1(1:LocalNodes), TempPerm)
!       PointerOnLagrange => LagrangeMultiplier2(1:LocalNodes)
!        CALL VariableAdd( Solver % Mesh % Variables, Solver % Mesh, PointerToSolver, &
!             TRIM(Solver % Variable % Name) // ' Upper Limit Lagrange', 1, LagrangeMultiplier2(1:LocalNodes), TempPerm)

        !-----------------------------------
        
        ! Get Information on Boundary Nodes
        !----------------------------------
        IsBoundaryNode = .FALSE.
        BoundaryMap = 0
        
        DO t=1, Solver % Mesh % NumberOfBoundaryElements
           Element => GetBoundaryElement(t,Solver)
           IF (ActiveBoundaryElement(Element)) THEN
              n = GetElementNOFNodes(Element)
              IsBoundaryNode(Element % NodeIndexes(1:N)) = .TRUE.
           ELSE
              IsBoundaryNode = .FALSE.
           END IF
        END DO
       
        ! Get Bulk to Boundary Mapping
        !-----------------------------
        NumberOfBoundaryNodes = 0
        DO i=1,M
           IF (IsBoundaryNode(i)) THEN
              NumberOfBoundaryNodes = NumberOfBoundaryNodes + 1
              BoundaryMap(i) = NumberOfBoundaryNodes
           END IF
        END DO
        
        NULLIFY( Hwrk )
        
        AllocationsDone = .TRUE.
     END IF

!------------------------------------------------------------------------------
!    Say hello
!------------------------------------------------------------------------------
     WRITE(Message,'(A,A)')&
          'Homologous Temperature Solver for variable', VariableName
     CALL INFO(SolverName,Message,Level=1)

!------------------------------------------------------------------------------
!    Read physical and numerical constants and initialize 
!------------------------------------------------------------------------------
     Constants => GetConstants()
     SolverParams => GetSolverParams()

     Stabilize = GetLogical( SolverParams,'Stabilize',Found )
     IF (.NOT. Found) Stabilize = .FALSE.
     UseBubbles = GetLogical( SolverParams,'Bubbles',Found )
     IF ( .NOT.Found .AND. (.NOT.Stabilize)) UseBubbles = .TRUE.

     NonlinearIter = GetInteger(   SolverParams, &
                     'Nonlinear System Max Iterations', Found )
     IF ( .NOT.Found ) NonlinearIter = 1

     IF (FirstTime) THEN
        NonlinearTol  = GetConstReal( SolverParams, &
                     'Nonlinear System Convergence Tolerance',    Found )

        OldNonlinearTol = NonlinearTol  
        NonlinearTolDegrease = GetConstReal( SolverParams, &
             'Nonlinear System Convergence Tolerance Degrease',    Found )
        IF (.NOT.Found) NonlinearTolDegrease = 1.0D00

        NonlinearTolMin  = GetConstReal( SolverParams, &
             'Nonlinear System Convergence Tolerance Min',    Found )
     
        IF (.NOT.Found) NonlinearTolDegrease = 1.0D00
        
     END  IF

     NewtonTol     = GetConstReal( SolverParams, &
                      'Nonlinear System Newton After Tolerance',  Found )
     NewtonIter    = GetInteger(   SolverParams, &
                      'Nonlinear System Newton After Iterations', Found )

     Relax = GetConstReal( SolverParams, &
               'Nonlinear System Relaxation Factor',Found )

     IF ( .NOT.Found ) Relax = 1.0D00

     RelaxIncrease = GetConstReal( SolverParams, &
          'Nonlinear System Relaxation Factor Increase',Found )
     IF (.NOT.Found) RelaxIncrease = 1.0D00

     RelaxMax = GetConstReal( SolverParams, &
          'Nonlinear System Relaxation Factor Max',Found )
     IF (.NOT.Found) RelaxMax = Relax     

     UzawaParameter = GetConstReal( SolverParams, &
               'Uzawa Parameter', Found)
     IF (.NOT.Found) THEN                
        LimitSolution = .FALSE.
        CALL INFO(SolverName, 'No Uzawa Parameter found. No limitting of solution', level=1)
     ELSE
        WRITE(Message,'(a,e13.4)') 'Uzawa Parameter:',  UzawaParameter
        CALL INFO(SolverName, Message, level=1)
        LimitSolution = .TRUE.
     END IF

     SaveRelax = Relax
     dt = Timestep
     CumulativeTime = 0.0d0


!------------------------------------------------------------------------------
!   time stepping loop.
!------------------------------------------------------------------------------
     DO WHILE( CumulativeTime < Timestep-1.0d-12 .OR. .NOT. TransientSimulation )

!------------------------------------------------------------------------------
!       The first time around this has been done by the caller...
!------------------------------------------------------------------------------
        IF ( TransientSimulation .AND. .NOT.FirstTime ) THEN
           CALL InitializeTimestep( Solver )
        END IF

!------------------------------------------------------------------------------
!       Save current solution
!------------------------------------------------------------------------------
        ALLOCATE( PrevSolution(LocalNodes) )
        PrevSolution = Temp(1:LocalNodes)

        totat = 0.0d0
        totst = 0.0d0
        IF (.NOT.FirstTime) THEN
           WRITE( Message, * ) 'Nonlinear Tolerance: old:',OldNonLinearTol,&
                ' new:', MAX(NonLinearTolMin,OldNonLinearTol*NonLinearTolDegrease)
           CALL Info( SolverName, Message, Level=4 )
           NonLinearTol = MAX(NonLinearTolMin,OldNonLinearTol*NonLinearTolDegrease)
           OldNonLinearTol = NonLinearTol
        ELSE
           WRITE( Message, * ) 'Nonlinear Tolerance at start:',NonLinearTol
           CALL Info( SolverName, Message, Level=4 )
           OldNonLinearTol = NonLinearTol
        END IF
!------------------------------------------------------------------------------
!       non-linear system iteration loop
!------------------------------------------------------------------------------
        DO iter=1,NonlinearIter

           IF (.NOT.FirstTime) THEN
              WRITE( Message, * ) 'Relaxation Factor: old:',Relax,&
                   ' new:', MIN(RelaxMax,Relax * Relaxincrease) 
              CALL Info( SolverName, Message, Level=4 )
              Relax = MIN(RelaxMax,Relax * Relaxincrease)
           ELSE
              WRITE( Message, * ) 'Relaxation Factor:',Relax
              CALL Info( SolverName, Message, Level=4 )
           END IF

           FirstTime = .FALSE.


           at  = CPUTime()
           at0 = RealTime()

           CALL Info( SolverName, ' ', Level=4 )
           CALL Info( SolverName, ' ', Level=4 )
           CALL Info( SolverName, '-------------------------------------',Level=4 )
           WRITE( Message,'(A,A,I3,A,I3)') &
                TRIM(Solver % Variable % Name),  ' iteration no.', iter,' of ',NonlinearIter
           CALL Info( SolverName, Message, Level=4 )
           CALL Info( SolverName, '-------------------------------------',Level=4 )
           CALL Info( SolverName, ' ', Level=4 )
           CALL Info( SolverName, 'Starting Assembly...', Level=4 )

!------------------------------------------------------------------------------
           CALL DefaultInitialize()

!-----------------------------------------------------------------------------
!      Update Lagrange multiplier:
!-----------------------------------------------------------------------------
           IF (LimitSolution) THEN
              LowerLimit = 0.0d00
              UpperLimit = 0.0d00

              LimitedSolution = .TRUE.

              ! Get lower and Upper limit

              DO t=1,Solver % NumberOfActiveElements
                 Element => GetActiveElement(t)
                 n = GetElementNOFNodes()
                 CALL GetElementNodes( ElementNodes )
                 Material => GetMaterial()
                 ! lower limit
                 !------------
                 LowerLimit(Element % Nodeindexes(1:N)) = ListGetReal(Material,TRIM(Solver % Variable % Name) // & 
                      ' Lower Limit',n,Element % NodeIndexes, Found)
                 IF (.NOT.Found) THEN
                    LimitedSolution(1,Element % Nodeindexes(1:N)) = .FALSE.
                    WRITE(Message,'(a,i)') 'No lower limit of solution for element no. ', t
                    CALL INFO(SolverName, Message, level=9)
                 END IF                 
                 ! upper limit
                 !------------
                 UpperLimit(Element % Nodeindexes(1:N)) = ListGetReal(Material,TRIM(Solver % Variable % Name) // & 
                      ' Upper Limit',n,Element % NodeIndexes, Found)
                 IF (.NOT. Found) THEN
                    LimitedSolution(2,Element % Nodeindexes(1:N)) = .FALSE.
                    WRITE(Message,'(a,i)') 'No upper limit of solution for element no. ', t
                    CALL INFO(SolverName, Message, level=9)
                 END IF
              END DO


              ! get Lagrange Multipliers
              ! ------------------------
              DO i = 1,M
                 ! upper limit
                 !------------
                 IF (LimitedSolution(2,i)) THEN
                    LagrangeMultiplier2(i) = MAX( 0.0d0, LagrangeMultiplier2(i) + UzawaParameter * &
                         (Temp(TempPerm(i)) - UpperLimit(i)))
!                    LagrangeMultiplier2(i) = MAX( 0.0d0,  UzawaParameter * (Temp(TempPerm(i)) - UpperLimit(i)))
                 ELSE 
                    LagrangeMultiplier2(i) = 0.0d00
                 END IF
                 ! lower limit
                 !-----------
                 IF (LimitedSolution(1,i)) THEN
                    LagrangeMultiplier1(i) = MIN( 0.0d0, LagrangeMultiplier1(i) + UzawaParameter * &
                         ( Temp(TempPerm(i)) - LowerLimit(i)))
!                    LagrangeMultiplier2(i) = MIN( 0.0d0,  UzawaParameter * (Temp(TempPerm(i)) - LowerLimit(i)))
                 ELSE
                    LagrangeMultiplier1(i) = 0.0d00
                 END IF
              END DO
           END IF

           CALL INFO(SolverName,'Max/min values Lagrange multiplier ...',Level=4)
           WRITE(Message,'(a,e13.6,a,e13.6)') &
                '... for lower constraint:', MAXVAL( LagrangeMultiplier1(:) ),'/',MINVAL( LagrangeMultiplier1(:) )
           CALL INFO(SolverName,Message,Level=4)
           WRITE(Message,'(a,e13.6,a,e13.6)') &
                '... or upper constraint:', MAXVAL( LagrangeMultiplier2(:) ),'/',MINVAL( LagrangeMultiplier2(:) )
           CALL INFO(SolverName,Message,Level=4)
           WRITE(Message,'(a,e13.6,a,e13.6)') &
                'Max/min values Temperature:', MAXVAL( Temp(:)),'/',MINVAL( Temp(:))
           CALL INFO(SolverName,Message,Level=4)
!------------------------------------------------------------------------------
           body_id = -1
           NULLIFY(Material)

!           PRINT *, 'Lagr.:', Norm, Solver % Variable % Norm 
!------------------------------------------------------------------------------
!      Bulk elements
!------------------------------------------------------------------------------
           DO t=1,Solver % NumberOfActiveElements

              IF ( RealTime() - at0 > 1.0 ) THEN
                 WRITE(Message,'(a,i3,a)' ) '   Assembly: ', INT(100.0 - 100.0 * &
                      (Solver % NumberOfActiveElements-t) / &
                      (1.0*Solver % NumberOfActiveElements)), ' % done'

                 CALL Info( SolverName, Message, Level=5 )

                 at0 = RealTime()
              END IF
!------------------------------------------------------------------------------
!             Check if this element belongs to a body where scalar equation
!             should be calculated
!------------------------------------------------------------------------------
              Element => GetActiveElement(t,Solver)
              IF (.NOT.ActiveBoundaryElement(Element,Solver)) CYCLE
!------------------------------------------------------------------------------
              IF ( Element % BodyId /= body_id ) THEN
!------------------------------------------------------------------------------
                 Equation => GetEquation()
                 IF (.NOT.ASSOCIATED(Equation)) THEN
                    WRITE (Message,'(A,I3)') 'No Equation  found for boundary element no. ', t
                    CALL FATAL(SolverName,Message)
                 END IF

                 ConvectionFlag = GetString( Equation, 'Convection', Found )

                 Material => GetMaterial()
                 IF (.NOT.ASSOCIATED(Material)) THEN
                    WRITE (Message,'(A,I3)') 'No Material found for boundary element no. ', t
                    CALL FATAL(SolverName,Message)
                 ELSE
                    material_id = GetMaterialId( Element, Found)
                    IF(.NOT.Found) THEN
                       WRITE (Message,'(A,I3)') 'No Material ID found for boundary element no. ', t
                       CALL FATAL(SolverName,Message)
                    END IF
                 END IF

!------------------------------------------------------------------------------            
              END IF
!------------------------------------------------------------------------------
              
              N = GetElementNOFNodes(Element)
              CALL GetElementNodes( ElementNodes )

!              CALL GetTempLocalSolution( LocalTemp )
!------------------------------------------------------------------------------
!             Get element material parameters
!------------------------------------------------------------------------------
              CALL ListGetRealArray( Material,TRIM(Solver % Variable % Name) // &
                   ' Heat Conductivity',Hwrk,n, Element % NodeIndexes )

              HeatConductivity = 0.0d0
              IF ( SIZE(Hwrk,1) == 1 ) THEN
                 DO i=1,3
                    HeatConductivity( i,i,1:N ) = Hwrk( 1,1,1:N)
                 END DO
              ELSE IF ( SIZE(Hwrk,2) == 1 ) THEN
                 DO i=1,MIN(3,SIZE(Hwrk,1))
                    HeatConductivity(i,i,1:N) = Hwrk(i,1,1:N)
                 END DO
              ELSE
                 DO i=1,MIN(3,SIZE(Hwrk,1))
                    DO j=1,MIN(3,SIZE(Hwrk,2))
                       HeatConductivity(i,j,1:N) = Hwrk(i,j,1:N)
                    END DO
                 END DO
              END IF

              HeatCapacity(1:N) =  ListGetReal( Material,  TRIM(Solver % Variable % Name) // &
                   ' Heat Capacity', n, Element % NodeIndexes, Found )
              IF (.NOT.Found) THEN
                 HeatCapacity = 0.0D00
                 WRITE(Message,'(a,a,a,i5,a,i5,a)') 'Keyword >', TRIM(Solver % Variable % Name) // &
                   ' Heat Capacity', '< not found for element ', t, ' material ', material_id
                 CALL INFO(SolverName,Message,Level=4)
              END IF

               Density(1:N) = ListGetReal( Material, 'Density',  N, Element % NodeIndexes, Found )
              IF (.NOT.Found) THEN
                 Density = 0.0D00
                 WRITE(Message,'(a,i5,a,i5,a)') 'Keyword >Density< not found for element ',&
                      t, ' material ', material_id
                 CALL INFO(SolverName,Message,Level=4)
              END IF

              Viscosity(1:N) = ListGetReal( Material, 'Viscosity',  N, Element % NodeIndexes, Found )
              IF (.NOT.Found) THEN
                 Viscosity = 0.0D00
                 WRITE(Message,'(a,i5,a,i5,a)') 'Keyword >Viscosity< not found for element ',&
                      t, ' material ', material_id
                 CALL INFO(SolverName,Message,Level=4)
              END IF

!              PRINT *, 'kappa=', HeatConductivity( 1:MIN(3,SIZE(Hwrk,1)),1:MIN(3,SIZE(Hwrk,2)),1:N ) 
!              PRINT *, 'cp=', HeatCapacity(1:N)

!------------------------------------------------------------------------------
!        Get mesh velocity
!------------------------------------------------------------------------------
              MeshVelocity = 0.0d0
              CALL GetVectorLocalSolution( MeshVelocity, 'Mesh Velocity')
!------------------------------------------------------------------------------
!        Get scalar velocity
!------------------------------------------------------------------------------         
              TempVeloU = 0.0d00
              TempVeloV = 0.0d00
              TempVeloW = 0.0d00
              ! asuming convection or ALE mesh contribution by default
              DO i=1,N
                 C1(i) = Density(i) * HeatCapacity(i)
!                 C1(i) = HeatCapacity(i)
!                 PRINT *, 'C1(',i,')=',C1(i)
              END DO

              IF ( ConvectionFlag == 'constant' ) THEN
                 TempVeloU(1:N)= GetReal( Material, 'Convection Velocity 1', Found )
                 TempVeloV(1:N) = GetReal( Material, 'Convection Velocity 2', Found )
                 TempVeloW(1:N) = GetReal( Material, 'Convection Velocity 3', Found )                 
              ELSE IF ( ConvectionFlag == 'computed' ) THEN
                 DO i=1,n
                    k = FlowPerm(Element % NodeIndexes(i))
                    IF ( k > 0 ) THEN
                       Pressure(i) = FlowSolution(NSDOFs*k) + ReferencePressure
!------------------------------------------------------------------------------
                       SELECT CASE( NSDOFs )
                       CASE(3)
                          TempVeloU(i) = FlowSolution( NSDOFs*k-2 )
                          TempVeloV(i) = FlowSolution( NSDOFs*k-1 )
                          TempVeloW(i) = 0.0D0
                       CASE(4)
                          TempVeloU(i) = FlowSolution( NSDOFs*k-3 )
                          TempVeloV(i) = FlowSolution( NSDOFs*k-2 )
                          TempVeloW(i) = FlowSolution( NSDOFs*k-1 )
                       END SELECT
                    ELSE
                       TempVeloU(i) = 0.0D0
                       TempVeloV(i) = 0.0D0
                       TempVeloW(i) = 0.0D0
                    END IF
                 END DO
                 WRITE(Message,'(a,i5, a, i5)') 'Convection in element ', t, &
                      ' material ',  material_id
              ELSE  ! Conduction and ALE contribution only
                 IF (ANY( MeshVelocity /= 0.0d0 )) THEN
                    WRITE(Message,'(a,i5, a, i5)') 'Only mesh deformation in element ', t,&
                         ' material ',  material_id
                 ELSE ! neither convection nor ALE mesh deformation contribution -> all C1(1:N)=0
                    C1 = 0.0D0 
                    WRITE(Message,'(a,i5, a, i5)') 'No convection and mesh deformation in element ', t,&
                         ' material ',  material_id
                 END IF                 
              END IF
              CALL INFO(SolverName,Message,Level=14)
             
              ! no compressibility by default
              C0=0.0d00


!------------------------------------------------------------------------------
!        Add body forces, if any
!------------------------------------------------------------------------------
              LOAD = 0.0D00
              BodyForce => GetBodyForce()
              IF ( ASSOCIATED( BodyForce ) ) THEN
                 bf_id = GetBodyForceId()
                 !Given volume source
                 !-------------------
                 LOAD(1:N) = LOAD(1:N) +   &
                      GetReal( BodyForce, TRIM(Solver % Variable % Name) // ' Volume Source', Found )
!                 IF (.NOT.Found) LOAD = 0.0D00
              END IF
!------------------------------------------------------------------------------
!    Lagrange multipliers
!------------------------------------------------------------------------------

              LOAD(1:N) = LOAD(1:N) &
                   - LagrangeMultiplier1(Element % NodeIndexes(1:N)) &
                   - LagrangeMultiplier2(Element % NodeIndexes(1:N))

!              PRINT *, t, 'h= ', LOAD(1:N)

!if (iter > 1) print*,maxval(LagrangeMultiplier1(Element % NodeIndexes(1:N))), minval(LagrangeMultiplier1(Element % NodeIndexes(1:N)))

!------------------------------------------------------------------------------
!        Get element local matrices, and RHS vectors
!------------------------------------------------------------------------------
         ! dummy input array for faking   heat capacity, density, temperature, 
         !                                enthalpy and viscosity
              Work = 1.0d00
              Zero = 0.0D00


              MASS = 0.0d00
              STIFF = 0.0d00
              FORCE = 0.0D00
!------------------------------------------------------------------------------
              IF ( CurrentCoordinateSystem() == Cartesian ) THEN
!------------------------------------------------------------------------------
                 CALL DiffuseConvectiveCompose( &
                      MASS, STIFF, FORCE, LOAD, &
                      HeatCapacity, C0, C1(1:N), HeatConductivity, &
                      .FALSE., Zero, Zero, TempVeloU, TempVeloV, TempVeloW, &
                      MeshVelocity(1,1:N),MeshVelocity(2,1:N),MeshVelocity(3,1:N),&
                      Viscosity, Density, Pressure, &
                      .FALSE., Stabilize, UseBubbles, Element, n, ElementNodes )
!------------------------------------------------------------------------------
              ELSE
!------------------------------------------------------------------------------
                 CALL DiffuseConvectiveGenCompose( &
                      MASS, STIFF, FORCE, LOAD, &
                      HeatCapacity, C0, C1(1:N), HeatConductivity, &
                      .FALSE., Zero, Zero, TempVeloU, TempVeloV, TempVeloW, &
                      MeshVelocity(1,1:N),MeshVelocity(2,1:N),MeshVelocity(3,1:N), Viscosity,&
                      Density, Pressure,.FALSE.,&
                      Stabilize, Element, n, ElementNodes )
                 
!------------------------------------------------------------------------------
              END IF
!------------------------------------------------------------------------------
              Bubbles = UseBubbles  .AND. &
                   ( ConvectionFlag == 'computed' .OR. ConvectionFlag == 'constant' )         
!------------------------------------------------------------------------------
!           If time dependent simulation add mass matrix to stiff matrix
!------------------------------------------------------------------------------
              TimeForce  = FORCE
              IF ( TransientSimulation ) THEN
                 IF ( Bubbles ) FORCE = 0.0d0
                 CALL Default1stOrderTime( MASS,STIFF,FORCE )
              END IF
!------------------------------------------------------------------------------
!           Update global matrices from local matrices
!------------------------------------------------------------------------------
              IF (  Bubbles ) THEN
                 CALL Condensate( N, STIFF, FORCE, TimeForce )
                 IF (TransientSimulation) CALL DefaultUpdateForce( TimeForce )
              END IF

              CALL DefaultUpdateEquations( STIFF, FORCE )
!           END IF
              
!------------------------------------------------------------------------------
           END DO     !  Bulk elements
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
!     Neumann & Newton boundary conditions
!------------------------------------------------------------------------------
           DO t=1, Solver % Mesh % NumberOfBoundaryElements

              ! get element information
              Element => GetBoundaryElement(t)
              IF ( .NOT.ActiveBoundaryElement() ) CYCLE
              n = GetElementNOFNodes()
              IF ( GetElementFamily() == 1 ) CYCLE
              BC => GetBC()
              bc_id = GetBCId( Element )
              CALL GetElementNodes( ElementNodes )


              other_body_id = Element % BoundaryInfo % outbody
              IF (other_body_id < 1) THEN ! only one body in calculation
                 ParentElement => Element % BoundaryInfo % Right
                 IF ( .NOT. ASSOCIATED(ParentElement) ) ParentElement => Element % BoundaryInfo % Left
              ELSE ! we are dealing with a body-body boundary and asume that the normal is pointing outwards
                 ParentElement => Element % BoundaryInfo % Right
                 IF (.NOT.ASSOCIATED(ParentElement) ) THEN ! boundary is declared in input file, but does not xist
                    ParentElement => Element % BoundaryInfo % Left 
                 ELSE
                    IF (ParentElement % BodyId == other_body_id) ParentElement => Element % BoundaryInfo % Left
                 END IF
              END IF
     
              IF (.NOT.ASSOCIATED(ParentElement)) THEN 
                 WRITE (Message,'(A,I5,A)')&
                      'No parent element found on either side for boundary element no. ',t,'.'
                 CALL FATAL(SolverName,Message)
!!$              ELSE
!!$                 Material => GetMaterial(ParentElement)
              END IF


              IF ( ASSOCIATED( BC ) ) THEN            
                 ! Check that we are on the correct boundary part!
                 STIFF=0.0D00
                 FORCE=0.0D00
                 MASS=0.0D00
                 LOAD=0.0D00
                 TransferCoeff = 0.0D00
                 TempExt = 0.0D00
                 FluxBC = .FALSE.
                 FluxBC =  GetLogical(BC,TRIM(Solver % Variable % Name) // ' Flux BC', Found)

                 IF (FluxBC) THEN
                    !------------------------------
                    !BC: -k@T/@n = \alpha(T - TempExt)
                    !------------------------------
                    TransferCoeff(1:N) = GetReal( BC, TRIM(Solver % Variable % Name) //  ' Transfer Coefficient',Found )
                    IF ( ANY(TransferCoeff(1:N) /= 0.0d0) ) THEN
                       TempExt(1:N) = GetReal( BC, TRIM(Solver % Variable % Name) // ' External Value',Found )   
                       DO j=1,n
                          LOAD(j) = LOAD(j) +  TransferCoeff(j) * TempExt(j)
                       END DO
                    END IF

                    !---------------
                    !BC: -k@T/@n = q
                    !---------------
                    LOAD(1:N)  = LOAD(1:N) + &
                         GetReal( BC, TRIM(Solver % Variable % Name) // ' Heat Flux', Found )

                    ! -------------------------------------
                    ! set boundary due to coordinate system
                    ! -------------------------------------
                    IF ( CurrentCoordinateSystem() == Cartesian ) THEN
                       CALL DiffuseConvectiveBoundary( STIFF,FORCE, &
                            LOAD,TransferCoeff,Element,n,ElementNodes )
                    ELSE
                       CALL DiffuseConvectiveGenBoundary(STIFF,FORCE,&
                            LOAD,TransferCoeff,Element,n,ElementNodes ) 
                    END IF
                 END IF
              END IF

!------------------------------------------------------------------------------
!         Update global matrices from local matrices
!------------------------------------------------------------------------------
              IF ( TransientSimulation ) THEN
                 MASS = 0.d0
                 CALL Default1stOrderTime( MASS, STIFF, FORCE )
              END IF
          
              CALL DefaultUpdateEquations( STIFF, FORCE )
!------------------------------------------------------------------------------
           END DO   ! Neumann & Newton BCs
!------------------------------------------------------------------------------

           CALL DefaultFinishAssembly()
           CALL DefaultDirichletBCs()

           CALL Info( SolverName, 'Assembly done', Level=4 )

!------------------------------------------------------------------------------
!     Solve the system and check for convergence
!------------------------------------------------------------------------------
           at = CPUTime() - at
           st = CPUTime()

           PrevNorm = Solver % Variable % Norm

           Norm = DefaultSolve()

           st = CPUTIme()-st
           totat = totat + at
           totst = totst + st
           WRITE(Message,'(a,i4,a,F8.2,F8.2)') 'iter: ',iter,' Assembly: (s)', at, totat
           CALL Info( SolverName, Message, Level=4 )
           WRITE(Message,'(a,i4,a,F8.2,F8.2)') 'iter: ',iter,' Solve:    (s)', st, totst
           CALL Info( SolverName, Message, Level=4 )

!           IF (LimitSolution) THEN
!              PRINT *, 'NNNNNNNNNNNNNNNNNNNNNNNNNOOOOOOOOOOOOOOOOOOOOOOOOOORRRRRRRRRRRRRRRRRRRRRRRRRMMMMMMMMMMMMMMM'
!              Norm = 0.0d00
!              DO i= 1,M
!                 IF ((LagrangeMultiplier1(i)==0.0d00) .AND. &
!                     (LagrangeMultiplier2(i)==0.0d00)) &
!                      Norm = Norm + SQRT(Temp(TempPerm(i))**2 )
!              END DO
!              Norm = Norm/M
!              Solver % Variable % Norm = Norm
!           END IF

!------------------------------------------------------------------------------


           IF ( PrevNorm + Norm /= 0.0d0 ) THEN
              RelativeChange = 2.0d0 * ABS( PrevNorm-Norm ) / (PrevNorm + Norm)
           ELSE
              RelativeChange = 0.0d0
           END IF

           WRITE( Message, * ) 'Result Norm   : ',Norm
           CALL Info( SolverName, Message, Level=4 )
           WRITE( Message, * ) 'Relative Change : ',RelativeChange
           CALL Info( SolverName, Message, Level=4 )

           IF ( RelativeChange < NewtonTol .OR. iter > NewtonIter ) &
                NewtonLinearization = .TRUE.

           IF ( RelativeChange < NonlinearTol ) EXIT
           

           CALL ListAddConstReal(Solver % Values,  &
                'Nonlinear System Relaxation Factor', Relax )

!------------------------------------------------------------------------------
        END DO ! of the nonlinear iteration
!------------------------------------------------------------------------------

        CALL ListAddConstReal(Solver % Values,  &
             'Nonlinear System Tolerance', NonlinearTol)

!------------------------------------------------------------------------------
!   Compute cumulative time done by now and time remaining
!------------------------------------------------------------------------------
        IF ( .NOT. TransientSimulation ) EXIT
        CumulativeTime = CumulativeTime + dt
        dt = Timestep - CumulativeTime
     END DO ! time interval

!------------------------------------------------------------------------------
     CALL  ListAddConstReal( Solver % Values,  &
          'Nonlinear System Relaxation Factor', SaveRelax )
!------------------------------------------------------------------------------

     DEALLOCATE( PrevSolution )

!   IF ( ListGetLogical( Solver % Values, 'Adaptive Mesh Refinement', Found ) ) &
!      CALL RefineMesh( Model,Solver,Temp,TempPerm, &
!            HeatInsideResidual, HeatEdgeResidual, HeatBoundaryResidual )

     SubroutineVisited = .TRUE.


   CONTAINS

SUBROUTINE HomologousTempBoundary(  StiffMatrix, ForceVector, LoadVector, &
       NodalC1,  Element, n, Permeable )
!------------------------------------------------------------------------------
    REAL(KIND=dp) :: StiffMatrix(:,:), ForceVector(:), LoadVector(:), NodalC1(:)
    INTEGER :: n
    LOGICAL :: Permeable
    TYPE(Element_t), POINTER :: Element
!------------------------------------------------------------------------------
    REAL(KIND=dp) :: SqrtElementMetric, s, C1, Load
    REAL(KIND=dp) :: Basis(n), dBasisdx(n,3), ddBasisddx(n,3,3)
    LOGICAL :: Stat
    INTEGER :: i,j,p,q,t,dim,CoordSys
    TYPE(GaussIntegrationPoints_t) :: IP

    TYPE(Nodes_t) :: Nodes
    SAVE Nodes
!------------------------------------------------------------------------------
    dim = CoordinateSystemDimension()
    CoordSys = CurrentCoordinateSystem()

    CALL GetElementNodes( Nodes )
    IP = GaussPoints( Element )

    StiffMatrix = 0.0d0
    ForceVector = 0.0d0

    ! Over all  Gauss-points
    
    DO t = 1, IP % n
       stat = ElementInfo( Element, Nodes, IP % u(t), IP % v(t), IP % w(t), &
            SqrtElementMetric, Basis, dBasisdx, ddBasisddx, .FALSE., .FALSE. )
       s = SqrtElementMetric * IP % s(t)      
       Load = SUM( LoadVector(1:N)*Basis(1:N) ) ! Load at Gauss-point
       PRINT *, t, ' out of total ', IP % n, SqrtElementMetric, IP % s(t), Load 
       DO q = 1,n
          ForceVector(q) = ForceVector(q) + s * Basis(q) * Load
       END DO
    END DO

  END SUBROUTINE HomologousTempBoundary

!!$  FUNCTION GetDivergence(Field, Element, ElementNodes, n, Nodes) RESULT(divergence)
!!$    USE DefUtils
!!$    USE TYPES
!!$
!!$    IMPLICIT NONE
!!$
!!$    ! external variables
!!$    REAL(KIND=dp) :: Field(:,:), divergence
!!$    INTEGER :: n, Nodes
!!$    TYPE(Nodes_t), TARGET    :: ElementNodes
!!$    TYPE(Element_t), TARGET :: Element
!!$
!!$    !internal variables
!!$    REAL(KIND=dp) :: SqrtElementMetric
!!$    REAL(KIND=dp) :: Basis(2*n),dBasisdx(2*n,3),ddBasisddx(n,3,3)
!!$    INTEGER :: DIM, j
!!$    LOGICAL :: stat
!!$    
!!$    DIM = CoordinateSystemDimension()
!!$
!!$    stat = ElementInfo( Element,ElementNodes, &
!!$         Element % Type % NodeU(n), Element % Type % NodeV(n), Element % Type % NodeW(n), &
!!$         SqrtElementMetric, Basis,dBasisdx,ddBasisddx, .FALSE. )
!!$
!!$    divergence = 0.0d00
!!$ 
!!$    DO j=1,DIM
!!$       divergence = divergence + SUM( dBasisdx(1:N,j) * Field(j,1:N) )
!!$    END DO
!!$  
!!$  END FUNCTION GetDivergence

  FUNCTION GetScalarGradient(Scalar, Element, ElementNodes, NodeNumber, Nodes, ElementNo) RESULT(gradient)
    USE DefUtils
    USE TYPES
    USE CoordinateSystems

    IMPLICIT NONE

    ! external variables
    REAL(KIND=dp) :: Scalar(:), gradient(3)
    INTEGER :: NodeNumber, Nodes, ElementNo
    TYPE(Nodes_t), TARGET    :: ElementNodes
    TYPE(Element_t), TARGET :: Element

    !internal variables
    REAL(KIND=dp) :: SqrtElementMetric
    REAL(KIND=dp) :: Basis(2*n),dBasisdx(2*n,3),ddBasisddx(n,3,3)
    INTEGER :: DIM, j
    LOGICAL :: stat, CylindricSymmetry


    DIM = CoordinateSystemDimension()
    CylindricSymmetry = (CurrentCoordinateSystem() == CylindricSymmetric .OR. &
         CurrentCoordinateSystem() == AxisSymmetric)
    IF ( CurrentCoordinateSystem() == Cartesian .OR. CylindricSymmetry) THEN
       stat = ElementInfo( Element,ElementNodes, &
            Element % Type % NodeU(NodeNumber), &
            Element % Type % NodeV(NodeNumber), &
            Element % Type % NodeW(NodeNumber), &
            SqrtElementMetric, Basis, dBasisdx, ddBasisddx, .FALSE. )

       IF (.NOT.stat) THEN
          WRITE(Message,'(a, i5, a)') 'Degenerated element ', ElementNo, ' found'
          CALL FATAL('GetScalarGradient',Message)
       END IF

       gradient = 0.0d00
 

       DO j=1,DIM
          gradient(j) = SUM( dBasisdx(1:NodeNumber,j) * Scalar(1:NodeNumber) )
       END DO
    ELSE
       CALL FATAL('GetScalarGradient', 'Only Cartesian 2D, CArtesian 3D, AxisSummetric and CylindricSymmetric implemented')
    END IF

  END FUNCTION GetScalarGradient


!------------------------------------------------------------------------------
  END SUBROUTINE HomologousTempSolver
!------------------------------------------------------------------------------

PROGRAM ReadTest
    
    USE BinIO

    IMPLICIT NONE
    INTEGER, PARAMETER :: dp = selected_real_kind(15)
    INTEGER, PARAMETER :: fu = 10

    IF( TestFile( "writetest.checkL" ) .AND. TestFile( "writetest.checkB" ) )THEN
        PRINT *, 'OK'
    ELSE
        PRINT *, 'DAMN!'
    END IF

CONTAINS

    LOGICAL FUNCTION TestFile( FName )
        CHARACTER(*) :: FName
        INTEGER :: a, stat, i
        REAL(dp) :: v(3), v2(3)
        CHARACTER(50) :: s, s2
        CHARACTER(256) :: Error
        CHARACTER :: E

        CALL BinOpen( fu, FName, "read", stat )
        IF ( stat /= 0 ) STOP 1

        CALL BinReadString( fu,E,stat )
        IF ( stat /= 0 ) STOP "1.5"
        CALL BinSetInputEndianess( fu,E )

        CALL BinReadInt4( fu, a, stat )
        IF ( stat /= 0 ) STOP 2

        CALL BinReadString( fu, s, stat )
        IF ( stat /= 0 ) STOP 3

        DO i = 1, SIZE( v )
            CALL BinReadDouble( fu, v(i), stat )
            IF ( stat /= 0 ) STOP 4
        END DO

        CALL BinReadString( fu, s2(1:8), stat )
        IF ( stat /= 0 ) STOP 5

        DO i = 1, SIZE( v2 )
            CALL BinReadDouble( fu, v2(i), stat )
            IF ( stat /= 0 ) STOP 6
        END DO

        ! At this point, we should have reached the end.
        CALL BinReadInt4( fu, i, stat )
        IF ( stat >= 0 ) STOP 7

        CALL BinClose( fu, stat )
        IF ( stat /= 0 ) STOP 8

        IF ( a == 5 .AND. TRIM(s) == "Hello World!"  &
                    .AND. ALL( v == (/ -7.13_dp, 0.01_dp, HUGE(v) /) ) &
                    .AND. ALL( v2 == (/ -7.13_dp, 0.01_dp, HUGE(v2) /) ) &
                    .AND. s2(2:7) == "Humhum" .AND. IACHAR(s2(1:1)) == 10 &
                                              .AND. IACHAR(s2(8:8)) == 10 ) then
            TestFile = .TRUE.
        ELSE
            !PRINT *, FName
            !PRINT *, a
            !PRINT *, "'", TRIM(s), "'"
            !PRINT *, v
            !PRINT *, "'", TRIM(s2(2:7)), "'"
            !PRINT *, IACHAR(s2(1:1)), IACHAR(s2(8:8))
            !PRINT *, v2
            TestFile = .FALSE.
        END IF
    END FUNCTION TestFile

END PROGRAM ReadTest

FUNCTION ISMIPHeinoAccumulation( Model, Node, DummyReal ) RESULT(accumulationRate)
  USE types
  USE CoordinateSystems
  USE SolverUtils
  USE ElementDescription
!-----------------------------------------------------------
  IMPLICIT NONE
!------------ external variables ---------------------------
  TYPE(Model_t) :: Model
  INTEGER :: Node
  REAL(KIND=dp) :: DummyReal, accumulationRate
!------------ internal variables----------------------------
  REAL (KIND=dp) :: YCoord, XCoord,ZCoord, Radius

  XCoord = Model % Nodes % x(Node)
  YCoord = Model % Nodes % y(Node)

  Radius = SQRT(XCoord**2 + YCoord**2)

  accumulationRate = -1.0D00*(0.15D00 + 7.5D-08 * Radius)/3.1556926D07

END FUNCTION ISMIPHeinoAccumulation

FUNCTION ISMIPHeinoSurfaceTemp( Model, Node, DummyReal ) RESULT(surfaceTemp)
  USE types
  USE CoordinateSystems
  USE SolverUtils
  USE ElementDescription
!-----------------------------------------------------------
  IMPLICIT NONE
!------------ external variables ---------------------------
  TYPE(Model_t) :: Model
  INTEGER :: Node
  REAL(KIND=dp) :: DummyReal, surfaceTemp
!------------ internal variables----------------------------
  REAL (KIND=dp) :: YCoord, XCoord, Radius

  XCoord = Model % Nodes % x(Node)
  YCoord = Model % Nodes % y(Node)

  Radius = SQRT(XCoord**2 + YCoord**2)

  surfaceTemp = 2.3315D02 + (2.5D-09 * (Radius/1.0D03)**3)

END FUNCTION ISMIPHeinoSurfaceTemp

FUNCTION getSlipCoefficient( Model, Node, Temperature ) RESULT(basalSlipCoefficient)
!-----------------------------------------------------------
  USE DefUtils
!-----------------------------------------------------------
  IMPLICIT NONE
!-----------------------------------------------------------
  !external variables
  TYPE(Model_t), TARGET :: Model
  INTEGER :: Node
  REAL(KIND=dp) :: Temperature, basalSlipCoefficient
  !internal variables
  TYPE(Element_t), POINTER :: CurrentElementAtBeginning, BoundaryElement, ParentElement
  TYPE(ValueList_t), POINTER :: ParentMaterial, BC
  TYPE(Variable_t), POINTER :: varTemperature, varPressure
  INTEGER :: N, NBoundary, NParent, BoundaryElementNode, ParentElementNode, &
       i, DIM, other_body_id, body_id, material_id, istat, NSDOFs
  REAL(KIND=dp) :: TempHom, ThermalCoefficient, SlipCoefficientMax
  REAL(KIND=dp), ALLOCATABLE :: PressureMeltingPoint(:), Slidingparameter(:)
  CHARACTER(LEN=MAX_NAME_LEN) :: TempName, BedrockType
  LOGICAL ::  GotIt, stat, Jump=.FALSE.

  !---------------
  ! Initialization
  !---------------
  CurrentElementAtBeginning => Model % CurrentElement 
  N = Model % MaxElementNodes 
  ALLOCATE(SlidingParameter(N),&  
       PressureMeltingPoint(N),&
       STAT = istat)
  IF (istat /= 0) THEN
     CALL FATAL('iceproperties (basalSlip)','Allocations failed')
  END IF

  PressureMeltingPoint = 273.16D00 ! default

  !-----------------------------------------------------------------
  ! get some information upon active boundary element and its parent
  !-----------------------------------------------------------------
  BoundaryElement => Model % CurrentElement
  IF ( .NOT. ASSOCIATED(BoundaryElement) ) THEN
     CALL FATAL('iceproperties (basalMelting)','No boundary element found')
  END IF
  other_body_id = BoundaryElement % BoundaryInfo % outbody
  IF (other_body_id < 1) THEN ! only one body in calculation
     ParentElement => BoundaryElement % BoundaryInfo % Right
     IF ( .NOT. ASSOCIATED(ParentElement) ) ParentElement => BoundaryElement % BoundaryInfo % Left
  ELSE ! we are dealing with a body-body boundary and asume that the normal is pointing outwards
     ParentElement => BoundaryElement % BoundaryInfo % Right
     IF (ParentElement % BodyId == other_body_id) ParentElement => BoundaryElement % BoundaryInfo % Left
  END IF
  ! just to be on the save side, check again
  IF ( .NOT. ASSOCIATED(ParentElement) ) THEN
     WRITE(Message,'(A,I10,A)')&
          'Parent Element for Boundary element no. ',&
          BoundaryElement % ElementIndex, ' not found'
     CALL FATAL('iceproperties (basalMelting)',Message)
  END IF  
  Model % CurrentElement => ParentElement
  body_id = ParentElement % BodyId
  material_id = ListGetInteger(Model % Bodies(body_id) % Values, 'Material', GotIt)
  ParentMaterial => Model % Materials(material_id) % Values
  IF ((.NOT. ASSOCIATED(ParentMaterial)) .OR. (.NOT. GotIt)) THEN
     WRITE(Message,'(A,I10,A,I10)')&
          'No material values found for body no ', body_id,&
          ' under material id ', material_id
     CALL FATAL('iceproperties (basalMelting)',Message)
  END IF
  ! number of nodes and node in elements
  NBoundary = BoundaryElement % Type % NumberOfNodes
  NParent = ParentElement % Type % NumberOfNodes
  DO BoundaryElementNode=1,Nboundary
     IF ( Node == BoundaryElement % NodeIndexes(BoundaryElementNode) ) EXIT
  END DO
  DO ParentElementNode=1,NParent
     IF ( Node == ParentElement % NodeIndexes(ParentElementNode) ) EXIT
  END DO
  !-------------------------
  ! Get Pressure Melting Point
  !-------------------------
  TempName =  GetString(ParentMaterial ,'Temperature Name', GotIt)
  PressureMeltingPoint(1:NParent) =&
       ListGetReal( ParentMaterial, TRIM(TempName) // ' Upper Limit',&
       NParent, ParentElement % NodeIndexes, GotIt)
  IF (.NOT. GotIt) THEN
     WRITE(Message,'(a,a,a)') 'No entry for ', TRIM(TempName) // ' Upper Limit', ' found'
     CALL FATAL('iceproperties (basalMelting)',Message)
  END IF
  !---------------------------------------------------------------------
  ! get temperate slip coefficient and upper limit for slip coefficient
  !---------------------------------------------------------------------
  Model % CurrentElement => BoundaryElement
  BC => GetBC()

  IF (.NOT.ASSOCIATED(BC)) THEN
     CALL FATAL('iceproperties (basalSlip)','No Boundary Condition associated')
  ELSE
     Slidingparameter(1:NBoundary) = GetReal(BC, 'Sliding Parameter', GotIt)
     IF (.NOT. GotIt) THEN
        CALL WARN('iceproperties (basalSlip)','Keyword >Temperate Slip Coefficient< not found')
        CALL WARN('iceproperties (basalSlip)','Asuming Default 1E05 [1/a]')
        SlidingParameter(1:NBoundary) = 1.0D05/3.1556926D07
     END IF
     SlipCoefficientMax = GetConstReal(BC, 'Max Slip Coefficient', GotIt)
     IF (.NOT. GotIt) THEN
        CALL WARN('iceproperties (basalSlip)','Keyword >Max Slip Coefficient< not found')
        CALL WARN('iceproperties (basalSlip)','Asuming Default 1.0E+16 [kg /(s m^2)]')
        SlipCoefficientMax = 1.0E+16
     END IF
  END IF
  !---------------------------------------------------------------------
  ! get type of bedrock (to set slip law accordingly)
  !---------------------------------------------------------------------
  BedrockType =  GetString(BC ,'Bedrock Type', GotIt)
  !------------------------------
  ! check relative temperature
  !------------------------------
  TempHom = MIN(Temperature - PressureMeltingPoint(ParentElementNode),0.0D00)
  !------------------------------
  ! get the result and check it
  !------------------------------
  SELECT CASE(BedrockType)

  CASE("Hard Rock")

  CASE("Soft Sediment")
       

  CASE DEFAULT 
     STOP
  END SELECT

  IF(basalSlipCoefficient > SlipCoefficientMax) THEN
     WRITE(Message,'(A,e10.4)') 'Applied upper threshold of ', SlipCoefficientMax
     CALL INFO('iceproperties (basalSlip)',Message,Level=9)
     basalSlipCoefficient = SlipCoefficientMax
  END IF
  !------------------------------
  ! clean up
  !------------------------------
  DEALLOCATE(Slidingparameter, PressureMeltingPoint)
END FUNCTION getSlipCoefficient

      Program plotfbed
      USE Types
      USE DefUtils
      IMPLICIT NONE
      REAL(KIND=dp) :: x, dx, fbed,dbed
      INTEGER :: i,n

      Open(2,file='plotfbed.dat')
 
      x=0.0_dp
      n = 1000
      dx = 1.0_dp/n
      Do i=1,n+1
      write(2,'(3(e14.8,2x))')x,fbed(x),dbed(x)
      x= x+dx
      End Do
      Close(1)
      END PROGRAM plotfbed

SUBROUTINE TuringSolver( Model,Solver,dt,TransientSimulation )
!DEC$ATTRIBUTES DLLEXPORT :: TuringSolver
!------------------------------------------------------------------------------
!******************************************************************************
!
!  Solve the Turing equation!
!
!  ARGUMENTS:
!
!  TYPE(Model_t) :: Model,  
!     INPUT: All model information (mesh, materials, BCs, etc...)
!
!  TYPE(Solver_t) :: Solver
!     INPUT: Linear & nonlinear equation solver options
!
!  REAL(KIND=dp) :: dt,
!     INPUT: Timestep size for time dependent simulations
!
!  LOGICAL :: TransientSimulation
!     INPUT: Steady state or transient simulation
!
!******************************************************************************
  USE DefUtils

  IMPLICIT NONE
!------------------------------------------------------------------------------
  TYPE(Solver_t) :: Solver
  TYPE(Model_t) :: Model

  REAL(KIND=dp) :: dt
  LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
! Local variables
!------------------------------------------------------------------------------
  LOGICAL :: AllocationsDone = .FALSE., Found
  TYPE(Element_t),POINTER :: Element

  REAL(KIND=dp) :: Norm
  INTEGER :: n, nb, nd, t, istat

  TYPE(ValueList_t), POINTER :: BodyForce, Material
  REAL(KIND=dp), ALLOCATABLE :: STIFF(:,:), LOAD(:), FORCE(:), MASS(:,:)

  REAL(KIND=dp), ALLOCATABLE :: CoeffA(:), CoeffB(:), CoeffC(:), CoeffG(:), &
           CoeffNu(:), DiffU(:), DiffV(:), Solution(:,:)

  SAVE MASS, STIFF, LOAD, FORCE, AllocationsDone, CoeffA, CoeffB, CoeffC, CoeffG, &
    CoeffNu, DiffU, DiffV, Solution
!------------------------------------------------------------------------------

  !Allocate some permanent storage, this is done first time only:
  !--------------------------------------------------------------
  IF ( .NOT. AllocationsDone ) THEN
     N = 2*Solver % Mesh % MaxElementDOFs  ! just big enough for elemental arrays
     ALLOCATE( FORCE(N), LOAD(N), STIFF(N,N), MASS(N,N), STAT=istat )

     ALLOCATE( CoeffA(N), stat=istat )
     ALLOCATE( CoeffB(N), stat=istat )
     ALLOCATE( CoeffC(N), stat=istat )
     ALLOCATE( CoeffG(N), stat=istat )
     ALLOCATE( CoeffNu(N), stat=istat )
     ALLOCATE( DiffU(N), stat=istat )
     ALLOCATE( DiffV(N), stat=istat )
     ALLOCATE( Solution(2,1:N), stat=istat )

     IF ( istat /= 0 ) THEN
        CALL Fatal( 'TuringSolve', 'Memory allocation error.' )
     END IF
     AllocationsDone = .TRUE.
  END IF

   !System assembly:
   !----------------
   CALL DefaultInitialize()
   DO t=1,Solver % NumberOfActiveElements
     Element => GetActiveElement(t)
     n  = GetElementNOFNodes()
     nd = GetElementNOFDOFs()

     CALL GetVectorLocalSolution( Solution )

     Material => GetMaterial()
     CoeffA(1:nd)  = GetReal( Material, 'Alpha' )
     CoeffB(1:nd)  = GetReal( Material, 'Beta' )
     CoeffC(1:nd)  = GetReal( Material, 'C' )
     CoeffG(1:nd)  = GetReal( Material, 'Gamma' )
     CoeffNu(1:nd) = GetReal( Material, 'nu' )
     DiffU(1:nd)   = GetReal( Material, 'du' )
     DiffV(1:nd)   = GetReal( Material, 'dv' )

     ! Get element local matrix and rhs vector:
     ! ----------------------------------------
     CALL LocalMatrix(  MASS, STIFF, FORCE, LOAD, Element, n, nd )

     IF ( TransientSimulation ) CALL Default1stOrderTime( MASS, STIFF, FORCE )
     CALL DefaultUpdateEquations( STIFF, FORCE )
   END DO
   CALL DefaultFinishAssembly()
   CALL DefaultDirichletBCs()


   ! And finally, solve:
   !--------------------
   Norm = DefaultSolve()

CONTAINS

!------------------------------------------------------------------------------
  SUBROUTINE LocalMatrix(  MASS, STIFF, FORCE, LOAD, Element, n, nd )
!------------------------------------------------------------------------------
    REAL(KIND=dp), TARGET :: MASS(:,:), STIFF(:,:), FORCE(:), LOAD(:)
    INTEGER :: n, nd
    TYPE(Element_t), POINTER :: Element
!------------------------------------------------------------------------------
    REAL(KIND=dp) :: Basis(nd),dBasisdx(nd,3),DetJ,LoadAtIP
    LOGICAL :: Stat
    INTEGER :: i,j,t,p,q,dim
    REAL(KIND=dp), POINTER :: M(:,:), A(:,:), F(:)
    TYPE(GaussIntegrationPoints_t) :: IP

    REAL(KIND=dp) :: du,dv,nu,alpha,beta,gamma,uprev,vprev,C,s, Base, Grad

    TYPE(Nodes_t) :: Nodes
    SAVE Nodes
!------------------------------------------------------------------------------
    dim = CoordinateSystemDimension()

    CALL GetElementNodes( Nodes )
    MASS  = 0.0d0
    STIFF = 0.0d0
    FORCE = 0.0d0

    ! Numerical integration:
    ! ----------------------
    IP = GaussPoints( Element )
    DO t=1,IP % n
      ! Basis function values & derivatives at the integration point:
      !--------------------------------------------------------------
      stat = ElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
            IP % W(t), detJ, Basis, dBasisdx )

      s = IP % s(t) * DetJ

      du =    SUM( Basis(1:nd) * DiffU(1:nd) )
      dv =    SUM( Basis(1:nd) * DiffV(1:nd) )
      nu =    SUM( Basis(1:nd) * CoeffNu(1:nd) )
      alpha = SUM( BAsis(1:nd) * CoeffA(1:nd) )
      beta  = SUM( Basis(1:nd) * CoeffB(1:nd) )
      C     = SUM( Basis(1:nd) * CoeffC(1:nd) )
      gamma = SUM( Basis(1:nd) * CoeffG(1:nd) )

      uprev = SUM( Basis(1:nd) * Solution( 1,1:nd ) )
      vprev = SUM( Basis(1:nd) * Solution( 2,1:nd ) )

      ! Finally, the elemental matrix & vector:
      !----------------------------------------
     DO p=1,nd
       DO q=1,nd
         i = 2*(p-1)+1
         j = 2*(q-1)+1
         M =>  MASS(i:i+1, j:j+1)
         A => STIFF(i:i+1, j:j+1)

         Base = s * Basis(q) * Basis(p)
         Grad = s * SUM( dBasisdx(q,:) * dBasisdx(p,:) )

         M(1,1) = M(1,1) + Base
         M(2,2) = M(2,2) + Base
         A(1,1) = A(1,1) + du*Grad + nu*((vprev+C)*vprev-1)    * Base
         A(1,2) = A(1,2) + nu*((3*vprev+C)*uprev-alpha) * Base
         A(2,1) = A(2,1) - nu*((vprev+C)*vprev+gamma) * Base
         A(2,2) = A(2,2) + dv*Grad - nu*((3*vprev+C)*uprev+beta) * Base
       END DO
       i = 2*(p-1)+1
       F => FORCE(i:i+1)
       F(1) = F(1) + s * nu*(3*vprev+C)*uprev*vprev * Basis(p)
       F(2) = F(2) - s * nu*(3*vprev+C)*uprev*vprev * Basis(p)
     END DO
    END DO
!------------------------------------------------------------------------------
  END SUBROUTINE LocalMatrix
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
END SUBROUTINE TuringSolver
!------------------------------------------------------------------------------

! *****************************************************************************/
! *
! *       ELMER, A Computational Fluid Dynamics Program.
! *
! *       Copyright 1st April 1995 - , Center for Scientific Computing,
! *                                    Finland.
! *
! *       All rights reserved. No part of this program may be used,
! *       reproduced or transmitted in any form or by any means
! *       without the written permission of CSC.
! *
! *****************************************************************************/
!
!/******************************************************************************
! *
! * Module containing a solver for (primarily thermal) Porous material flow
! *
! ******************************************************************************
! *
! *                     Author:       Juha Ruokolainen
! *
! *                    Address: Center for Scientific Computing
! *                            Tietotie 6, P.O. Box 405
! *                              02101 Espoo, Finland
! *                              Tel. +358 0 457 2723
! *                            Telefax: +358 0 457 2302
! *                          EMail: Juha.Ruokolainen@csc.fi
! *
! *                       Date: 08 Jun 1997
! *
! *                Modified by:  OG 
! *
! *       Date of modification: 
! *
! *****************************************************************************/
!------------------------------------------------------------------------------
   RECURSIVE SUBROUTINE PorousSolver( Model,Solver,dt,TransientSimulation )
!------------------------------------------------------------------------------

    USE DefUtils

    IMPLICIT NONE

!------------------------------------------------------------------------------
!******************************************************************************
!
!  Solve stress equations for one timestep
!
!  ARGUMENTS:
!
!  TYPE(Model_t) :: Model,  
!     INPUT: All model information (mesh,materials,BCs,etc...)
!
!  TYPE(Solver_t) :: Solver
!     INPUT: Linear equation solver options
!
!  REAL(KIND=dp) :: dt,
!     INPUT: Timestep size for time dependent simulations (NOTE: Not used
!            currently)
!
!
!    Solve:  -p,j + Sij,j + D.fi = 0 and ui,i + Kcp.p = 0
!    with 
!       Sij = 2 eta ( Eij - Ekk / 3 delta_ij) 
!       Kcp = b(D) B^(1/n) ED^{(n-1)/n}
!       ED^2 = 2 eij.eij/a(D) + Ekk^2/b(D)
!       eta = 2/a(D) B^{-1/n} ED^{(1-n)/n}
!       The relative density D is an input for this solver
!   From Gagliardini and Meyssonnier, 1997. Annals of Glaciology 24.
!
!
!******************************************************************************

     TYPE(Model_t)  :: Model
     TYPE(Solver_t), TARGET :: Solver

     LOGICAL ::  TransientSimulation
     REAL(KIND=dp) :: dt
!------------------------------------------------------------------------------
!    Local variables
!------------------------------------------------------------------------------
     TYPE(Solver_t), POINTER :: PSolver

     TYPE(Matrix_t),POINTER :: StiffMatrix

     INTEGER :: i, j, k, l, n, t, iter, NDeg, STDOFs, LocalNodes, istat
     INTEGER :: dim, comp 

     TYPE(ValueList_t),POINTER :: Material, BC, BodyForce
     TYPE(Nodes_t) :: ElementNodes
     TYPE(Element_t),POINTER :: CurrentElement

     REAL(KIND=dp) :: RelativeChange, UNorm, PrevUNorm, Gravity(3), &
         Normal(3), NewtonTol, NonlinearTol, s, Wn(2), MinSRInvariant
         

     REAL(KIND=dp)  :: NodalStresses(3,3), &
       NodalStrainRate(3,3),  NodalSpin(3,3)   

     REAL(KIND=dp), ALLOCATABLE :: Basis(:),ddBasisddx(:,:,:)
     REAL(KIND=dp), ALLOCATABLE :: dBasisdx(:,:), SlipCoeff(:,:)
     REAL(KIND=dp) :: u,v,w,detJ
     
     LOGICAL :: stat, CSymmetry 
       
     INTEGER, PARAMETER :: INDi(1:6) = (/ 1, 2, 3, 1, 2, 3 /) ,&
           INDj(1:6)=(/ 1, 2, 3, 2, 3, 1 /)

     INTEGER :: NewtonIter, NonlinearIter

     TYPE(Variable_t), POINTER :: PorousSol, DensityVariable
     TYPE(Variable_t), POINTER :: SpinVar
     REAL(KIND=dp), POINTER :: SpinValues(:)
     INTEGER, POINTER :: SpinPerm(:)

     TYPE(Variable_t), POINTER :: DevStressVar 
     REAL(KIND=dp), POINTER :: DSValues(:)
     INTEGER, POINTER :: DSPerm(:)

     TYPE(Variable_t), POINTER :: StrainRateVar 
     REAL(KIND=dp), POINTER :: SRValues(:)
     INTEGER, POINTER :: SRPerm(:)

     REAL(KIND=dp), POINTER ::  Porous(:), Work(:,:), &
           ForceVector(:),  NodalPorous(:), PorousComp(:), &
           DensityValues(:)

     CHARACTER(LEN=MAX_NAME_LEN) :: EquationName

     INTEGER, POINTER :: PorousPerm(:), NodeIndexes(:), &
                         DensityPerm(:)

     INTEGER :: PorousType
     LOGICAL :: GotForceBC, GotIt, NewtonLinearization = .FALSE., &
                NormalTangential=.FALSE.

     INTEGER :: body_id,bf_id
     INTEGER :: old_body = -1
     LOGICAL :: AllocationsDone = .FALSE., FreeSurface, &
                Requal0
           
     REAL(KIND=dp), ALLOCATABLE:: LocalMassMatrix(:,:), &
       LocalStiffMatrix(:,:), LoadVector(:,:), LocalForce(:), &
       Alpha(:,:), Beta(:), & 
       BoundaryDispl(:), LocalDensity(:), &
       TimeForce(:), RefS(:), RefD(:), RefSpin(:), &
       LocalVelo(:,:), LocalFluidity(:), Localfa(:), Localfb(:)
            
     INTEGER :: NumberOfBoundaryNodes
     INTEGER, POINTER :: BoundaryReorder(:)

     REAL(KIND=dp) :: Bu, Bv, Bw, RM(3,3)
     REAL(KIND=dp), POINTER :: BoundaryNormals(:,:), &
         BoundaryTangent1(:,:), BoundaryTangent2(:,:)

     REAL(KIND=dp) :: at, at0, CPUTime, RealTime


!------------------------------------------------------------------------------
     SAVE NumberOfBoundaryNodes,BoundaryReorder,BoundaryNormals, &
              BoundaryTangent1, BoundaryTangent2

     SAVE TimeForce, Basis, dBasisdx, ddBasisddx
     SAVE LocalMassMatrix, LocalStiffMatrix, LoadVector, &
       LocalForce, ElementNodes, Alpha, Beta,  &
       AllocationsDone,BoundaryDispl, &
       NodalPorous, LocalDensity, Wn, MinSRInvariant, old_body, &
       LocalFluidity, Localfa, Localfb

     SAVE RefD, RefS, RefSpin, LocalVelo, SlipCoeff 
              
!------------------------------------------------------------------------------
!  Read constants from constants section of SIF file
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
!    Get variables needed for solution
!------------------------------------------------------------------------------
      IF ( .NOT. ASSOCIATED( Solver % Matrix ) ) RETURN

      PorousSol => Solver % Variable
      PorousPerm => PorousSol % Perm
      STDOFs =  PorousSol % DOFs
      Porous => PorousSol % Values

      LocalNodes = COUNT( PorousPerm > 0 )
      IF ( LocalNodes <= 0 ) RETURN


      DensityVariable => &
              VariableGet(Solver % Mesh %Variables,'Relative Density')
      IF ( ASSOCIATED( DensityVariable ) ) THEN
       DensityPerm    => DensityVariable % Perm
       DensityValues => DensityVariable % Values
      END IF

      SpinVar => VariableGet(Solver % Mesh %Variables,'Spin')
      IF ( ASSOCIATED( SpinVar ) ) THEN
      SpinPerm => SpinVar % Perm    
      SpinValues => SpinVar % Values  
      END IF
      
      StrainRateVar => VariableGet(Solver % Mesh %Variables,'StrainRate')
      IF ( ASSOCIATED( StrainRateVar ) ) THEN
      SRPerm => StrainRateVar % Perm    
      SRValues => StrainRateVar % Values  
      END IF

      DevStressVar => &
               VariableGet(Solver % Mesh % Variables,'DeviatoricStress')
      IF ( ASSOCIATED( DevStressVar ) ) THEN
      DSPerm => DevStressVar % Perm    
      DSValues => DevStressVar % Values  
      END IF

      StiffMatrix => Solver % Matrix
      ForceVector => StiffMatrix % RHS
      UNorm = Solver % Variable % Norm

!------------------------------------------------------------------------------
!     Allocate some permanent storage, this is done first time only
!------------------------------------------------------------------------------
      IF ( .NOT. AllocationsDone .OR. Solver % Mesh % Changed) THEN
        N = Model % MaxElementNodes
        dim = CoordinateSystemDimension()

       IF ( AllocationsDone ) THEN
         DEALLOCATE( ElementNodes % x,     &
                     ElementNodes % y,     &
                     ElementNodes % z,     &
                     BoundaryDispl,        &
                     LocalVelo,            &
                     LocalDensity,         &
                     LocalForce,           &
                     RefD, RefS, RefSpin,  &
                     LocalMassMatrix,      &
                     LocalStiffMatrix,     &
                     LoadVector, Alpha, Beta, &
                     SlipCoeff, LocalFluidity , &
                     Localfa, Localfb )
       END IF

       ALLOCATE( ElementNodes % x( N ), &
                 ElementNodes % y( N ), &
                 ElementNodes % z( N ), &
                 BoundaryDispl( N ), &
                 LocalDensity( N ), &
                 LocalForce( 2*STDOFs*N ),&
                 RefS(2*dim*LocalNodes ),&                              
                 RefD(2*dim*LocalNodes ),&                              
                 RefSpin((2*dim-3)*LocalNodes ),&                       
                 LocalVelo( 3,N ),&                                     
                 Basis( 2*N ),ddBasisddx(1,1,1), dBasisdx( 2*N,3 ), &
                 TimeForce( 2*STDOFs*N ), &
                 LocalMassMatrix( 2*STDOFs*N,2*STDOFs*N ),  &
                 LocalStiffMatrix( 2*STDOFs*N,2*STDOFs*N ),  &
                 LoadVector( 4,N ), Alpha( 3,N ), Beta( N ), &
                 SlipCoeff(3,N), LocalFluidity(N), &
                 Localfa( N ), Localfb( N ),  STAT=istat )

       IF ( istat /= 0 ) THEN
          CALL Fatal( 'PorousSolve', 'Memory allocation error.' )
       END IF
!------------------------------------------------------------------------------
!    Check for normal/tangetial coordinate system defined velocities
!------------------------------------------------------------------------------
       CALL CheckNormalTangentialBoundary( Model, &
        'Normal-Tangential Porous', NumberOfBoundaryNodes, &
          BoundaryReorder, BoundaryNormals, BoundaryTangent1, &
             BoundaryTangent2, Model % Dimension )
!------------------------------------------------------------------------------

       AllocationsDone = .TRUE.
      END IF

!------------------------------------------------------------------------------
!    Do some additional initialization, and go for it
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
      NonlinearTol = GetConstReal( Solver % Values, &
        'Nonlinear System Convergence Tolerance' )

      NewtonTol = GetConstReal( Solver % Values, &
        'Nonlinear System Newton After Tolerance' )

      NewtonIter = GetInteger( Solver % Values, &
        'Nonlinear System Newton After Iterations' )

      NonlinearIter = GetInteger( Solver % Values, &
         'Nonlinear System Max Iterations',GotIt )

      IF ( .NOT.GotIt ) NonlinearIter = 1
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------

      EquationName = GetString( Solver % Values, 'Equation' )

      FreeSurface = .FALSE.

!------------------------------------------------------------------------------
      DO iter=1,NonlinearIter

       at  = CPUTime()
       at0 = RealTime()

       CALL Info( 'PorousSolve', ' ', Level=4 )
       CALL Info( 'PorousSolve', ' ', Level=4 )
       CALL Info( 'PorousSolve', &
                   '-------------------------------------',Level=4 )
       WRITE( Message, * ) 'POROUS MATERIAL FLOW SOLVER ITERATION', iter
       CALL Info( 'PorousSolve', Message,Level=4 )
       CALL Info( 'PorousSolve', &
                   '-------------------------------------',Level=4 )
       CALL Info( 'PorousSolve', ' ', Level=4 )
       CALL Info( 'PorousSolve', 'Starting assembly...',Level=4 )
!------------------------------------------------------------------------------
!      Compute average normals for boundaries having the normal & tangential
!      field components specified on the boundaries
!------------------------------------------------------------------------------
       IF ( (iter == 1 .OR. FreeSurface) .AND. NumberOfBoundaryNodes > 0 ) THEN
          CALL AverageBoundaryNormals( Model, &
               'Normal-Tangential Porous', NumberOfBoundaryNodes, &
            BoundaryReorder, BoundaryNormals, BoundaryTangent1, &
               BoundaryTangent2, Model % Dimension )
       END IF
!------------------------------------------------------------------------------
       CALL DefaultInitialize()
!------------------------------------------------------------------------------
       DO t=1,Solver % NumberOFActiveElements

         IF ( RealTime() - at0 > 1.0 ) THEN
           WRITE(Message,'(a,i3,a)' ) '   Assembly: ',  &
             INT(100.0 - 100.0 * (Solver % NumberOfActiveElements-t) / &
             (1.0*Solver % NumberOfActiveElements)), ' % done'
           CALL Info( 'PorousSolve', Message, Level=5 )
           at0 = RealTime()
         END IF

         CurrentElement => GetActiveElement(t)
         n = GetElementNOFNodes()
         NodeIndexes => CurrentElement % NodeIndexes

         ElementNodes % x(1:n) = Model % Nodes % x(NodeIndexes(1:n))
         ElementNodes % y(1:n) = Model % Nodes % y(NodeIndexes(1:n))
         ElementNodes % z(1:n) = Model % Nodes % z(NodeIndexes(1:n))

         Material => GetMaterial()

!------------------------------------------------------------------------------
!    Read in material constants from Material section
!------------------------------------------------------------------------------
         body_id = CurrentElement % BodyId
         IF (body_id /= old_body) Then 
            old_body = body_id
            Call  GetMaterialDefs()
        END IF

        LocalFluidity(1:n) = ListGetReal( Material, &
                         'Fluidity Parameter', n, NodeIndexes, GotIt )
        IF (.NOT.GotIt) THEN
         WRITE(Message,'(A)') 'Variable Fluidity Parameter not found. &
                            &Setting to 1.0'
         CALL INFO('PorousSolve', Message, Level = 20)
         LocalFluidity(1:n) = 1.0
        END IF
!
! Function a(D) (=1 if incompressible)
! 
        Localfa(1:n) = ListGetReal( Material, &
                         'FunctionA', n, NodeIndexes, GotIt )
        IF (.NOT.GotIt) THEN
         WRITE(Message,'(A)') 'FunctionA not found. &
                            &Setting to 1.0'
         CALL INFO('PorousSolve', Message, Level = 20)
         Localfa(1:n) = 1.0
        END IF
!
! Function b(D) (=0 if incompressible)
! 
        Localfb(1:n) = ListGetReal( Material, &
                         'FunctionB', n, NodeIndexes, GotIt )
        IF (.NOT.GotIt) THEN
         WRITE(Message,'(A)') 'FunctionB not found. &
                            &Setting to 0.0'
         CALL INFO('PorousSolve', Message, Level = 20)
         Localfb(1:n) = 0.0
        END IF

!------------------------------------------------------------------------------
!        Set body forces
!------------------------------------------------------------------------------
         LoadVector = 0.0D0

         BodyForce => GetBodyForce()
         IF ( ASSOCIATED( BodyForce ) ) THEN
           LoadVector(1,1:n) = LoadVector(1,1:n) + ListGetReal( &
                   BodyForce, 'Porous Force 1', n, NodeIndexes, gotIt)
           LoadVector(2,1:n) = LoadVector(2,1:n) + ListGetReal( &
                   BodyForce, 'Porous Force 2', n, NodeIndexes, gotIt)
           LoadVector(3,1:n) = LoadVector(3,1:n) + ListGetReal( & 
                   BodyForce, 'Porous Force 3', n, NodeIndexes, gotIt)
         END IF
!------------------------------------------------------------------------------
!        Get element local stiffness & mass matrices
!------------------------------------------------------------------------------

         LocalDensity(1:n)= DensityValues(DensityPerm(NodeIndexes(1:n)))

         LocalVelo = 0.0d0
         DO i=1,STDOFs - 1
            LocalVelo(i,1:n) = Porous( STDOFs*(PorousPerm(NodeIndexes(1:n))-1) + i)
         END DO
         CALL LocalMatrix( LocalMassMatrix, LocalStiffMatrix, &
              LocalForce, LoadVector, LocalDensity, LocalVelo, &
              LocalFluidity, CurrentElement, n, &
              ElementNodes, Wn, MinSRInvariant, Localfa, Localfb )

!------------------------------------------------------------------------------
!        Update global matrices from local matrices 
!------------------------------------------------------------------------------
         IF ( TransientSimulation ) THEN 
           CALL Default1stOrderTime( LocalMassMatrix, &
                LocalStiffMatrix, LocalForce )
         END IF
         CALL DefaultUpdateEquations( LocalStiffMatrix, LocalForce )
      END DO

      CALL Info( 'PorousSolve', 'Assembly done', Level=4 )

!------------------------------------------------------------------------------
!     Neumann & Newton boundary conditions
!------------------------------------------------------------------------------
      DO t = 1, Model % NumberOFBoundaryElements

        CurrentElement => GetBoundaryElement(t)
        IF ( GetElementFamily() == 101 ) CYCLE
        IF ( .NOT. ActiveBoundaryElement() ) CYCLE

        n = GetElementNOFNodes()
        NodeIndexes => CurrentElement % NodeIndexes

        ElementNodes % x(1:n) = Model % Nodes % x(NodeIndexes(1:n))
        ElementNodes % y(1:n) = Model % Nodes % y(NodeIndexes(1:n))
        ElementNodes % z(1:n) = Model % Nodes % z(NodeIndexes(1:n))

        BC => GetBC()
        IF ( ASSOCIATED( BC ) ) THEN
            LoadVector = 0.0D0
            Alpha      = 0.0D0
            Beta       = 0.0D0
!------------------------------------------------------------------------------
!           Force in given direction BC: \tau\cdot n = F
!------------------------------------------------------------------------------
            GotForceBC = .FALSE.

            LoadVector(1,1:n) = &
                    ListGetReal( BC, 'Force 1', n, NodeIndexes,  GotIt )
            GotForceBC = GotForceBC .OR. gotIt

            LoadVector(2,1:n) = & 
                     ListGetReal( BC, 'Force 2', n, NodeIndexes, GotIt )
            GotForceBC = GotForceBC .OR. gotIt

            LoadVector(3,1:n) = &
                     ListGetReal( BC, 'Force 3', n, NodeIndexes, GotIt )
            GotForceBC = GotForceBC .OR. gotIt

            Beta(1:n) = &
                ListGetReal( BC, 'Normal Force', n, NodeIndexes, GotIt )
            GotForceBC = GotForceBC .OR. gotIt

!------------------------------------------------------------------------------
!             slip boundary condition BC: \tau\cdot n = R_k u_k
!------------------------------------------------------------------------------

              SlipCoeff = 0.0d0
              SlipCoeff(1,1:n) =  ListGetReal( BC, &
                    'Porous Slip Coeff 1', n, NodeIndexes, GotIt )
              GotForceBC = GotForceBC .OR. gotIt

              SlipCoeff(2,1:n) =  ListGetReal( BC, &
                    'Porous Slip Coeff 2', n, NodeIndexes, GotIt )
              GotForceBC = GotForceBC .OR. gotIt

              SlipCoeff(3,1:n) =  ListGetReal( BC, &
                    'Porous Slip Coeff 3', n, NodeIndexes, GotIt )
              GotForceBC = GotForceBC .OR. gotIt

              NormalTangential = ListGetLogical( BC, &
                     'Normal-Tangential Porous', GotIt )
               
            IF ( .NOT.GotForceBC ) CYCLE
!------------------------------------------------------------------------------
            CALL LocalMatrixBoundary( LocalStiffMatrix, LocalForce, &
                 LoadVector, Alpha, Beta, SlipCoeff, NormalTangential, &
                 CurrentElement, n, ElementNodes )
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!           If boundary fields have been defined in normal/tangetial coordinate
!           systems, weŽll have to rotate the matrix & force vector to that
!           coordinate system
!------------------------------------------------------------------------------
            IF ( NumberOfBoundaryNodes > 0 ) THEN
              CALL RotateMatrix( LocalStiffMatrix, LocalForce, n,&
                   CoordinateSystemDimension(), STDOFs, &
                   BoundaryReorder(NodeIndexes), BoundaryNormals, &
                   BoundaryTangent1, BoundaryTangent2 )
            END IF
!------------------------------------------------------------------------------
!           Update global matrices from local matrices (will also affect
!           LocalStiffMatrix and LocalForce if transientsimulation is on).
!------------------------------------------------------------------------------
            LocalMassMatrix = 0.0_dp
            IF ( TransientSimulation ) THEN
              CALL Default1stOrderTime( LocalMassMatrix, & 
                   LocalStiffMatrix, LocalForce )
            END IF
            CALL DefaultUpdateEquations( LocalStiffMatrix, LocalForce )
!------------------------------------------------------------------------------
         END IF
      END DO
!------------------------------------------------------------------------------

      CALL DefaultFinishAssembly()

!------------------------------------------------------------------------------
!     Dirichlet boundary conditions
!------------------------------------------------------------------------------
      CALL DefaultDirichletBCs()
!------------------------------------------------------------------------------

      CALL Info( 'PorousSolve', 'Set boundaries done', Level=4 )

!------------------------------------------------------------------------------
!     Solve the system and check for convergence
!------------------------------------------------------------------------------
      PrevUNorm = UNorm

      UNorm = DefaultSolve()
      
      UNorm = 0.0_dp
      n = Solver % Variable % DOFs
      DO i=1,n-1
        UNorm = UNorm + SUM( Solver % Variable % Values(i::n)**2 )
      END DO
      UNorm = SQRT(UNorm)
      Solver % Variable % norm = UNorm

      IF ( PrevUNorm + UNorm /= 0.0d0 ) THEN
         RelativeChange = 2.0d0 * ABS( PrevUNorm - UNorm) / ( PrevUnorm + UNorm)
      ELSE
         RelativeChange = 0.0d0
      END IF

      WRITE( Message, * ) 'Result Norm   : ',UNorm, PrevUNorm
      CALL Info( 'PorousSolve', Message, Level=4 )
      WRITE( Message, * ) 'Relative Change : ',RelativeChange
      CALL Info( 'PorousSolve', Message, Level=4 )

!------------------------------------------------------------------------------
      IF ( RelativeChange < NewtonTol .OR. &
             iter > NewtonIter ) NewtonLinearization = .TRUE.

      IF ( RelativeChange < NonLinearTol ) EXIT

!------------------------------------------------------------------------------
    END DO ! of nonlinear iter
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
!   Compute the StrainRate, Spin  and deviatoric Stress
!   Nodal values      
!------------------------------------------------------------------------------

     IF ((ASSOCIATED( StrainRateVar)).OR.(ASSOCIATED(DevStressVar))&
      .OR.(ASSOCIATED(SpinVar))) THEN
       RefD=0.
       RefS=0.
       RefSpin=0.
       IF (ASSOCIATED(StrainRateVar)) SRValues = 0.
       IF (ASSOCIATED(devStressVar)) DSValues = 0.
       IF (ASSOCIATED(SPinVar)) SpinValues = 0.

      DO t=1,Solver % NumberOFActiveElements

         CurrentElement => GetActiveElement(t)
         n = GetElementNOFNodes()
         NodeIndexes => CurrentElement % NodeIndexes

         body_id = CurrentElement % BodyId
         CSymmetry = CurrentCoordinateSystem() == AxisSymmetric
         dim = CoordinateSystemDimension()

!------------------------------------------------------------------------------
!    Read in material constants from Material section
!------------------------------------------------------------------------------
        IF (body_id /= old_body) Then 
              old_body = body_id
              Call  GetMaterialDefs()
        END IF

        LocalFluidity(1:n) = ListGetReal( Material, &
                      'Fluidity Parameter', n, NodeIndexes, GotIt )
        IF (.NOT.GotIt) THEN
         WRITE(Message,'(A)') 'Variable Fluidity Parameter not found. &
                            &Setting to 1.0'
         CALL INFO('PorousSolve', Message, Level = 20)
         LocalFluidity(1:n) = 1.0
        END IF


         ElementNodes % x(1:n) = Model % Nodes % x(NodeIndexes(1:n))
         ElementNodes % y(1:n) = Model % Nodes % y(NodeIndexes(1:n))
         ElementNodes % z(1:n) = Model % Nodes % z(NodeIndexes(1:n))

         
!
! Function a(D) (=1 if incompressible)
! 
        Localfa(1:n) = ListGetReal( Material, &
                         'FunctionA', n, NodeIndexes, GotIt )
        IF (.NOT.GotIt) THEN
         WRITE(Message,'(A)') 'FunctionA not found. &
                            &Setting to 1.0'
         CALL INFO('PorousSolve', Message, Level = 20)
         Localfa(1:n) = 1.0
        END IF
!
! Function b(D) (=0 if incompressible)
! 
        Localfb(1:n) = ListGetReal( Material, &
                         'FunctionB', n, NodeIndexes, GotIt )
        IF (.NOT.GotIt) THEN
         WRITE(Message,'(A)') 'FunctionB not found. &
                            &Setting to 0.0'
         CALL INFO('PorousSolve', Message, Level = 20)
         Localfb(1:n) = 0.0
        END IF

         LocalDensity(1:n) =DensityValues(DensityPerm(NodeIndexes(1:n)))

         LocalVelo = 0.0d0
         DO i=1,STDOFs - 1
            LocalVelo(i,1:n) = Porous( STDOFs*(PorousPerm(NodeIndexes(1:n))-1) + i)
         END DO
! Go for all nodes of the element        
         Do i=1,n

! u, v, w local coord of node i
           u = CurrentElement % Type % NodeU(i)
           v = CurrentElement % Type % NodeV(i)
           w = CurrentElement % Type % NodeW(i)
       
            stat = ElementInfo(CurrentElement,ELementNodes,u,v,w,detJ, &
               Basis,dBasisdx,ddBasisddx,.FALSE.,.FALSE.)
! Axi symmetric case when R=0 strain, stress not calculated exactly in
! x=0 (I agree it is not very nice, better solution ???)
        Requal0 = .False.
        IF (( CSymmetry) .And. & 
          (SUM(ElementNodes % x(1:n) * Basis(1:n)) == 0.0)) THEN  
           Requal0 = .True.
            u= u + 0.0001  
            stat = ElementInfo(CurrentElement,ELementNodes,u,v,w,detJ, &
               Basis,dBasisdx,ddBasisddx,.FALSE.,.FALSE.)
        END IF

           CALL LocalSD(NodalStresses, NodalStrainRate, NodalSpin, & 
                 LocalVelo, LocalFluidity,  &
                LocalDensity, CSymmetry, Basis, dBasisdx, &
                CurrentElement, n, ElementNodes, dim, Wn, &
                MinSRInvariant, Localfa, Localfb )
                

        IF (Requal0) NodalSpin = 0. 

           IF (ASSOCIATED(StrainRateVar)) &
             RefD(2*dim*(SRPerm(NodeIndexes(i))-1)+1 : &
                                      2*dim*SRPerm(NodeIndexes(i))) &
             =RefD(2*dim*(SRPerm(NodeIndexes(i))-1)+1 : &
                                      2*dim*SRPerm(NodeIndexes(i))) + 1.

          IF (ASSOCIATED(DevStressVar)) &
            RefS(2*dim*(DSPerm(NodeIndexes(i))-1)+1 : &
                                      2*dim*DSPerm(NodeIndexes(i))) &
            =RefS(2*dim*(DSPerm(NodeIndexes(i))-1)+1 :  &
                                      2*dim*DSPerm(NodeIndexes(i))) + 1.

          IF (ASSOCIATED(SpinVar)) &
            RefSpin((2*dim-3)*(SpinPerm(NodeIndexes(i))-1)+1 :  &
                                (2*dim-3)*SpinPerm(NodeIndexes(i))) &
            =RefSpin((2*dim-3)*(SpinPerm(NodeIndexes(i))-1)+1 :  &
                                (2*dim-3)*SpinPerm(NodeIndexes(i))) + 1.


           IF (ASSOCIATED(StrainRateVar)) THEN
             comp=0
             DO j=1,2*dim
               comp=comp+1
               SRValues(2*dim*(SRPerm(NodeIndexes(i))-1)+comp)=&
               SRValues(2*dim*(SRPerm(NodeIndexes(i))-1)+comp) + &
                NodalStrainRate(INDi(j),INDj(j))
             END DO
           END IF

           IF (ASSOCIATED(DevStressVar)) THEN
             comp=0
             DO j=1,2*dim
               comp=comp+1
               DSValues(2*dim*(DSPerm(NodeIndexes(i))-1)+comp)=&
                DSValues(2*dim*(DSPerm(NodeIndexes(i))-1)+comp) + &
                NodalStresses(INDi(j),INDj(j))
             END DO
           END IF

           IF (ASSOCIATED(SpinVar)) THEN
             comp=0
             DO j=1,(2*dim-3)
             comp=comp+1
             SpinValues((2*dim-3)*(SpinPerm(NodeIndexes(i))-1)+comp)=&
             SPinValues((2*dim-3)*(SpinPerm(NodeIndexes(i))-1)+comp) + &
             NodalSpin(INDi(j+3),INDj(j+3))
             END DO
           END IF

          END DO
        END DO

        IF (ASSOCIATED(StrainRateVar)) THEN
              WHERE(RefD > 0.)
                SRVAlues = SRValues / RefD
              END WHERE
        END IF
        
        IF (ASSOCIATED(DevStressVar)) THEN
           WHERE(RefS > 0.)
                DSVAlues = DSValues / RefS
           END WHERE
        END IF

        IF (ASSOCIATED(SpinVar)) THEN
            WHERE(RefSpin > 0.)
                SpinVAlues = SpinValues / RefSpin
            END WHERE
        END IF
        
    END IF

!------------------------------------------------------------------------------
!  END  Compute the StrainRate and Deviatoric Stress
!------------------------------------------------------------------------------
      
CONTAINS

      SUBROUTINE GetMaterialDefs()

      Wn(2) = ListGetConstReal( Material , 'Powerlaw Exponent', GotIt )
      IF (.NOT.GotIt) THEN
         WRITE(Message,'(A)') 'Variable  Powerlaw Exponent not found. &
                                    & Setting to 1.0'
         CALL INFO('PorousSolve', Message, Level = 20)
         Wn(2) = 1.0
      ELSE
       WRITE(Message,'(A,F10.4)') 'Powerlaw Exponent = ',   Wn(2)
       CALL INFO('PorousSolve', Message, Level = 20)
       END IF

! Get the Minimum value of the Effective Strain rate 
      MinSRInvariant = 10e-10_dp 
      IF ( Wn(2) > 1.0 ) THEN
        MinSRInvariant =  &
             ListGetConstReal( Material, 'Min Second Invariant', GotIt )
        IF (.NOT.GotIt) THEN
          WRITE(Message,'(A)') 'Variable Min Second Invariant not &
                    &found. Setting to 100.0*AEPS )'
          CALL INFO('PorousSolve', Message, Level = 20)
        ELSE
          WRITE(Message,'(A,E14.8)') 'Min Second Invariant = ', MinSRInvariant
          CALL INFO('PorousSolve', Message, Level = 20)
        END IF
      END IF

!------------------------------------------------------------------------------
      END SUBROUTINE GetMaterialDefs
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
      SUBROUTINE LocalMatrix( MassMatrix, StiffMatrix, ForceVector, &
              LoadVector, NodalDensity, NodalVelo, &
              NodalFluidity, Element, n, Nodes, Wn, MinSRInvariant, &
              Nodalfa, Nodalfb )
              
              
              
              
!------------------------------------------------------------------------------

     REAL(KIND=dp) :: StiffMatrix(:,:), MassMatrix(:,:)
     REAL(KIND=dp) :: LoadVector(:,:), NodalVelo(:,:)
     REAL(KIND=dp) :: Wn(2), MinSRInvariant
     REAL(KIND=dp), DIMENSION(:) :: ForceVector, NodalDensity,  &
                    NodalFluidity, Nodalfa, Nodalfb
     TYPE(Nodes_t) :: Nodes
     TYPE(Element_t) :: Element
     INTEGER :: n
!------------------------------------------------------------------------------
!
     REAL(KIND=dp) :: Basis(2*n),ddBasisddx(1,1,1)
     REAL(KIND=dp) :: dBasisdx(2*n,3),SqrtElementMetric

     REAL(KIND=dp) :: Force(3), density, fa, fb 
     Real(kind=dp) :: Bg, BGlenT

     REAL(KIND=dp), DIMENSION(4,4) :: A,M
     REAL(KIND=dp) :: Load(3)
     REAL(KIND=dp) :: nn, ss, LGrad(3,3), SR(3,3)

     INTEGER :: i, j, k, p, q, t, dim, NBasis, ind(3)

     REAL(KIND=dp) :: s,u,v,w, Radius
     REAL(KIND=dp) :: ParameterA, ParameterB
  
     REAL(KIND=dp) :: Em, eta, Kcp
     TYPE(GaussIntegrationPoints_t), TARGET :: IntegStuff

     INTEGER :: N_Integ

     REAL(KIND=dp), DIMENSION(:), POINTER :: U_Integ,V_Integ,W_Integ,S_Integ

     LOGICAL :: stat, CSymmetry


!------------------------------------------------------------------------------
      dim = CoordinateSystemDimension()

      ForceVector = 0.0D0
      StiffMatrix = 0.0D0
      MassMatrix  = 0.0D0

!    
!    Integration stuff
!    
      NBasis = 2*n
      IntegStuff = GaussPoints( Element, Element % Type % GaussPoints2 )

      U_Integ => IntegStuff % u
      V_Integ => IntegStuff % v
      W_Integ => IntegStuff % w
      S_Integ => IntegStuff % s
      N_Integ =  IntegStuff % n
!
!   Now we start integrating
!
      DO t=1,N_Integ

      u = U_Integ(t)
      v = V_Integ(t)
      w = W_Integ(t)

!------------------------------------------------------------------------------
!     Basis function values & derivatives at the integration point
!------------------------------------------------------------------------------
      stat = ElementInfo( Element,Nodes,u,v,w,SqrtElementMetric, &
            Basis,dBasisdx,ddBasisddx,.FALSE.,.TRUE. )

      s = SqrtElementMetric * S_Integ(t)
!------------------------------------------------------------------------------
!  
!     Force at integration point
!   
      Force = 0.0d0
      DO i=1,dim
         Force(i) = SUM( LoadVector(i,1:n)*Basis(1:n))
      END DO


      Radius = SUM( Nodes % x(1:n) * Basis(1:n) )
!
!    variables at the integration point
!
      Density = SUM( NodalDensity(1:n)*Basis(1:n) )
!
! Nodal value interpolated at the integration point
!
!     fa = SUM( Nodalfa(1:n)*Basis(1:n) )
!     fb = SUM( Nodalfb(1:n)*Basis(1:n) )
!
! Integration point value function of the integration pt density
      fa = ParameterA(Density)
      fb = ParameterB(Density)

      write(*,*)Density,fa,fb

      Wn(1) = SUM( NodalFluidity(1:n)*Basis(1:n) )

      Bg=Wn(1)                      

      CSymmetry = CurrentCoordinateSystem() == AxisSymmetric
      IF ( CSymmetry ) s = s * Radius

!
! Case non-linear calculate E_D^2 = gamma_e^2/fa + E_m^2/fb
! ----------------------------------------------------------
      ss = 1.0_dp
      IF ( Wn(2) > 1.0 ) THEN
        LGrad = MATMUL( NodalVelo(:,1:n), dBasisdx(1:n,:) )
        SR = 0.5 * ( LGrad + TRANSPOSE(LGrad) )
      
        IF ( CSymmetry ) THEN
          SR(1,3) = 0.0
          SR(2,3) = 0.0
          SR(3,1) = 0.0
          SR(3,2) = 0.0
          SR(3,3) = 0.0
          IF ( Radius > 10*AEPS ) THEN
            SR(3,3) = SUM( Nodalvelo(1,1:n) * Basis(1:n) ) /Radius
          END IF
        END IF

        Em = SR(1,1)+SR(2,2)+SR(3,3)
        DO i = 1, 3
          SR(i,i) = SR(i,i) - Em/3.0
        END DO

        ss = 0.0_dp
        DO i = 1, 3
          DO j = 1, 3
            ss = ss + SR(i,j)**2
          END DO
        END DO
        ss = 2.0*ss / fa
        IF ( fb /= 0.0_dp ) ss = ss + Em**2 / fb

        nn =(1.0 - Wn(2))/Wn(2)

        ss = SQRT(ss)
        IF (ss < MinSRInvariant ) ss = MinSRInvariant
        ss =  ss**nn 
      END IF
!
! Bulk effective viscosity and Compressibility parameter Kcp 
!     
      eta = ss / (fa * Bg**( 1.0 / Wn( 2 ) ) ) 
      Kcp = fb * Bg**( 1.0 / Wn( 2 ) ) / ss 

!
!    Loop over basis functions (of both unknowns and weights)
!

      DO p=1,NBasis
       DO q=1,NBasis

        A = 0.0d0
        M = 0.0d0

         DO i=1,dim
           DO j=1,dim

! terms 2 eta Eij dEij
             A(i,i)=A(i,i) + eta* dbasisdx(q,j)*dbasisdx(p,j)
             A(i,j)=A(i,j) + eta* dbasisdx(q,i)*dbasisdx(p,j)

! terms 2 / 3 eta Eii dEii
             A(i,j)=A(i,j) - 2.0/3.0 * eta* dbasisdx(q,j)*dbasisdx(p,i)

           END DO

! Pressure gradient
            A(i,dim+1) = -dBasisdx(p,i) * Basis(q)

! Continuity equation:
            A(dim+1,i) = A(dim+1,i) + dBasisdx(q,i) * Basis(p)
         END DO

         IF ( CSymmetry ) A(1,dim+1) =  A(1,dim+1) - Basis(p) * Basis(q) / Radius
         IF ( CSymmetry ) A(dim+1,1) =  A(dim+1,1) + Basis(p) * Basis(q) / Radius


         A(dim+1, dim+1) = A(dim+1,dim+1) + Kcp * basis(q) * basis(p)

! Add nodal matrix to element matrix
         DO i=1,dim+1
            DO j=1,dim+1
               StiffMatrix( (dim+1)*(p-1)+i,(dim+1)*(q-1)+j ) =  &
                    StiffMatrix( (dim+1)*(p-1)+i,(dim+1)*(q-1)+j ) + s*A(i,j)
            END DO
         END DO

       END DO

! The righthand side...
        Load = 0.0d0
  
        DO i=1,dim
           Load(i) = Load(i) + Force(i) * Basis(p)
        END DO

        DO i=1,dim
           ForceVector((dim+1)*(p-1)+i) = ForceVector((dim+1)*(p-1)+i) +  &
                     s * Load(i) * Density
        END DO
      END DO
      END DO 

      DO j=n+1,n+Element % bdofs
        i = (dim+1)*j
        StiffMatrix(i,:) = 0.0_dp
        StiffMatrix(:,i) = 0.0_dp
        StiffMatrix(i,i) = 1.0_dp
        MassMatrix(:,i) = 0.0_dp
        MassMatrix(i,:) = 0.0_dp
        ForceVector(i) = 0.0_dp
      END DO

!------------------------------------------------------------------------------
      END SUBROUTINE LocalMatrix
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
      SUBROUTINE LocalMatrixBoundary( BoundaryMatrix, BoundaryVector, &
                 LoadVector, NodalAlpha, NodalBeta, NodalSlipCoeff, & 
                  NormalTangential, Element, n, Nodes )
                      
!------------------------------------------------------------------------------
     REAL(KIND=dp) :: BoundaryMatrix(:,:),BoundaryVector(:)
     REAL(KIND=dp) :: NodalAlpha(:,:),NodalBeta(:),LoadVector(:,:)
     REAL(KIND=dp) :: NodalSlipCoeff(:,:)
     TYPE(Element_t),POINTER  :: Element
     TYPE(Nodes_t)    :: Nodes
     LOGICAL :: NormalTangential
     INTEGER :: n
!------------------------------------------------------------------------------
     REAL(KIND=dp) :: Basis(n),ddBasisddx(1,1,1)
     REAL(KIND=dp) :: dBasisdx(n,3),SqrtElementMetric

     REAL(KIND=dp) :: u,v,w,s
     REAL(KIND=dp) :: Force(3),Alpha(3),Beta,Normal(3)
     REAL(KIND=dp), POINTER :: U_Integ(:),V_Integ(:),W_Integ(:),S_Integ(:)

     REAL(KIND=dp) :: Tangent(3),Tangent2(3),Vect(3), SlipCoeff
     INTEGER :: i,t,q,p,dim,N_Integ, c

     LOGICAL :: stat

     TYPE(GaussIntegrationPoints_t), TARGET :: IntegStuff
!------------------------------------------------------------------------------

      dim = CoordinateSystemDimension()
      c=dim+1

      BoundaryVector = 0.0D0
      BoundaryMatrix = 0.0D0
!
!  Integration stuff
!
      IntegStuff = GaussPoints( element )
      U_Integ => IntegStuff % u
      V_Integ => IntegStuff % v
      W_Integ => IntegStuff % w
      S_Integ => IntegStuff % s
      N_Integ =  IntegStuff % n
!
!  Now we start integrating
!
      DO t=1,N_Integ

       u = U_Integ(t)
       v = V_Integ(t)
       w = W_Integ(t)

!------------------------------------------------------------------------------
!    Basis function values & derivatives at the integration point
!------------------------------------------------------------------------------
       stat = ElementInfo( Element, Nodes, u, v, w, SqrtElementMetric, &
                Basis, dBasisdx, ddBasisddx, .FALSE. )

       s = SqrtElementMetric * S_Integ(t)
       IF ( CurrentCoordinateSystem() == AxisSymmetric ) &
        s = s * SUM( Nodes % x(1:n) * Basis(1:n) )
!------------------------------------------------------------------------------
       Force = 0.0D0
       DO i=1,dim
         Force(i) = SUM( LoadVector(i,1:n)*Basis(1:n) )
         Alpha(i) = SUM( NodalAlpha(i,1:n)*Basis(1:n) )
       END DO

       Normal = NormalVector( Element,Nodes,u,v,.TRUE. )
       Force = Force + SUM( NodalBeta(1:n)*Basis(1:n) ) * Normal

       SELECT CASE( Element % TYPE % DIMENSION )
       CASE(1)
        Tangent(1) =  Normal(2)
        Tangent(2) = -Normal(1)
        Tangent(3) =  0.0d0
       CASE(2)
        CALL TangentDirections( Normal, Tangent, Tangent2 ) 
       END SELECT
  
       IF ( ANY( NodalSlipCoeff(:,:) /= 0.0d0 ) ) THEN
         DO p=1,n
           DO q=1,n
             DO i=1,DIM
              SlipCoeff = SUM( NodalSlipCoeff(i,1:n) * Basis(1:n) )
  
              IF (NormalTangential ) THEN
                SELECT CASE(i)
                   CASE(1)
                     Vect = Normal
                   CASE(2)
                     Vect = Tangent
                   CASE(3)
                     Vect = Tangent2
                END SELECT
  
                DO j=1,DIM
                   DO k=1,DIM
                      BoundaryMatrix( (p-1)*c+j,(q-1)*c+k ) = &
                         BoundaryMatrix( (p-1)*c+j,(q-1)*c+k ) + &
                          s * SlipCoeff * Basis(q) * Basis(p) * Vect(j) * Vect(k)
                   END DO
                END DO
               ELSE
                 BoundaryMatrix( (p-1)*c+i,(q-1)*c+i ) = &
                     BoundaryMatrix( (p-1)*c+i,(q-1)*c+i ) + &
                          s * SlipCoeff * Basis(q) * Basis(p)
               END IF
             END DO
           END DO
         END DO
       END IF



      DO p=1,N
       DO q=1,N
         DO i=1,dim
           BoundaryMatrix((p-1)*(dim+1)+i,(q-1)*(dim+1)+i) =  &
             BoundaryMatrix((p-1)*(dim+1)+i,(q-1)*(dim+1)+i) + &
               s * Alpha(i) * Basis(q) * Basis(p)
         END DO
       END DO
      END DO

      DO q=1,N
       DO i=1,dim
         BoundaryVector((q-1)*(dim+1)+i) = BoundaryVector((q-1)*(dim+1)+i) + &
                   s * Basis(q) * Force(i)
       END DO
      END DO

      END DO
!------------------------------------------------------------------------------
      END SUBROUTINE LocalMatrixBoundary
!------------------------------------------------------------------------------


!------------------------------------------------------------------------------
      SUBROUTINE LocalSD( Stress, StrainRate, Spin, &
        NodalVelo,  NodalFluidity, Nodaldensity,  &
        CSymmetry, Basis, dBasisdx, Element, n,  Nodes, dim,  Wn, &
        MinSRInvariant, Nodalfa, Nodalfb )
       
!------------------------------------------------------------------------------
!    Subroutine to computre the nodal Strain-Rate, Stress, ...
!------------------------------------------------------------------------------
     LOGICAL ::  CSymmetry 
     INTEGER :: n, dim
     INTEGER :: INDi(6),INDj(6)
     REAL(KIND=dp) :: Stress(:,:), StrainRate(:,:), Spin(:,:)
     REAL(KIND=dp) :: NodalVelo(:,:), NodalFluidity(:)
     REAL(KIND=dp) :: Basis(2*n), ddBasisddx(1,1,1)
     REAL(KIND=dp) :: dBasisdx(2*n,3)
     REAL(KIND=dp) :: detJ
     REAL(KIND=dp) :: NodalDensity(:), Nodalfa(:), Nodalfb(:)
     REAL(KIND=dp) :: u, v, w      
     REAL(KIND=dp) :: Wn(2),  D(6), MinSRInvariant
     LOGICAL :: Isotropic
      
     TYPE(Nodes_t) :: Nodes
     TYPE(Element_t) :: Element
!------------------------------------------------------------------------------
     LOGICAL :: stat
     INTEGER :: i,j,k,p,q
     REAL(KIND=dp) :: LGrad(3,3), Radius, Density, fa, fb 
     REAL(KIND=dp) :: DSR(3,3),  Em 
     Real(kind=dp) :: Bg, BGlenT, ss, nn
!------------------------------------------------------------------------------
     
      Stress = 0.0
      StrainRate = 0.0
      Spin = 0.0

!
      Density = SUM( NodalDensity(1:n)*Basis(1:n) )
      fa = SUM( Nodalfa(1:n)*Basis(1:n) )
      fb = SUM( Nodalfb(1:n)*Basis(1:n) )
      Wn(1) = SUM( NodalFluidity(1:n)*Basis(1:n) )
      
      Bg=Wn(1)                
!
!    Compute strainRate : 
!    -------------------

      LGrad = MATMUL( NodalVelo(:,1:n), dBasisdx(1:n,:) )
        
      StrainRate = 0.5 * ( LGrad + TRANSPOSE(LGrad) )
      
      IF ( CSymmetry ) THEN
        StrainRate(1,3) = 0.0
        StrainRate(2,3) = 0.0
        StrainRate(3,1) = 0.0
        StrainRate(3,2) = 0.0
        StrainRate(3,3) = 0.0
        Radius = SUM( Nodes % x(1:n) * Basis(1:n) )
        IF ( Radius > 10*AEPS ) THEN
         StrainRate(3,3) = SUM( Nodalvelo(1,1:n) * Basis(1:n) ) / Radius
        END IF
      END IF
      Em = StrainRate(1,1)+StrainRate(2,2)+StrainRate(3,3)
      DSR = StrainRate
!
! Case non-linear calculate E_D^2 = gamma_e^2/fa + E_m^2/fb
! ----------------------------------------------------------
      ss = 1.0_dp
      IF ( Wn(2) > 1.0 ) THEN

        DO i = 1, 3
          DSR(i,i) = DSR(i,i) - Em/3.0
        END DO

        ss = 0.0_dp
        DO i = 1, 3
          DO j = 1, 3
            ss = ss + DSR(i,j)**2
          END DO
        END DO
        ss = 2.0*ss / fa
        IF ( fb /= 0.0_dp ) ss = ss + Em**2 / fb

        nn =(1.0 - Wn(2))/Wn(2)

        ss = SQRT(ss)
        IF (ss < MinSRInvariant ) ss = MinSRInvariant
        ss =  ss**nn 
      END IF 

!
!    Compute Spin : 
!    --------------

        Spin = 0.5 * ( LGrad - TRANSPOSE(LGrad) )
!
!    Compute deviatoric stresses: 
!    ----------------------------
        Stress = 2.0 * ss * DSR / (fa * Bg**(1.0 / Wn( 2 ) ) ) 
!------------------------------------------------------------------------------
      END SUBROUTINE LocalSD      
!------------------------------------------------------------------------------
!        
!------------------------------------------------------------------------------
      END SUBROUTINE PorousSolver
!------------------------------------------------------------------------------

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! subroutine de calcul des 3 : - valeurs propres de a2
!                              - angles d'Euler
!
!--------------------------------------------------------
      subroutine R2Ro(a2,dim,ai,Euler)

      use Types    ! types d'Elmer

      implicit none

      Real(dp),dimension(6),intent(in) :: a2
      integer :: dim               ! dimension  (2D-3D)
      Real(dp),dimension(3),intent(out) :: ai,Euler
      Real(dp) :: disc
      Real(dp), parameter :: Prec=1.e-06
      Real(dp) :: a,b,c,aplusa
      Complex :: Sol(3)
      Integer :: typeSol
      Integer :: i


      SELECT CASE(dim)

! ******** case 2D **********
      CASE(2)
        
     ! a2 in the orthotropic frame
     !   IF (abs(a2(4)).LT.Prec) Then
     !      ai(1:3)=a2(1:3)
     !      Euler=0._dp
     !      
     !   ELSE
        
           disc = (a2(1)+a2(2))*(a2(1)+a2(2)) - &
              4.*(a2(1)*a2(2)-a2(4)*a2(4))

           IF (disc.LT.0._dp) THEN
              print *, 'Pb to calculate eigenvalues of a2'
              stop
           END IF

            disc = sqrt(disc)
        
            ai(2) = 0.5 * (a2(1)+a2(2)+disc)
            ai(1) = 0.5 * (a2(1)+a2(2)-disc)

            Euler=0._dp
            Euler(1) = atan2(a2(4),a2(1)-ai(2))


            Do i=1,2
             ai(i)=Max(ai(i),0._dp)
            End do

            
            aplusa=ai(1)+ai(2)
            If (aplusa.GT.1._dp) then
               !  write(*,*) 'depasse 1 dans R2R0',aplusa,ai(1),ai(2)
                    do i=1,2
                     ai(i)=ai(i)/aplusa
                    end do
            endif
            
            ai(3) = 1._dp-ai(1)-ai(2)
        
      !  END IF

! *********** case 3D **************
      CASE(3)
        ! a2 in the orthotropic frame.
        IF ((abs(a2(4)).LT.prec).and.(abs(a2(5)).LT.prec) &
           .and.(abs(a2(6)).LT.prec) ) THEN
              ai(1:3)=a2(1:3)
              Euler=0.
        ! plane (1,2) isotropic      
        ELSE IF ((abs(a2(5)).LT.prec).and.(abs(a2(6)).LT.prec)) THEN

           disc = (a2(1)+a2(2))*(a2(1)+a2(2)) - &
              4.*(a2(1)+a2(2)+a2(4)*a2(4))
              

           IF (disc.LT.0._dp) THEN
              print *, 'Pb to calculate eigenvalues of a2'
              stop
           END IF

            disc = sqrt(disc)

            
            ! 2 eigenvalues
            ai(2) = 0.5 * (a2(1)+a2(2)+disc)
            ai(1) = 0.5 * (a2(1)+a2(2)-disc)

            ! eigenvalues beetwen 0 and 1

            Do i=1,2
             ai(i)=Max(ai(i),0._dp)
            End do
            aplusa=ai(1)+ai(2)
            If (aplusa.GT.1._dp) then
                    do i=1,2
                     ai(i)=ai(i)/aplusa
                    end do
            endif

            ai(3) = 1._dp-ai(1)-ai(2)

            Euler=0.
            Euler(1) = atan2(a2(4),a2(1)-ai(2))
                
         ! plane (2,3) isotropic
         ELSE IF ((abs(a2(4)).LT.prec).and.(abs(a2(6)).LT.prec)) THEN

           disc = (a2(2)+a2(3))*(a2(2)+a2(3)) - &
              4.*(a2(2)+a2(3)+a2(5)*a2(5))

           IF (disc.LT.0._dp) THEN
              print *, 'Pb to calculate eigenvalues of a2'
              stop
           END IF

            disc = sqrt(disc)
            
            ai(2) = 0.5 * (a2(1)+a2(3)+disc)
            ai(3) = 0.5 * (a2(1)+a2(3)-disc)
        
            Do i=2,3
             ai(i)=Max(ai(i),0._dp)
            End do
            aplusa=ai(2)+ai(3)
            If (aplusa.GT.1._dp) then
                    do i=2,3
                     ai(i)=ai(i)/aplusa
                    end do
            endif

            ai(1) = 1._dp-ai(2)-ai(3)

            Euler=0.
            Euler(2) = atan2(a2(5),a2(2)-ai(3))

          ! plane (1,3) isotropic
         ELSE IF ((abs(a2(4)).LT.prec).and.(abs(a2(5)).LT.prec)) THEN
         
           disc = (a2(1)+a2(3))*(a2(1)+a2(3)) - &
              4.*(a2(1)+a2(3)+a2(6)*a2(6))

           IF (disc.LT.0._dp) THEN
              print *, 'Pb to calculate eigenvalues of a2'
              stop
           END IF

            disc = sqrt(disc)

            ai(3) = 0.5 * (a2(1)+a2(3)+disc)
            ai(1) = 0.5 * (a2(1)+a2(3)-disc)
        
            Do i=1,3,2
             ai(i)=Max(ai(i),0._dp)
            End do
            aplusa=ai(1)+ai(3)
            If (aplusa.GT.1._dp) then
                    do i=1,3,2
                     ai(i)=ai(i)/aplusa
                    end do
            endif

            ai(2) = 1._dp-ai(1)-ai(3)

            
            Euler(1) = -0.5*Pi
            Euler(2) = atan2(a2(6),a2(1)-ai(3))
            Euler(3)= 0.5*Pi

         ! general case
        ELSE
                
          ! Recherche des 3 valeurs propres ai(i)
          ! equation caracteristique de la forme l^3+al^2+bl+c=0
                
             a=-1.
             b=a2(1)*(a2(2)+a2(3))+a2(2)*a2(3) &
                -a2(5)*a2(5)-a2(4)*a2(4)-a2(6)*a2(6)
             c=-a2(1)*a2(2)*a2(3)-2.*a2(4)*a2(6)*a2(5) &
               +a2(1)*a2(5)*a2(5)+a2(2)*a2(6)*a2(6) &
               +a2(3)*a2(4)*a2(4)

             Call degre3(a,b,c,Sol,typeSol)
              If (typeSol.EQ.1) Then
                Do i=1,3
                 ai(i)=real(Sol(i))
                End Do
              Else
                Write(*,*)'Solution complex in R2Ro'
                stop
              END IF
              
            !! Euler Angles                                                           
                                              
             write(*,*) 'pas encore pret'
             stop
         
        END IF

      CASE DEFAULT
        write(*,*) 'dimens',dim
        print *, 'Eigenvalues of a2, dimension not available'
      
      END SELECT

!      write(*,*)'------------------------------------------------------'
!      write(*,'((a),6(e13.5,x))') 'a2',a2(:)
!      write(*,'((a),3(e13.5,x))') 'ai',ai(:)
!      write(*,'((a),3(e13.5,x))') 'Euler',Euler(:)
!      write(*,*) '-----------------------------------------------------'

      

      RETURN
      END
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! solution equation du troisieme degre
! 
! type=1 3 racines reelles
! type=2 1 racine reelle + 2 complexes
!
!
      Subroutine degre3(a,b,c,sol,type)
      
      Use Types

      Implicit None
      Real(kind=dp) ::   a,b,c,R1,R
      Real(kind=dp) ::  p,q,phi
      Integer  :: i,type
      Complex  :: sol(3)


      p=b-a*a/3.
      q=2.*a*a*a/27.-a*b/3.+c

      R=q*q/4.+p*p*p/27.

      If (R.GT.0.) Then
       R1=(-q/2.+sqrt(R))**(1./3.)+(-q/2.-sqrt(R))**(1./3.)
       sol(1)=cmplx(R1,0.)
       sol(2)=cmplx(-R1/2.,sqrt(3.*R1*R1+4.*p)/2.)
       sol(3)=cmplx(-R1/2.,-sqrt(3.*R1*R1+4.*p)/2.)
       type=2
      Else If (R.LT.0.) Then
        phi=Acos(-q*sqrt(-27./(4.*p*p*p)))
        sol(1)=cmplx(2.*sqrt(-p/3.)*cos(phi/3.),0.)
        sol(2)=cmplx(2.*sqrt(-p/3)*cos((2.*Pi+phi)/3.),0.)
        sol(3)=cmplx(2.*sqrt(-p/3)*cos((4.*Pi+phi)/3.),0.)
        type=1
      Else
         sol(1)=cmplx(3.*q/p,0.)
         sol(2)=cmplx(-3.*q/(2.*p),0.)
         sol(3)=cmplx(-3.*q/(2.*p),0.)
         type=1
      End If
      Do i=1,3
        sol(i)=sol(i)- cmplx(a/3.,0.)
      End Do


      End
        

c
c   sens = 1 : tri des ki pour avoir k1 < k2 < k3
c   sens =-1 : tri des visc apres calcul avec k1 < k2 < k3 
c
c
       Subroutine triki(ki0,ki,visc,ordre,sens)

       use defgrid
       
       implicit none
       
       Real(kind=dp), Dimension(3) ::  ki0,ki
       real(kind=dp), Dimension(6) :: visc,b
       real(kind=dp) :: a
       Integer :: sens,i,j
       Integer, Dimension(3) :: ordre 
       
       

c
c    Passage pour trier les ki
c
       If (sens.EQ.1) Then
         Do i=1,3
           ki(i)=ki0(i)
           ordre(i)=i
         End Do
         Do j=2,3
          a=ki(j)
          Do i=j-1,1,-1
          If (ki(i).LE.a) Goto 20
          ki(i+1)=ki(i)
          ordre(i+1)=ordre(i)
          End Do
  20      Continue
         ki(i+1)=a
         ordre(i+1)=j
         End Do
c
c   Passage pour remettre les viscosite dans le bon ordre
c
       ElseIf (sens.EQ.-1) Then

         Do i=1,6
         b(i)=visc(i)
         End Do
         Do i=1,3
          visc(ordre(i))=b(i)
          visc(ordre(i)+3)=b(i+3)
        End Do

       Else
         Write(*,*)'triki.f : sens <> 1 ou -1' 
       Stop
       End If
       End

!/******************************************************************************
! *
! *       ELMER, A Computational Fluid Dynamics Program.
! *
! *       Copyright 1st April 1995 - , Center for Scientific Computing,
! *                                    Finland.
! *
! *       All rights reserved. No part of this program may be used,
! *       reproduced or transmitted in any form or by any means
! *       without the written permission of CSC.
! *
! *****************************************************************************/
!
!/******************************************************************************
! *
! * FreeSurfaceSolver: Solver for free surface evolution in 2d and 3d flows
! *                    with/without surface flux 
! *
! ******************************************************************************
! *
! *                    Author:  Juha Ruokolainen
! *
! *                    Address: Center for Scientific Computing
! *                                Tietotie 6, P.O. BOX 405
! *                                  02101 Espoo, Finland
! *                                  Tel. +358 0 457 2723
! *                                Telefax: +358 0 457 2183
! *                              EMail: Thomas.Zwinger@csc.fi
! *
! *                       Date: 17  May 2002
! *
! *                Modified by: Peter Råback, Juha Ruokolainen, Mikko Lyly
! *
! *
!/******************************************************************************
! *
! *       Modified by: Thomas Zwinger
! *
! *       Date of modification: 4. May 2004
! *
! *****************************************************************************/
   SUBROUTINE FSurfSolverPenalty( Model,Solver,dt,TransientSimulation )
  !DEC$ATTRIBUTES DLLEXPORT :: FSurfSolverPenalty
     USE DefUtils
     USE Differentials
     IMPLICIT NONE


!------------------------------------------------------------------------------
!    external variables
!------------------------------------------------------------------------------
     TYPE(Model_t) :: Model
     TYPE(Solver_t):: Solver
     REAL(KIND=dp) :: dt
     LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
!    Local variables
!------------------------------------------------------------------------------
     INTEGER :: & 
          i,j,t,N,NMAX,MMAX,KMAX,Nmatrix,bf_id,DIM,istat,&
          NSDOFs,NonlinearIter, iter, SubroutineVisited=0


     REAL(KIND=dp) :: &
          at,st,totat,totst,CPUTime,Norm,PrevNorm,LocalBottom, cv, &
          Relax, MaxDisp, maxdh, NonlinearTol, UzawaParameter, RelativeChange, &
          SteadyTol,SteadyDisp

     LOGICAL ::&
          firstTime=.TRUE., GotIt, AllocationsDone = .FALSE., stat, &
          NeedOldValues,  Bubbles = .FALSE.,&
          NormalFlux = .TRUE., SubstantialSurface = .TRUE.,&
          UseBodyForce = .TRUE., LimitedSolution(2) = .FALSE., &
          Converged = .FALSE., &
          LimitDisp,DispSteady



     CHARACTER(LEN=MAX_NAME_LEN)  ::  FlowSolverName


     TYPE(Nodes_t)   :: ElementNodes
     TYPE(Element_t),POINTER :: Element
     TYPE(Variable_t), POINTER :: FlowSol


     INTEGER, POINTER ::&
          FreeSurfPerm(:), FlowPerm(:), NodeIndexes(:)


     INTEGER, ALLOCATABLE :: BoundaryMapping(:), BoundaryPerm(:)


     REAL(KIND=dp), POINTER ::&
          FreeSurf(:), PreFreeSurf(:,:), TimeForce(:),&
          FlowSolution(:), PrevFlowSol(:,:), ElemFreeSurf(:), OldFreeSurf(:)
 
     REAL(KIND=dp), ALLOCATABLE :: &          
          STIFF(:,:),SourceFunc(:),FORCE(:), &
          MASS(:,:), Velo(:,:), Flux(:,:),  Limit(:,:), &
          auxReal(:), OldDy(:), LocalLimit(:,:)
     INTEGER, ALLOCATABLE :: AlreadyDone(:)
          
     TYPE(ValueList_t), POINTER :: BodyForce, SolverParams, Material
!-----------------------------------------------------------------------------
!      remember these variables
!----------------------------------------------------------------------------- 
     SAVE STIFF, MASS, SourceFunc, FORCE, &
          ElementNodes, AllocationsDone, Velo, OldFreeSurf, TimeForce, &
          SubroutineVisited, ElemFreeSurf, Flux, SubstantialSurface, NormalFlux,&
          UseBodyForce,  Limit, BoundaryPerm, BoundaryMapping, &
          auxReal, Norm, PrevNorm, OldDy, LocalLimit, AlreadyDone,KMAX


!------------------------------------------------------------------------------
!    Get constants
!------------------------------------------------------------------------------
     MMAX = Solver % Mesh % NumberOfNodes
     DIM = CoordinateSystemDimension()
     SolverParams => GetSolverParams()
     
     MaxDisp = GetConstReal( SolverParams, 'Maximum Displacement', LimitDisp)
     NeedOldValues=LimitDisp


     cv = GetConstReal( SolverParams, 'Velocity Implicity', GotIt)
     IF(.NOT. GotIt) cv = 1.0d0 
     WRITE(Message,'(a,F8.2)') 'Velocity implicity (1=fully implicit)=', cv
     CALL Info('FreeSurfaceSolver', Message, Level=4)


     Relax = GetConstReal( SolverParams, 'Relaxation Factor', GotIt)
     IF(.NOT. GotIt) Relax = 1.0d0
     NeedOldValues = (NeedOldValues.OR.(GotIt .AND. (Relax < 1.0d00)))


     NonlinearIter = GetInteger(   SolverParams, &
          'Nonlinear System Max Iterations', GotIt )
     IF ( .NOT.GotIt ) NonlinearIter = 1


     NonlinearTol  = GetConstReal( SolverParams, &
          'Nonlinear System Convergence Tolerance',    GotIt )
     IF ((NonlinearIter > 1) .AND. (.NOT.GotIt)) THEN
        CALL Fatal('FreeSurfaceSolver',&
             'No Value for Nonlinear System Convergence Tolerance found')
     END IF

! pour limiter en deplacement
     SteadyTol = GetConstReal(   SolverParams, &
                    'Steady State Convergence Tolerance', GotIt )
     SteadyDisp = GetConstReal(   SolverParams, &
                    'Steady State Displacement Tolerance', DispSteady )
                                                                                                                             
!!!!!!!!!!!!!!
 


    
     UzawaParameter = GetConstReal( SolverParams, &
               'Uzawa Parameter', GotIt)
     IF (.NOT.GotIt) THEN                
        LimitedSolution = .FALSE.
     END IF


     Bubbles = GetLogical( SolverParams,'Bubbles',GotIt )
     IF (Bubbles) THEN
        CALL Info('FreeSurfaceSolver', 'Using Bubble stabilization', Level=4)
     ELSE
        CALL Info('FreeSurfaceSolver', &
             'Using residual squared-stabilized formulation.', Level=4)
     END IF


     UseBodyForce =  GetLogical( SolverParams,'Use Accumulation',GotIt )
     IF (.NOT.Gotit) UseBodyForce = .TRUE.


     IF (UseBodyForce) THEN
        NormalFlux =  GetLogical( SolverParams,'Normal Flux',GotIt )
        IF (.NOT.Gotit) NormalFlux = .TRUE.


        IF (NormalFlux) THEN
           CALL Info('FreeSurfaceSolver', &
                'Using scalar value for accumulaton/ablation rate', Level=4)
        ELSE
           CALL Info('FreeSurfaceSolver', &
                'Computing accumulaton/ablation rate from input vector', Level=4)
        END IF
     ELSE
        NormalFlux = .TRUE.
        CALL Info('FreeSurfaceSolver', 'Zero accumulation/ablation', Level=4)
     END IF


!------------------------------------------------------------------------
!    Get Velocity from (Navier)-Stokes-Solver or AIFlow Solver
!------------------------------------------------------------------------
     FlowSolverName = GetString( SolverParams, 'Flow Solver Name', GotIt )    
     IF (.NOT.Gotit) FlowSolverName = 'Flow Solution'
     FlowSol => VariableGet( Solver % Mesh % Variables, FlowSolverName )
     IF ( ASSOCIATED( FlowSol ) ) THEN
       FlowPerm     => FlowSol % Perm
       NSDOFs       =  FlowSol % DOFs
       FlowSolution => FlowSol % Values
       PrevFlowSol => FlowSol % PrevValues
       WRITE(Message,'(a,i1,a,i1)') 'DIM=', DIM, ', NSDOFs=', NSDOFs
       CALL Info( 'FreeSurfaceSolver', Message, level=4) 
     ELSE
       CALL Info('FreeSurfaceSolver', 'No variable for velocity associated.', Level=4)
     END IF




!------------------------------------------------------------------------------
!    Get variables for the solution
!------------------------------------------------------------------------------
     FreeSurf     => Solver % Variable % Values     ! Nodal values for free surface displacement
     FreeSurfPerm => Solver % Variable % Perm       ! Permutations for free surface displacement
     PreFreeSurf  => Solver % Variable % PrevValues ! Nodal values for free surface displacement
                                                    !                     from previous timestep
!------------------------------------------------------------------------------
!    assign norm
!------------------------------------------------------------------------------
     IF (AllocationsDone) THEN 
        Norm = Solver % Variable % Norm
     ELSE
        Norm = 0.0d00
     END IF



!------------------------------------------------------------------------------
!    Allocate some permanent storage, 
!    this is done first time only or if there have been changes in the mesh
!------------------------------------------------------------------------------
     IF ( .NOT. AllocationsDone .OR. Solver % Mesh % Changed) THEN
        NMAX = Model % MaxElementNodes
        IF (Bubbles) THEN
           Nmatrix = 2*NMAX
        ELSE
           Nmatrix = NMAX
        END IF


        ! get node mapping for boundary body
        KMAX = COUNT(FreeSurfPerm .NE. 0)
       
        IF (AllocationsDone ) THEN
           DEALLOCATE(  ElementNodes % x,    &
                ElementNodes % y,    &
                ElementNodes % z,    &
                TimeForce,           &
                FORCE,    &
                STIFF, &
                MASS,  &
                Velo, &
                OldDy, &
                AlreadyDone, &
                LocalLimit, &
                Flux, &
                ElemFreeSurf,&
                SourceFunc,&
                Limit, &
                auxReal, &
                BoundaryMapping, &
                BoundaryPerm)
        END IF
       
        ALLOCATE( ElementNodes % x( NMAX ),    &
             ElementNodes % y( NMAX ),    &
             ElementNodes % z( NMAX ),    &
             TimeForce( NMAX ),           &
             FORCE( Nmatrix ),    &
             STIFF( Nmatrix, Nmatrix ), &
             MASS( Nmatrix, Nmatrix ),  &
             Velo( 3, NMAX ), &
             OldDy( NMAX ),&
             AlreadyDone(KMAX),&
             LocalLimit(2, NMAX), &
             Flux( 3, NMAX), &
             ElemFreeSurf( NMAX ),&
             SourceFunc( NMAX ), &
             Limit( 2, kMAX ), &
             auxReal( NMAX ), &
             BoundaryMapping( KMAX ), &
             BoundaryPerm( MMAX ), &
             STAT=istat )
        IF ( istat /= 0 ) THEN
           CALL Fatal('FreeSurfaceSolver','Memory allocation error, Aborting.')
        END IF


        ! previous values
        !----------------
        IF(NeedOldValues) THEN


           IF (AllocationsDone) DEALLOCATE(OldFreeSurf)


           ALLOCATE(OldFreeSurf(KMAX), STAT=istat)
           
           IF ( istat /= 0 ) THEN
              CALL Fatal('FreeSurfaceSolver','Memory allocation error, Aborting.')
           END IF
           DO i=1,KMAX
              OldFreeSurf(i) = FreeSurf(i)
           END DO
        END IF


       
        IF (.NOT. AllocationsDone) THEN
           CALL Info('FreeSurfaceSolver','Memory allocations done', Level=3)
           AllocationsDone = .TRUE.
        ELSE
           CALL Info('FreeSurfaceSolver','Memory allocation update done', Level=3)
        END IF


        ! get boundary mapping and permutation
        !-------------------------------------
        j=0
        BoundaryPerm(1:MMAX) = 0
        DO i=1,MMAX
           IF (FreeSurfPerm(i) > 0) THEN
              j = j+1
              BoundaryMapping(j) = FreeSurfPerm(i) 
              BoundaryPerm(i) = j
           END IF
        END DO
        IF (j .NE. KMAX) THEN
           WRITE(Message,'(A,I5,A,I5)') 'Number of mapped nodes ', j,&
                ' does not match number of non-zero permutations ', KMAX
           CALL FATAL('FreeSurfaceSolver',Message)
        END IF
     END IF
     

      If (NeedOldValues) Then
           DO i=1,KMAX
              OldFreeSurf(i) = FreeSurf(i)
           END DO
       End if


!------------------------------------------------------------------------------
!    Nonlinear iteration loop
!------------------------------------------------------------------------------
     Converged = .FALSE.
     DO iter=1,NonlinearIter
        WRITE(Message,'(A,I5,A,I5)') 'Nonlinear iteration no.',iter,&
             ' of max. ', NonlinearIter
        CALL INFO('FreeSurfaceSolver',Message,level=4)


!------------------------------------------------------------------------------
!       Get limit for Upper and Lower surface position
!------------------------------------------------------------------------------
        LimitedSolution = .FALSE.
        ! Get lower and Upper limit
        ! (loop all elements)
        !--------------------------        
        DO t=1,Solver % NumberOfActiveElements
           Element => GetActiveElement(t)
           n = GetElementNOFNodes()
           CALL GetElementNodes( ElementNodes )
           Material => GetMaterial()
           IF (.NOT.ASSOCIATED(Material)) THEN
              CALL INFO('FreeSurfaceSolver','No material found', Level=3)
           ELSE
              auxReal(1:n) = ListGetReal(Material, 'Min Flow Depth', n, Element % NodeIndexes, GotIt)
              IF (GotIt) THEN
                 DO i= 1,n
                    Limit(1,BoundaryPerm(Element % NodeIndexes(i))) = auxReal(i)
                 END DO
                 LimitedSolution(1) = .TRUE.
              END IF
              auxReal(1:n) = ListGetReal(Material,'Max Flow Depth',n,Element % NodeIndexes, GotIt)
              IF (GotIt) THEN
                 DO i= 1,n          
                    Limit(2,BoundaryPerm(Element % NodeIndexes(i))) = auxReal(i)
                 END DO
                 LimitedSolution(2) = .TRUE.
              END IF
           END IF
        END DO
        
!------------------------------------------------------------------------------
!       Do some additional initialization, and go for it
!------------------------------------------------------------------------------
        AlreadyDone = 0
        totat = 0.0d0
        totst = 0.0d0
        at = CPUTime()
        CALL Info( 'FreeSurfaceSolver', 'start assembly', Level=4 )
        CALL DefaultInitialize()
!------------------------------------------------------------------------------
!       Do the assembly
!------------------------------------------------------------------------------
        DO t=1,Solver % NumberOfActiveElements
           Element => GetActiveElement(t)
           n = GetElementNOFNodes()
           NodeIndexes => Element % NodeIndexes


           ! set coords of highest occuring dimension to zero (to get correct path element)
           !-------------------------------------------------------------------------------
           ElementNodes % x(1:n) = Solver % Mesh % Nodes % x(NodeIndexes)
           IF (DIM == 2) THEN
              ElementNodes % y(1:n) = 0.0
              ElementNodes % z(1:n) = 0.0
           ELSE IF (DIM == 3) THEN
              ElementNodes % y(1:n) = Solver % Mesh % Nodes % y(NodeIndexes)
              ElementNodes % z(1:n) = 0.0d0
           ELSE
              WRITE(Message,'(a,i1,a)')&
                   'It is not possible to compute free-surface problems in DIM=',&
                   DIM, ' dimensions. Aborting'
              CALL Fatal( 'FreeSurfaceSolver', Message) 
              STOP   
           END IF


           ! get velocity profile
           IF ( ASSOCIATED( FlowSol ) ) THEN
              DO i=1,n
                 j = NSDOFs*FlowPerm(NodeIndexes(i))


                 IF(TransientSimulation .AND. ABS(cv-1.0) > 0.001) THEN
                    IF((DIM == 2) .AND. (NSDOFs == 3)) THEN
                       Velo(1,i) = cv * FlowSolution( j-2 ) + (1-cv) * PrevFlowSol(j-2,1)
                       Velo(2,i) = cv * FlowSolution( j-1 ) + (1-cv) * PrevFlowSol(j-1,1)
                       Velo(3,i) = 0.0d0
                    ELSE IF ((DIM == 3) .AND. (NSDOFs == 4)) THEN
                       Velo(1,i) = cv * FlowSolution( j-3 ) + (1-cv) * PrevFlowSol(j-3,1)
                       Velo(2,i) = cv * FlowSolution( j-2 ) + (1-cv) * PrevFlowSol(j-2,1)
                       Velo(3,i) = cv * FlowSolution( j-1 ) + (1-cv) * PrevFlowSol(j-1,1)
                    ELSE IF ((CurrentCoordinateSystem() == CylindricSymmetric) &
                         .AND. (DIM == 2) .AND. (NSDOFs == 4)) THEN  
                       Velo(1,i) = cv * FlowSolution( j-3 ) + (1-cv) * PrevFlowSol(j-3,1)
                       Velo(2,i) = cv * FlowSolution( j-2 ) + (1-cv) * PrevFlowSol(j-2,1)
                       Velo(3,i) = cv * FlowSolution( j-1 ) + (1-cv) * PrevFlowSol(j-1,1)
                    ELSE
                       WRITE(Message,'(a,i1,a,i1,a)')&
                            'DIM=', DIM, ' NSDOFs=', NSDOFs, ' does not combine. Aborting'
                       CALL Fatal( 'FreeSurfaceSolver', Message)               
                    END IF
                 ELSE
                    IF((DIM == 2) .AND. (NSDOFs == 3)) THEN
                       Velo(1,i) = FlowSolution( j-2 ) 
                       Velo(2,i) = FlowSolution( j-1 ) 
                       Velo(3,i) = 0.0d0
                    ELSE IF ((DIM == 3) .AND. (NSDOFs == 4)) THEN
                       Velo(1,i) = FlowSolution( j-3 ) 
                       Velo(2,i) = FlowSolution( j-2 ) 
                       Velo(3,i) = FlowSolution( j-1 ) 
                    ELSE IF ((CurrentCoordinateSystem() == CylindricSymmetric) &
                         .AND. (DIM == 2) .AND. (NSDOFs == 4)) THEN
                       Velo(1,i) = FlowSolution( j-3 ) 
                       Velo(2,i) = FlowSolution( j-2 ) 
                       Velo(3,i) = FlowSolution( j-1 ) 
                    ELSE
                       WRITE(Message,'(a,i1,a,i1,a)')&
                            'DIM=', DIM, ' NSDOFs=', NSDOFs, ' does not combine. Aborting'
                       CALL Fatal( 'FreeSurfaceSolver', Message)
                    END IF
                 END IF
              END DO
           ELSE
              Velo=0.0d0          
           END IF
!------------------------------------------------------------------------------
!          get the accumulation/ablation rate (i.e. normal surface flux)
!          from the body force section
!------------------------------------------------------------------------------
           SourceFunc = 0.0d0
           Flux  = 0.0d0
           SubstantialSurface = .TRUE.
           BodyForce => GetBodyForce()
           IF ( UseBodyForce.AND.ASSOCIATED( BodyForce ) ) THEN
              SubstantialSurface = .FALSE.
              ! Accumulation/ablation is given in normal direction of surface:
              !---------------------------------------------------------------
              IF (NormalFlux) THEN 
                 SourceFunc(1:n) = GetReal( BodyForce, &
                      'Accumulation Ablation' )
                 ! Accumulation/ablation has to be computed from given flux:
                 !----------------------------------------------------------
              ELSE 
                 Flux(1,1:n) = GetReal( BodyForce, 'Accumulation Flux 1')
                 IF (DIM == 2) THEN
                    Flux(2,1:n) = GetReal( BodyForce, 'Accumulation Flux 2' )
                 ELSE
                    Flux(2,1:n) = 0.0d0
                 END IF
                 IF (DIM == 3) THEN
                    Flux(3,1:n) = GetReal( BodyForce, 'Accumulation Flux 3' )
                 ELSE
                    Flux(3,1:n) = 0.0d0
                 END IF
                 SourceFunc = 0.0d0
              END IF
           END IF
           IF( TransientSimulation) THEN
              ElemFreeSurf(1:n) = PreFreeSurf(FreeSurfPerm(NodeIndexes),1)
           END IF

!---------------------------------------------------------------
!          Previous non linear iter solution for that element
!---------------------------------------------------------------
           OldDy(1:n) = FreeSurf( FreeSurfPerm( NodeIndexes(1:n)))

!---------------------------------------------------------------
!          LocalLimit from Limit
!---------------------------------------------------------------
           LocalLimit(1:2,1:n) = Limit(1:2,BoundaryPerm(NodeIndexes))           
!          
!------------------------------------------------------------------------------
!          Get element local matrix, and rhs vector
!------------------------------------------------------------------------------
           CALL LocalMatrix( STIFF, MASS, FORCE,&
                SourceFunc, ElemFreeSurf, Velo, Element,&
                n, ElementNodes, NodeIndexes, TransientSimulation,&
                Flux, NormalFlux, SubstantialSurface, OldDy,&
                LimitedSolution, LocalLimit, UzawaParameter)

!------------------------------------------------------------------------------
!        If time dependent simulation add mass matrix to stiff matrix
!------------------------------------------------------------------------------
           IF ( Bubbles ) TimeForce  = FORCE
           IF ( TransientSimulation ) THEN
!------------------------------------------------------------------------------
!          NOTE: This will replace STIFF and LocalForce with the
!                combined information...
!------------------------------------------------------------------------------
              IF ( Bubbles ) FORCE = 0.0d0
              CALL Default1stOrderTime( MASS, STIFF, FORCE )
           END IF
!------------------------------------------------------------------------------
!        Update global matrices from local matrices
!------------------------------------------------------------------------------
           IF (Bubbles) THEN
              CALL Condensate( N, STIFF, FORCE, TimeForce )
              IF ( TransientSimulation ) CALL DefaultUpdateForce( TimeForce )
           END IF
!------------------------------------------------------------------------------
!      Update global matrix and rhs vector from local matrix & vector
!------------------------------------------------------------------------------
           CALL DefaultUpdateEquations( STIFF, FORCE )
!------------------------------------------------------------------------------
        END DO


!------------------------------------------------------------------------------
!     Neumann & Newton boundary conditions
!------------------------------------------------------------------------------
!
! MIND: In weak formulation it is not possible to prescribe a contact angle on
!       a boundary in this solver. This has to be taken care of in the boundary
!       condition for the stress tensor in the Navier-Stokes Solver. Thus, in
!       generally it does not make sense to prescribe a van Neumann type of
!       condition here.


!------------------------------------------------------------------------------
!    FinishAssemebly must be called after all other assembly steps, but before
!    Dirichlet boundary settings. Actually no need to call it except for
!    transient simulations.
!------------------------------------------------------------------------------
        CALL DefaultFinishAssembly()
        CALL DefaultDirichletBCs()


!------------------------------------------------------------------------------
!    Solve System
!------------------------------------------------------------------------------
        at = CPUTime() - at
        st = CPUTime()


        PrevNorm = Norm
        Solver % Variable % Norm = Norm

        Norm = DefaultSolve()

        Solver % Variable % Norm = Norm
        


        IF(NeedOldValues) THEN
        IF(LimitDisp) THEN 
           maxdh = -HUGE(maxdh)         
           DO i=1, Model % NumberOfNodes
              j = FreeSurfPerm(i)
              IF(j > 0) THEN
                 maxdh = MAX(maxdh, ABS(FreeSurf(j)-OldFreeSurf(j)))
              END IF
           END DO
           IF(maxdh > MaxDisp) THEN
              Relax = Relax * MaxDisp/maxdh
           END IF
           WRITE(Message,'(a,E8.2)') 'Maximum displacement',maxdh
           CALL Info( 'FreeSurfaceSolver', Message, Level=4 )
        END IF
        WRITE(Message,'(a,F8.2)') 'pp Relaxation factor',Relax
        CALL Info( 'FreeSurfaceSolver', Message, Level=4 )
           DO i=1, Model % NumberOfNodes
              j = FreeSurfPerm(i)
              IF(j > 0) THEN
                 FreeSurf(j) = Relax * FreeSurf(j) + (1-Relax) * OldFreeSurf(j)
              END IF
           END DO
        END IF


        st = CPUTIme()-st
        totat = totat + at
        totst = totst + st


        WRITE(Message,'(a,F8.2,F8.2)') 'Assembly: (s)', at, totat
        CALL Info( 'FreeSurfaceSolver', Message, Level=4 )
        WRITE(Message,'(a,F8.2,F8.2)') ' Solve:    (s)', st, totst
        CALL Info( 'FreeSurfaceSolver', Message, Level=4 )
        SubroutineVisited = SubroutineVisited + 1
        
        ! is the solution converged?
        !---------------------------
        IF ( PrevNorm + Norm /= 0.0d0 ) THEN
           RelativeChange = 2.0d0 * ABS( PrevNorm-Norm ) / (PrevNorm + Norm)
        ELSE
           RelativeChange = 0.0d0
        END IF
        WRITE( Message, * ) 'Result Norm   : ',Norm
        CALL Info( 'Free Surface Solve', Message, Level=4 )
        WRITE( Message, * ) 'Relative Change : ',RelativeChange
        CALL Info( 'Free Surface Solve', Message, Level=4 )

!!!!!!!! !!  pour limiter le deplacement
     If (NonlinearIter.eq.1) then
     IF (DispSteady) Then
      IF(maxdh.GT.SteadyDisp) then
              SteadyTol= RelativeChange/2._dp
      else
              SteadyTol= RelativeChange*2._dp
      Endif
      CALL  ListAddConstReal( SolverParams,  &
                'Steady State Convergence Tolerance', SteadyTol )
     ENDIF
     Endif
     write(*,*) 'Steady State Convergence Tolerance', SteadyTol
!!!!!!!!!!!!!!!!


        IF ( RelativeChange < NonlinearTol ) EXIT
     END DO ! of the nonlinear iteration
!------------------------------------------------------------------------------
   CONTAINS


!------------------------------------------------------------------------------
!==============================================================================
     SUBROUTINE LocalMatrix( STIFF, MASS, FORCE,&
          SourceFunc, OldFreeSurf, Velo, &
          Element, nCoord, Nodes, NodeIndexes, TransientSimulation,&
          Flux, NormalFlux, SubstantialSurface, OldDy,&
          LimitedSolution, LocalLimit, UzawaParameter)
!------------------------------------------------------------------------------
!    INPUT:  SourceFunc(:)   nodal values of the accumulation/ablation function
!            
!            Element         current element
!            n               number of nodes
!            Nodes           current node points
!
!    OUTPUT: STIFF(:,:)
!            MASS(:,:)
!            FORCE(:)
!------------------------------------------------------------------------------
!      external variables:
!      ------------------------------------------------------------------------
       REAL(KIND=dp) ::&
             STIFF(:,:), MASS(:,:), FORCE(:), SourceFunc(:), &
             Velo(:,:), OldFreeSurf(:), Flux(:,:), OldDy(:), &
             LocalLimit(:,:), UzawaParameter
             


       INTEGER :: nCoord, NodeIndexes(:)
       TYPE(Nodes_t) :: Nodes
       TYPE(Element_t), POINTER :: Element
       LOGICAL :: TransientSimulation,NormalFlux,SubstantialSurface, &
                  LimitedSolution(:)
!------------------------------------------------------------------------------
!      internal variables:
!      ------------------------------------------------------------------------
       REAL(KIND=dp) ::&
          Basis(2*nCoord),dBasisdx(2*nCoord,3),ddBasisddx(2*nCoord,3,3),&
          Vgauss(3), VMeshGauss(3), Source, gradFreeSurf(3), normGradFreeSurf,&
          FluxGauss(3),X,Y,Z,U,V,W,S,SqrtElementMetric,&
          SU(2*nCoord),SW(2*nCoord),Tau,hK,UNorm, Oldh, LowerLimit, &
          UpperLimit
       LOGICAL :: Stat, Bed(2)
       INTEGER :: i,j,t,p,q, n
       TYPE(GaussIntegrationPoints_t) :: IntegStuff
!------------------------------------------------------------------------------


       FORCE = 0.0d0
       STIFF = 0.0d0
       MASS  = 0.0d0


       IF (Bubbles) THEN
          n = nCoord * 2
       ELSE
          n = nCoord
       END IF


       hK = ElementDiameter( Element, Nodes )
!
!      Numerical integration:
!      ----------------------
       IF (Bubbles) THEN
          IntegStuff = GaussPoints( Element, Element % type % gausspoints2)
       ELSE
          IntegStuff = GaussPoints( Element )
       END IF


       SU = 0.0d0
       SW = 0.0d0


       DO t = 1,IntegStuff % n
         U = IntegStuff % u(t)
         V = IntegStuff % v(t)
         W = IntegStuff % w(t)
         S = IntegStuff % s(t)
!
!        Basis function values & derivatives at the integration point:
!        -------------------------------------------------------------
         stat = ElementInfo( Element,Nodes,U,V,W,SqrtElementMetric, &
              Basis,dBasisdx,ddBasisddx,.FALSE., Bubbles )


!        Correction from metric
!        ----------------------
          S = S * SqrtElementMetric


         IF ( CurrentCoordinateSystem() /= Cartesian ) THEN
            X = SUM( Nodes % x(1:nCoord) * Basis(1:nCoord) )
            Y = SUM( Nodes % y(1:nCoord) * Basis(1:nCoord) )
            Z = SUM( Nodes % z(1:nCoord) * Basis(1:nCoord) )
            S = S * X
         END IF
!
!        Velocities and (norm of) gradient of free surface and source function 
!        at Gauss point
!        ---------------------------------------------------------------------

         gradFreeSurf=0.0d0
         Vgauss=0.0d0
         VMeshGauss=0.0d0


         DO i=1,DIM-1
!GAG!      gradFreeSurf(i) = SUM(dBasisdx(1:nCoord,i)*OldFreeSurf(1:nCoord))
           gradFreeSurf(i) = SUM(dBasisdx(1:nCoord,i)*OldDy(1:nCoord))
         END DO

         gradFreeSurf(DIM) = 1.0d0

         DO i=1,DIM
           Vgauss(i) = SUM( Basis(1:nCoord)*Velo(i,1:nCoord) )
         END DO

         IF (DIM==3) THEN
           normGradFreeSurf = SQRT(1.0d0 + gradFreeSurf(1)**2 + &
                gradFreeSurf(2)**2)
         ELSE
           normGradFreeSurf = SQRT(1.0d0 + gradFreeSurf(1)**2)
         END IF


         UNorm = SQRT( SUM( Vgauss(1:dim-1)**2 ) )
         Tau = hK / ( 2*Unorm )


         ! Srabilized 
         IF ( .NOT. Bubbles ) THEN
            DO p=1,n
               SU(p) = 0.0d0
               DO i=1,dim-1
                  SU(p) = SU(p) + Vgauss(i) * dBasisdx(p,i)
               END DO


               SW(p) = 0.0d0
               DO i=1,dim-1
                  SW(p) = SW(p) + Vgauss(i) * dBasisdx(p,i)
               END DO
            END DO
         END IF


!        Stiffness matrix:
!        -----------------
         DO p=1,n
           DO q=1,n
             DO i=1,DIM-1
               STIFF(p,q) = STIFF(p,q) + &
                       s * Vgauss(i) * dBasisdx(q,i) * Basis(p)
             END DO
             STIFF(p,q) =  STIFF(p,q) + s * Tau * SU(q) * SW(p)
           END DO
           
         END DO



!        Mass Matrix:
!        ------------
         IF ( TransientSimulation ) THEN
            DO p=1,n
              DO q=1,n
                MASS(p,q) = MASS(p,q) +  &
                         S * Basis(q) * (Basis(p) + Tau*SW(p))
              END DO
            END DO
         END IF


!        Get accumulation/ablation function if flux input is given
!        (i.e., calculate vector product between flux and normal)
!        --------------------------------------------------------- 
         IF (.NOT.(SubstantialSurface)) THEN
            IF (NormalFlux) THEN 
               Source = normGradFreeSurf * SUM( SourceFunc(1:nCoord) &
                    * Basis(1:nCoord) )
            ELSE
               DO i=1,dim
                  FluxGauss(i) = SUM(Basis(1:nCoord)*Flux(i,1:nCoord))
               END DO
               Source = SUM(FluxGauss(1:DIM)*gradFreeSurf(1:DIM))
            END IF
         ELSE
            Source = 0.0d0
         END IF


!        Assemble force vector:
!        ---------------------
         FORCE(1:n) = FORCE(1:n) &
              + (Vgauss(dim)+Source) * (Basis(1:n) + Tau*SW(1:n)) * s
      END DO
!
! add the bed conditions using a penality if necessary
! 
      Do  p = 1, n  
         If (LimitedSolution(1)) THEN      
               IF  ((OldDy(p) - LocalLimit(1,p)).LE.0.0d0) Then
                       STIFF(p,p) = STIFF(p,p) +  &
                                      UzawaParameter
                    If (Abs(LocalLimit(1,p)).GT.1.0/UzawaParameter) Then               
                       FORCE(p) = FORCE(p) +  &
                        LocalLimit(1,p) * UzawaParameter 
                    End If    
               END IF
         End If

         If ((LimitedSolution(2)) .And.  &
                        ((OldDy(p) - LocalLimit(2,p)).GT. 0.0e0)) Then
                       STIFF(p,p) = STIFF(p,p) +  &
                                      UzawaParameter 
                       FORCE(p) = FORCE(p) +  &
                       UzawaParameter * LocalLimit(2,p) 
         End If
      End Do
!------------------------------------------------------------------------------
    END SUBROUTINE LocalMatrix


!==============================================================================
!------------------------------------------------------------------------------
  END SUBROUTINE FSurfSolverPenalty
!------------------------------------------------------------------------------ 

PROGRAM CHECK
  IMPLICIT NONE
  CHARACTER*100 :: A
  INTEGER :: I
  REAL*8 :: R, Tol
  COMPLEX :: C

  OPEN(1,FILE='out3.txt')
  READ(1,*) A, I, C
  CLOSE(1)

  OPEN(2,FILE='TARGET.RESULT')
  READ(2,*) R, Tol
  CLOSE(2)

  OPEN(3,FILE='tmp.log', STATUS='UNKNOWN')
  IF( ABS( REAL(C)-R ) < Tol ) THEN
     WRITE(3,'(A,2F8.1)' ) '(NRM,RELC): ',-1.0, 0.0     !    Passed
  ELSE
     WRITE(3,'(A,2F8.1)' ) '(NRM,RELC): ', 1.0, 0.0     !    Failed
  END IF
  WRITE(3,'(a)' )  'END TEST CASE 1, NRM=-1'
  WRITE(3,'(a)' )  'ALL DONE'
  CLOSE(3)

END PROGRAM CHECK

! Sinus bed 
!
! y = bed(x) and y = d bed(x) / dx
!
! --------------------------------------------------------
      FUNCTION fbed(x)
        USE types
        USE DefUtils
      IMPLICIT NONE
      REAL(KIND=dp) :: fbed,x
      REAL(KIND=dp) :: x0,R
      LOGICAL :: FirstTime=.TRUE.
      CHARACTER(len=1) :: Rien
      INTEGER :: i
     
      SAVE FirstTime, x0, R
     
      IF (FirstTime) THEN
        FirstTime = .FALSE.
        write(*,*)'----------------------------------------------------'
        write(*,*)'YOU ARE SOLVING THE CIRCLE PROBLEM (cercle.geo mesh)'
        write(*,*)'----------------------------------------------------'
        Open(10,file='cercle0.geo')
        DO i = 1, 5
          Read(10,*)Rien
        END DO
        Read(10,'(5x,e14.8)')x0
        Read(10,'(5x,e14.8)')R 
        Close(10)
      END IF

      If (x.LE.R+x0) Then
           fbed = Sqrt(R*R - (x-x0)*(x-x0))
      Else If (x.LE.3*R+x0) Then
           fbed = - Sqrt(R*R - (x-2*R-x0)*(x-2*R-x0))
      Else 
           fbed = Sqrt(R*R - (x-4*R-x0)*(x-4*R-x0))
      End If
     

      END FUNCTION fbed
! --------------------------------------------------------
      FUNCTION dbed(x)
        USE types
        USE DefUtils
      IMPLICIT NONE
      REAL(KIND=dp) :: dbed,x,fbed
      REAL(KIND=dp) :: x0,R, DEN, EPS = 1.0e-06_dp
      LOGICAL :: FirstTime=.TRUE.
      CHARACTER(len=1) :: Rien
      INTEGER :: i
     
      SAVE FirstTime, x0, R
     
      IF (FirstTime) THEN
        FirstTime = .FALSE.
        Open(10,file='cercle0.geo')
        DO i = 1, 5
          Read(10,*)Rien
        END DO
        Read(10,'(5x,e14.8)')x0
        Read(10,'(5x,e14.8)')R 
        Close(10)
      END IF

      DEN = fbed(x)
      If (Abs(DEN) < EPS) DEN = SIGN(EPS,DEN) 
      
      If (x.LE.R+x0) Then
           dbed = -(x-x0) / DEN 
      Else If (x.LE.3*R+x0) Then
           dbed = -(x-2*R-x0) / DEN 
      Else 
           dbed = -(x-4*R-x0) / DEN 
      End If


      END FUNCTION dbed
! --------------------------------------------------------

! *****************************************************************************/
! *
! *       ELMER, A Computational Fluid Dynamics Program.
! *
! *       Copyright 1st April 1995 - , Center for Scientific Computing,
! *                                    Finland.
! *
! *       All rights reserved. No part of this program may be used,
! *       reproduced or transmitted in any form or by any means
! *       without the written permission of CSC.
! *
! *****************************************************************************/
!
!/******************************************************************************
! *
! * Module containing a solver for (primarily thermal) anisotropic flow
! *
! ******************************************************************************
! *
! *                     Author:       Juha Ruokolainen
! *
! *                    Address: Center for Scientific Computing
! *                            Tietotie 6, P.O. Box 405
! *                              02101 Espoo, Finland
! *                              Tel. +358 0 457 2723
! *                            Telefax: +358 0 457 2302
! *                          EMail: Juha.Ruokolainen@csc.fi
! *
! *                       Date: 08 Jun 1997
! *
! *                Modified by:  Fabien / OG 
! *
! *       Date of modification: 13/10/05 from version 1.5
! *                             of  AIFlowSolver_ai.
! *
! *****************************************************************************/
!------------------------------------------------------------------------------
   RECURSIVE SUBROUTINE AIFlowSolver( Model,Solver,dt,TransientSimulation )
!------------------------------------------------------------------------------

    USE DefUtils

    IMPLICIT NONE

!------------------------------------------------------------------------------
!******************************************************************************
!
!  Solve stress equations for one timestep
!
!  ARGUMENTS:
!
!  TYPE(Model_t) :: Model,  
!     INPUT: All model information (mesh,materials,BCs,etc...)
!
!  TYPE(Solver_t) :: Solver
!     INPUT: Linear equation solver options
!
!  REAL(KIND=dp) :: dt,
!     INPUT: Timestep size for time dependent simulations (NOTE: Not used
!            currently)
!
!******************************************************************************

     TYPE(Model_t)  :: Model
     TYPE(Solver_t), TARGET :: Solver

     LOGICAL ::  TransientSimulation
     REAL(KIND=dp) :: dt
!------------------------------------------------------------------------------
!    Local variables
!------------------------------------------------------------------------------
     TYPE(Solver_t), POINTER :: PSolver

     TYPE(Matrix_t),POINTER :: StiffMatrix

     INTEGER :: i, j, k, l, n, t, iter, NDeg, STDOFs, LocalNodes, istat
     INTEGER :: dim, comp 

     TYPE(ValueList_t),POINTER :: Material, BC, BodyForce
     TYPE(Nodes_t) :: ElementNodes
     TYPE(Element_t),POINTER :: CurrentElement

     REAL(KIND=dp) :: RelativeChange, UNorm, PrevUNorm, Gravity(3), &
         Normal(3), NewtonTol, NonlinearTol, s, Wn(7), MinSRInvariant
         

     REAL(KIND=dp)  :: NodalStresses(3,3), &
       NodalStrainRate(3,3),  NodalSpin(3,3)   

     REAL(KIND=dp), ALLOCATABLE :: Basis(:),ddBasisddx(:,:,:)
     REAL(KIND=dp), ALLOCATABLE :: dBasisdx(:,:), SlipCoeff(:,:)
     REAL(KIND=dp) :: u,v,w,detJ
     
     LOGICAL :: stat, CSymmetry 
       
     INTEGER, PARAMETER :: INDi(1:6) = (/ 1, 2, 3, 1, 2, 3 /) ,&
           INDj(1:6)=(/ 1, 2, 3, 2, 3, 1 /)

     INTEGER :: NewtonIter, NonlinearIter

     TYPE(Variable_t), POINTER :: AIFlowSol, TempSol, Var, FabricVariable
     TYPE(Variable_t), POINTER :: SpinVar 
     REAL(KIND=dp), POINTER :: SpinValues(:)
     INTEGER, POINTER :: SpinPerm(:)

     TYPE(Variable_t), POINTER :: DevStressVar 
     REAL(KIND=dp), POINTER :: DSValues(:)
     INTEGER, POINTER :: DSPerm(:)

     TYPE(Variable_t), POINTER :: StrainRateVar 
     REAL(KIND=dp), POINTER :: SRValues(:)
     INTEGER, POINTER :: SRPerm(:)

     REAL(KIND=dp), POINTER :: Temperature(:),AIFlow(:),Work(:,:), &
           ForceVector(:), VonMises(:), NodalAIFlow(:), AIFlowComp(:), &
           FabricValues(:)

     CHARACTER(LEN=MAX_NAME_LEN) :: EquationName

     INTEGER, POINTER :: TempPerm(:), AIFlowPerm(:), NodeIndexes(:), &
                         FabricPerm(:)

     INTEGER :: AIFlowType
     LOGICAL :: GotForceBC, GotIt, NewtonLinearization = .FALSE., &
                NormalTangential=.FALSE.

     INTEGER :: body_id,bf_id
     INTEGER :: old_body = -1
     LOGICAL :: Isotropic, AllocationsDone = .FALSE., FreeSurface, &
                Requal0

     REAL(KIND=dp) :: FabricGrid(4878)

     INTEGER, DIMENSION(3:8) :: NnodeLinear=(/3, 4, 4, 5, 6, 8/)
           
     REAL(KIND=dp), ALLOCATABLE:: LocalMassMatrix(:,:), &
       LocalStiffMatrix(:,:), LoadVector(:,:), LocalForce(:), &
       LocalTemperature(:), Alpha(:,:), Beta(:), & 
       ReferenceTemperature(:), BoundaryDispl(:), K1(:), K2(:), E1(:), &
       E2(:), E3(:), TimeForce(:), RefS(:), RefD(:), RefSpin(:), &
       LocalVelo(:,:), LocalFluidity(:)
            
     INTEGER :: NumberOfBoundaryNodes
     INTEGER, POINTER :: BoundaryReorder(:)

     REAL(KIND=dp) :: Bu, Bv, Bw, RM(3,3)
     REAL(KIND=dp), POINTER :: BoundaryNormals(:,:), &
         BoundaryTangent1(:,:), BoundaryTangent2(:,:)
     CHARACTER(LEN=MAX_NAME_LEN) :: viscosityFile

     REAL(KIND=dp) :: at, at0, CPUTime, RealTime


!------------------------------------------------------------------------------
     SAVE NumberOfBoundaryNodes,BoundaryReorder,BoundaryNormals, &
              BoundaryTangent1, BoundaryTangent2, FabricGrid, viscosityFile

     SAVE TimeForce, Basis, dBasisdx, ddBasisddx
     SAVE LocalMassMatrix, LocalStiffMatrix, LoadVector, &
       LocalForce, ElementNodes, Alpha, Beta, LocalTemperature, &
       Isotropic,AllocationsDone,ReferenceTemperature,BoundaryDispl, &
       NodalAIFlow, K1, K2, E1, E2, E3, Wn, MinSRInvariant, old_body, &
       LocalFluidity

     SAVE RefD, RefS, RefSpin, LocalVelo, SlipCoeff 
              
!------------------------------------------------------------------------------
!  Read constants from constants section of SIF file
!------------------------------------------------------------------------------
      Wn(7) = GetConstReal( Model % Constants, 'Gas Constant', GotIt )
      IF (.NOT.GotIt) THEN
        WRITE(Message,'(A)') 'VariableGas Constant  not found. &
                     &Setting to 8.314'
        CALL INFO('AIFlowSolve', Message, level=20)
        Wn(7) = 8.314
      ELSE
        WRITE(Message,'(A,F10.4)') 'Gas Constant = ',   Wn(7)
        CALL INFO('AIFlowSolve', Message , level = 20)
      END IF
!------------------------------------------------------------------------------
!    Get variables needed for solution
!------------------------------------------------------------------------------
      IF ( .NOT. ASSOCIATED( Solver % Matrix ) ) RETURN

      AIFlowSol => Solver % Variable
      AIFlowPerm => AIFlowSol % Perm
      STDOFs =  AIFlowSol % DOFs
      AIFlow => AIFlowSol % Values

      LocalNodes = COUNT( AIFlowPerm > 0 )
      IF ( LocalNodes <= 0 ) RETURN

      TempSol => VariableGet( Solver % Mesh % Variables, 'Temperature' )
      IF ( ASSOCIATED( TempSol) ) THEN
        TempPerm    => TempSol % Perm
        Temperature => TempSol % Values
      END IF

      FabricVariable => VariableGet(Solver % Mesh % Variables, 'Fabric')
      IF ( ASSOCIATED( FabricVariable ) ) THEN
       FabricPerm    => FabricVariable % Perm
       FabricValues => FabricVariable % Values
      END IF

      SpinVar => VariableGet(Solver % Mesh %Variables,'Spin')
      IF ( ASSOCIATED( SpinVar ) ) THEN
      SpinPerm => SpinVar % Perm    
      SpinValues => SpinVar % Values  
      END IF
      
      StrainRateVar => VariableGet(Solver % Mesh %Variables,'StrainRate')
      IF ( ASSOCIATED( StrainRateVar ) ) THEN
      SRPerm => StrainRateVar % Perm    
      SRValues => StrainRateVar % Values  
      END IF

      DevStressVar => &
               VariableGet(Solver % Mesh % Variables,'DeviatoricStress')
      IF ( ASSOCIATED( DevStressVar ) ) THEN
      DSPerm => DevStressVar % Perm    
      DSValues => DevStressVar % Values  
      END IF

      StiffMatrix => Solver % Matrix
      ForceVector => StiffMatrix % RHS
      UNorm = Solver % Variable % Norm

!------------------------------------------------------------------------------
!     Allocate some permanent storage, this is done first time only
!------------------------------------------------------------------------------
      IF ( .NOT. AllocationsDone .OR. Solver % Mesh % Changed) THEN
        N = Model % MaxElementNodes
        dim = CoordinateSystemDimension()

       IF ( AllocationsDone ) THEN
         DEALLOCATE( ElementNodes % x,     &
                     ElementNodes % y,     &
                     ElementNodes % z,     &
                     BoundaryDispl,        &
                     ReferenceTemperature, &
                     LocalTemperature,     &
                     LocalVelo,            &
                     LocalForce,           &
                     RefD, RefS, RefSpin,  &
                     LocalMassMatrix,      &
                     LocalStiffMatrix,     &
                     LoadVector, Alpha, Beta, &
                     SlipCoeff, LocalFluidity )
       END IF

       ALLOCATE( ElementNodes % x( N ), &
                 ElementNodes % y( N ), &
                 ElementNodes % z( N ), &
                 BoundaryDispl( N ), &
                 ReferenceTemperature( N ), &
                 LocalTemperature( N ), &
                 K1( N ), K2( N ), E1( N ), E2( N ), E3( N ), &
                 LocalForce( 2*STDOFs*N ),&
                 RefS(2*dim*LocalNodes ),&                              
                 RefD(2*dim*LocalNodes ),&                              
                 RefSpin((2*dim-3)*LocalNodes ),&                       
                 LocalVelo( 3,N ),&                                     
                 Basis( 2*N ),ddBasisddx(1,1,1), dBasisdx( 2*N,3 ), &
                 TimeForce( 2*STDOFs*N ), &
                 LocalMassMatrix( 2*STDOFs*N,2*STDOFs*N ),  &
                 LocalStiffMatrix( 2*STDOFs*N,2*STDOFs*N ),  &
                 LoadVector( 4,N ), Alpha( 3,N ), Beta( N ), &
                 SlipCoeff(3,N), LocalFluidity(N), STAT=istat )

       IF ( istat /= 0 ) THEN
          CALL Fatal( 'AIFlowSolve', 'Memory allocation error.' )
       END IF
!------------------------------------------------------------------------------
!    Check for normal/tangetial coordinate system defined velocities
!------------------------------------------------------------------------------
       CALL CheckNormalTangentialBoundary( Model, &
        'Normal-Tangential AIFlow',NumberOfBoundaryNodes, &
          BoundaryReorder, BoundaryNormals, BoundaryTangent1, &
             BoundaryTangent2, Model % Dimension )
!------------------------------------------------------------------------------

       AllocationsDone = .TRUE.
      END IF

!------------------------------------------------------------------------------
!    Do some additional initialization, and go for it
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
      NonlinearTol = GetConstReal( Solver % Values, &
        'Nonlinear System Convergence Tolerance' )

      NewtonTol = GetConstReal( Solver % Values, &
        'Nonlinear System Newton After Tolerance' )

      NewtonIter = GetInteger( Solver % Values, &
        'Nonlinear System Newton After Iterations' )

      NonlinearIter = GetInteger( Solver % Values, &
         'Nonlinear System Max Iterations',GotIt )

      IF ( .NOT.GotIt ) NonlinearIter = 1
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------

      EquationName = GetString( Solver % Values, 'Equation' )

      FreeSurface = .FALSE.

!------------------------------------------------------------------------------
      DO iter=1,NonlinearIter

       at  = CPUTime()
       at0 = RealTime()

       CALL Info( 'AIFlowSolve', ' ', Level=4 )
       CALL Info( 'AIFlowSolve', ' ', Level=4 )
       CALL Info( 'AIFlowSolve', &
                   '-------------------------------------',Level=4 )
       WRITE( Message, * ) 'ANISOTROPIC FLOW SOLVER ITERATION', iter
       CALL Info( 'AIFlowSolve', Message,Level=4 )
       CALL Info( 'AIFlowSolve', &
                   '-------------------------------------',Level=4 )
       CALL Info( 'AIFlowSolve', ' ', Level=4 )
       CALL Info( 'AIFlowSolve', 'Starting assembly...',Level=4 )
!------------------------------------------------------------------------------
!      Compute average normals for boundaries having the normal & tangential
!      field components specified on the boundaries
!------------------------------------------------------------------------------
       IF ( (iter == 1 .OR. FreeSurface) .AND. NumberOfBoundaryNodes > 0 ) THEN
          CALL AverageBoundaryNormals( Model, &
               'Normal-Tangential AIFlow', NumberOfBoundaryNodes, &
            BoundaryReorder, BoundaryNormals, BoundaryTangent1, &
               BoundaryTangent2, Model % Dimension )
       END IF
!------------------------------------------------------------------------------
       CALL DefaultInitialize()
!------------------------------------------------------------------------------
       DO t=1,Solver % NumberOFActiveElements

         IF ( RealTime() - at0 > 1.0 ) THEN
           WRITE(Message,'(a,i3,a)' ) '   Assembly: ',  &
             INT(100.0 - 100.0 * (Solver % NumberOfActiveElements-t) / &
             (1.0*Solver % NumberOfActiveElements)), ' % done'
           CALL Info( 'AIFlowSolve', Message, Level=5 )
           at0 = RealTime()
         END IF

         CurrentElement => GetActiveElement(t)
         n = GetElementNOFNodes()
         NodeIndexes => CurrentElement % NodeIndexes

         ElementNodes % x(1:n) = Model % Nodes % x(NodeIndexes(1:n))
         ElementNodes % y(1:n) = Model % Nodes % y(NodeIndexes(1:n))
         ElementNodes % z(1:n) = Model % Nodes % z(NodeIndexes(1:n))

         Material => GetMaterial()

!------------------------------------------------------------------------------
!    Read in material constants from Material section
!------------------------------------------------------------------------------
         body_id = CurrentElement % BodyId
         IF ((body_id /= old_body) .OR. (t==1)) Then 
            old_body = body_id
            Call  GetMaterialDefs()
        END IF

        LocalFluidity(1:n) = ListGetReal( Material, &
                         'Fluidity Parameter', n, NodeIndexes, GotIt )
        IF (.NOT.GotIt) THEN
         WRITE(Message,'(A)') 'Variable Fluidity Parameter not found. &
                            &Setting to 1.0'
         CALL INFO('AIFlowSolve', Message, Level = 20)
         LocalFluidity(1:n) = 1.0
        END IF

!------------------------------------------------------------------------------
!        Set body forces
!------------------------------------------------------------------------------
         LoadVector = 0.0D0

         BodyForce => GetBodyForce()
         IF ( ASSOCIATED( BodyForce ) ) THEN
           LoadVector(1,1:n) = LoadVector(1,1:n) + ListGetReal( &
                   BodyForce, 'AIFlow Force 1', n, NodeIndexes, gotIt)
           LoadVector(2,1:n) = LoadVector(2,1:n) + ListGetReal( &
                   BodyForce, 'AIFlow Force 2', n, NodeIndexes, gotIt)
           LoadVector(3,1:n) = LoadVector(3,1:n) + ListGetReal( & 
                   BodyForce, 'AIFlow Force 3', n, NodeIndexes, gotIt)
         END IF
!------------------------------------------------------------------------------
!        Get element local stiffness & mass matrices
!------------------------------------------------------------------------------
         LocalTemperature = 0.0D0
         IF ( ASSOCIATED(TempSol) ) THEN
           DO i=1,n
             k = TempPerm(NodeIndexes(i))
             LocalTemperature(i) = Temperature(k)
           END DO
         ELSE
           LocalTemperature(1:n) = 0.0d0
         END IF

! fabric not needed if isotropic
         IF(.NOT.Isotropic) THEN
           K1(1:n) = FabricValues( 5 * (FabricPerm(NodeIndexes(1:n))-1) + 1 )
           K2(1:n) = FabricValues( 5 * (FabricPerm(NodeIndexes(1:n))-1) + 2 )
           E1(1:n) = FabricValues( 5 * (FabricPerm(NodeIndexes(1:n))-1) + 3 )
           E2(1:n) = FabricValues( 5 * (FabricPerm(NodeIndexes(1:n))-1) + 4 )
           E3(1:n) = FabricValues( 5 * (FabricPerm(NodeIndexes(1:n))-1) + 5 )
         ENDIF

         LocalVelo = 0.0d0
         DO i=1,STDOFs - 1
            LocalVelo(i,1:n) = AIFlow( STDOFs*(AIFlowPerm(NodeIndexes(1:n))-1) + i)
         END DO

         CALL LocalMatrix( LocalMassMatrix, LocalStiffMatrix, &
              LocalForce, LoadVector, K1, K2, E1, E2, E3, LocalVelo, &
              LocalTemperature, LocalFluidity, CurrentElement, n, &
              ElementNodes, Wn, MinSRInvariant, Isotropic)

        TimeForce = 0.0d0
        IF ( n<=NNodeLinear(GetElementFamily()) ) &
           CALL NSCondensate(N, N,STDOFs-1,LocalStiffMatrix,LocalForce,TimeForce )
!------------------------------------------------------------------------------
!        If boundary fields have been defined in normal/tangential
!        coordinate systems, weŽll have to rotate the matrix & force vector
!        to that coordinate system
!------------------------------------------------------------------------------
         IF ( NumberOfBoundaryNodes > 0 ) THEN
           CALL RotateMatrix( LocalStiffMatrix,LocalForce,n, &
           CoordinateSystemDimension(), STDOFs, &
            BoundaryReorder(NodeIndexes),BoundaryNormals,BoundaryTangent1, &
                              BoundaryTangent2 )
         END IF

!------------------------------------------------------------------------------
!        Update global matrices from local matrices 
!------------------------------------------------------------------------------
         CALL DefaultUpdateEquations( LocalStiffMatrix, LocalForce )
      END DO

      CALL Info( 'AIFlowSolve', 'Assembly done', Level=4 )

!------------------------------------------------------------------------------
!     Neumann & Newton boundary conditions
!------------------------------------------------------------------------------
      DO t = 1, Model % NumberOFBoundaryElements

        CurrentElement => GetBoundaryElement(t)
        IF ( GetElementFamily() == 101 ) CYCLE
        IF ( .NOT. ActiveBoundaryElement() ) CYCLE

        n = GetElementNOFNodes()
        NodeIndexes => CurrentElement % NodeIndexes

        ElementNodes % x(1:n) = Model % Nodes % x(NodeIndexes(1:n))
        ElementNodes % y(1:n) = Model % Nodes % y(NodeIndexes(1:n))
        ElementNodes % z(1:n) = Model % Nodes % z(NodeIndexes(1:n))

        BC => GetBC()
        IF ( ASSOCIATED( BC ) ) THEN
            LoadVector = 0.0D0
            Alpha      = 0.0D0
            Beta       = 0.0D0
!------------------------------------------------------------------------------
!           Force in given direction BC: \tau\cdot n = F
!------------------------------------------------------------------------------
            GotForceBC = .FALSE.

            LoadVector(1,1:n) = &
                    ListGetReal( BC, 'Force 1', n, NodeIndexes,  GotIt )
            GotForceBC = GotForceBC .OR. gotIt

            LoadVector(2,1:n) = & 
                     ListGetReal( BC, 'Force 2', n, NodeIndexes, GotIt )
            GotForceBC = GotForceBC .OR. gotIt

            LoadVector(3,1:n) = &
                     ListGetReal( BC, 'Force 3', n, NodeIndexes, GotIt )
            GotForceBC = GotForceBC .OR. gotIt

            Beta(1:n) = &
                ListGetReal( BC, 'Normal Force', n, NodeIndexes, GotIt )
            GotForceBC = GotForceBC .OR. gotIt

!------------------------------------------------------------------------------
!             slip boundary condition BC: \tau\cdot n = R_k u_k
!------------------------------------------------------------------------------

              SlipCoeff = 0.0d0
              SlipCoeff(1,1:n) =  ListGetReal( BC, &
                    'AIFlow Slip Coeff 1', n, NodeIndexes, GotIt )
              GotForceBC = GotForceBC .OR. gotIt

              SlipCoeff(2,1:n) =  ListGetReal( BC, &
                    'AIFlow Slip Coeff 2', n, NodeIndexes, GotIt )
              GotForceBC = GotForceBC .OR. gotIt

              SlipCoeff(3,1:n) =  ListGetReal( BC, &
                    'AIFlow Slip Coeff 3', n, NodeIndexes, GotIt )
              GotForceBC = GotForceBC .OR. gotIt

              NormalTangential = ListGetLogical( BC, &
                     'Normal-Tangential AIFlow', GotIt )
               
            IF ( .NOT.GotForceBC ) CYCLE
!------------------------------------------------------------------------------
            CALL LocalMatrixBoundary( LocalStiffMatrix, LocalForce, &
                 LoadVector, Alpha, Beta, SlipCoeff, NormalTangential, &
                 CurrentElement, n, ElementNodes )
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!           If boundary fields have been defined in normal/tangetial coordinate
!           systems, weŽll have to rotate the matrix & force vector to that
!           coordinate system
!------------------------------------------------------------------------------
            IF ( NumberOfBoundaryNodes > 0 ) THEN
              CALL RotateMatrix( LocalStiffMatrix, LocalForce, n,&
                   CoordinateSystemDimension(), STDOFs, &
                   BoundaryReorder(NodeIndexes), BoundaryNormals, &
                   BoundaryTangent1, BoundaryTangent2 )
            END IF
!------------------------------------------------------------------------------
!           Update global matrices from local matrices (will also affect
!           LocalStiffMatrix and LocalForce if transientsimulation is on).
!------------------------------------------------------------------------------
            CALL DefaultUpdateEquations( LocalStiffMatrix, LocalForce )
!------------------------------------------------------------------------------
         END IF
      END DO
!------------------------------------------------------------------------------

      CALL DefaultFinishAssembly()

!------------------------------------------------------------------------------
!     Dirichlet boundary conditions
!------------------------------------------------------------------------------
      CALL DefaultDirichletBCs()
!------------------------------------------------------------------------------

      CALL Info( 'AIFlowSolve', 'Set boundaries done', Level=4 )

!------------------------------------------------------------------------------
!     Solve the system and check for convergence
!------------------------------------------------------------------------------
      PrevUNorm = UNorm

      UNorm = DefaultSolve()

      IF ( PrevUNorm + UNorm /= 0.0d0 ) THEN
         RelativeChange = 2.0d0 * ABS( PrevUNorm - UNorm) / ( PrevUnorm + UNorm)
      ELSE
         RelativeChange = 0.0d0
      END IF

      WRITE( Message, * ) 'Result Norm   : ',UNorm, PrevUNorm
      CALL Info( 'AIFlowSolve', Message, Level=4 )
      WRITE( Message, * ) 'Relative Change : ',RelativeChange
      CALL Info( 'AIFlowSolve', Message, Level=4 )
!------------------------------------------------------------------------------
!     If boundary fields have been defined in normal/tangential coordinate
!     systems, weŽll have to rotate the solution back to coordinate axis
!     directions
!------------------------------------------------------------------------------
      IF ( NumberOfBoundaryNodes > 0 ) THEN
        DO i=1,Model % NumberOfNodes
          k = BoundaryReorder(i)

          IF ( k > 0 ) THEN
            j = AIFlowPerm(i)

            IF ( j > 0 ) THEN
              IF ( CoordinateSystemDimension() < 3 ) THEN
                Bu = AIFlow( STDOFs*(j-1)+1 )
                Bv = AIFlow( STDOFs*(j-1)+2 )

                AIFlow( STDOFs*(j-1)+1) = BoundaryNormals(k,1) * Bu - &
                                BoundaryNormals(k,2) * Bv

                AIFlow( STDOFs*(j-1)+2) = BoundaryNormals(k,2) * Bu + &
                                BoundaryNormals(k,1) * Bv
              ELSE
                Bu = AIFlow( STDOFs*(j-1)+1 )
                Bv = AIFlow( STDOFs*(j-1)+2 )
                Bw = AIFlow( STDOFs*(j-1)+3 )

                RM(1,:) = BoundaryNormals(k,:)
                RM(2,:) = BoundaryTangent1(k,:)
                RM(3,:) = BoundaryTangent2(k,:)

                AIFlow(STDOFs*(j-1)+1) = RM(1,1)*Bu+RM(2,1)*Bv+RM(3,1)*Bw
                AIFlow(STDOFs*(j-1)+2) = RM(1,2)*Bu+RM(2,2)*Bv+RM(3,2)*Bw
                AIFlow(STDOFs*(j-1)+3) = RM(1,3)*Bu+RM(2,3)*Bv+RM(3,3)*Bw
              END IF
            END IF
          END IF
        END DO 
      END IF
!------------------------------------------------------------------------------
      IF ( RelativeChange < NewtonTol .OR. &
             iter > NewtonIter ) NewtonLinearization = .TRUE.

      IF ( RelativeChange < NonLinearTol ) EXIT

!------------------------------------------------------------------------------
    END DO ! of nonlinear iter
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
!   Compute the StrainRate, Spin  and deviatoric Stress
!   Nodal values      
!------------------------------------------------------------------------------

     IF ((ASSOCIATED( StrainRateVar)).OR.(ASSOCIATED(DevStressVar))&
      .OR.(ASSOCIATED(SpinVar))) THEN
       RefD=0.
       RefS=0.
       RefSpin=0.
       IF (ASSOCIATED(StrainRateVar)) SRValues = 0.
       IF (ASSOCIATED(devStressVar)) DSValues = 0.
       IF (ASSOCIATED(SPinVar)) SpinValues = 0.

      DO t=1,Solver % NumberOFActiveElements

         CurrentElement => GetActiveElement(t)
         n = GetElementNOFNodes()
         NodeIndexes => CurrentElement % NodeIndexes

         body_id = CurrentElement % BodyId
         CSymmetry = CurrentCoordinateSystem() == AxisSymmetric
         dim = CoordinateSystemDimension()

!------------------------------------------------------------------------------
!    Read in material constants from Material section
!------------------------------------------------------------------------------
        IF (body_id /= old_body) Then 
              old_body = body_id
              Call  GetMaterialDefs()
        END IF

        LocalFluidity(1:n) = ListGetReal( Material, &
                      'Fluidity Parameter', n, NodeIndexes, GotIt )
        IF (.NOT.GotIt) THEN
         WRITE(Message,'(A)') 'Variable Fluidity Parameter not found. &
                            &Setting to 1.0'
         CALL INFO('AIFlowSolve', Message, Level = 20)
         LocalFluidity(1:n) = 1.0
        END IF


         ElementNodes % x(1:n) = Model % Nodes % x(NodeIndexes(1:n))
         ElementNodes % y(1:n) = Model % Nodes % y(NodeIndexes(1:n))
         ElementNodes % z(1:n) = Model % Nodes % z(NodeIndexes(1:n))

! n nodale values of the temperature
         
         LocalTemperature = 0.0D0
         IF ( ASSOCIATED(TempSol) ) THEN
           DO i=1,n
             k = TempPerm(NodeIndexes(i))
             LocalTemperature(i) = Temperature(k)
           END DO
         ELSE
           LocalTemperature(1:n) = 0.0d0
         END IF

! n nodales values of the 5 fabric parameters, not needed if isotropic
         IF(.NOT.Isotropic) Then
           K1(1:n) = FabricValues( 5 * (FabricPerm(NodeIndexes(1:n))-1) + 1 ) 
           K2(1:n) = FabricValues( 5 * (FabricPerm(NodeIndexes(1:n))-1) + 2 )
           E1(1:n) = FabricValues( 5 * (FabricPerm(NodeIndexes(1:n))-1) + 3 )
           E2(1:n) = FabricValues( 5 * (FabricPerm(NodeIndexes(1:n))-1) + 4 )
           E3(1:n) = FabricValues( 5 * (FabricPerm(NodeIndexes(1:n))-1) + 5 )
         END IF

! 2D U,V,p    STDOFs=3
! 3D U,V,W,p  STDOFs=4
         LocalVelo = 0.0d0
         DO i=1,STDOFs - 1
            LocalVelo(i,1:n) = AIFlow( STDOFs*(AIFlowPerm(NodeIndexes(1:n))-1) + i)
         END DO
! Go for all nodes of the element        
         Do i=1,n

! u, v, w local coord of node i
           u = CurrentElement % Type % NodeU(i)
           v = CurrentElement % Type % NodeV(i)
           w = CurrentElement % Type % NodeW(i)
       
            stat = ElementInfo(CurrentElement,ELementNodes,u,v,w,detJ, &
               Basis,dBasisdx,ddBasisddx,.FALSE.,.FALSE.)
! Axi symmetric case when R=0 strain, stress not calculated exactly in
! x=0 (I agree it is not very nice, better solution ???)
        Requal0 = .False.
        IF (( CSymmetry) .And. & 
          (SUM(ElementNodes % x(1:n) * Basis(1:n)) == 0.0)) THEN  
           Requal0 = .True.
            u= u + 0.0001  
            stat = ElementInfo(CurrentElement,ELementNodes,u,v,w,detJ, &
               Basis,dBasisdx,ddBasisddx,.FALSE.,.FALSE.)
        END IF

           CALL LocalSD(NodalStresses, NodalStrainRate, NodalSpin, & 
                 LocalVelo, LocalTemperature, LocalFluidity,  &
                K1, K2, E1, E2, E3, CSymmetry, Basis, dBasisdx, &
                CurrentElement, n, ElementNodes, dim, Wn, &
                MinSRInvariant, Isotropic)
                

        IF (Requal0) NodalSpin = 0. 

           IF (ASSOCIATED(StrainRateVar)) &
             RefD(2*dim*(SRPerm(NodeIndexes(i))-1)+1 : &
                                      2*dim*SRPerm(NodeIndexes(i))) &
             =RefD(2*dim*(SRPerm(NodeIndexes(i))-1)+1 : &
                                      2*dim*SRPerm(NodeIndexes(i))) + 1.

          IF (ASSOCIATED(DevStressVar)) &
            RefS(2*dim*(DSPerm(NodeIndexes(i))-1)+1 : &
                                      2*dim*DSPerm(NodeIndexes(i))) &
            =RefS(2*dim*(DSPerm(NodeIndexes(i))-1)+1 :  &
                                      2*dim*DSPerm(NodeIndexes(i))) + 1.

          IF (ASSOCIATED(SpinVar)) &
            RefSpin((2*dim-3)*(SpinPerm(NodeIndexes(i))-1)+1 :  &
                                (2*dim-3)*SpinPerm(NodeIndexes(i))) &
            =RefSpin((2*dim-3)*(SpinPerm(NodeIndexes(i))-1)+1 :  &
                                (2*dim-3)*SpinPerm(NodeIndexes(i))) + 1.


           IF (ASSOCIATED(StrainRateVar)) THEN
             comp=0
             DO j=1,2*dim
               comp=comp+1
               SRValues(2*dim*(SRPerm(NodeIndexes(i))-1)+comp)=&
               SRValues(2*dim*(SRPerm(NodeIndexes(i))-1)+comp) + &
                NodalStrainRate(INDi(j),INDj(j))
             END DO
           END IF

           IF (ASSOCIATED(DevStressVar)) THEN
             comp=0
             DO j=1,2*dim
               comp=comp+1
               DSValues(2*dim*(DSPerm(NodeIndexes(i))-1)+comp)=&
                DSValues(2*dim*(DSPerm(NodeIndexes(i))-1)+comp) + &
                NodalStresses(INDi(j),INDj(j))
             END DO
           END IF

           IF (ASSOCIATED(SpinVar)) THEN
             comp=0
             DO j=1,(2*dim-3)
             comp=comp+1
             SpinValues((2*dim-3)*(SpinPerm(NodeIndexes(i))-1)+comp)=&
             SPinValues((2*dim-3)*(SpinPerm(NodeIndexes(i))-1)+comp) + &
             NodalSpin(INDi(j+3),INDj(j+3))
             END DO
           END IF

          END DO
        END DO

        IF (ASSOCIATED(StrainRateVar)) THEN
              WHERE(RefD > 0.)
                SRVAlues = SRValues / RefD
              END WHERE
        END IF
        
        IF (ASSOCIATED(DevStressVar)) THEN
           WHERE(RefS > 0.)
                DSVAlues = DSValues / RefS
           END WHERE
        END IF

        IF (ASSOCIATED(SpinVar)) THEN
            WHERE(RefSpin > 0.)
                SpinVAlues = SpinValues / RefSpin
            END WHERE
        END IF
        
    END IF

!------------------------------------------------------------------------------
!  END  Compute the StrainRate and Deviatoric Stress
!------------------------------------------------------------------------------
      
CONTAINS

      SUBROUTINE GetMaterialDefs()
      ! check if we are isotropic or not
      Isotropic = ListGetLogical( Material , 'Isotropic',Gotit )
      IF (.NOT.Gotit) Then
          Isotropic = .False.
           WRITE(Message,'(A)') 'Isotropic set to False'
           CALL INFO('AIFlowSolve', Message, Level = 20)
      ELSE
           IF ( (ASSOCIATED( FabricVariable )).AND.Isotropic ) Then
              WRITE(Message,'(A)') 'Be carefull Isotropic is true &
                           & and Fabric is defined!'
              CALL INFO('AIFlowSolve', Message, Level = 1)
           END IF
      END IF

      IF (.NOT.Isotropic) Then
        ! Get the viscosity file and store the viscosities into FabricGrid
         viscosityFile = ListGetString( Material ,'Viscosity File',GotIt )
         IF (.NOT.GotIt) THEN
            WRITE(Message,'(3A)') &
                      'Viscosity File ', viscosityFile, ' not found'
           CALL FATAL('AIFlowSolve',Message)
         ELSE
             OPEN( 1, File = viscosityFile)
             DO i=1,813
                 READ( 1, '(6(e14.8))' ) FabricGrid( 6*(i-1)+1:6*(i-1)+6 )
             END DO
             CLOSE(1)
          END IF
      ENDIF


      Wn(2) = ListGetConstReal( Material , 'Powerlaw Exponent', GotIt )
      IF (.NOT.GotIt) THEN
         WRITE(Message,'(A)') 'Variable  Powerlaw Exponent not found. &
                                    & Setting to 1.0'
         CALL INFO('AIFlowSolve', Message, Level = 20)
         Wn(2) = 1.0
      ELSE
       WRITE(Message,'(A,F10.4)') 'Powerlaw Exponent = ',   Wn(2)
       CALL INFO('AIFlowSolve', Message, Level = 20)
       END IF

      Wn(3) = ListGetConstReal( Material, 'Activation Energy 1', GotIt )
      IF (.NOT.GotIt) THEN
         WRITE(Message,'(A)') 'Variable Activation Energy 1 not found.&
                            & Setting to 1.0'
         CALL INFO('AIFlowSolve', Message, Level = 20)
         Wn(3) = 1.0
      ELSE
         WRITE(Message,'(A,F10.4)') 'Activation Energy 1 = ',   Wn(3)
         CALL INFO('AIFlowSolve', Message, Level = 20)
      END IF

      Wn(4) = ListGetConstReal( Material, 'Activation Energy 2', GotIt )
      IF (.NOT.GotIt) THEN
         WRITE(Message,'(A)') 'Variable Activation Energy 2 not found. &
                               &Setting to 1.0'
         CALL INFO('AIFlowSolve', Message, Level = 20)
         Wn(4) = 1.0
      ELSE
         WRITE(Message,'(A,F10.4)') 'Activation Energy 2 = ',   Wn(4)
         CALL INFO('AIFlowSolve', Message, Level = 20)
      END IF

      Wn(5) = ListGetConstReal(Material, 'Reference Temperature', GotIt)
      IF (.NOT.GotIt) THEN
         WRITE(Message,'(A)') 'Variable Reference Temperature not found. &
                               &Setting to -10.0 (Celsius)'
         CALL INFO('AIFlowSolve', Message, Level = 20)
         Wn(5) = -10.0
      ELSE
         WRITE(Message,'(A,F10.4)') 'Reference Temperature = ',   Wn(5)
         CALL INFO('AIFlowSolve', Message, Level = 20)
      END IF

      Wn(6) = ListGetConstReal( Material, 'Limit Temperature', GotIt )
      IF (.NOT.GotIt) THEN
         WRITE(Message,'(A)') 'Variable Limit Temperature not found. &
                               &Setting to -10.0 (Celsius)'
         CALL INFO('AIFlowSolve', Message, Level = 20)
         Wn(6) = -10.0
      ELSE
         WRITE(Message,'(A,F10.4)') 'Limit Temperature = ',   Wn(6)
         CALL INFO('AIFlowSolve', Message, Level = 20)
      END IF

! Get the Minimum value of the Effective Strain rate 
      MinSRInvariant = 1.0D-10
      IF ( Isotropic .AND. (Wn(2) > 1.0 ) ) THEN
        MinSRInvariant =  &
             ListGetConstReal( Material, 'Min Second Invariant', GotIt )
        IF (.NOT.GotIt) THEN
          WRITE(Message,'(A)') 'Variable Min Second Invariant not &
                    &found. Setting to 1.0D-10 )'
          CALL INFO('AIFlowSolve', Message, Level = 20)
        ELSE
          WRITE(Message,'(A,E14.8)') 'Min Second Invariant = ', MinSRInvariant
          CALL INFO('AIFlowSolve', Message, Level = 20)
        END IF
      END IF

!------------------------------------------------------------------------------
      END SUBROUTINE GetMaterialDefs
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
      SUBROUTINE LocalMatrix( MassMatrix, StiffMatrix, ForceVector, &
              LoadVector, NodalK1, NodalK2, NodalEuler1, NodalEuler2, &
              NodalEuler3, NodalVelo, NodalTemperature, NodalFluidity, &
              Element, n, Nodes, Wn, MinSRInvariant, Isotropic )
              
              
!------------------------------------------------------------------------------

     REAL(KIND=dp) :: StiffMatrix(:,:), MassMatrix(:,:)
     REAL(KIND=dp) :: LoadVector(:,:), NodalVelo(:,:)
     REAL(KIND=dp) :: Wn(7), MinSRInvariant
     REAL(KIND=dp), DIMENSION(:) :: ForceVector, NodalK1, NodalK2, &
             NodalEuler1, NodalEuler2, NodalEuler3, NodalTemperature, &
             NodalFluidity
     TYPE(Nodes_t) :: Nodes
     TYPE(Element_t) :: Element
     LOGICAL :: Isotropic
     INTEGER :: n
!------------------------------------------------------------------------------
!
     REAL(KIND=dp) :: Basis(2*n),ddBasisddx(1,1,1)
     REAL(KIND=dp) :: dBasisdx(2*n,3),detJ, pBasis(n)

     REAL(KIND=dp) :: Force(3), K1, K2, Euler1, Euler2, Euler3
     Real(kind=dp) :: Bg, BGlenT

     REAL(KIND=dp), DIMENSION(4,4) :: A,M
     REAL(KIND=dp) :: Load(3), Temperature,  C(6,6)
     REAL(KIND=dp) :: nn, ss, LGrad(3,3), SR(3,3), epsi

     INTEGER :: i, j, k, p, q, t, dim, cc, NBasis, ind(3), LinearBasis

     REAL(KIND=dp) :: s,u,v,w, Radius, B(6,3), G(3,6), eta
  
     REAL(KIND=dp) :: dDispldx(3,3), ai(3), Angle(3), a2(6)
     TYPE(GaussIntegrationPoints_t), TARGET :: IntegStuff

     INTEGER, POINTER :: EdgeMap(:,:)
     INTEGER :: N_Integ

     REAL(KIND=dp), DIMENSION(:), POINTER :: U_Integ,V_Integ,W_Integ,S_Integ

     LOGICAL :: stat, CSymmetry, P2P1

     TYPE(ElementType_t), POINTER :: SaveType, LinearType

     INTERFACE
      Subroutine R2Ro(a2,dim,ai,angle)
         USE Types
         REAL(KIND=dp),intent(in) :: a2(6)
         Integer :: dim
         REAL(KIND=dp),intent(out) :: ai(3), Angle(3)
      End Subroutine R2Ro
                 
      Subroutine OPILGGE_ai(ai,Angle,Tc,W,etaI,eta36)
          USE Types
          REAL(KIND=dp) :: ai(3), Angle(3), Tc, W(7), EtaI(:), Eta36(6,6)
        END SUBROUTINE OPILGGE_ai

      END INTERFACE

!------------------------------------------------------------------------------
      dim = CoordinateSystemDimension()
      cc=dim+1

      ForceVector = 0.0D0
      StiffMatrix = 0.0D0
      MassMatrix  = 0.0D0

!    
!    Integration stuff
!    
      P2P1 = n>NNodeLinear(GetElementFamily())
      IF ( P2P1 ) THEN
        NBasis = n

        SELECT CASE(GetElementFamily())
        CASE(3)
          LinearBasis = 3
          LinearType => GetElementType(303)
        CASE(4)
          LinearBasis = 4
          LinearType => GetElementType(404)
        CASE(5)
          LinearBasis = 4
          LinearType => GetElementType(504)
        CASE(6)
          LinearBasis = 5
          LinearType => GetElementType(605)
        CASE(7)
          LinearBasis = 6
          LinearType => GetElementType(706)
        CASE(8)
          LinearBasis = 8
          LinearType => GetElementType(808)
        END SELECT
        SaveType => Element % Type
        IntegStuff = GaussPoints( Element )
      ELSE
        NBasis = 2*n
        IntegStuff = GaussPoints( Element, Element % Type % GaussPoints2 )
      END IF

      U_Integ => IntegStuff % u
      V_Integ => IntegStuff % v
      W_Integ => IntegStuff % w
      S_Integ => IntegStuff % s
      N_Integ =  IntegStuff % n
!
!   Now we start integrating
!
      DO t=1,N_Integ

      u = U_Integ(t)
      v = V_Integ(t)
      w = W_Integ(t)

!------------------------------------------------------------------------------
!     Basis function values & derivatives at the integration point
!------------------------------------------------------------------------------
      IF ( P2P1 ) THEN
         Element % Type => LinearType
         stat = ElementInfo( Element,Nodes,u,v,w,detJ,PBasis )
         Element % Type => SaveType
      END IF
      stat = ElementInfo( Element,Nodes,u,v,w,detJ, &
         Basis,dBasisdx,ddBasisddx,.FALSE.,.TRUE. )

      s = detJ * S_Integ(t)
!------------------------------------------------------------------------------
!  
!     Force at integration point
!   
      Force = 0.0d0
      DO i=1,dim
         Force(i) = SUM( LoadVector(i,1:n)*Basis(1:n))
      END DO


      Radius = SUM( Nodes % x(1:n) * Basis(1:n) )
!
!     Temperature at the integration point
!
      Temperature = SUM( NodalTemperature(1:n)*Basis(1:n) )
      Wn(1) = SUM( NodalFluidity(1:n)*Basis(1:n) )
      Bg = BGlenT(Temperature,Wn)

! if not isotropic use GOLF
      C = 0.0_dp
      IF (.NOT.Isotropic) Then
         a2(1) = SUM( NodalK1(1:n) * Basis(1:n) ) 
         a2(2) = SUM( NodalK2(1:n) * Basis(1:n) ) 
         a2(3) = 1.d0 - a2(1) - a2(2)
         a2(4) = SUM( NodalEuler1(1:n) * Basis(1:n) )
         a2(5) = SUM( NodalEuler2(1:n) * Basis(1:n) )
         a2(6) = SUM( NodalEuler3(1:n) * Basis(1:n) )
      
         CALL R2Ro(a2,dim,ai,angle)
         CALL OPILGGE_ai(ai,Angle,Temperature,Wn,FabricGrid,C)

! else use isotropic law
      ELSE
          eta = 1.0_dp / Bg
      ENDIF
      
      CSymmetry = CurrentCoordinateSystem() == AxisSymmetric
      IF ( CSymmetry ) s = s * Radius

!
! Case non-linear and ISOTROPIC
! -----------------------------

      IF ( Isotropic .AND. (Wn(2) > 1.0) ) THEN
        LGrad = MATMUL( NodalVelo(:,1:n), dBasisdx(1:n,:) )
        SR = 0.5 * ( LGrad + TRANSPOSE(LGrad) )
      
        IF ( CSymmetry ) THEN
          SR(1,3) = 0.0
          SR(2,3) = 0.0
          SR(3,1) = 0.0
          SR(3,2) = 0.0
          SR(3,3) = 0.0
          IF ( Radius > 10*AEPS ) THEN
            SR(3,3) = SUM( Nodalvelo(1,1:n) * Basis(1:n) ) /Radius
                 
          END IF
          epsi = SR(1,1)+SR(2,2)+SR(3,3)
          DO i=1,3   
            SR(i,i) = SR(i,i) - epsi/3.0
          END DO
        ELSE
          epsi = SR(1,1)+SR(2,2)+SR(3,3)
          DO i=1,dim 
            SR(i,i) = SR(i,i) - epsi/dim
          END DO
        END IF

        ss = 0.0_dp
        DO i = 1, 3
          DO j = 1, 3
            ss = ss + SR(i,j)**2
          END DO
        END DO
        nn =(1.0 - Wn(2))/Wn(2)

        ss = SQRT(2.0_dp * ss)
        IF (ss < MinSRInvariant ) ss = MinSRInvariant

        eta  = eta * (ss/Bg)**nn 

      END IF

!
!    Loop over basis functions (of both unknowns and weights)
!

      M = 0.0d0
      DO p=1,NBasis

       
        IF (.Not.Isotropic) THEN
          G = 0.0d0
          IF ( CSymmetry ) THEN
            G(1,1) = dBasisdx(p,1)
            G(1,3) = Basis(p) / Radius
            G(1,4) = dBasisdx(p,2)
            G(2,2) = dBasisdx(p,2)
            G(2,4) = dBasisdx(p,1)
          ELSE
            G(1,1) = dBasisdx(p,1)
            G(2,2) = dBasisdx(p,2)
            G(3,3) = dBasisdx(p,3)
            G(1,4) = dBasisdx(p,2)
            G(2,4) = dBasisdx(p,1)
            G(2,5) = dBasisdx(p,3)
            G(3,5) = dBasisdx(p,2)
            G(1,6) = dBasisdx(p,3)
            G(3,6) = dBasisdx(p,1)
          END IF
          G = MATMUL( G, C )
        END IF 
 
       DO q=1,NBasis

         IF (.Not.Isotropic) THEN
           B = 0.0d0
           IF ( CSymmetry ) THEN
             B(1,1) = dBasisdx(q,1)
             B(2,2) = dBasisdx(q,2)
             B(3,1) = Basis(q) / Radius
             B(4,1) = dBasisdx(q,2)
             B(4,2) = dBasisdx(q,1)
           ELSE
             B(1,1) = dBasisdx(q,1)
             B(2,2) = dBasisdx(q,2)
             B(3,3) = dBasisdx(q,3)
             B(4,1) = dBasisdx(q,2)
             B(4,2) = dBasisdx(q,1)
             B(5,2) = dBasisdx(q,3)
             B(5,3) = dBasisdx(q,2)
             B(6,1) = dBasisdx(q,3)
             B(6,3) = dBasisdx(q,1)
           END IF
           A(1:3,1:3) = MATMUL( G, B )
         ELSE

         A = 0.0d0
           DO i=1,dim
              DO j=1,dim
                A(i,i)=A(i,i) + eta* dbasisdx(q,j)*dbasisdx(p,j)
                A(i,j)=A(i,j) + eta* dbasisdx(q,i)*dbasisdx(p,j)
              END DO
           END DO

         END IF

! Pressure gradient
         DO i=1,dim
            A(i,cc) = -dBasisdx(p,i) * Basis(q)
         END DO
         IF ( CSymmetry ) A(1,cc) =  A(1,cc) - Basis(p) * Basis(q) / Radius

! Continuity equation:
         DO i=1,dim
            IF ( P2P1 .AND. p <= LinearBasis ) THEN
              A(cc,i) = dBasisdx(q,i) * PBasis(p)
            ELSE IF (.NOT.P2P1) THEN
              A(cc,i) = dBasisdx(q,i) * Basis(p)
            END IF
         END DO
         IF ( P2P1 .AND. p <= LinearBasis ) THEN
            IF ( CSymmetry ) A(cc,1) =  A(cc,1) + PBasis(p) * Basis(q) / Radius
         ELSE IF (.NOT.P2P1) THEN
            IF ( CSymmetry ) A(cc,1) =  A(cc,1) + Basis(p) * Basis(q) / Radius
         END IF
         A(cc, cc) = 0.0d0

! Add nodal matrix to element matrix
         DO i=1,cc
            DO j=1,cc
               StiffMatrix( cc*(p-1)+i,cc*(q-1)+j ) =  &
                    StiffMatrix( cc*(p-1)+i,cc*(q-1)+j ) + s*A(i,j)
            END DO
         END DO

       END DO

! The righthand side...
        Load = 0.0d0
  
        DO i=1,dim
           Load(i) = Load(i) + Force(i) * Basis(p)
        END DO

        DO i=1,dim
           ForceVector(cc*(p-1)+i) = ForceVector(cc*(p-1)+i) + s*Load(i)
        END DO

      END DO

! Non linear element -> apply p2p1 element

      j = GetElementFamily()
      IF ( n > NNodeLinear(j) ) THEN
        EdgeMap => GetEdgeMap(j)
        DO i=j+1,n
          p = EdgeMap(i-j,1)
          q = EdgeMap(i-j,2)
          StiffMatrix( cc*i, : ) = 0.0d0
          MassMatrix(  cc*i, : ) = 0.0d0
          ForceVector( cc*i ) = 0.0d0
          StiffMatrix( cc*i, cc*i ) = 1.0d0
          StiffMatrix( cc*i, cc*p ) = -1.0d0/2.0d0
          StiffMatrix( cc*i, cc*q ) = -1.0d0/2.0d0
        END DO
      END IF 


      END DO 
!------------------------------------------------------------------------------
      END SUBROUTINE LocalMatrix
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
      SUBROUTINE LocalMatrixBoundary( BoundaryMatrix, BoundaryVector, &
                 LoadVector, NodalAlpha, NodalBeta, NodalSlipCoeff, & 
                  NormalTangential, Element, n, Nodes )
                      
!------------------------------------------------------------------------------
     REAL(KIND=dp) :: BoundaryMatrix(:,:),BoundaryVector(:)
     REAL(KIND=dp) :: NodalAlpha(:,:),NodalBeta(:),LoadVector(:,:)
     REAL(KIND=dp) :: NodalSlipCoeff(:,:)
     TYPE(Element_t),POINTER  :: Element
     TYPE(Nodes_t)    :: Nodes
     LOGICAL :: NormalTangential
     INTEGER :: n
!------------------------------------------------------------------------------
     REAL(KIND=dp) :: Basis(n),ddBasisddx(1,1,1)
     REAL(KIND=dp) :: dBasisdx(n,3),detJ

     REAL(KIND=dp) :: u,v,w,s
     REAL(KIND=dp) :: Force(3),Alpha(3),Beta,Normal(3)
     REAL(KIND=dp), POINTER :: U_Integ(:),V_Integ(:),W_Integ(:),S_Integ(:)

     REAL(KIND=dp) :: Tangent(3),Tangent2(3),Vect(3), SlipCoeff
     INTEGER :: i,t,q,p,dim,N_Integ, c

     LOGICAL :: stat

     TYPE(GaussIntegrationPoints_t), TARGET :: IntegStuff
!------------------------------------------------------------------------------

      dim = CoordinateSystemDimension()
      c=dim+1

      BoundaryVector = 0.0D0
      BoundaryMatrix = 0.0D0
!
!  Integration stuff
!
      IntegStuff = GaussPoints( element )
      U_Integ => IntegStuff % u
      V_Integ => IntegStuff % v
      W_Integ => IntegStuff % w
      S_Integ => IntegStuff % s
      N_Integ =  IntegStuff % n
!
!  Now we start integrating
!
      DO t=1,N_Integ

       u = U_Integ(t)
       v = V_Integ(t)
       w = W_Integ(t)

!------------------------------------------------------------------------------
!    Basis function values & derivatives at the integration point
!------------------------------------------------------------------------------
       stat = ElementInfo( Element, Nodes, u, v, w, detJ, &
                Basis, dBasisdx, ddBasisddx, .FALSE. )

       s = detJ * S_Integ(t)
       IF ( CurrentCoordinateSystem() == AxisSymmetric ) &
        s = s * SUM( Nodes % x(1:n) * Basis(1:n) )
!------------------------------------------------------------------------------
       Force = 0.0D0
       DO i=1,dim
         Force(i) = SUM( LoadVector(i,1:n)*Basis(1:n) )
         Alpha(i) = SUM( NodalAlpha(i,1:n)*Basis(1:n) )
       END DO

       Normal = NormalVector( Element,Nodes,u,v,.TRUE. )
       Force = Force + SUM( NodalBeta(1:n)*Basis(1:n) ) * Normal

       SELECT CASE( Element % TYPE % DIMENSION )
       CASE(1)
        Tangent(1) =  Normal(2)
        Tangent(2) = -Normal(1)
        Tangent(3) =  0.0d0
       CASE(2)
        CALL TangentDirections( Normal, Tangent, Tangent2 ) 
       END SELECT
  
       IF ( ANY( NodalSlipCoeff(:,:) /= 0.0d0 ) ) THEN
         DO p=1,n
           DO q=1,n
             DO i=1,DIM
              SlipCoeff = SUM( NodalSlipCoeff(i,1:n) * Basis(1:n) )
  
              IF (NormalTangential ) THEN
                SELECT CASE(i)
                   CASE(1)
                     Vect = Normal
                   CASE(2)
                     Vect = Tangent
                   CASE(3)
                     Vect = Tangent2
                END SELECT
  
                DO j=1,DIM
                   DO k=1,DIM
                      BoundaryMatrix( (p-1)*c+j,(q-1)*c+k ) = &
                         BoundaryMatrix( (p-1)*c+j,(q-1)*c+k ) + &
                          s * SlipCoeff * Basis(q) * Basis(p) * Vect(j) * Vect(k)
                   END DO
                END DO
               ELSE
                 BoundaryMatrix( (p-1)*c+i,(q-1)*c+i ) = &
                     BoundaryMatrix( (p-1)*c+i,(q-1)*c+i ) + &
                          s * SlipCoeff * Basis(q) * Basis(p)
               END IF
             END DO
           END DO
         END DO
       END IF



      DO p=1,N
       DO q=1,N
         DO i=1,dim
           BoundaryMatrix((p-1)*(dim+1)+i,(q-1)*(dim+1)+i) =  &
             BoundaryMatrix((p-1)*(dim+1)+i,(q-1)*(dim+1)+i) + &
               s * Alpha(i) * Basis(q) * Basis(p)
         END DO
       END DO
      END DO

      DO q=1,N
       DO i=1,dim
         BoundaryVector((q-1)*(dim+1)+i) = BoundaryVector((q-1)*(dim+1)+i) + &
                   s * Basis(q) * Force(i)
       END DO
      END DO

      END DO
!------------------------------------------------------------------------------
      END SUBROUTINE LocalMatrixBoundary
!------------------------------------------------------------------------------


!------------------------------------------------------------------------------
      SUBROUTINE LocalSD( Stress, StrainRate, Spin, &
        NodalVelo, NodalTemp, NodalFluidity, NodalK1,  &
        NodalK2, NodalE1, NodalE2, NodalE3, CSymmetry, &
        Basis, dBasisdx, Element, n,  Nodes, dim,  Wn, MinSRInvariant, &
        Isotropic)
!------------------------------------------------------------------------------
!    Subroutine to computre the nodal Strain-Rate, Stress, ...
!------------------------------------------------------------------------------
     LOGICAL ::  CSymmetry 
     INTEGER :: n, dim
     INTEGER :: INDi(6),INDj(6)
     REAL(KIND=dp) :: Stress(:,:), StrainRate(:,:), Spin(:,:)
     REAL(KIND=dp) :: NodalVelo(:,:), NodalTemp(:), NodalFluidity(:)
     REAL(KIND=dp) :: Basis(2*n), ddBasisddx(1,1,1)
     REAL(KIND=dp) :: dBasisdx(2*n,3)
     REAL(KIND=dp) :: detJ
     REAL(KIND=dp) :: NodalK1(:), NodalK2(:)
     REAL(KIND=dp) :: NodalE1(:), NodalE2(:), NodalE3(:)
     REAL(KIND=dp) :: u, v, w      
     REAL(KIND=dp) :: Wn(7),  D(6), MinSRInvariant
     LOGICAL :: Isotropic
      
     TYPE(Nodes_t) :: Nodes
     TYPE(Element_t) :: Element
!------------------------------------------------------------------------------
     LOGICAL :: stat
     INTEGER :: i,j,k,p,q
     REAL(KIND=dp) :: LGrad(3,3),   Radius, Temp, ai(3), Angle(3),a2(6)
     REAL(KIND=dp) :: C(6,6), epsi
     Real(kind=dp) :: Bg, BGlenT, ss, nn
!------------------------------------------------------------------------------
     INTERFACE
      Subroutine R2Ro(a2,dim,ai,angle)
         USE Types
         REAL(KIND=dp),intent(in) :: a2(6)
         Integer :: dim
         REAL(KIND=dp),intent(out) :: ai(3), Angle(3)
      End Subroutine R2Ro
                 
      Subroutine OPILGGE_ai(ai,Angle,Tc,W,etaI,eta36)
          USE Types
          REAL(KIND=dp) :: ai(3), Angle(3), Tc, W(7), EtaI(:), Eta36(6,6)
        END SUBROUTINE OPILGGE_ai
      END INTERFACE
!------------------------------------------------------------------------------
     
      Stress = 0.0
      StrainRate = 0.0
      Spin = 0.0

!
!     Temperature at the integration point
      Temp = SUM( NodalTemp(1:n)*Basis(1:n) )
      Wn(1) = SUM( NodalFluidity(1:n)*Basis(1:n) )
      
      C = 0.0_dp
      IF (.Not.Isotropic) then
!    Material parameters at that point
        a2(1) = SUM( NodalK1(1:n) * Basis(1:n) ) 
        a2(2) = SUM( NodalK2(1:n) * Basis(1:n) ) 
        a2(3) = 1.d0 - a2(1) - a2(2)
        a2(4) = SUM( NodalE1(1:n) * Basis(1:n) )
        a2(5) = SUM( NodalE2(1:n) * Basis(1:n) )
        a2(6) = SUM( NodalE3(1:n) * Basis(1:n) )
      
        CALL R2Ro(a2,dim,ai,Angle)
        CALL OPILGGE_ai(ai,Angle,Temp,Wn,FabricGrid,C)

      ELSE
         Bg=BGlenT(Temp,Wn)
         Do i=1,3
            C(i,i)=2._dp/Bg
         End do
         Do i=4,6
            C(i,i)=1.0_dp/Bg
         End do
      END IF
!
!    Compute strainRate : 
!    -------------------

      LGrad = MATMUL( NodalVelo(:,1:n), dBasisdx(1:n,:) )
        
      StrainRate = 0.5 * ( LGrad + TRANSPOSE(LGrad) )
      
      IF ( CSymmetry ) THEN
        StrainRate(1,3) = 0.0
        StrainRate(2,3) = 0.0
        StrainRate(3,1) = 0.0
        StrainRate(3,2) = 0.0
        StrainRate(3,3) = 0.0
        Radius = SUM( Nodes % x(1:n) * Basis(1:n) )
        IF ( Radius > 10*AEPS ) THEN
         StrainRate(3,3) = SUM( Nodalvelo(1,1:n) * Basis(1:n) ) / Radius
        END IF
        epsi = StrainRate(1,1)+StrainRate(2,2)+StrainRate(3,3)
        DO i=1,3   
          StrainRate(i,i) = StrainRate(i,i) - epsi/3.0
        END DO
      ELSE
        epsi = StrainRate(1,1)+StrainRate(2,2)+StrainRate(3,3)
        DO i=1,dim 
          StrainRate(i,i) = StrainRate(i,i) - epsi/dim
        END DO
      END IF
 
!
! Case non-linear and ISOTROPIC
! -----------------------------

      IF ( Isotropic .AND. (Wn(2) > 1.0) ) THEN
        ss = 0.0_dp
        DO i = 1, 3
          DO j = 1, 3
            ss = ss + StrainRate(i,j)**2
          END DO
        END DO
        nn = (1.0 - Wn(2))/Wn(2)
        ss = SQRT(2.0_dp * ss)
         
        IF (ss < MinSRInvariant ) ss = MinSRInvariant
        
        C = C * (ss/Bg)**nn 
      END IF


!
!    Compute Spin : 
!    --------------

        Spin = 0.5 * ( LGrad - TRANSPOSE(LGrad) )
!
!    Compute deviatoric stresses: 
!    ----------------------------
      D(1) = StrainRate(1,1)
      D(2) = StrainRate(2,2)
      D(3) = StrainRate(3,3)
      D(4) = 2. * StrainRate(1,2)
      D(5) = 2. * StrainRate(2,3)
      D(6) = 2. * StrainRate(3,1)
      
      INDi(1:6) = (/ 1, 2, 3, 1, 2, 3 /)
      INDj(1:6) = (/ 1, 2, 3, 2, 3, 1 /)
      DO k = 1, 2*dim
       DO j = 1, 2*dim
        Stress( INDi(k),INDj(k) ) = &
        Stress( INDi(k),INDj(k) ) + C(k,j) * D(j)
       END DO
       IF (k > 3)  Stress( INDj(k),INDi(k) ) = Stress( INDi(k),INDj(k) )
      END DO
!------------------------------------------------------------------------------
      END SUBROUTINE LocalSD      
!------------------------------------------------------------------------------
!        



!------------------------------------------------------------------------------
      END SUBROUTINE AIFlowSolver
!------------------------------------------------------------------------------

!/******************************************************************************
! *
! *       ELMER, A Computational Fluid Dynamics Program.
! *
! *       Copyright 1st April 1995 - , Center for Scientific Computing,
! *                                    Finland.
! *
! *       All rights reserved. No part of this program may be used,
! *       reproduced or transmitted in any form or by any means
! *       without the written permission of CSC.
! *
! *****************************************************************************/
!
!/******************************************************************************
! *
! * CavitySolve                                           
! * To be compiled with two functions fbed = bed(x) and dbed = d bed(x) / dx
! *    move the nodes of a Free surface by -dt(u.n)n 
! *    n = outside normal to the free surface      
! *    u = velocity from either NS solver or AIFlow solver      
! *    dt =  time increment 
! *
! ******************************************************************************
! *
! *                    Author:  Olivier Gagliardini
! *
! *                       Date: 27 Sep 2005
! *
! *                Modified by: 
! *
! *
!/******************************************************************************
! *
! *       Modified by: 
! *
! *       Date of modification: 
! *
! *****************************************************************************/
!---------------------------------------------------------------------
!---------------------------------------------------------------------
       SUBROUTINE CavitySolve( Model, Solver, dt, TransientSimulation )

       USE types
       USE DefUtils
       USE CoordinateSystems
       USE SolverUtils
       USE ElementDescription
!-----------------------------------------------------------
       IMPLICIT NONE
!-----------------------------------------------------------
       TYPE(Solver_t), TARGET :: Solver
       TYPE(Model_t) :: Model
       REAL(KIND=dp) :: dt
       LOGICAL :: TransientSimulation
!-----------------------------------------------------------
       TYPE(Variable_t), POINTER :: moveFSSolution
       REAL(KIND=dp), POINTER :: moveFSvector(:)
       INTEGER, POINTER :: moveFSPerm(:), NodeIndexes(:)
       TYPE(Element_t), POINTER ::  BCElement
       TYPE(Nodes_t) :: Nodes
       TYPE(Variable_t), POINTER :: TimeVar
       TYPE(Variable_t), POINTER :: DevStressVar, & 
              FlowVariable, NormalVariable, MHVariable
       TYPE(ValueList_t), POINTER :: BC, SolverParams
       REAL(KIND=dp), POINTER ::  MHPrev(:,:), DSValues(:), & 
              FlowValues(:), NormalValues(:)
       INTEGER, POINTER :: FlowPerm(:), NormalPerm(:), MHPerm(:), DSPerm(:)
       CHARACTER(LEN=MAX_NAME_LEN)  ::  FlowSolverName, BCTypeName, & 
                                        SaveFileName
       INTEGER :: DIM, n, i, j, k, p, istat, Nn, nbed2, &
                                 nbed1,nbed10, NMAX, Nn2, Node
       REAL(KIND=dp) :: x, y, u, v, Velocity(3),lbed10, lbed20, &
                     LastTime= 0.0, xEnd, xFirst, xf, xd, xbed2, xbed1, &
                     dMULN, dMUFN, mu1, mu2, Large, Normal(3)
       REAL(KIND=dp) ::  dt1, dt2, dt3, tanbed(2), dx, TrueTime
       REAL(KIND=dp) :: aa, bb, cc, dd, s
       REAL(KIND=dp) :: EPS, pwater, ds, Nvelo, sc           
       REAL(KIND=dp) :: taub, ub, fx, fy, pice, deltaFS, MaxdeltaFS, Bu, Bv   
       REAL(KIND=dp) :: Sxx(3),Syy(3),Sxy(3),Velo(3,3), LocalNormal(3,3), &
                         lc, ltot, xa, xb, slope
       REAL(KIND=dp), ALLOCATABLE ::  xn(:), yn(:), xn0(:), &
               yn0(:), xnew(:), ynew(:), y2new(:), intersept(:),  &
               dMU(:), x0(:), y0(:), y1new(:), y3new(:), Nvector(:)
       INTEGER, ALLOCATABLE :: ordre(:), ind(:), BCType(:)
        
       LOGICAL :: AllocationsDone = .FALSE. , FirstTime = .TRUE., &
                 FirstTime2 = .TRUE., SaveFile = .FALSE.
       LOGICAL :: GotIt, succes, FirstNodeMove
       
       COMMON /interbed/aa,bb,cc,dd

       INTERFACE 
         SUBROUTINE indexx(arr,ind) 
         USE types
         USE DefUtils
         IMPLICIT NONE 
         REAL(KIND=dp) :: arr(:) 
         INTEGER :: ind(:) 
         END SUBROUTINE indexx
         SUBROUTINE spline(x,y,yp1,ypn,y2) 
         USE types
         USE DefUtils
         IMPLICIT NONE 
         REAL(KIND=dp), DIMENSION(:), INTENT(IN) :: x,y 
         REAL(KIND=dp), INTENT(IN) :: yp1,ypn 
         REAL(KIND=dp), DIMENSION(:), INTENT(OUT) :: y2 
         END SUBROUTINE spline
         FUNCTION splint(xa,ya,y2a,x) 
         USE types
         USE DefUtils
         IMPLICIT NONE 
         REAL(KIND=dp), DIMENSION(:), INTENT(IN) :: xa,ya,y2a 
         REAL(KIND=dp), INTENT(IN) :: x 
         REAL(KIND=dp) :: splint
         END FUNCTION splint
         FUNCTION zbrent(func,x1,x2,tol)
         USE types
         USE DefUtils
         IMPLICIT NONE 
         REAL(KIND=dp), INTENT(IN) :: x1,x2,tol 
         REAL(KIND=dp) :: zbrent 
         INTERFACE 
         FUNCTION func(x) 
         USE types
         USE DefUtils
         IMPLICIT NONE 
         REAL(KIND=dp), INTENT(IN) :: x 
         REAL(KIND=dp) :: func 
         END FUNCTION func 
         END INTERFACE 
         END FUNCTION zbrent
         FUNCTION intbed(x)
         USE types
         USE DefUtils
         REAL(KIND=dp) :: intbed,x
         END FUNCTION intbed
         FUNCTION intbed1(x)
         USE types
         USE DefUtils
         REAL(KIND=dp) :: intbed1,x
         END FUNCTION intbed1
         FUNCTION intbed2(x)
         USE types
         USE DefUtils
         REAL(KIND=dp) :: intbed2,x
         END FUNCTION intbed2
         FUNCTION curvi(x1,x2,func,N)
         USE types
         USE DefUtils
         IMPLICIT NONE 
         REAL(KIND=dp), INTENT(IN) :: x1,x2
         REAL(KIND=dp) :: curvi  
         INTEGER :: N
         INTERFACE 
         FUNCTION func(x) 
         USE types
         USE DefUtils
         IMPLICIT NONE 
         REAL(KIND=dp), INTENT(IN) :: x 
         REAL(KIND=dp) :: func 
         END FUNCTION func 
         END INTERFACE 
         END FUNCTION curvi 
         FUNCTION fbed(x)
         USE types
         USE DefUtils
         REAL(KIND=dp) :: fbed,x
         END FUNCTION fbed
         FUNCTION dbed(x)
         USE types
         USE DefUtils
         REAL(KIND=dp) :: dbed,x
         END FUNCTION dbed
       END INTERFACE

       Save DIM, Nodes,  FlowSolverName,  &
                 LastTime, xEnd, xFirst, xd, xf, Nn, &
                 FirstNodeMove, EPS, TrueTime, intersept, &
                 Large, Nn2, dMU, x0, y0, SaveFile, SaveFileName
       Save BCType, ordre, xn, xn0, yn, yn0, dMULN, dMUFN, & 
             lbed10, lbed20, Nvector



       moveFSSolution => VariableGet( Solver % Mesh % Variables, &
&                                          'moveFS' ) 
       IF ( ASSOCIATED( moveFSSolution ) ) THEN 
          moveFSvector => moveFSSolution % Values
          moveFSPerm => moveFSSolution % Perm
       ELSE
          PRINT *,'FATAL: Unable to set pointer to the current solution'
          STOP
       END IF
!
! Read data from Solver
! 
! IF FIRSTIME ------------------------------------------------------
      IF (FirstTime) THEN
         FirstTime=.FALSE.
         TrueTime = 0.0_dp 
         DIM = CoordinateSystemDimension()
         SolverParams => GetSolverParams()

         FlowSolverName = GetString( SolverParams, &
&                                    'Flow Solver Name', GotIt )    
         IF (.NOT.Gotit) THEN
           CALL INFO('Cavity Solver','No Flow Solver Name given,&
&                   default Value = Flow Solution    ', Level=4)
            FlowSolverName = 'Flow Solution'
         END IF

         FirstNodeMove = GetLogical( SolverParams, &
&                                    'First Node Move', GotIt )    
         IF (.NOT.Gotit) THEN
           CALL INFO('Cavity Solver','No First Node Move given,&
&                   default Value = False    ', Level=4)
            FirstNodeMove = .False. 
         END IF

         SaveFileName = GetString( SolverParams, &
&                                    'Save File Name', SaveFile )    

        IF (SaveFile) THEN
        OPEN(22,File=SaveFileName)
        WRITE(22,'("# 1  : Time")')
        WRITE(22,'("# 2  : TrueTime")')
        WRITE(22,'("# 3  : dt")')
        WRITE(22,'("# 4  : Tau_b")')
        WRITE(22,'("# 5  : p_ice")')
        WRITE(22,'("# 6  : p_water")')
        WRITE(22,'("# 7  : U_b")')
        WRITE(22,'("# 8  : Tau_b / N")')
        WRITE(22,'("# 9  : U_b / N")')
        WRITE(22,'("# 10 : f_x")')
        WRITE(22,'("# 11 : f_y")')
        WRITE(22,'("# 12 : U.n")')
        WRITE(22,'("# 13 : Max(U.n)")')
        WRITE(22,'("# 14 : Max(slope)")')
        WRITE(22,'("# 15 : xbed1")')
        WRITE(22,'("# 16 : xbed2")')
        WRITE(22,'("# 17 : s_cavity")')
        CLOSE(22)
        END IF

        xf = -1.0e20_dp
        xd = 1.0e20_dp
        EPS = 100.0_dp*EPSILON(xf)
        Large = 0.1_dp*HUGE(xf) 
        Nn = 1
        NMAX = 0
        DO p = 1, Model % NumberOfBoundaryElements
          BCElement => GetBoundaryElement(p) 

!         IF( .NOT. ActiveBoundaryElement(BCElement) )  CYCLE
          IF( GetElementFamily(BCElement) == 1 ) CYCLE
          
          BC => GetBC( BCElement ) 

          BCTypeName  = GetString(BC, 'Cavity Type', GotIt)

          IF (GotIt.AND.(BCTypeName=='cavity')) THEN
            n = BCElement % Type % NumberOfNodes
            IF (n>NMAX) NMAX = n
            Nn = Nn + n - 1
          END IF
          
          IF (MAXVAL(Model % Nodes % x(BCElement % NodeIndexes))>xf)  &
                 xf = MAXVAL(Model % Nodes % x(BCElement % NodeIndexes))

          IF (MINVAL(Model % Nodes % x(BCElement % NodeIndexes))<xd)  &
                 xd = MINVAL(Model % Nodes % x(BCElement % NodeIndexes))

        END DO
        Nn2 = FLOOR(Nn/2.0)
        ALLOCATE( Nodes % x( NMAX ), Nodes % y( NMAX ), Nodes % z( NMAX ))

        NMAX = Model % NumberOfNodes
        ALLOCATE( dMU(2*NMAX), x0(NMAX), y0(NMAX), NVector(2*NMAX) ) 
                 
        NMAX = Model % NumberOfBoundaryElements
        ALLOCATE( BCType(NMAX) )

        ALLOCATE( ordre(Nn), ind(Nn), xn(Nn), yn(Nn), &
                    xn0(Nn), yn0(Nn), intersept(Nn) )
        
        x0 = Model % Nodes % x
        y0 = Model % Nodes % y

! Get the nodes number of the free surface
! and the bed and the ramp

        j = 0 
        ordre = 0
        BCType = 0
        DO p = 1, Model % NumberOfBoundaryElements
          BCElement => GetBoundaryElement(p) 

!         IF( .NOT. ActiveBoundaryElement(BCElement) )  CYCLE
          IF( GetElementFamily(BCElement) == 1 ) CYCLE
          BC => GetBC( BCElement ) 
          BCTypeName  = GetString(BC, 'Cavity Type', GotIt)
            

          IF (GotIt) THEN
            n = BCElement % Type % NumberOfNodes
              IF (BCTypeName=='cavity') THEN 
                BCType(p) = 1
                DO i = 1, n
                  IF (.NOT.ANY(ordre== BCElement % NodeIndexes( i ))) THEN
                    j = j + 1
                    ordre(j) = BCElement % NodeIndexes( i )
                    xn(j) = Model % Nodes % x( BCElement % NodeIndexes( i ) )
                  END IF 
                END DO 
              ELSE IF (BCTypeName=='bed') THEN 
                BCType(p) = 2
              ELSE IF (BCTypeName=='ramp') THEN 
                BCType(p) = 3
              END IF
          END IF
        END DO

! Get ordre(i) ordered with increasing x 

        ind = 0
        CALL indexx(xn,ind)
        ordre=ordre(ind)
        xFirst = Model % Nodes % x( ordre(1) ) 
        xEnd = Model % Nodes % x( ordre(Nn) ) 
        lbed10 = curvi(xd,xFirst,fbed,100)
        lbed20 = curvi(xEnd,xf,fbed,100)
         

        DEALLOCATE(ind) 
       END IF
! END IF FIRSTIME --------------------------------------------------
!-------------------------------------------------------------------
!    Get Velocity from (Navier)-Stokes-Solver or AIFlow Solver
!------------------------------------------------------------------------
      TimeVar => VariableGet( Model % Variables, 'Time' )
      FlowVariable => VariableGet( Solver % Mesh % Variables, FlowSolverName )
      IF ( ASSOCIATED( FlowVariable ) ) THEN
       FlowPerm    => FlowVariable % Perm
       FlowValues  => FlowVariable % Values
      ELSE
      CALL Info('moveFS Solver', 'No variable for velocity &
&                                  associated.', Level=4)
      END IF

!------------------------------------------------
!    Get MeshUpdate computed from MeshUpdateSolver              
!------------------------------------------------

     MHVariable => VariableGet( Solver % Mesh % Variables, &
&                                                  "Mesh Update" )
     IF ( ASSOCIATED( MHVariable ) ) THEN
       MHPerm    => MHVariable % Perm
       MHPrev  => MHVariable % PrevValues
     ELSE
       CALL Info('moveFS Solver', 'No variable for Mesh &
&                   Update associated.', Level=4)
     END IF
      If ( FirstTime2 ) MHPrev=0.0_dp
      FirstTime2=.FALSE.
!--------------------------
!    Compute Normal Vector                                      
!--------------------------
      Nvector = 0.0_dp
      DO p = 1, Model % NumberOfBoundaryElements
        BCElement => GetBoundaryElement(p) 
        IF (GetElementFamily(BCElement) == 1 ) CYCLE
        IF (BCType(p)==0) CYCLE 
        n = BCElement % Type % NumberOfNodes
        CALL GetElementNodes( Nodes, BCElement )
        NodeIndexes => BCElement % NodeIndexes

        DO i=1,n
          Bu = BCElement % Type % NodeU(i)
          Bv = 0.0D0
          k = NodeIndexes( i )
          Normal =  NormalVector(BCElement, Nodes, Bu, Bv, .TRUE.) 
          Nvector(DIM*(k-1)+1:DIM*k) = Nvector(DIM*(k-1)+1:DIM*k) + & 
                   Normal(1:DIM)
        END DO
      END DO
! Norm 
      DO p = 1, Model % NumberOfBoundaryElements
        BCElement => GetBoundaryElement(p) 
        IF (GetElementFamily(BCElement) == 1 ) CYCLE
        IF (BCType(p)==0) CYCLE 
        n = BCElement % Type % NumberOfNodes
        NodeIndexes => BCElement % NodeIndexes
        DO i=1,n
          k = NodeIndexes( i )
          s = SQRT( SUM( Nvector(DIM*(k-1)+1:DIM*k)**2 ) )
          IF ( s /= 0.0D0 ) THEN
            Nvector(DIM*(k-1)+1:DIM*k) = Nvector(DIM*(k-1)+1:DIM*k)/s 
          END IF
        END DO
      END DO


! ---------------------------------------
! Get the MeshUpdate of the cavity  Nodes 
! ---------------------------------------

           LastTime = TimeVar % Values( 1 )
           CALL Info( 'CavitySolve', ' ', Level=4 )
           CALL Info( 'CavitySolve', '---------------',Level=4 )
           CALL Info( 'CavitySolve', ' CAVITY SOLVER ',Level=4 )
           CALL Info( 'CavitySolve', '---------------',Level=4 )
           CALL Info( 'CavitySolve', ' ', Level=4 )

          intersept = Large
          k = FlowVariable % DOFs
          deltaFS=0.0_dp
          MaxdeltaFS=0.0_dp
          DO p = 1, Nn         
            xn0(p) = x0( ordre(p) ) + &
                    MHPrev( DIM*(MHPerm( ordre(p) ) - 1 ) + 1 , 1 )
            yn0(p) = y0( ordre(p) ) + &
                    MHPrev( DIM*(MHPerm( ordre(p) ) - 1 ) + 2 , 1 )

! Get velocity  node ordre(p)   
            Velocity = 0.0_dp
            Nvelo = 0.0_dp
            DO i=1,k-1
            Velocity(i) = FlowValues( k*( FlowPerm( ordre(p) )-1 ) +i ) 
            Nvelo = Nvelo + Velocity(i)*Nvector(DIM*(ordre(p)-1)+i)
            END DO
            xn(p) = xn0(p) + dt * Velocity(1)                          
            yn(p) = yn0(p) + dt * Velocity(2)                          

            deltaFS = deltaFS + Nvelo**2 
            IF (Nvelo**2 > MaxdeltaFS) MaxdeltaFS = Nvelo**2

! test if node intersept bed
            IF ((yn(p)<=fbed(xn(p))).AND.(p/=1).AND.(p/=Nn))  THEN
              bb = xn0(p) - xn(p)
              aa = (yn0(p) - yn(p))/bb
              bb = (yn(p)*xn0(p)-xn(p)*yn0(p))/bb
              x = zbrent(intbed,xn0(p),xn(p),1.0e-08_dp)
              intersept(p) = dt * (x-xn0(p))/(xn(p)-xn0(p))
            END IF
          END DO
! should be 
          intersept(1) = 0.0_dp
          intersept(Nn) = 0.0_dp

! Find first node intersepting bed
          dt1 = dt           
          dt2 = dt            
          dt3 = dt
          nbed1 = 1
          nbed2 = Nn
          DO p = 2, Nn2
            IF (FirstNodeMove) THEN
              IF (intersept(p)<=dt1) THEN
                 dt1 = intersept(p)
                 nbed1 = p
              ENDIF
            END IF
            IF (intersept(Nn-p+1)<=dt2) THEN
               dt2 = intersept(Nn-p+1)
               nbed2 = Nn-p+1
            ENDIF
          END DO

! Find in which side it intersept first 
          IF ((nbed1/=1).AND.(nbed2/=Nn)) THEN
            IF (dt1 < dt2) THEN
! First Node intersepting is on left
              nbed2 = Nn
            ELSEIF (dt2 < dt1) THEN
! First Node intersepting is on right
              nbed1 = 1 
            END IF           
          END IF           
!
! Find dt3, xbed1 and xbed2
!
         xbed1 = xn0(1)
         nbed10=nbed1
!
! CASE 1 : No intersecting node 
!
         IF ((nbed10==1).AND.(nbed2==Nn)) THEN
           dt3 = dt
           IF (FirstNodeMove) THEN
             aa = xn(2)
             bb = yn(2)
             cc = FlowValues( k*( FlowPerm( ordre(2) )-1 )+1) 
             dd = FlowValues( k*( FlowPerm( ordre(2) )-1 )+2) 
             xa = xn0(1)
             xb = aa      
             IF (intbed2(xa)*intbed2(xb)<=0.0_dp) THEN
                xbed1 = zbrent(intbed2,xa,xb,1.0e-8_dp)
             ELSE
                xbed1 = xn(1)
             END IF
           END IF
           aa = xn(Nn-1)
           bb = yn(Nn-1) 
           cc = FlowValues( k*( FlowPerm( ordre(Nn-1) )-1 )+1) 
           dd = FlowValues( k*( FlowPerm( ordre(Nn-1) )-1 )+2) 
           xa = aa     
           xb = xn(Nn)
           IF (intbed2(xa)*intbed2(xb)<=0.0_dp) THEN
              xbed2 = zbrent(intbed2,xa,xb,1.0e-8_dp)
           ELSE
              xbed2 = xn(Nn)
           END IF
           write(*,*)'Case 1',dt3,xbed1,xbed2
           
!
! CASE 2 : intersecting node on right 
!
         ELSE IF ((nbed10==1).AND.(nbed2<Nn)) THEN
           dt3 = dt2
           IF (dt3 > EPS) THEN
             IF (FirstNodeMove) THEN
               aa = xn(2)
               bb = yn(2)
               cc = FlowValues( k*( FlowPerm( ordre(2) )-1 )+1) 
               dd = FlowValues( k*( FlowPerm( ordre(2) )-1 )+2) 
               xa = xn0(1)
               xb = aa    
               IF (intbed2(xa)*intbed2(xb)<=0.0) THEN
                 xbed1 = zbrent(intbed2,xa,xb,1.0e-8_dp)
               ELSE
                  xbed1 = xn(1)
               END IF
             END IF

             bb = xn0(nbed2) - xn(nbed2)
             aa = (yn0(nbed2) - yn(nbed2))/bb
             bb = (yn(nbed2)*xn0(nbed2)-xn(nbed2)*yn0(nbed2))/bb
             xbed2 = zbrent(intbed,xn0(nbed2),xn(nbed2),1.0e-08_dp)
           
           ELSE
            xbed1 = xn0(1)
            xbed2 = xn0(nbed2)
            nbed1 = nbed1 + 1
           END IF

           write(*,*)'Case 2',dt3,xbed1,xbed2

!
! CASE 3 : intersecting node on left 
!
         ELSE IF ((nbed10>1).AND.(nbed2==Nn)) THEN
           dt3 = dt1
            
           IF (dt3 > EPS) THEN
             IF (FirstNodeMove) THEN
               bb = xn0(nbed1) - xn(nbed1)
               aa = (yn0(nbed1) - yn(nbed1))/bb
               bb = (yn(nbed1)*xn0(nbed1)-xn(nbed1)*yn0(nbed1))/bb
               xbed1 = zbrent(intbed,xn0(nbed1),xn(nbed1),1.0e-08_dp)
             END IF
             aa = xn(Nn-1)
             bb = yn(Nn-1) 
             cc = FlowValues( k*( FlowPerm( ordre(Nn-1) )-1 )+1) 
             dd = FlowValues( k*( FlowPerm( ordre(Nn-1) )-1 )+2) 
             xa = aa        
             xb = xn(Nn)
             IF (intbed2(xa)*intbed2(xb)<=0.0) THEN
                xbed2 = zbrent(intbed2,xa,xb,1.0e-8_dp)
             ELSE
                xbed2 = xn(Nn)
             END IF
           ELSE
             xbed1 = xn0(nbed1)
             xbed2 = xn0(Nn)
             nbed1 = nbed1 + 1
           END IF

           write(*,*)'Case 3',dt3,xbed1,xbed2
!
! CASE 4 : intersecting node on left and right 
!
         ELSE  ! nbed1 > 1 and nbed2 < Nn
           dt3 = MIN(dt1,dt2) 
           
           IF (dt3 < EPS) THEN 
             IF (FirstNodeMove) THEN 
               bb = xn0(nbed1) - xn(nbed1)
               aa = (yn0(nbed1) - yn(nbed1))/bb
               bb = (yn(nbed1)*xn0(nbed1)-xn(nbed1)*yn0(nbed1))/bb
               xbed1 = zbrent(intbed,xn0(nbed1),xn(nbed1),1.0e-08_dp)
             END IF

             bb = xn0(nbed2) - xn(nbed2)
             aa = (yn0(nbed2) - yn(nbed2))/bb
             bb = (yn(nbed2)*xn0(nbed2)-xn(nbed2)*yn0(nbed2))/bb
             xbed2 = zbrent(intbed,xn0(nbed2),xn(nbed2),1.0e-08_dp)

           ELSE
             xbed1 = xn0(nbed1)
             xbed2 = xn0(nbed2)
             nbed1 = nbed1 + 1
           END IF

           write(*,*)'Case 4',dt3,xbed1,xbed2

         END IF

         IF (nbed1==1) nbed1=0 


          ALLOCATE( xnew(nbed2+1-nbed1),ynew(nbed2+1-nbed1), &
                   y1new(nbed2+1-nbed1), y2new(nbed2+1-nbed1), &
                   y3new(nbed2+1-nbed1) )
! new position of nbed nodes
          xnew(1) = xbed1 
          ynew(1) = fbed(xbed1) 
          k = FlowVariable % DOFs
          n = 2
          lc =0.0_dp
          DO p = 1+nbed1, nbed2
            Velocity = 0.0_dp
            DO i=1,k-1
            Velocity(i) = FlowValues( k*( FlowPerm( ordre(p) )-1 ) +i ) 
            END DO
            
            xnew(n) = xn0(p) + dt3 * Velocity(1)
            ynew(n) = yn0(p) + dt3 * Velocity(2)



! IF nbed=Nn -> move last node exactly on the bed             
            IF (p==nbed2)  THEN
               ynew(n)=fbed(xbed2)
            END IF

! Cavity length 
            lc = lc + SQRT((xnew(n)-xnew(n-1))**2 + &
                                 (ynew(n)-ynew(n-1))**2 ) 

            n = n +1
          END DO

! First derivative of the cavity
          y1new(1) = dbed(xbed1)         
          y1new(nbed2+1-nbed1) = dbed(xbed2)         
          DO n = 2, nbed2-nbed1
            y1new(n) = (ynew(n+1) - ynew(n-1))/(xnew(n+1) - xnew(n-1))
          END DO

! New cavity lenght and space between nodes
          
          ds = lc / (Nn - 1)

! New position of the nodes on the cavity surface
          dMU = 0.0
          CALL spline(xnew,ynew,dbed(xbed1),dbed(xbed2),y2new)
          CALL spline(xnew,y1new,1.0e40_dp,1.0e40_dp,y3new)
          x = xbed1 
          y = fbed(x)           
          dMU(2*ordre(1)-1) = x - xn0(1)
          dMU(2*ordre(1)) = y - yn0(1)
          

          DO p = 2, Nn 

            tanbed(1) =  1.0_dp            
            tanbed(2) =  splint(xnew,y1new,y3new,x)
            tanbed = tanbed / SQRT(tanbed(1)**2 + tanbed(2)**2)
            tanbed(1) = ABS(tanbed(1)) 
            IF (tanbed(1) < EPS) tanbed(1) = EPS/ds
            x = x + ds*tanbed(1)

! Again take care that node Nn is exactly on bed
             
            IF (p==Nn) THEN
              x = xbed2
              y = fbed(x)           
            ELSE
              y = splint(xnew,ynew,y2new,x) 
            ENDIF

! Take care that no node are bellow the bed

            IF (y < fbed(x)) THEN
               write(*,*)'y < fbed',p,x,y, fbed(x)
               y = fbed(x) + EPS
            END IF

            dMU(2*ordre(p)-1) = x - xn0(p)
            dMU(2*ordre(p)) = y - yn0(p)
         
          END DO

          dMUFN = curvi(xn0(1),xbed1,fbed,20)
          dMULN = curvi(xn0(Nn),xbed2,fbed,20)


          TrueTime = TrueTime + dt3
!
! Change time to get next time right
!
          TimeVar % Values(1) =  LastTime -dt + dt3 

          DEALLOCATE(xnew,ynew,y2new)


! ----------------------------------
! Compute the Mesh Update value
! ----------------------------------
!
        DO p = 1, Model % NumberOfBoundaryElements
          BCElement => GetBoundaryElement(p) 
          IF (GetElementFamily(BCElement) == 1 ) CYCLE
          IF (BCType(p)==0) CYCLE 

          n = BCElement % Type % NumberOfNodes
          
          DO i=1, n
            mu1 = 0.0
            mu2 = 0.0 
            Node = BCElement % NodeIndexes(i)
! Nodes on the Free Surface
            IF (BCType(p)==1) THEN
               ! Read the water pressure (constant in space) 
               IF (Node==ordre(1)) THEN
                 BC => GetBC( BCElement ) 
                 IF (FlowSolverName=='aiflow') THEN
                  Sxx(1:n) =  GetReal(BC, 'Normal Force', GotIt)
                 ELSE IF (FlowSolverName=='flow solution') THEN
                  Sxx(1:n) = GetReal(BC, 'External Pressure', GotIt)
                 END IF
                  pwater = -Sxx(1)
               END IF

               mu1 = dMU(2*Node-1) + &
                        MHPrev( DIM*MHPerm( Node ) - 1 , 1 )
               mu2 = dMU(2*Node) + &
                        MHPrev( DIM*MHPerm( Node ) , 1 )
              IF ((.Not.FirstNodeMove).AND.(Node==ordre(1))) THEN
                mu1 = 0.0_dp  
                mu2 = 0.0_dp            
              END IF 

! Nodes before and after the free surface
            ELSE IF ((BCType(p)==2).OR.(BCType(p)==3)) THEN
              IF ((x0(Node)>=xEnd).And.(xf-x0(Node)>EPS)) THEN
                mu1 = MHPrev( DIM*( MHPerm( Node ) -1 ) + 1 , 1 )
                x = Model % Nodes % x( Node )
                tanbed(1) = 1.0_dp
                tanbed(2) = dbed(x)
                tanbed = tanbed / sqrt(tanbed(1)**2 + tanbed(2)**2)
                tanbed(1) = ABS(tanbed(1)) 
                IF (tanbed(1)>EPS) THEN          
                  mu1 = mu1 + dMULN * tanbed(1) * &
                                    curvi(x0(Node),xf,fbed,100)/lbed20 
                ELSE
                  mu1 = mu1 + EPS
                END IF
                x = x0(Node) + mu1
                y = fbed(x)
                mu2 = y - y0( Node ) 
                IF (Node==ordre(Nn)) THEN
                  mu1 = MHPrev( DIM*( MHPerm( Node ) -1 ) + 1, 1 ) + &
                              dMU( 2*(Node -1) + 1) 
                  mu2 = MHPrev( DIM*( MHPerm( Node ) -1 ) + 2, 1 ) + &
                              dMU( 2*(Node -1) + 2) 
                END IF

! Nodes before the free surface
              ELSE IF ((x0(Node)<=xFirst).AND.(x0(Node)-xd>EPS) &
                                        .AND.(FirstNodeMove)) THEN
                mu1 = MHPrev( DIM*( MHPerm( Node ) -1 ) + 1 , 1 )
                x = Model % Nodes % x( Node )
                tanbed(1) = 1.0_dp 
                tanbed(2) = dbed(x)
                tanbed = tanbed / sqrt(tanbed(1)**2 + tanbed(2)**2)
                tanbed(1) = ABS(tanbed(1)) 
                IF (tanbed(1)<EPS) tanbed(1)=EPS
                mu1 = mu1 + dMUFN * tanbed(1) * & 
                                 curvi(xd,x0(Node),fbed,100)/lbed10 
                x = x0(Node) + mu1
                y = fbed(x)
                mu2 = y - y0( Node ) 

                IF (Node==ordre(1)) THEN
                  mu1 = MHPrev( DIM*( MHPerm( Node ) -1 ) + 1, 1 ) + &
                           dMU( 2*(Node -1) + 1) 
                  mu2 = MHPrev( DIM*( MHPerm( Node ) -1 ) + 2, 1 ) + &
                           dMU( 2*(Node -1) + 2) 
                END IF
              END IF  
            END IF
              moveFSVector(DIM*moveFSPerm(Node) - 1) = mu1 
              moveFSVector(DIM*moveFSPerm(Node) ) = mu2 

          END DO

        END DO

! ----------------------------------
! Compute output (taub, us, pi, ...)
! ----------------------------------
!
      DevStressVar => &
             VariableGet(Solver % Mesh % Variables,'DeviatoricStress')
      IF ( ASSOCIATED( DevStressVar ) ) THEN
      DSPerm => DevStressVar % Perm    
      DSValues => DevStressVar % Values  
      END IF

      sc = 0.0_dp
      taub = 0.0_dp
      ub = 0.0_dp
      pice = 0.0_dp
      fx = 0.0_dp
      fy = 0.0_dp
      ltot=0.0_dp 
      slope = 0.0_dp
      DO p = 1, Model % NumberOfBoundaryElements
        BCElement => GetBoundaryElement(p) 
        IF (GetElementFamily(BCElement) == 1 ) CYCLE
        IF (BCType(p)==0) CYCLE 
        n = BCElement % Type % NumberOfNodes

        CALL GetElementNodes( Nodes, BCElement )

        NodeIndexes => BCElement % NodeIndexes

        Nodes % x(1:n) = Model % Nodes % x(NodeIndexes(1:n))
        Nodes % y(1:n) = Model % Nodes % y(NodeIndexes(1:n))
        Nodes % z(1:n) = Model % Nodes % z(NodeIndexes(1:n))


        Sxx(1:n) = DSValues(2*dim*(DSPerm(NodeIndexes(1:n))-1) + 1) -&
                  FlowValues( (dim+1)*FlowPerm(NodeIndexes(1:n)) ) 
        Syy(1:n) = DSValues(2*dim*(DSPerm(NodeIndexes(1:n))-1) + 2) -&
                  FlowValues( (dim+1)*FlowPerm(NodeIndexes(1:n)) ) 
        Sxy(1:n) = DSValues(2*dim*(DSPerm(NodeIndexes(1:n))-1) + 4) 

        Velo = 0.0d0
        LocalNormal=0.0_dp
        DO i=1,DIM         
         LocalNormal(i,1:n)=Nvector(DIM*(NodeIndexes(1:n)-1)+i)
         Velo(i,1:n) = FlowValues((DIM+1)*(FlowPerm(NodeIndexes(1:n))-1)+i) 
        END DO
        Call BCIntegrals(ub, taub, pice, fx, fy, ltot, sc, &
                     Sxx, Syy, Sxy, Velo, LocalNormal,  BCType(p),  &
                     BCElement, n, Nodes)
                            

        DO i = 1, n
          k = NodeIndexes( i )
          IF ( SQRT(SUM(Nvector(DIM*(k-1)+1:DIM*k)**2)) /= 0.0_dp ) THEN
            IF (Nvector(2*k)/=0.0_dp) THEN
              IF (-Nvector(2*k-1)/Nvector(2*k)>slope) &
                           slope = -Nvector(2*k-1)/Nvector(2*k)
            ELSE
              IF (Nvector(2*k-1)>0.0) slope = Large
            END IF
          END IF
        END DO

      END DO
      taub = taub / ltot          
      pice = pice / ltot
      ub = ub / ltot       
      deltaFS = SQRT(deltaFS) / ( Nn * ub ) 
      MaxdeltaFS = SQRT(MaxdeltaFS) / ub

      IF (SaveFile) THEN
        OPEN(22,File=SaveFileName,POSITION='APPEND') 
        WRITE(22,'(17(e14.8,2x))')LastTime, TrueTime, dt3, taub, & 
             pice, pwater, ub, taub/(pice-pwater),  ub/(pice - pwater),&
             fx, fy, deltaFS, MaxdeltaFS, slope, xbed1, xbed2, sc
                 
        CLOSE(22)
      CALL Info( 'CavitySolve', '---------------------',Level=4 )
      WRITE( Message, * ) ' dFS = V.n , Max(V.n)  : ',deltaFS, MaxdeltaFS
      CALL Info( 'CavitySolve', Message, Level=4 )
      CALL Info( 'CavitySolve', '---------------------',Level=4 )
      END IF
     
! ----------------------------------

CONTAINS

!
! --------------------------------------------------------------------------------------
! Integration over the Boundary Element of some data
! --------------------------------------------------------------------------------------
!
         SUBROUTINE BCIntegrals(ub, tau, pice, fx, fy, l, sc, &
             Sxx, Syy, Sxy, Velo, LocalNormal, BCn, Element, n, ElementNodes)  
                                
 
!          USE types
!          USE DefUtils
!          USE CoordinateSystems
!          USE SolverUtils
!          USE ElementDescription
!          IMPLICIT NONE
           REAL(KIND=dp) :: ub, tau, pice,  fx, fy, l, sc
           REAL(KIND=dp) :: Sxx(3), Syy(3), Sxy(3), Velo(3,3), &
                            LocalNormal(3,3)
           TYPE(Element_t),POINTER  :: Element
           TYPE(Nodes_t)    :: ElementNodes
           INTEGER :: BCn, n
!------------------------------------------------------------------------------
           REAL(KIND=dp) :: Basis(n),ddBasisddx(1,1,1)
           REAL(KIND=dp) :: dBasisdx(n,3),SqrtElementMetric
           REAL(KIND=dp) :: u,v,w,s
           REAL(KIND=dp) :: Sig(3,3)
           REAL(KIND=dp), POINTER :: U_Integ(:),V_Integ(:),W_Integ(:),S_Integ(:)
           REAL(KIND=dp) :: Velocity(3), Snn, norma(3)
           INTEGER :: i,j,t,q,p,DIM,N_Integ
           LOGICAL :: stat
           TYPE(GaussIntegrationPoints_t), TARGET :: IntegStuff
           
!------------------------------------------------------------------------------
           DIM = CoordinateSystemDimension()
!
!  Integration stuff
!
           IntegStuff = GaussPoints( Element )
           U_Integ => IntegStuff % u
           V_Integ => IntegStuff % v
           W_Integ => IntegStuff % w
           S_Integ => IntegStuff % s
           N_Integ =  IntegStuff % n
!
!  Now we start integrating
!
           DO t=1,N_Integ

             u = U_Integ(t)
             v = V_Integ(t)
             w = W_Integ(t)

!------------------------------------------------------------------------------
!    Basis function values & derivatives at the integration point
!------------------------------------------------------------------------------
              stat = ElementInfo( Element, ElementNodes, u, v, w, &
                SqrtElementMetric, Basis, dBasisdx, ddBasisddx, .FALSE.)
                

              s = SqrtElementMetric * S_Integ(t)
           
              Sig = 0.0
              Sig(1,1) = SUM(Sxx(1:n)*Basis(1:n)) 
              Sig(2,2) = SUM(Syy(1:n)*Basis(1:n)) 
              Sig(1,2) = SUM(Sxy(1:n)*Basis(1:n)) 
              Sig(2,1) = Sig(1,2)
! Normal Upward-pointing normal
!             Normal = - NormalVector( Element,ElementNodes,u,v,.TRUE. )
              Snn = 0.0
              Velocity = 0.0
              normal = 0.0
              DO i=1, DIM
                Velocity(i) = SUM(Velo(i,1:n)*Basis(1:n) )
                normal(i) = -SUM(LocalNormal(i,1:n)*Basis(1:n) )
              END DO

              DO i=1, DIM
                DO j=1, DIM
                  Snn = Snn + Sig(i,j)*Normal(i)*Normal(j) 
                END DO
              END DO
              
              ub = ub + Velocity(1) * Normal(2) * s
              l = l + Normal(2) * s 
              tau  = tau + Snn * Normal(1) * s 
              pice = pice - Snn * Normal(2) * s 
             
              IF (BCn==1)  THEN
                sc = sc + s
              END IF
              
              IF (BCn==3) THEN
                fx = fx + Snn * Normal(1) * s 
                fy = fy - Snn * Normal(2) * s 
              END IF

         END DO
         END SUBROUTINE BCINtegrals
!
! --------------------------------------------------------------------------------------


END SUBROUTINE CavitySolve



! --------------------------------------------------------
     FUNCTION intbed(x)
       USE types
       USE DefUtils
     REAL(KIND=dp) :: intbed,x, fbed
     REAL(KIND=dp) :: aa, bb, cc, dd
     COMMON /interbed/aa,bb,cc,dd

     intbed = fbed(x) - aa*x -bb 
      

     END FUNCTION intbed
!
      FUNCTION intbed2(x)
       USE types
       USE DefUtils
       REAL(KIND=dp) :: intbed2, x, fbed, dbed
       REAL(KIND=dp) :: aa, bb, cc, dd
       REAL(KIND=dp) :: EPS, dx
       COMMON /interbed/aa,bb,cc,dd
! last node function
      EPS = 100.0_dp*EPSILON(aa)
      IF (cc < 0.0) THEN
         cc = -cc
         dd = -dd
      ENDIF
      IF (cc < EPS) cc = EPS
      dx = x - aa
      IF (ABS(dx) < EPS) dx = EPS
      intbed2 = 2.0_dp/dx*(fbed(x)-bb)-dd/cc-dbed(x) 
      END FUNCTION intbed2

! --------------------------------------------------------
      FUNCTION curvi(x0,x1,func,N)
       USE types
       USE DefUtils
       REAL(KIND=dp) :: x0, x1, x,  dx, l
       REAL(KIND=dp) ::  dl1, dl2, curvi
       INTEGER :: i, N
       INTERFACE 
         FUNCTION func(x) 
         USE types
         USE DefUtils
         IMPLICIT NONE 
         REAL(KIND=dp), INTENT(IN) :: x 
         REAL(KIND=dp) :: func 
         END FUNCTION func 
       END INTERFACE 
!
! Calculate the length of a curve
! l > 0 if x0 < x1, else l < 0 
!
!
       dx = (x1-x0)/N
       l = 0.0_dp
       x = x0
       y = func(x) 
         DO i=2,N+1
         dl1 = x 
         dl2 = y
         x = x + dx
         y = func(x)
         dl1 = x - dl1
         dl2 = y - dl2
         l = l + SQRT(dl1**2 + dl2**2)
         END DO
      IF (x0 < x1) THEN
        curvi = l
      ELSE
        curvi = -l
      END IF
      END FUNCTION curvi

! --------------------------------------------------------
      FUNCTION intbed1(x)
       USE types
       USE DefUtils
     REAL(KIND=dp) :: intbed1,x, dbed, fbed, Norm
     REAL(KIND=dp) :: normal(2),XM(2)
     REAL(KIND=dp) :: aa, bb, cc, dd
     COMMON /interbed/aa,bb,cc,dd
     COMMON /interbed/a,b

! function that return f(x) = XM.n X(x,fbed), M(a,b), n (dbed,-1)
    
     ! Norm of XM 
      XM(1) = aa - x
      XM(2) = bb - fbed(x)
      Norm = sqrt(XM(1)**2+XM(2)**2)
      XM = XM/Norm

      normal(1) = dbed(x) 
      normal(2) = -1.0       
      Norm = sqrt(normal(1)**2+normal(2)**2)
      normal = normal/Norm

      intbed1 = SUM(normal*XM) 

      END FUNCTION intbed1
! -------------------------------------------------------------
! Numerical recipes subroutines  and functions          -------
! -------------------------------------------------------------
       SUBROUTINE indexx(arr,ind) 
       USE types
       USE DefUtils
       IMPLICIT NONE 
       REAL(KIND=dp) :: arr(:) 
       INTEGER :: ind(:) 
       INTEGER, PARAMETER :: NN=15, NSTACK=50
       REAL(KIND=dp) :: a 
       INTEGER :: n,k,i,j,indext,jstack,l,r 
       INTEGER, DIMENSION(NSTACK) :: istack 

        n = size(arr)
        Do i = 1, n
        ind( i ) = i 
        END DO
jstack=0 
l=1 
r=n 
do 
if (r-l < NN) then 
do j=l+1,r 
indext=ind(j) 
a=arr(indext) 
do i=j-1,l,-1 
if (arr(ind(i)) <= a) exit 
ind(i+1)=ind(i) 
end do 
ind(i+1)=indext 
end do 
if (jstack == 0) RETURN 
r=istack(jstack) 
l=istack(jstack-1) 
jstack=jstack-2 
else 
k=(l+r)/2 
call swap(ind(k),ind(l+1)) 
call icomp_xchg(ind(l),ind(r)) 
call icomp_xchg(ind(l+1),ind(r)) 
call icomp_xchg(ind(l),ind(l+1)) 
i=l+1 
j=r 
indext=ind(l+1) 
a=arr(indext) 
do 
do 
i=i+1 
if (arr(ind(i)) >= a) exit 
end do 
do 
j=j-1 
if (arr(ind(j)) <= a) exit 
end do 
if (j < i) exit 
call swap(ind(i),ind(j)) 
end do 
ind(l+1)=ind(j) 
ind(j)=indext 
jstack=jstack+2 
if (jstack > NSTACK) Write(*,*)' indexx: NSTACK too small'
if (r-i+1 >= j-l) then 
istack(jstack)=r
istack(jstack-1)=i 
r=j-1 
else 
istack(jstack)=j-1 
istack(jstack-1)=l 
l=i 
end if 
end if 
end do 
CONTAINS 
SUBROUTINE icomp_xchg(i,j) 
INTEGER :: i,j 
INTEGER :: swp 
if (arr(j) < arr(i)) then 
swp=i 
i=j 
j=swp 
end if 
END SUBROUTINE icomp_xchg 
SUBROUTINE swap(a,b) 
INTEGER :: a, b
INTEGER :: dum
dum = a
a = b
b = dum
END SUBROUTINE swap
END SUBROUTINE indexx
! --------------------------------------------------------
FUNCTION splint(xa,ya,y2a,x) 
       USE types
       USE DefUtils
IMPLICIT NONE 
REAL(KIND=dp), DIMENSION(:), INTENT(IN) :: xa,ya,y2a 
REAL(KIND=dp), INTENT(IN) :: x 
REAL(KIND=dp) :: splint
INTEGER :: khi,klo,n
REAL(KIND=dp) :: a,b,h 
n = size(xa)
klo=max(min(locate(xa,x),n-1),1)
khi=klo+1 
h=xa(khi)-xa(klo) 
if (h == 0.0) THEN
    Write(*,*)' bad xa input in splint'  
    Write(*,*)khi,klo,xa(khi),xa(klo),x
End IF
a=(xa(khi)-x)/h 
b=(x-xa(klo))/h 
splint=a*ya(klo)+b*ya(khi)+((a**3-a)*y2a(klo)+(b**3-b)*y2a(khi))*(h**2)/6.0_dp 
CONTAINS
! ----------------------------------------------------------------------------

FUNCTION locate(xx,x) 
       USE types
       USE DefUtils
IMPLICIT NONE 
REAL(KIND=dp), DIMENSION(:), INTENT(IN) :: xx 
REAL(KIND=dp), INTENT(IN) :: x 
INTEGER :: locate 
INTEGER :: n,jl,jm,ju 
LOGICAL :: ascnd
n=size(xx) 
ascnd = (xx(n) >= xx(1)) 
jl=0 
ju=n+1  
do 
if (ju-jl <= 1) exit 
jm=(ju+jl)/2 
if (ascnd .eqv. (x >= xx(jm))) then 
jl=jm 
else 
ju=jm 
end if 
end do 
if (x == xx(1)) then 
locate=1 
else if (x == xx(n)) then 
locate=n-1 
else 
locate=jl 
end if 
END FUNCTION locate

END FUNCTION splint
! ----------------------------------------------------------------------------

SUBROUTINE spline(x,y,yp1,ypn,y2) 
       USE types
       USE DefUtils
IMPLICIT NONE 
REAL(KIND=dp), DIMENSION(:), INTENT(IN) :: x,y 
REAL(KIND=dp), INTENT(IN) :: yp1,ypn 
REAL(KIND=dp), DIMENSION(:), INTENT(OUT) :: y2 
INTEGER :: n 
REAL(KIND=dp), DIMENSION(size(x)) :: a,b,c,r 
INTERFACE
SUBROUTINE tridag(a,b,c,r,u) 
       USE types
       USE DefUtils
IMPLICIT NONE 
REAL(KIND=dp), DIMENSION(:), INTENT(IN) :: a,b,c,r 
REAL(KIND=dp), DIMENSION(:), INTENT(OUT) :: u 
END SUBROUTINE tridag
END INTERFACE
n = size(x)
c(1:n-1)=x(2:n)-x(1:n-1) 
r(1:n-1)=6.0_dp*((y(2:n)-y(1:n-1))/c(1:n-1)) 
r(2:n-1)=r(2:n-1)-r(1:n-2) 
a(2:n-1)=c(1:n-2) 
b(2:n-1)=2.0_dp*(c(2:n-1)+a(2:n-1)) 
b(1)=1.0 
b(n)=1.0 
if (yp1 > 0.99e30_dp) then 
r(1)=0.0 
c(1)=0.0 
else 
r(1)=(3.0_dp/(x(2)-x(1)))*((y(2)-y(1))/(x(2)-x(1))-yp1)
c(1)=0.5 
end if 
if (ypn > 0.99e30_dp) then 
r(n)=0.0 
a(n)=0.0 
else 
r(n)=(-3.0_dp/(x(n)-x(n-1)))*((y(n)-y(n-1))/(x(n)-x(n-1))-ypn) 
a(n)=0.5 
end if 
call tridag(a(2:n),b(1:n),c(1:n-1),r(1:n),y2(1:n)) 
END SUBROUTINE spline

! ----------------------------------------------------------------------------

SUBROUTINE tridag(a,b,c,r,u) 
       USE types
       USE DefUtils
IMPLICIT NONE 
REAL(KIND=dp), DIMENSION(:), INTENT(IN) :: a,b,c,r 
REAL(KIND=dp), DIMENSION(:), INTENT(OUT) :: u 
REAL(KIND=dp), DIMENSION(size(b)) :: gam
INTEGER :: n,j 
REAL(KIND=dp) :: bet 
n = size(b)
bet=b(1) 
if (bet == 0.0) Write(*,*)' tridag_ser: Error at code stage 1 ' 
u(1)=r(1)/bet 
do j=2,n 
gam(j)=c(j-1)/bet 
bet=b(j)-a(j-1)*gam(j) 
if (bet == 0.0) Write(*,*)' tridag_ser: Error at code stage 2 ' 
u(j)=(r(j)-a(j-1)*u(j-1))/bet 
end do 
do j=n-1,1,-1 
u(j)=u(j)-gam(j+1)*u(j+1) 
end do 
END SUBROUTINE tridag

! ----------------------------------------------------------------------------
FUNCTION zbrent(func,x1,x2,tol)
       USE types
       USE DefUtils
IMPLICIT NONE 
REAL(KIND=dp), INTENT(IN) :: x1,x2,tol 
REAL(KIND=dp) :: zbrent 
INTERFACE 
FUNCTION func(x) 
       USE types
       USE DefUtils
IMPLICIT NONE 
REAL(KIND=dp), INTENT(IN) :: x 
REAL(KIND=dp) :: func 
END FUNCTION func 
END INTERFACE 
INTEGER, PARAMETER :: ITMAX=100 
REAL(KIND=dp), PARAMETER :: EPS=epsilon(x1)
INTEGER :: iter 
REAL(KIND=dp) :: a,b,c,d,e,fa,fb,fc,p,q,r,s,tol1,xm 
a=x1 
b=x2 
fa=func(a) 
fb=func(b) 
if ((fa > 0.0 .and. fb > 0.0) .or. (fa < 0.0 .and. fb < 0.0)) THEN 
            write(*,*)' root must be bracketed for zbrent r' 
            write(*,*)a,b,fa,fb
END IF
c=b 
fc=fb 
do iter=1,ITMAX 
if ((fb > 0.0 .and. fc > 0.0) .or. (fb < 0.0 .and. fc < 0.0)) then 
c=a 
fc=fa 
d=b-a 
e=d 
end if 
if (abs(fc) < abs(fb)) then 
a=b 
b=c 
c=a 
fa=fb 
fb=fc 
fc=fa 
end if 
tol1=2.0_dp*EPS*abs(b)+0.5_dp*tol 
xm=0.5_dp*(c-b) 
if (abs(xm) <= tol1 .or. fb == 0.0) then 
zbrent=b 
RETURN 
end if 
if (abs(e) >= tol1 .and. abs(fa) > abs(fb)) then 
s=fb/fa  
if (a == c) then 
p=2.0_dp*xm*s 
q=1.0_dp-s
else 
q=fa/fc 
r=fb/fc 
p=s*(2.0_dp*xm*q*(q-r)-(b-a)*(r-1.0_dp)) 
q=(q-1.0_dp)*(r-1.0_dp)*(s-1.0_dp) 
end if 
if (p > 0.0) q=-q 
p=abs(p) 
if (2.0_dp*p < min(3.0_dp*xm*q-abs(tol1*q),abs(e*q))) then 
e=d 
d=p/q
else
d=xm
e=d 
end if 
else 
d=xm 
e=d 
end if 
a=b 
fa=fb 
b=b+merge(d,sign(tol1,xm), abs(d) > tol1 ) 
fb=func(b) 
end do 
Write(*,*)' zbrent: exceeded maximum iterations ' 
zbrent=b 

END FUNCTION zbrent

! *****************************************************************************/
! *
! *       ELMER, A Computational Fluid Dynamics Program.
! *
! *       Copyright 1st April 1995 - , Center for Scientific Computing,
! *                                    Finland.
! *
! *       All rights reserved. No part of this program may be used,
! *       reproduced or transmitted in any form or by any means
! *       without the written permission of CSC.
! *
! *****************************************************************************/
!
!/******************************************************************************
! *
! * Module containing a solver for computing the strain rate Eij and tr(Eij)                               
! * 2D SDOFs = 5 (E11, E22, E33, E12, Eii)
! * 3D SDOFs = 7 (E11, E22, E33, E12, E23, E31, Eii)
! * Keywords : Flow Solver Name (AIFlow, Flow Solution, Porous, ...)
! *
! ******************************************************************************
! *
! *                     Author:       Juha Ruokolainen
! *
! *                    Address: Center for Scientific Computing
! *                            Tietotie 6, P.O. Box 405
! *                              02101 Espoo, Finland
! *                              Tel. +358 0 457 2723
! *                            Telefax: +358 0 457 2302
! *                          EMail: Juha.Ruokolainen@csc.fi
! *
! *                       Date: 08 Jun 1997
! *
! *                Modified by:  Fabien / OG 
! *
! *       Date of modification: 13/10/05 from version 1.5
! *
! *****************************************************************************/
!------------------------------------------------------------------------------
   RECURSIVE SUBROUTINE ComputeStrainRate( Model,Solver,dt,TransientSimulation )
!------------------------------------------------------------------------------

    USE DefUtils

    IMPLICIT NONE

!------------------------------------------------------------------------------
!******************************************************************************
!
!  Solve stress equations for one timestep
!
!  ARGUMENTS:
!
!  TYPE(Model_t) :: Model,  
!     INPUT: All model information (mesh,materials,BCs,etc...)
!
!  TYPE(Solver_t) :: Solver
!     INPUT: Linear equation solver options
!
!  REAL(KIND=dp) :: dt,
!     INPUT: Timestep size for time dependent simulations (NOTE: Not used
!            currently)
!
!******************************************************************************

     TYPE(Model_t)  :: Model
     TYPE(Solver_t), TARGET :: Solver

     LOGICAL ::  TransientSimulation
     REAL(KIND=dp) :: dt
!------------------------------------------------------------------------------
!    Local variables
!------------------------------------------------------------------------------
     TYPE(Solver_t), POINTER :: PSolver

     TYPE(Matrix_t),POINTER :: StiffMatrix

     INTEGER :: i, j, k, l, n, t, iter, NDeg, STDOFs, LocalNodes, istat
     INTEGER :: dim

     TYPE(ValueList_t),POINTER :: Material, BC
     TYPE(Nodes_t) :: ElementNodes
     TYPE(Element_t),POINTER :: CurrentElement

     REAL(KIND=dp) :: RelativeChange, UNorm, PrevUNorm, s
                      

     REAL(KIND=dp), ALLOCATABLE :: Basis(:),ddBasisddx(:,:,:)
     REAL(KIND=dp), ALLOCATABLE :: dBasisdx(:,:)
     REAL(KIND=dp) :: u, v, w, detJ
     
     LOGICAL :: stat, CSymmetry 

     INTEGER :: NewtonIter, NonlinearIter

     TYPE(Variable_t), POINTER :: EiiSol, FlowVariable 

     REAL(KIND=dp), POINTER :: Eii(:), FlowValues(:), &
           ForceVector(:),  NodalEii(:), EiiComp(:)

     INTEGER, POINTER :: EiiPerm(:), NodeIndexes(:), &
                         FlowPerm(:)

     LOGICAL :: GotIt, AllocationsDone = .FALSE.

     REAL(KIND=dp), ALLOCATABLE:: LocalMassMatrix(:,:), &
       LocalStiffMatrix(:,:), LocalForce(:), &
       LocalVelo(:,:)
            
     CHARACTER(LEN=MAX_NAME_LEN) :: FlowSolverName

     REAL(KIND=dp) :: at, at0, CPUTime, RealTime


!------------------------------------------------------------------------------
     SAVE Basis, dBasisdx, ddBasisddx
     SAVE LocalMassMatrix, LocalStiffMatrix, LocalForce, &
          ElementNodes, AllocationsDone  
     SAVE LocalVelo,  dim

!------------------------------------------------------------------------------
!  Read the name of the Flow Solver (NS, AIFlow, Porous, ...)
!------------------------------------------------------------------------------
      
     FlowSolverName = GetString( Solver % Values, 'Flow Solver Name', GotIt )    
     IF (.NOT.Gotit) FlowSolverName = 'aiflow'
     FlowVariable => VariableGet( Solver % Mesh % Variables, FlowSolverName )
     IF ( ASSOCIATED( FlowVariable ) ) THEN
       FlowPerm    => FlowVariable % Perm
       FlowValues  => FlowVariable % Values
     ELSE
       CALL Info('ComputeStrainRate', &
                      & 'No variable for velocity associated.', Level=4)
     END IF
!              
!------------------------------------------------------------------------------
!    Get variables needed for solution
!------------------------------------------------------------------------------
      IF ( .NOT. ASSOCIATED( Solver % Matrix ) ) RETURN

      EiiSol => Solver % Variable
      EiiPerm => EiiSol % Perm
      STDOFs =  EiiSol % DOFs
      Eii => EiiSol % Values

      LocalNodes = COUNT( EiiPerm > 0 )
      IF ( LocalNodes <= 0 ) RETURN


      StiffMatrix => Solver % Matrix
      ForceVector => StiffMatrix % RHS
      UNorm = Solver % Variable % Norm

!------------------------------------------------------------------------------
!     Allocate some permanent storage, this is done first time only
!------------------------------------------------------------------------------
      IF ( .NOT. AllocationsDone .OR. Solver % Mesh % Changed) THEN
        N = Model % MaxElementNodes
        dim = CoordinateSystemDimension()

       IF ( AllocationsDone ) THEN
         DEALLOCATE( ElementNodes % x,     &
                     ElementNodes % y,     &
                     ElementNodes % z,     &
                     LocalVelo,            &                      
                     Basis, ddBasisddx,    &
                     dBasisdx,             &
                     LocalMassMatrix,      &
                     LocalStiffMatrix,     &
                     LocalForce )
       END IF

       ALLOCATE( ElementNodes % x( N ), &
                 ElementNodes % y( N ), &
                 ElementNodes % z( N ), &
                 LocalVelo( 3,N ), &                                    
                 Basis( 2*N ),ddBasisddx(1,1,1), dBasisdx( 2*N,3 ), &
                 LocalMassMatrix( 2*STDOFs*N,2*STDOFs*N ),  &
                 LocalStiffMatrix( 2*STDOFs*N,2*STDOFs*N ),  &
                 LocalForce( 2*STDOFs*N ),  STAT=istat )

       IF ( istat /= 0 ) THEN
          CALL Fatal( 'ComputeStrainRate', 'Memory allocation error.' )
       END IF
!------------------------------------------------------------------------------
       AllocationsDone = .TRUE.
      END IF


!------------------------------------------------------------------------------
      NonlinearIter = 1
      DO iter=1,NonlinearIter

       at  = CPUTime()
       at0 = RealTime()

       CALL Info( 'ComputeStrainRate', ' ', Level=4 )
       CALL Info( 'ComputeStrainRate', ' ', Level=4 )
       CALL Info( 'ComputeStrainRate', ' ', Level=4 )
       CALL Info( 'ComputeStrainRate', ' ', Level=4 )
       CALL Info( 'ComputeStrainRate', 'Starting assembly...',Level=4 )

!------------------------------------------------------------------------------
       CALL DefaultInitialize()
!------------------------------------------------------------------------------
       DO t=1,Solver % NumberOFActiveElements

         IF ( RealTime() - at0 > 1.0 ) THEN
           WRITE(Message,'(a,i3,a)' ) '   Assembly: ',  &
             INT(100.0 - 100.0 * (Solver % NumberOfActiveElements-t) / &
             (1.0*Solver % NumberOfActiveElements)), ' % done'
           CALL Info( 'ComputeStrainRate', Message, Level=5 )
           at0 = RealTime()
         END IF

         CurrentElement => GetActiveElement(t)
         n = GetElementNOFNodes()
         NodeIndexes => CurrentElement % NodeIndexes

         ElementNodes % x(1:n) = Model % Nodes % x(NodeIndexes(1:n))
         ElementNodes % y(1:n) = Model % Nodes % y(NodeIndexes(1:n))
         ElementNodes % z(1:n) = Model % Nodes % z(NodeIndexes(1:n))

         Material => GetMaterial()


!------------------------------------------------------------------------------
!        Get element local stiffness & mass matrices
!------------------------------------------------------------------------------

          LocalVelo = 0.0d0
          DO i=1, dim
             LocalVelo(i,1:n) = FlowValues((dim+1)*(FlowPerm(NodeIndexes(1:n))-1) + i)
          END DO

          CALL LocalMatrix( LocalMassMatrix, LocalStiffMatrix, &
              LocalForce, LocalVelo, CurrentElement, n, ElementNodes )
              

!------------------------------------------------------------------------------
!        Update global matrices from local matrices 
!------------------------------------------------------------------------------
         CALL DefaultUpdateEquations( LocalStiffMatrix, LocalForce )
 
      END DO

      CALL Info( 'ComputeStrainRate', 'Assembly done', Level=4 )


      CALL DefaultFinishAssembly()

!------------------------------------------------------------------------------
!     Dirichlet boundary conditions
!------------------------------------------------------------------------------
      CALL DefaultDirichletBCs()

!------------------------------------------------------------------------------

      CALL Info( 'ComputeStrainRate', 'Set boundaries done', Level=4 )

!------------------------------------------------------------------------------
!     Solve the system and check for convergence
!------------------------------------------------------------------------------
      PrevUNorm = UNorm

      UNorm = DefaultSolve()

      unorm = 0
      n = Solver % Variable % DOFs
      DO i=1,n-1
        unorm = unorm + SUM( solver % variable % values(i::n)**2 )
      END DO
      unorm = SQRT( unorm )
      solver % variable % norm = unorm

      IF ( PrevUNorm + UNorm /= 0.0d0 ) THEN
         RelativeChange = 2.0d0 * ABS( PrevUNorm - UNorm) / ( PrevUnorm + UNorm)
      ELSE
         RelativeChange = 0.0d0
      END IF

      WRITE( Message, * ) 'Result Norm   : ',UNorm, PrevUNorm
      CALL Info( 'ComputeStrainRate', Message, Level=4 )
      WRITE( Message, * ) 'Relative Change : ',RelativeChange
      CALL Info( 'ComputeStrainRate', Message, Level=4 )


!------------------------------------------------------------------------------
    END DO ! of nonlinear iter
!------------------------------------------------------------------------------

      
CONTAINS


!------------------------------------------------------------------------------
      SUBROUTINE LocalMatrix( MassMatrix, StiffMatrix, ForceVector, &
              NodalVelo, Element, n, Nodes )
              
!------------------------------------------------------------------------------

     REAL(KIND=dp) :: StiffMatrix(:,:), MassMatrix(:,:)
     REAL(KIND=dp) ::  NodalVelo(:,:), ForceVector(:)
     TYPE(Nodes_t) :: Nodes
     TYPE(Element_t) :: Element
     INTEGER :: n
!------------------------------------------------------------------------------
!
     REAL(KIND=dp) :: Basis(2*n), ddBasisddx(1,1,1)
     REAL(KIND=dp) :: dBasisdx(2*n,3), detJ

     REAL(KIND=dp) :: LGrad(3,3), SR(3,3),  Eij(7)

     INTEGER :: i, j, k, p, q, t, dim, cc

     REAL(KIND=dp) :: s, u, v, w, Radius
  
     TYPE(GaussIntegrationPoints_t), TARGET :: IntegStuff

     INTEGER :: N_Integ

     REAL(KIND=dp), DIMENSION(:), POINTER :: U_Integ, V_Integ, W_Integ, S_Integ

     LOGICAL :: stat, CSymmetry

!------------------------------------------------------------------------------
      dim = CoordinateSystemDimension()
      cc = 2*dim + 1

      ForceVector = 0.0D0
      StiffMatrix = 0.0D0
      MassMatrix  = 0.0D0

      IntegStuff = GaussPoints( Element )

      U_Integ => IntegStuff % u
      V_Integ => IntegStuff % v
      W_Integ => IntegStuff % w
      S_Integ => IntegStuff % s
      N_Integ =  IntegStuff % n
!
!   Now we start integrating
!
      DO t=1,N_Integ

      u = U_Integ(t)
      v = V_Integ(t)
      w = W_Integ(t)

!------------------------------------------------------------------------------
!     Basis function values & derivatives at the integration point
!------------------------------------------------------------------------------
       stat = ElementInfo(Element,Nodes,u,v,w,detJ, &
                 Basis,dBasisdx,ddBasisddx,.FALSE.,.FALSE.)


       s = detJ * S_Integ(t)


       Radius = SUM( Nodes % x(1:n) * Basis(1:n) )
       CSymmetry = CurrentCoordinateSystem() == AxisSymmetric
       IF ( CSymmetry ) s = s * Radius
!
! Strain-Rate and Eii = tr(Eij)
!
        SR = 0.0
        Eij = 0.0
        LGrad = MATMUL( NodalVelo(:,1:n), dBasisdx(1:n,:) )
        SR = 0.5 * ( LGrad + TRANSPOSE(LGrad) )
        IF ( CSymmetry ) THEN
          SR(1,3) = 0.0
          SR(2,3) = 0.0
          SR(3,1) = 0.0
          SR(3,2) = 0.0
          SR(3,3) = 0.0
          IF ( Radius > 10*AEPS ) THEN
            SR(3,3) = SUM( Nodalvelo(1,1:n) * Basis(1:n) ) /Radius
                 
          END IF
        END IF
        Eij(1) = SR(1,1)        
        Eij(2) = SR(2,2)        
        Eij(3) = SR(3,3)        
        Eij(4) = SR(1,2)        
        IF (dim > 2) THEN
          Eij(5) = SR(2,3)
          Eij(6) = SR(3,1)
        END IF
        Eij(cc) = SR(1,1) + SR(2,2) + SR(3,3)

        DO i=1,cc 
          DO p=1,n         
            DO q=1,n        
            StiffMatrix(cc*(p-1)+i,cc*(q-1)+i ) =  &
               StiffMatrix(cc*(p-1)+i,cc*(q-1)+i ) + s*Basis(q)*Basis(p)
            END DO

             ForceVector(cc*(p-1)+i) =  &
                     ForceVector(cc*(p-1)+i) + s*Eij(i)*Basis(p) 
          END DO
        END DO
      END DO 

!------------------------------------------------------------------------------
      END SUBROUTINE LocalMatrix
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
      END SUBROUTINE ComputeStrainRate
!------------------------------------------------------------------------------

! *****************************************************************************/
! *
! *       ELMER, A Computational Fluid Dynamics Program.
! *
! *       Copyright 1st April 1995 - , Center for Scientific Computing,
! *                                    Finland.
! *
! *       All rights reserved. No part of this program may be used,
! *       reproduced or transmitted in any form or by any means
! *       without the written permission of CSC.
! *
! *****************************************************************************/
!
!/******************************************************************************
! *
! * Module containing a solver for computing deviatoric or Cauchy 
! *          stress from flow solution 
! * 2D SDOFs = 4 (S11, S22, S33, S12)
! * 3D SDOFs = 6 (S11, S22, S33, S12, S23, S31)
! * Keywords : Cauchy (Logical), 
! *            Flow Solver Name (AIFlow, Flow Solution, Porous, ...)
! *
! ******************************************************************************
! *
! *                     Author:       Juha Ruokolainen
! *
! *                    Address: Center for Scientific Computing
! *                            Tietotie 6, P.O. Box 405
! *                              02101 Espoo, Finland
! *                              Tel. +358 0 457 2723
! *                            Telefax: +358 0 457 2302
! *                          EMail: Juha.Ruokolainen@csc.fi
! *
! *                       Date: 08 Jun 1997
! *
! *                Modified by:  Fabien / OG 
! *
! *       Date of modification: 13/10/05 from version 1.5
! *
! *****************************************************************************/
!------------------------------------------------------------------------------
   RECURSIVE SUBROUTINE ComputeDevStress( Model,Solver,dt,TransientSimulation )
!------------------------------------------------------------------------------

    USE DefUtils

    IMPLICIT NONE

!------------------------------------------------------------------------------
!******************************************************************************
!
!  Solve stress equations for one timestep
!
!  ARGUMENTS:
!
!  TYPE(Model_t) :: Model,  
!     INPUT: All model information (mesh,materials,BCs,etc...)
!
!  TYPE(Solver_t) :: Solver
!     INPUT: Linear equation solver options
!
!  REAL(KIND=dp) :: dt,
!     INPUT: Timestep size for time dependent simulations (NOTE: Not used
!            currently)
!
!******************************************************************************

     TYPE(Model_t)  :: Model
     TYPE(Solver_t), TARGET :: Solver

     LOGICAL ::  TransientSimulation
     REAL(KIND=dp) :: dt
!------------------------------------------------------------------------------
!    Local variables
!------------------------------------------------------------------------------
     TYPE(Solver_t), POINTER :: PSolver

     TYPE(Matrix_t),POINTER :: StiffMatrix

     INTEGER :: i, j, k, l, n, t, iter, NDeg, STDOFs, LocalNodes, istat
     INTEGER :: dim

     TYPE(ValueList_t),POINTER :: Material, BC
     TYPE(Nodes_t) :: ElementNodes
     TYPE(Element_t),POINTER :: CurrentElement

     REAL(KIND=dp) :: RelativeChange, UNorm, PrevUNorm, &
                      s, Wn(7), MinSRInvariant

     REAL(KIND=dp), ALLOCATABLE :: Basis(:),ddBasisddx(:,:,:)
     REAL(KIND=dp), ALLOCATABLE :: dBasisdx(:,:)
     REAL(KIND=dp) :: u, v, w, detJ
     
     LOGICAL :: stat, CSymmetry 

     INTEGER :: NewtonIter, NonlinearIter

     TYPE(Variable_t), POINTER :: StressSol, TempSol, FabricVariable, FlowVariable 

     REAL(KIND=dp), POINTER :: Temperature(:), Stress(:), &
           ForceVector(:),  NodalStress(:), StressComp(:), &
           FabricValues(:), FlowValues(:)


     INTEGER, POINTER :: TempPerm(:), StressPerm(:), NodeIndexes(:), &
                         FabricPerm(:), FlowPerm(:)

     INTEGER :: body_id
     INTEGER :: old_body = -1

     LOGICAL :: Isotropic, AllocationsDone = .FALSE.,  &
                Requal0
     LOGICAL :: GotIt,  Cauchy = .FALSE.

     REAL(KIND=dp) :: FabricGrid(4878)

     INTEGER, DIMENSION(3:8) :: NnodeLinear=(/3, 4, 4, 5, 6, 8/)
           
     REAL(KIND=dp), ALLOCATABLE:: LocalMassMatrix(:,:), &
       LocalStiffMatrix(:,:), LocalForce(:), &
       LocalTemperature(:), & 
       K1(:), K2(:), E1(:), &
       E2(:), E3(:), LocalP(:),  &
       LocalVelo(:,:), LocalFluidity(:)
            
     INTEGER :: NumberOfBoundaryNodes
     INTEGER, POINTER :: BoundaryReorder(:)

     REAL(KIND=dp), POINTER :: BoundaryNormals(:,:), &
         BoundaryTangent1(:,:), BoundaryTangent2(:,:)
     CHARACTER(LEN=MAX_NAME_LEN) :: viscosityFile, FlowSolverName

     REAL(KIND=dp) :: at, at0, CPUTime, RealTime


!------------------------------------------------------------------------------
     SAVE NumberOfBoundaryNodes, BoundaryReorder, BoundaryNormals, &
              BoundaryTangent1, BoundaryTangent2, FabricGrid, viscosityFile

     SAVE Basis, dBasisdx, ddBasisddx
     SAVE LocalMassMatrix, LocalStiffMatrix, LocalForce, &
          ElementNodes,  LocalTemperature, &
          Isotropic, AllocationsDone,  &
          K1, K2, E1, E2, E3, Wn, MinSRInvariant, old_body, &
          LocalFluidity, Cauchy
     SAVE LocalVelo, LocalP, dim

!------------------------------------------------------------------------------
!  Read the name of the Flow Solver (NS, AIFlow, Porous, ...)
!------------------------------------------------------------------------------
      
     FlowSolverName = GetString( Solver % Values, 'Flow Solver Name', GotIt )    
     IF (.NOT.Gotit) FlowSolverName = 'aiflow'
     FlowVariable => VariableGet( Solver % Mesh % Variables, FlowSolverName )
     IF ( ASSOCIATED( FlowVariable ) ) THEN
       FlowPerm    => FlowVariable % Perm
       FlowValues  => FlowVariable % Values
     ELSE
       CALL Info('ComputeDevStress', &
                      & 'No variable for velocity associated.', Level=4)
     END IF
!              
!------------------------------------------------------------------------------
!  Read constants from constants section of SIF file
!------------------------------------------------------------------------------
      Wn(7) = GetConstReal( Model % Constants, 'Gas Constant', GotIt )
      IF (.NOT.GotIt) THEN
        WRITE(Message,'(A)') 'VariableGas Constant  not found. &
                     &Setting to 8.314'
        CALL INFO('ComputeDevStress', Message, level=20)
        Wn(7) = 8.314
      ELSE
        WRITE(Message,'(A,F10.4)') 'Gas Constant = ',   Wn(7)
        CALL INFO('ComputeDevStress', Message , level = 20)
      END IF

      Cauchy = ListGetLogical( Solver % Values , 'Cauchy', Gotit )
      IF (.NOT.Gotit) THEN
          Cauchy = .FALSE.
           WRITE(Message,'(A)') 'Cauchy set to False'
           CALL INFO('ComputeDevStress', Message, Level = 20)
      END IF
!------------------------------------------------------------------------------
!    Get variables needed for solution
!------------------------------------------------------------------------------
      IF ( .NOT. ASSOCIATED( Solver % Matrix ) ) RETURN

      StressSol => Solver % Variable
      StressPerm => StressSol % Perm
      STDOFs =  StressSol % DOFs
      Stress => StressSol % Values

      LocalNodes = COUNT( StressPerm > 0 )
      IF ( LocalNodes <= 0 ) RETURN

      TempSol => VariableGet( Solver % Mesh % Variables, 'Temperature' )
      IF ( ASSOCIATED( TempSol) ) THEN
        TempPerm    => TempSol % Perm
        Temperature => TempSol % Values
      END IF

      FabricVariable => VariableGet(Solver % Mesh % Variables, 'Fabric')
      IF ( ASSOCIATED( FabricVariable ) ) THEN
       FabricPerm    => FabricVariable % Perm
       FabricValues => FabricVariable % Values
      END IF


      StiffMatrix => Solver % Matrix
      ForceVector => StiffMatrix % RHS
      UNorm = Solver % Variable % Norm

!------------------------------------------------------------------------------
!     Allocate some permanent storage, this is done first time only
!------------------------------------------------------------------------------
      IF ( .NOT. AllocationsDone .OR. Solver % Mesh % Changed) THEN
        N = Model % MaxElementNodes
        dim = CoordinateSystemDimension()

       IF ( AllocationsDone ) THEN
         DEALLOCATE( ElementNodes % x,     &
                     ElementNodes % y,     &
                     ElementNodes % z,     &
                     LocalTemperature,     &
                     K1, K2, E1, E2, E3,   &
                     LocalVelo, LocalP,    &                      
                     Basis, ddBasisddx,    &
                     dBasisdx,             &
                     LocalMassMatrix,      &
                     LocalStiffMatrix,     &
                     LocalForce,           &
                     LocalFluidity )
       END IF

       ALLOCATE( ElementNodes % x( N ), &
                 ElementNodes % y( N ), &
                 ElementNodes % z( N ), &
                 LocalTemperature( N ), &
                 K1( N ), K2( N ), E1( N ), E2( N ), E3( N ), &
                 LocalVelo( 3,N ), LocalP( N ), &                                     
                 Basis( 2*N ),ddBasisddx(1,1,1), dBasisdx( 2*N,3 ), &
                 LocalMassMatrix( 2*STDOFs*N,2*STDOFs*N ),  &
                 LocalStiffMatrix( 2*STDOFs*N,2*STDOFs*N ),  &
                 LocalForce( 2*STDOFs*N ),  &
                 LocalFluidity(N), STAT=istat )

       IF ( istat /= 0 ) THEN
          CALL Fatal( 'ComputeDevStress', 'Memory allocation error.' )
       END IF
!------------------------------------------------------------------------------

       AllocationsDone = .TRUE.
      END IF


!------------------------------------------------------------------------------
      NonlinearIter = 1
      DO iter=1,NonlinearIter

       at  = CPUTime()
       at0 = RealTime()

       CALL Info( 'ComputeDevStress', ' ', Level=4 )
       CALL Info( 'ComputeDevStress', ' ', Level=4 )
       CALL Info( 'ComputeDevStress', ' ', Level=4 )
       CALL Info( 'ComputeDevStress', ' ', Level=4 )
       CALL Info( 'ComputeDevStress', 'Starting assembly...',Level=4 )

!------------------------------------------------------------------------------
       CALL DefaultInitialize()
!------------------------------------------------------------------------------
       DO t=1,Solver % NumberOFActiveElements

         IF ( RealTime() - at0 > 1.0 ) THEN
           WRITE(Message,'(a,i3,a)' ) '   Assembly: ',  &
             INT(100.0 - 100.0 * (Solver % NumberOfActiveElements-t) / &
             (1.0*Solver % NumberOfActiveElements)), ' % done'
           CALL Info( 'ComputeDevStress', Message, Level=5 )
           at0 = RealTime()
         END IF

         CurrentElement => GetActiveElement(t)
         n = GetElementNOFNodes()
         NodeIndexes => CurrentElement % NodeIndexes

         ElementNodes % x(1:n) = Model % Nodes % x(NodeIndexes(1:n))
         ElementNodes % y(1:n) = Model % Nodes % y(NodeIndexes(1:n))
         ElementNodes % z(1:n) = Model % Nodes % z(NodeIndexes(1:n))

         Material => GetMaterial()

!------------------------------------------------------------------------------
!    Read in material constants from Material section
!------------------------------------------------------------------------------
         SELECT CASE( FlowSolverName)

         CASE('aiflow')

          body_id = CurrentElement % BodyId
          IF ((body_id /= old_body) .OR. (t==1)) THEN 
             old_body = body_id
             CALL  GetMaterialDefs()
          END IF

          LocalFluidity(1:n) = ListGetReal( Material, &
                         'Fluidity Parameter', n, NodeIndexes, GotIt )
          IF (.NOT.GotIt) THEN
            WRITE(Message,'(A)') 'Variable Fluidity Parameter not found. &
                            &Setting to 1.0'
            CALL INFO('ComputeStress', Message, Level = 20)
            LocalFluidity(1:n) = 1.0_dp
          END IF


!------------------------------------------------------------------------------
!        Get element local stiffness & mass matrices
!------------------------------------------------------------------------------
          LocalTemperature = 0.0_dp
          IF ( ASSOCIATED(TempSol) ) THEN
            DO i=1,n
              k = TempPerm(NodeIndexes(i))
              LocalTemperature(i) = Temperature(k)
            END DO
          ELSE
            LocalTemperature(1:n) = 0.0_dp
          END IF

! fabric not needed if isotropic
          IF(.NOT.Isotropic) THEN
            K1(1:n) = FabricValues( 5 * (FabricPerm(NodeIndexes(1:n))-1) + 1 )
            K2(1:n) = FabricValues( 5 * (FabricPerm(NodeIndexes(1:n))-1) + 2 )
            E1(1:n) = FabricValues( 5 * (FabricPerm(NodeIndexes(1:n))-1) + 3 )
            E2(1:n) = FabricValues( 5 * (FabricPerm(NodeIndexes(1:n))-1) + 4 )
            E3(1:n) = FabricValues( 5 * (FabricPerm(NodeIndexes(1:n))-1) + 5 )
          ENDIF

          LocalVelo = 0.0_dp
          DO i=1, dim
             LocalVelo(i,1:n) = FlowValues((dim+1)*(FlowPerm(NodeIndexes(1:n))-1) + i)
          END DO
          LocalP(1:n) = FlowValues((dim+1)*FlowPerm(NodeIndexes(1:n)))

          CALL LocalAIFlowMatrix( LocalMassMatrix, LocalStiffMatrix, &
              LocalForce,  K1, K2, E1, E2, E3, LocalVelo, LocalP, &
              LocalTemperature, LocalFluidity, CurrentElement, n, &
              ElementNodes, Wn, MinSRInvariant, Isotropic, Cauchy)

!!!! Restricted to the Power Law case
         CASE('flow solution')
          
          body_id = CurrentElement % BodyId
          IF ((body_id /= old_body) .OR. (t==1)) THEN 
             old_body = body_id
             CALL  GetMaterialDefsNS()
          END IF

          LocalFluidity(1:n) = ListGetReal( Material, &
                         'Viscosity', n, NodeIndexes, GotIt )
          IF (.NOT.GotIt) THEN
            WRITE(Message,'(A)') 'Variable Viscosity not found. &
                            &Setting to 1.0'
            CALL INFO('ComputeStress', Message, Level = 20)
            LocalFluidity(1:n) = 1.0_dp
          END IF
! B = 1/ eta^n
          LocalFluidity = 1.0_dp / (LocalFluidity**Wn(2)) 
          LocalVelo = 0.0_dp
          DO i=1, dim
             LocalVelo(i,1:n) = FlowValues((dim+1)*(FlowPerm(NodeIndexes(1:n))-1) + i)
          END DO
          LocalP(1:n) = FlowValues((dim+1)*FlowPerm(NodeIndexes(1:n)))

          CALL LocalNSMatrix( LocalMassMatrix, LocalStiffMatrix, &
              LocalForce,  LocalVelo, LocalP, &
              LocalFluidity, CurrentElement, n, &
              ElementNodes, Wn, MinSRInvariant, Cauchy)

! to be done
         CASE('porous')
         

         END SELECT 

!------------------------------------------------------------------------------
!        Update global matrices from local matrices 
!------------------------------------------------------------------------------
!        IF ( TransientSimulation ) THEN
!           CALL Default1stOrderTime( LocalMassMatrix, &
!                LocalStiffMatrix, LocalForce )
!        END IF
         CALL DefaultUpdateEquations( LocalStiffMatrix, LocalForce )
      END DO

      CALL Info( 'ComputeDevStress', 'Assembly done', Level=4 )


      CALL DefaultFinishAssembly()

!------------------------------------------------------------------------------
!     Dirichlet boundary conditions
!------------------------------------------------------------------------------
      CALL DefaultDirichletBCs()

!------------------------------------------------------------------------------

      CALL Info( 'ComputeDevStress', 'Set boundaries done', Level=4 )

!------------------------------------------------------------------------------
!     Solve the system and check for convergence
!------------------------------------------------------------------------------
      PrevUNorm = UNorm

      UNorm = DefaultSolve()

      unorm = 0
      n = Solver % Variable % DOFs
      DO i=1,n-1
        unorm = unorm + SUM( solver % variable % values(i::n)**2 )
      END DO
      unorm = SQRT( unorm )
      solver % variable % norm = unorm

      IF ( PrevUNorm + UNorm /= 0.0d0 ) THEN
         RelativeChange = 2.0d0 * ABS( PrevUNorm - UNorm) / ( PrevUnorm + UNorm)
      ELSE
         RelativeChange = 0.0d0
      END IF

      WRITE( Message, * ) 'Result Norm   : ',UNorm, PrevUNorm
      CALL Info( 'ComputeDevStress', Message, Level=4 )
      WRITE( Message, * ) 'Relative Change : ',RelativeChange
      CALL Info( 'ComputeDevStress', Message, Level=4 )


!------------------------------------------------------------------------------
    END DO ! of nonlinear iter
!------------------------------------------------------------------------------

      
CONTAINS

      SUBROUTINE GetMaterialDefs()
      ! check if we are isotropic or not
      Isotropic = ListGetLogical( Material , 'Isotropic',Gotit )
      IF (.NOT.Gotit) THEN
          Isotropic = .FALSE.
           WRITE(Message,'(A)') 'Isotropic set to False'
           CALL INFO('ComputeDevStress', Message, Level = 20)
      ELSE
           IF ( (ASSOCIATED( FabricVariable )).AND.Isotropic ) THEN
              WRITE(Message,'(A)') 'Be carefull Isotropic is true &
                           & and Fabric is defined!'
              CALL INFO('ComputeDevStress', Message, Level = 1)
           END IF
      END IF

      IF (.NOT.Isotropic) THEN
        ! Get the viscosity file and store the viscosities into FabricGrid
         viscosityFile = ListGetString( Material ,'Viscosity File',GotIt )
         IF (.NOT.GotIt) THEN
            WRITE(Message,'(3A)') &
                      'Viscosity File ', viscosityFile, ' not found'
           CALL FATAL('ComputeDevStress',Message)
         ELSE
             OPEN( 1, File = viscosityFile)
             DO i=1,813
                 READ( 1, '(6(e14.8))' ) FabricGrid( 6*(i-1)+1:6*(i-1)+6 )
             END DO
             CLOSE(1)
          END IF
      ENDIF


      Wn(2) = ListGetConstReal( Material , 'Powerlaw Exponent', GotIt )
      IF (.NOT.GotIt) THEN
         WRITE(Message,'(A)') 'Variable  Powerlaw Exponent not found. &
                                    & Setting to 1.0'
         CALL INFO('ComputeDevStress', Message, Level = 20)
         Wn(2) = 1.0_dp
      ELSE
       WRITE(Message,'(A,F10.4)') 'Powerlaw Exponent = ',   Wn(2)
       CALL INFO('ComputeDevStress', Message, Level = 20)
       END IF

      Wn(3) = ListGetConstReal( Material, 'Activation Energy 1', GotIt )
      IF (.NOT.GotIt) THEN
         WRITE(Message,'(A)') 'Variable Activation Energy 1 not found.&
                            & Setting to 1.0'
         CALL INFO('ComputeDevStress', Message, Level = 20)
         Wn(3) = 1.0_dp
      ELSE
         WRITE(Message,'(A,F10.4)') 'Activation Energy 1 = ',   Wn(3)
         CALL INFO('ComputeDevStress', Message, Level = 20)
      END IF

      Wn(4) = ListGetConstReal( Material, 'Activation Energy 2', GotIt )
      IF (.NOT.GotIt) THEN
         WRITE(Message,'(A)') 'Variable Activation Energy 2 not found. &
                               &Setting to 1.0'
         CALL INFO('ComputeDevStress', Message, Level = 20)
         Wn(4) = 1.0_dp
      ELSE
         WRITE(Message,'(A,F10.4)') 'Activation Energy 2 = ',   Wn(4)
         CALL INFO('ComputeDevStress', Message, Level = 20)
      END IF

      Wn(5) = ListGetConstReal(Material, 'Reference Temperature', GotIt)
      IF (.NOT.GotIt) THEN
         WRITE(Message,'(A)') 'Variable Reference Temperature not found. &
                               &Setting to -10.0 (Celsius)'
         CALL INFO('ComputeDevStress', Message, Level = 20)
         Wn(5) = -10.0_dp
      ELSE
         WRITE(Message,'(A,F10.4)') 'Reference Temperature = ',   Wn(5)
         CALL INFO('ComputeDevStress', Message, Level = 20)
      END IF

      Wn(6) = ListGetConstReal( Material, 'Limit Temperature', GotIt )
      IF (.NOT.GotIt) THEN
         WRITE(Message,'(A)') 'Variable Limit Temperature not found. &
                               &Setting to -10.0 (Celsius)'
         CALL INFO('ComputeDevStress', Message, Level = 20)
         Wn(6) = -10.0_dp
      ELSE
         WRITE(Message,'(A,F10.4)') 'Limit Temperature = ',   Wn(6)
         CALL INFO('ComputeDevStress', Message, Level = 20)
      END IF

! Get the Minimum value of the Effective Strain rate 
      MinSRInvariant = 1.0e-10_dp
      IF ( Isotropic .AND. (Wn(2) > 1.0 ) ) THEN
        MinSRInvariant =  &
             ListGetConstReal( Material, 'Min Second Invariant', GotIt )
        IF (.NOT.GotIt) THEN
          WRITE(Message,'(A)') 'Variable Min Second Invariant not &
                    &found. Setting to 1.0D-10 )'
          CALL INFO('ComputeDevStress', Message, Level = 20)
        ELSE
          WRITE(Message,'(A,E14.8)') 'Min Second Invariant = ', MinSRInvariant
          CALL INFO('ComputeDevStress', Message, Level = 20)
        END IF
      END IF

!------------------------------------------------------------------------------
      END SUBROUTINE GetMaterialDefs
!------------------------------------------------------------------------------

      SUBROUTINE GetMaterialDefsNS()
      ! check if we are isotropic or not


      Wn(2) = ListGetConstReal( Material , 'Viscosity Exponent', GotIt )

      IF (.NOT.GotIt) THEN
         WRITE(Message,'(A)') 'Variable  Powerlaw Exponent not found. &
                                    & Setting to 1.0'
         CALL INFO('ComputeDevStress', Message, Level = 20)
         Wn(2) = 1.0_dp
      ELSE
         Wn(2) = 1.0_dp / Wn(2)
         WRITE(Message,'(A,F10.4)') 'Viscosity Exponent = ',   Wn(2)
         CALL INFO('ComputeDevStress', Message, Level = 20)
      END IF

! Get the Minimum value of the Effective Strain rate 
      MinSRInvariant = 1.0e-10_dp
      IF ( Wn(2) > 1.0  ) THEN
        MinSRInvariant =  &
             ListGetConstReal( Material, 'Critical Shear Rate', GotIt )
        IF (.NOT.GotIt) THEN
          WRITE(Message,'(A)') 'Variable Critical Shear Rate not &
                    &found. Setting to 1.0D-10 )'
          CALL INFO('ComputeDevStress', Message, Level = 20)
        ELSE
          WRITE(Message,'(A,E14.8)') 'Critical Shear Rate = ', MinSRInvariant
          CALL INFO('ComputeDevStress', Message, Level = 20)
        END IF
      END IF

!------------------------------------------------------------------------------
      END SUBROUTINE GetMaterialDefsNS
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
      SUBROUTINE LocalAIFlowMatrix( MassMatrix, StiffMatrix, ForceVector, &
              NodalK1, NodalK2, NodalEuler1, NodalEuler2, &
              NodalEuler3, NodalVelo, NodalP, NodalTemperature, NodalFluidity, &
              Element, n, Nodes, Wn, MinSRInvariant, Isotropic, Cauchy )
              
              
              
!------------------------------------------------------------------------------

     REAL(KIND=dp) :: StiffMatrix(:,:), MassMatrix(:,:)
     REAL(KIND=dp) ::  NodalVelo(:,:)
     REAL(KIND=dp) :: Wn(7), MinSRInvariant
     REAL(KIND=dp), DIMENSION(:) :: ForceVector, NodalK1, NodalK2, &
             NodalEuler1, NodalEuler2, NodalEuler3, NodalTemperature, &
             NodalFluidity, NodalP
     TYPE(Nodes_t) :: Nodes
     TYPE(Element_t) :: Element
     LOGICAL :: Isotropic, Cauchy
     INTEGER :: n
!------------------------------------------------------------------------------
!
     REAL(KIND=dp) :: Basis(2*n),ddBasisddx(1,1,1)
     REAL(KIND=dp) :: dBasisdx(2*n,3),detJ, pBasis(n)

     REAL(KIND=dp) :: K1, K2, Euler1, Euler2, Euler3
     REAL(kind=dp) :: Bg, BGlenT, Stress(6)

     REAL(KIND=dp), DIMENSION(4,4) :: A,M
     REAL(KIND=dp) :: Temperature,  C(6,6), Pressure
     REAL(KIND=dp) :: nn, ss, LGrad(3,3), SR(3,3), D(6), epsi

     INTEGER :: i, j, k, p, q, t, dim, cc, NBasis, ind(3), LinearBasis

     REAL(KIND=dp) :: s, u, v, w, Radius, eta
  
     REAL(KIND=dp) :: dDispldx(3,3), ai(3), Angle(3), a2(6)
     TYPE(GaussIntegrationPoints_t), TARGET :: IntegStuff

     INTEGER, POINTER :: EdgeMap(:,:)
     INTEGER :: N_Integ, nd

     REAL(KIND=dp), DIMENSION(:), POINTER :: U_Integ,V_Integ,W_Integ,S_Integ

     LOGICAL :: stat, CSymmetry, P2P1, MiniElement

     TYPE(ElementType_t), POINTER :: SaveType, LinearType

     INTERFACE
      SUBROUTINE R2Ro(a2,dim,ai,angle)
         USE Types
         REAL(KIND=dp),INTENT(in) :: a2(6)
         INTEGER :: dim
         REAL(KIND=dp),INTENT(out) :: ai(3), Angle(3)
      END SUBROUTINE R2Ro
                 
      SUBROUTINE OPILGGE_ai(ai,Angle,Tc,W,etaI,eta36)
          USE Types
          REAL(KIND=dp) :: ai(3), Angle(3), Tc, W(7), EtaI(:), Eta36(6,6)
        END SUBROUTINE OPILGGE_ai

      END INTERFACE

!------------------------------------------------------------------------------
      dim = CoordinateSystemDimension()
      cc=2*dim


      ForceVector = 0.0_dp
      StiffMatrix = 0.0_dp
      MassMatrix  = 0.0_dp

      IntegStuff = GaussPoints( Element )

      U_Integ => IntegStuff % u
      V_Integ => IntegStuff % v
      W_Integ => IntegStuff % w
      S_Integ => IntegStuff % s
      N_Integ =  IntegStuff % n
!
!   Now we start integrating
!
      DO t=1,N_Integ

      u = U_Integ(t)
      v = V_Integ(t)
      w = W_Integ(t)

!------------------------------------------------------------------------------
!     Basis function values & derivatives at the integration point
!------------------------------------------------------------------------------
       stat = ElementInfo(Element,Nodes,u,v,w,detJ, &
                 Basis,dBasisdx,ddBasisddx,.FALSE.,.FALSE.)


       s = detJ * S_Integ(t)


       Radius = SUM( Nodes % x(1:n) * Basis(1:n) )
       CSymmetry = CurrentCoordinateSystem() == AxisSymmetric
       IF ( CSymmetry ) s = s * Radius
!
!     Temperature at the integration point
!
       Temperature = SUM( NodalTemperature(1:n)*Basis(1:n) )
       Wn(1) = SUM( NodalFluidity(1:n)*Basis(1:n) )
       Bg = BGlenT(Temperature,Wn)
       Pressure = SUM( NodalP(1:n)*Basis(1:n) )
!
! Strain-Rate
!
        LGrad = MATMUL( NodalVelo(:,1:n), dBasisdx(1:n,:) )
        SR = 0.5 * ( LGrad + TRANSPOSE(LGrad) )
        IF ( CSymmetry ) THEN
          SR(1,3) = 0.0_dp
          SR(2,3) = 0.0_dp
          SR(3,1) = 0.0_dp
          SR(3,2) = 0.0_dp
          SR(3,3) = 0.0_dp
          IF ( Radius > 10*AEPS ) THEN
            SR(3,3) = SUM( Nodalvelo(1,1:n) * Basis(1:n) ) /Radius
                 
          END IF
          epsi = SR(1,1)+SR(2,2)+SR(3,3)
          DO i=1,3   
            SR(i,i) = SR(i,i) - epsi/3.0_dp
          END DO
        ELSE
          epsi = SR(1,1)+SR(2,2)+SR(3,3)
          DO i=1,dim 
            SR(i,i) = SR(i,i) - epsi/dim
          END DO
        END IF

! if not isotropic use GOLF
      C = 0.0_dp
      IF (.NOT.Isotropic) THEN
         a2(1) = SUM( NodalK1(1:n) * Basis(1:n) ) 
         a2(2) = SUM( NodalK2(1:n) * Basis(1:n) ) 
         a2(3) = 1.d0 - a2(1) - a2(2)
         a2(4) = SUM( NodalEuler1(1:n) * Basis(1:n) )
         a2(5) = SUM( NodalEuler2(1:n) * Basis(1:n) )
         a2(6) = SUM( NodalEuler3(1:n) * Basis(1:n) )
      
         CALL R2Ro(a2,dim,ai,angle)
         CALL OPILGGE_ai(ai,Angle,Temperature,Wn,FabricGrid,C)

! else use isotropic law
      ELSE
         Do i = 1,3
           C(i,i) = 2.0_dp / Bg
           C(i+3,i+3) = 1.0_dp / Bg
         END DO
      ENDIF
      

!
! Case non-linear and ISOTROPIC
! -----------------------------

      IF ( Isotropic .AND. (Wn(2) > 1.0) ) THEN
      

        ss = 0.0_dp
        DO i = 1, 3
          DO j = 1, 3
            ss = ss + SR(i,j)**2
          END DO
        END DO
        nn =(1.0_dp - Wn(2))/Wn(2)

        ss = SQRT(2.0_dp * ss)
        IF (ss < MinSRInvariant ) ss = MinSRInvariant

        C  = C * (ss/Bg)**nn 

      END IF

!
!    Compute deviatoric stresses or Cauchy stresses: 
!    ----------------------------
      D(1) = SR(1,1)
      D(2) = SR(2,2)
      D(3) = SR(3,3)
      D(4) = 2. * SR(1,2)
      D(5) = 2. * SR(2,3)
      D(6) = 2. * SR(3,1)
      
      Stress = 0.0_dp
      DO k = 1, cc      
       DO j = 1, cc       
        Stress(k) = Stress(k) + C(k,j) * D(j)
       END DO
      END DO
      IF (Cauchy) THEN
        DO k=1,3
          Stress(k) = Stress(k) - Pressure
        END DO 
      END IF
      
      DO i = 1, cc
        DO p=1,n         
          DO q=1,n        
            StiffMatrix(cc*(p-1)+i,cc*(q-1)+i ) =  &
               StiffMatrix(cc*(p-1)+i,cc*(q-1)+i ) + s*Basis(q)*Basis(p)
          END DO

             ForceVector(cc*(p-1)+i) =  &
                     ForceVector(cc*(p-1)+i) + s*Stress(i)*Basis(p) 
        END DO
      END DO

      END DO 

!------------------------------------------------------------------------------
      END SUBROUTINE LocalAIFlowMatrix
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
      SUBROUTINE LocalNSMatrix( MassMatrix, StiffMatrix, ForceVector, &
               NodalVelo, NodalP, NodalFluidity, &
              Element, n, Nodes, Wn, MinSRInvariant, Cauchy )
!------------------------------------------------------------------------------

     REAL(KIND=dp) :: StiffMatrix(:,:), MassMatrix(:,:)
     REAL(KIND=dp) ::  NodalVelo(:,:)
     REAL(KIND=dp) :: Wn(7), MinSRInvariant
     REAL(KIND=dp), DIMENSION(:) :: ForceVector,  &
                              NodalFluidity, NodalP
     TYPE(Nodes_t) :: Nodes
     TYPE(Element_t) :: Element
     LOGICAL ::  Cauchy
     INTEGER :: n
!------------------------------------------------------------------------------
!
     REAL(KIND=dp) :: Basis(2*n),ddBasisddx(1,1,1)
     REAL(KIND=dp) :: dBasisdx(2*n,3),detJ, pBasis(n)

     REAL(kind=dp) :: Bg,  Stress(6)

     REAL(KIND=dp), DIMENSION(4,4) :: A,M
     REAL(KIND=dp) :: Temperature,  C(6,6), Pressure
     REAL(KIND=dp) :: nn, ss, LGrad(3,3), SR(3,3), D(6), epsi

     INTEGER :: i, j, k, p, q, t, dim, cc, NBasis, ind(3), LinearBasis

     REAL(KIND=dp) :: s, u, v, w, Radius, eta
  
     REAL(KIND=dp) :: dDispldx(3,3), ai(3), Angle(3), a2(6)
     TYPE(GaussIntegrationPoints_t), TARGET :: IntegStuff

     INTEGER, POINTER :: EdgeMap(:,:)
     INTEGER :: N_Integ, nd

     REAL(KIND=dp), DIMENSION(:), POINTER :: U_Integ,V_Integ,W_Integ,S_Integ

     LOGICAL :: stat, CSymmetry, P2P1, MiniElement

     TYPE(ElementType_t), POINTER :: SaveType, LinearType


!------------------------------------------------------------------------------
      dim = CoordinateSystemDimension()
      cc=2*dim


      ForceVector = 0.0_dp
      StiffMatrix = 0.0_dp
      MassMatrix  = 0.0_dp

      IntegStuff = GaussPoints( Element )

      U_Integ => IntegStuff % u
      V_Integ => IntegStuff % v
      W_Integ => IntegStuff % w
      S_Integ => IntegStuff % s
      N_Integ =  IntegStuff % n
!
!   Now we start integrating
!
      DO t=1,N_Integ

      u = U_Integ(t)
      v = V_Integ(t)
      w = W_Integ(t)

!------------------------------------------------------------------------------
!     Basis function values & derivatives at the integration point
!------------------------------------------------------------------------------
       stat = ElementInfo(Element,Nodes,u,v,w,detJ, &
                 Basis,dBasisdx,ddBasisddx,.FALSE.,.FALSE.)


       s = detJ * S_Integ(t)


       Radius = SUM( Nodes % x(1:n) * Basis(1:n) )
       CSymmetry = CurrentCoordinateSystem() == AxisSymmetric
       IF ( CSymmetry ) s = s * Radius
!
!     Temperature at the integration point
!
       Wn(1) = SUM( NodalFluidity(1:n)*Basis(1:n) )
       Bg = Wn(1)                       
       Pressure = SUM( NodalP(1:n)*Basis(1:n) )
!
! Strain-Rate
!
        LGrad = MATMUL( NodalVelo(:,1:n), dBasisdx(1:n,:) )
        SR = 0.5 * ( LGrad + TRANSPOSE(LGrad) )
        IF ( CSymmetry ) THEN
          SR(1,3) = 0.0_dp
          SR(2,3) = 0.0_dp
          SR(3,1) = 0.0_dp
          SR(3,2) = 0.0_dp
          SR(3,3) = 0.0_dp
          IF ( Radius > 10*AEPS ) THEN
            SR(3,3) = SUM( Nodalvelo(1,1:n) * Basis(1:n) ) /Radius
                 
          END IF
          epsi = SR(1,1)+SR(2,2)+SR(3,3)
          DO i=1,3   
            SR(i,i) = SR(i,i) - epsi/3.0_dp
          END DO
        ELSE
          epsi = SR(1,1)+SR(2,2)+SR(3,3)
          DO i=1,dim 
            SR(i,i) = SR(i,i) - epsi/dim
          END DO
        END IF

        C = 0.0_dp
         Do i = 1,3
           C(i,i) = 2.0_dp / Bg
           C(i+3,i+3) = 1.0_dp / Bg
         END DO
      

!
! Case non-linear and ISOTROPIC
! -----------------------------

      IF ( Wn(2) > 1.0 ) THEN
        ss = 0.0_dp
        DO i = 1, 3
          DO j = 1, 3
            ss = ss + SR(i,j)**2
          END DO
        END DO
        nn =(1.0_dp - Wn(2))/Wn(2)

        ss = SQRT(2.0_dp * ss)
        IF (ss < MinSRInvariant ) ss = MinSRInvariant

        C  = C * (ss/Bg)**nn 
      END IF

!
!    Compute deviatoric stresses or Cauchy stresses: 
!    ----------------------------
      D(1) = SR(1,1)
      D(2) = SR(2,2)
      D(3) = SR(3,3)
      D(4) = 2. * SR(1,2)
      D(5) = 2. * SR(2,3)
      D(6) = 2. * SR(3,1)
      
      Stress = 0.0_dp
      DO k = 1, cc      
       DO j = 1, cc       
        Stress(k) = Stress(k) + C(k,j) * D(j)
       END DO
      END DO
      IF (Cauchy) THEN
        DO k=1,3
          Stress(k) = Stress(k) - Pressure
        END DO 
      END IF
      
      DO i = 1, cc
        DO p=1,n         
          DO q=1,n        
            StiffMatrix(cc*(p-1)+i,cc*(q-1)+i ) =  &
               StiffMatrix(cc*(p-1)+i,cc*(q-1)+i ) + s*Basis(q)*Basis(p)
          END DO

             ForceVector(cc*(p-1)+i) =  &
                     ForceVector(cc*(p-1)+i) + s*Stress(i)*Basis(p) 
        END DO
      END DO

      END DO 

!------------------------------------------------------------------------------
      END SUBROUTINE LocalNSMatrix
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
      END SUBROUTINE ComputeDevStress
!------------------------------------------------------------------------------

!
! A partir des 6 viscosites eta_i (loi type boehler)
! retourne les 9 viscosites de la matrice en expression de Voigt      
! dans le repere d'orthotropie
!      
      !  s11 = A11 d11 + A12 d22 + A13 d33
      !  s22 = A12 d11 + A22 d22 + A23 d33
      !  s33 = A13 d11 + A23 d22 + A33 d33
      !  s23 = A44 2*d23
      !  s31 = A55 2*d31
      !  s12 = A66 2*d12

!  Retourne etaVO(9) = Xi
!
!              |X1 X2 X3         |
!              |X2 X4 X5         |
!     Aij =    |X3 X5 X6         |
!              |         X7      |
!              |            X8   |
!              |               X9|

      Subroutine viscVoigt(v,etaVO)

      Implicit None
      Real, Dimension(6) :: v
      Real, Dimension(9) :: etaVO
      Real :: a,b

      a =  4. * v(6) - v(3) 

      etaVO(1) = (v(1) + 2.* v(4) + a )/3.0
      etaVO(4) = (v(2) + 2.* v(5) + a )/3.0
      etaVO(6) = 2.* v(6)

      b = 2.* (v(3) - v(6))

      etaVO(5) = - (v(2) + b + 2.*v(5))/3.0
      etaVO(3) = - (v(1) + b + 2.*v(4))/3.0
      etaVO(2) = etaVO(3) + etaVO(5) + v(3)

      etaVO(7) = .5* (v(5) + v(6)) 
      etaVO(8) = .5* (v(4) + v(6)) 
      etaVO(9) = .5* (v(4) + v(5)) 

      Return
      End 

#!/bin/csh
#$ -S /bin/csh
#$ -N mpi-test
#$ -o test.out
#$ -cwd
#$ -l h_rt=00:10:00
#$ -l h_vmem=200M
#$ -pe cre 2

setenv LD_LIBRARY_PATH ".:/opt/SUNWhpc/lib:/wrk/vierinen/src/buildtools/build.corona1.2005-06-09-10-49-12/fem/src/"

printf "JOB_ID: %s\n" $JOB_ID
printf "PE_HOSTFILE: %s\n" $PE_HOSTFILE

printf "Running it\n"
mprun -np 2 ../../src/ElmerSolver_mpi

printf "Done...\n" 

math Principal.1=Stress.1*0;
math Principal.2=Stress.1*0;
math Principal.3=Stress.1*0;

do i 0 [@ $NumberOfTimesteps-1] {
  math n=time($i);
  math a=0;
  math {
     for( k=0:size(n)[1]-1 ) {
       a(0,0)=Stress.1(k);
       a(1,1)=Stress.2(k);
       a(0,1)=Stress.4(k);
       a(1,0)=a(0,1);
       x=eig(a);
       Principal.1(k)=x(0,0);
       Principal.2(k)=x(1,0);
    }
  }
}

#!/bin/sh
#
# Regenerate configuration files
# libtoolize --force --copy
aclocal
automake -afc --foreign
autoheader
autoconf

# Run configure for this platform
#./configure $*
echo "Now you are ready to run ./configure"
